

#include "FormListFunctions.h"


VisContainerInterface2Ptr VisRecursiveList::calcSize(void)
{ 
  // Erstelle Ableitungsbaum und fuege die Listenelemente ein
  if(optRoot->containerExists("listelement"))
  {
    //assert(listElements); // Dies ist eine Plausibilitaetspruefung !?
    if (!listElements) {
       vlError("FormList-Layout: RootDrawing has 'listelement' container, but the List is empty");
    } else {
      optRoot->setSubElement(
       HeadVisContainerInterface2PtrList(listElements)->toType2(),"listelement");
      listElements=TailVisContainerInterface2PtrList(listElements);
    }
  }
  deriv.add(optRoot);

  if (!listElements && optTerm->containerExists("listelement")) {
          vlError("FormList-Layout: Too few list elements to fill rootDrawing and termDrawing 'listelement' containers");
  }
  else if(listElements)
  {
    while(TailVisContainerInterface2PtrList(listElements))
    {
      deriv.add(optRec->getDrawingTrafo());
      deriv.last()->setSubElement(
        HeadVisContainerInterface2PtrList(listElements)->toType2(),"listelement");
      listElements=TailVisContainerInterface2PtrList(listElements);
    }
    if(optTerm->containerExists("listelement"))
      optTerm->setSubElement(
        HeadVisContainerInterface2PtrList(listElements)->toType2(),"listelement");
    else
    {
      deriv.add(optRec->getDrawingTrafo());
      deriv.last()->setSubElement(
        HeadVisContainerInterface2PtrList(listElements)->toType2(),"listelement");
    }
  }
  deriv.add(optTerm);

  //Fuege die Formularelemente ein
  while(formElements)
  {
    VisContainerPosition2Ptr pos=HeadVisContainerPosition2PtrList(formElements);
    formElements=TailVisContainerPosition2PtrList(formElements);
    if(optRoot->containerExists(pos->containerName))
      optRoot->setSubElement(pos->element,pos->containerName);
    else
    {
      assert(optTerm->containerExists(pos->containerName));
      optTerm->setSubElement(pos->element,pos->containerName);
    }
  }

  // setze die Knotenzeiger
  for(int i=0; i<deriv.getSize(); i++) 
  {
    deriv[i]->nodePtr=nodePtr;
    deriv[i]->listRootNodePtr=listRootNodePtr;
    //deriv[i]->insPointProc=insPointProc;
  }

  //berechne Groessen
  for(int i=deriv.getSize()-1; i>1; i--)
    deriv[i-1]->setSubElement(deriv[i]->expand(),"sublist");
  if(optRoot->containerExists("sublist")) optRoot->setSubElement(deriv[1]->expand(),"sublist");
  else 
  { 
    assert(optRoot->containerExists("default"));
    optRoot->setSubElement(deriv[1]->expand(),"default");
  }
  return optRoot->expand();
}


void VisRecursiveList::draw(void)
{
  for(int i=0; i<deriv.getSize()-1; i++) 
    deriv[i]->draw(i);
  deriv[deriv.getSize()-1]->draw(VisDerivpos_term);
}



