
#include "cleanup.h"
#include <list>
#include <stdio.h>

std::list<VLObject*> cleanupList;


class TempCharPtrWrapper: public VLObject
{
private:
  char *buffer;
public:
  TempCharPtrWrapper(char *aBuffer) { buffer = aBuffer; };
  ~TempCharPtrWrapper() { printf("Deleting string: %s\n", buffer); free(buffer); };
};


void registerTemp(char *buffer) 
{
  registerTemp(new TempCharPtrWrapper(buffer));
}


void registerTemp(VLObject *obj)
{
  cleanupList.push_back(obj);
}


void cleanupTemp()
{
  std::list<VLObject*>::iterator p = cleanupList.begin();
  while (p != cleanupList.end()) {
    VLObject *obj = (*p);
    delete obj;
    p++;
  }
  cleanupList.clear();
}
