##############################################################
# -Geometrics (Resizeclient)
##############################################################
proc startresize {name parent x y X Y} {
upvar #0 ::${parent}:: mstruct ::${parent}::${name} cstruct
#puts "startresize"
if {$cstruct(status)=="minimized"} return
set cstruct(lastevent) "$X $Y"
set geo   [split [winfo geometry $cstruct(path)] +x]
set down  [expr [lindex $geo 1] -20]
set right [expr [lindex $geo 0] -20]
if {$x<20} { ;#westy
   if {$y<20} {
      set result nw
      } else {
      if {$y>$down} {set result sw} else {set result w}
      }
   } else { ;#NOT westy
   if {$x>$right} { ;#easty
      if {$y<20} {
         set result ne
         } else {
         if {$y>$down} {set result se} else {set result e}
         }
      } else { ;#NOT westy and  NOT easty
      if {$y>$down} {set result s} else {set result n}
      }
   }

# Only resize an empty frame
pack forget $cstruct(path).$name

set cstruct(eventtype) $result
}
proc doresize {name parent x y} {
upvar #0 ::${parent}:: mstruct ::${parent}::${name} cstruct
#puts "doresize"
if {$cstruct(status)=="minimized"} return
set oldx  [lindex $cstruct(lastevent) 0]
set oldy  [lindex $cstruct(lastevent) 1]
if {[winfo rootx $mstruct(path)] > $x} {set x [winfo rootx $mstruct(path)]}
if {[winfo rooty $mstruct(path)] > $y} {set y [winfo rooty $mstruct(path)]}
if {([winfo rootx $mstruct(path)]+[winfo width  $mstruct(path)]) < $x} {set x [expr [winfo width  $mstruct(path)]+[winfo rootx $mstruct(path)]]}
if {([winfo rooty $mstruct(path)]+[winfo height $mstruct(path)]) < $y} {set y [expr [winfo height $mstruct(path)]+[winfo rooty $mstruct(path)]]}
set maxx  [winfo width  $cstruct(path)]
set maxy  [winfo height $cstruct(path)]
set dx    [expr $x-$oldx]
set dy    [expr $y-$oldy]
switch $cstruct(eventtype) {
       n  {
          if {[expr $maxy-$dy]<$mstruct(minheight)} return
          $mstruct(path) itemconfig $cstruct(id) -height [expr $maxy-$dy]
          $mstruct(path) move $cstruct(id)  0 $dy
          }
       ne {
          if {[expr $maxy-$dy]<$mstruct(minheight)} {
             if {[expr $maxx+$dx]<$mstruct(minwidth)} {
                return
                } else {
                $mstruct(path) itemconfig $cstruct(id) -width  [expr $maxx+$dx]
                set y $oldy
                }
             } else {
             if {[expr $maxx+$dx]<$mstruct(minwidth)} {
                $mstruct(path) itemconfig $cstruct(id) -height [expr $maxy-$dy]
                $mstruct(path) move $cstruct(id)  0 $dy
                set x $oldx
                } else {
                $mstruct(path) itemconfig $cstruct(id) -width  [expr $maxx+$dx] -height [expr $maxy-$dy]
                $mstruct(path) move $cstruct(id)  0 $dy
                }
             }
          }
       e  {
          if {[expr $maxx+$dx]<$mstruct(minwidth)} return
          $mstruct(path) itemconfig $cstruct(id) -width  [expr $maxx+$dx]
          }
       se {
          if {[expr $maxy+$dy]<$mstruct(minheight)} {
             if {[expr $maxx+$dx]<$mstruct(minwidth)} { 
                return 
                } else {
                $mstruct(path) itemconfig $cstruct(id) -width  [expr $maxx+$dx]
                set y $oldy
                }
             } else {
             if {[expr $maxx+$dx]<$mstruct(minwidth)} { 
                $mstruct(path) itemconfig $cstruct(id) -height [expr $maxy+$dy]
                set x $oldx
                } else {
                $mstruct(path) itemconfig $cstruct(id) -width  [expr $maxx+$dx] -height [expr $maxy+$dy]
                }
             }
          }
       s  {
          if {[expr $maxy+$dy]<$mstruct(minheight)} return
          $mstruct(path) itemconfig $cstruct(id) -height [expr $maxy+$dy]
          }
       sw {
          if {[expr $maxy+$dy]<$mstruct(minheight)} {
             if {[expr $maxx-$dx]<$mstruct(minwidth)} {
                return
                } else {
                $mstruct(path) itemconfig $cstruct(id) -width  [expr $maxx-$dx]
                $mstruct(path) move $cstruct(id) $dx 0
                set y $oldy
                }
             } else {
             if {[expr $maxx-$dx]<$mstruct(minwidth)} {  
                $mstruct(path) itemconfig $cstruct(id) -height [expr $maxy+$dy]
                set x $oldx
                } else {
                $mstruct(path) itemconfig $cstruct(id) -width  [expr $maxx-$dx] -height [expr $maxy+$dy]
                $mstruct(path) move $cstruct(id)  $dx 0
                }           
             }
          }
       w  {
          if {[expr $maxx-$dx]<$mstruct(minwidth)} return
          $mstruct(path) itemconfig $cstruct(id) -width  [expr $maxx-$dx]
          $mstruct(path) move $cstruct(id) $dx 0
          }
       nw {
          if {[expr $maxy-$dy]<$mstruct(minheight)} {
             if {[expr $maxx-$dx]<$mstruct(minwidth)} {
                return
                } else {
                $mstruct(path) itemconfig $cstruct(id) -width  [expr $maxx-$dx]
                $mstruct(path) move $cstruct(id) $dx 0
                set y $oldy
                }
             } else {
             if {[expr $maxx-$dx]<$mstruct(minwidth)} {
                $mstruct(path) itemconfig $cstruct(id) -height [expr $maxy-$dy]
                $mstruct(path) move $cstruct(id)  0 $dy
                set x $oldx
                } else {
                $mstruct(path) itemconfig $cstruct(id) -width  [expr $maxx-$dx] -height [expr $maxy-$dy]
                $mstruct(path) move $cstruct(id)  $dx $dy
                }
             }           
          }
       }
set cstruct(lastevent) "$x $y"
}
proc endresize {name parent x y} {
upvar #0 ::${parent}:: mstruct ::${parent}::${name} cstruct
#puts "endresize"
if {($cstruct(status)=="minimized") || ($cstruct(status)=="maximized")} return
pack $cstruct(path).$name -side top -fill both -expand yes

update idletasks
array set cstruct [subst {
      "lastevent" "-1 -1"
      "eventtype" ""
      "rootx"     "[lindex [$mstruct(path) bbox $cstruct(id)] 0]"
      "rooty"     "[lindex [$mstruct(path) bbox $cstruct(id)] 1]"
      "width"     "[winfo width  $cstruct(path)]"
      "height"    "[winfo height $cstruct(path)]"
      }]
}

variable cursor

switch $::Mysund_MDI(platform) {
    "unix" { 
	array set cursor {
	    "normal_pointer"      "top_left_arrow"
	    "resize_top_left"     "top_left_corner"
	    "resize_top_right"    "top_right_corner"
	    "resize_bottom_left"  "bottom_left_corner"
	    "resize_bottom_right" "bottom_right_corner"
	    "resize_left"         "left_side"
	    "resize_right"        "right_side"
	    "resize_top"          "top_side"
	    "resize_bottom"       "bottom_side"
	}
    }

    "macintosh" { 
	array set cursor {
	    "normal_pointer"      "top_left_arrow"
	    "resize_top_left"     "top_left_corner"
	    "resize_top_right"    "top_right_corner"
	    "resize_bottom_left"  "bottom_left_corner"
	    "resize_bottom_right" "bottom_right_corner"
	    "resize_left"         "left_side"
	    "resize_right"        "right_side"
	    "resize_top"          "top_side"
	    "resize_bottom"       "bottom_side"
	}
    }
    
    "windows" {
	array set cursor {
	    "normal_pointer"      "arrow"
	    "resize_top_left"     "size_nw_se"
	    "resize_top_right"    "size_ne_sw"
	    "resize_bottom_left"  "size_ne_sw"
	    "resize_bottom_right" "size_nw_se"
	    "resize_left"         "size_we"
	    "resize_right"        "size_we"
	    "resize_top"          "size_ns"
	    "resize_bottom"       "size_ns"
	}   
    }	
}
	
proc setclientcursor {name parent x y} {
upvar #0 ::${parent}:: mstruct ::${parent}::${name} cstruct
variable cursor
set geo [split [winfo geometry $cstruct(path)] +x]
set right [expr [lindex $geo 0] - 20]
set down  [expr [lindex $geo 1] - 20]
set rightbd [expr [lindex $geo 0] - 7]
set downbd  [expr [lindex $geo 1] - 7]
if {("$cstruct(status)" == "minimized") || ("$cstruct(status)" == "maximized")} {
    $cstruct(path) configure -cursor $cursor(normal_pointer)
    return
}
if { (3 < $x) && ($x < $rightbd) && (3 < $y) && ($y < $downbd)} {
    $cstruct(path) configure -cursor $cursor(normal_pointer)
    return
}
if {"$x" < "20"} {
    if {"$y" < "20"} {$cstruct(path) configure -cursor $cursor(resize_top_left) ;return}
    if {"$y" > "$down"} {
	$cstruct(path) configure -cursor $cursor(resize_bottom_left) ;return
    } else {$cstruct(path) configure -cursor $cursor(resize_left) ;return}
}
if {"$x" > "$right"} {
    if {"$y" < "20"} {$cstruct(path) configure -cursor $cursor(resize_top_right) ;return}
    if {"$y" > "$down"} {
	$cstruct(path) configure -cursor $cursor(resize_bottom_right) ;return
    } else { 
	$cstruct(path) configure -cursor $cursor(resize_right) ;return
    }
} else {
    if {"$y" < "20"} {
	$cstruct(path) configure -cursor $cursor(resize_top) ;return
    } else {
	$cstruct(path) configure -cursor $cursor(resize_bottom) ;return
    }
}
}
##############################################################
# -Geometrics (Moveclient)
##############################################################
proc startmove {name parent x y} {
upvar #0 ::${parent}:: mstruct ::${parent}::${name} cstruct
#puts "startmove"
set cstruct(lastevent) "$x $y"
}
proc domove {name parent x y} {
upvar #0 ::${parent}:: mstruct ::${parent}::${name} cstruct
if {$cstruct(status)=="maximized"} return
#puts "domove"
set oldx  [lindex $cstruct(lastevent) 0]
set oldy  [lindex $cstruct(lastevent) 1]
if {[winfo rootx $mstruct(path)] > $x} {set x [winfo rootx $mstruct(path)]}
if {[winfo rooty $mstruct(path)] > $y} {set y [winfo rooty $mstruct(path)]}
if {([winfo rootx $mstruct(path)]+[winfo width  $mstruct(path)]) < $x} {set x [expr [winfo width  $mstruct(path)]+[winfo rootx $mstruct(path)]]}
if {([winfo rooty $mstruct(path)]+[winfo height $mstruct(path)]) < $y} {set y [expr [winfo height $mstruct(path)]+[winfo rooty $mstruct(path)]]}
$mstruct(path) move $cstruct(id) [expr $x-$oldx] [expr $y-$oldy]
set cstruct(lastevent) "$x $y"
}
proc endmove {name parent x y} {
upvar #0 ::${parent}:: mstruct ::${parent}::${name} cstruct
if {$cstruct(lastevent) == "-1 -1"} return
if {$cstruct(status)=="maximized"} return
#puts "endmove"
if {$cstruct(status)=="minimized"} {
   set cstruct(minroot) [lrange [$mstruct(path) bbox $cstruct(id)] 0 1]
   } else {
   set cstruct(rootx) [lindex [$mstruct(path) bbox $cstruct(id)] 0]
   set cstruct(rooty) [lindex [$mstruct(path) bbox $cstruct(id)] 1]
   }
set cstruct(lastevent) "-1 -1"
}

##############################################################
# -Client handling maximize minimize normalize
##############################################################

proc closeclient {name parent} {
    upvar #0 $parent$name cstruct $parent mstruct
    #update idletasks

    if {[set cmd [info commands [lindex $cstruct(closecmd) 0]]] != ""} { 
	if ![eval [subst $cstruct(closecmd)]] return 
    }

    destroyclient $name $parent
}

proc destroyclient {name parent} {
    upvar #0 $parent$name cstruct $parent mstruct
    #update idletasks

    destroy $cstruct(path)
    $mstruct(path) delete $cstruct(id)
    set mstruct(clientlist) [lreplace $mstruct(clientlist) [lsearch $mstruct(clientlist) $name] [lsearch $mstruct(clientlist) $name]]
    for {set i 0} {$i<=[$mstruct(path).menu index last]} {incr i} {
	if {([$mstruct(path).menu type $i]!="command")||("[$mstruct(path).menu entrycget $i -label]"!="$cstruct(title)")} {
	    continue
	} else {
	    $mstruct(path).menu delete $i
	}
    }
    unset cstruct
}


proc minclient {name parent} {
    upvar #0 $parent$name cstruct $parent mstruct

#    puts "minclient $name $parent"
    $mstruct(path) itemconfig $cstruct(id) -width $mstruct(minwidth) -height $mstruct(minheight)
    set canx  [winfo width  $mstruct(path)]
    set cany  [winfo height $mstruct(path)]
    set minx  $mstruct(minwidth)
    set miny  $mstruct(minheight)
    $cstruct(path).system.pfile.menu entryconfig 0 -state normal
    $cstruct(path).system.pfile.menu entryconfig 3 -state disabled
    $cstruct(path).system.pfile.menu entryconfig 4 -state normal
    if {$cstruct(minroot) != ""} {
	$mstruct(path) coords $cstruct(id) [lindex $cstruct(minroot) 0] [lindex $cstruct(minroot) 1]
    } else {
	set found 0
	for     {set iy 0} {$iy < "[expr $cany-$miny]" } {incr iy [expr 1+$mstruct(minheight)]} {
	    for {set ix 0} {$ix < "[expr $canx-$minx]" } {incr ix [expr 1+$mstruct(minwidth)]} {
		set overlappers [$mstruct(path) find overlapping [expr $ix] [expr $cany-$iy] [expr $ix+$minx] [expr $cany-$miny-$iy]]
		set found 1
		if {"[llength $overlappers]" == "0"} {
		    break     
		} else {
		    foreach cli $mstruct(clientlist) {
			upvar #0 $parent$cli curcli
			if {[lsearch $overlappers $curcli(id)]!="-1" && $curcli(status)=="minimized" } {
			    set found 0
			    break
			}
		    } ;#foreach
		    if $found break
		} ;#ifelse
		if $found break
	    } ;#for
	    if $found break
	} ;#for
	$mstruct(path) coords     $cstruct(id) [expr $ix] [expr $cany-$iy-$miny]
    } ;#if
    if {$cstruct(status) == "maximized"} {
	$cstruct(path).system.pmin configure -image pnorm -command [subst {::MDI::maxclient $name $parent}]
    } else {
	$cstruct(path).system.pmin configure -image pnorm -command [subst {::MDI::normclient $name $parent}]
    }
    $cstruct(path).system.pmax configure -image pmax  -command [subst {::MDI::maxclient   $name $parent}]
    $cstruct(path).system.pmin configure -image pnorm -command [subst {::MDI::normclient  $name $parent}]
    set cstruct(status) "minimized"
    eval [subst {bind $cstruct(path).system <Double-ButtonPress-1> { $cstruct(path).system.pmin invoke}}]
    eval [subst {bind $cstruct(path).system.title <Double-ButtonPress-1> { $cstruct(path).system.pmin invoke}}]
    foreach cli $mstruct(clientlist) {
	upvar #0 $parent$cli curclient
	if {$curclient(status)!="minimized"} {
	    ::MDI::setcurrent $cli $parent
	    break
	}
    }
    update idletasks
    if {[font measure MDIfont $cstruct(title)] > [winfo width $cstruct(path).system.title]} {
	set str [lindex [$cstruct(path).system.title con -text] 4]
	while {[font measure MDIfont $str] > [winfo width $cstruct(path).system.title]} {
	    set str "[string range $str 0 [expr [string length $str]-3]]."
	}
	$cstruct(path).system.title con -text $str
    }
} ;#end proc

proc maxclient {name parent} {
    upvar #0 $parent$name cstruct $parent mstruct
    
    #by cs: buxfix: unmaximize all clients, otherwise an error occurs
    unmaxall $parent

#    puts "maxclient $name $parent"
#    puts "rootx $cstruct(rootx), rooty $cstruct(rooty)"
    $cstruct(path).system.pmax con -command ""
    set cstruct(status) "maximized"
    $cstruct(path).system.pfile.menu entryconfig 4 -state disabled
    $cstruct(path).system.pfile.menu entryconfig 0 -state normal
    $cstruct(path).system.pfile.menu entryconfig 3 -state normal
    if {$mstruct(menupath) == ""} { 
	$mstruct(path) coords $cstruct(id) 0 0
	$mstruct(path) itemconfig $cstruct(id) \
		-width [winfo width $mstruct(path)] -height [winfo height $mstruct(path)]
	$cstruct(path).system.pmin configure \
		-image pmin  -command [subst {::MDI::minclient  $name $parent}]
	$cstruct(path).system.pmax configure \
		-image pnorm -command [subst {::MDI::normclient $name $parent}]
    } else {
	if {[winfo class $mstruct(menupath)] != "Frame"} {
	    puts "error: \"$mstruct(menupath)\"'class isn't a Frame" 
	}
	#foreach dims [pack slaves $mstruct(menupath)] {
	    #puts "$dims from menu"
	    #eval [subst {set tmp($dims) "[pack info $dims]"}]
	    #pack forget $dims
	#}
	set first [lindex [pack slaves $mstruct(menupath)] 0]
	set last  [lindex [pack slaves $mstruct(menupath)] [expr [llength [pack slaves $mstruct(menupath)]] -1]]
	label $mstruct(menupath).pfile -image pfile -bd 1 -bg $::MDI::syslgray
	pack $mstruct(menupath).pfile -side left -padx 2 -before $first
	set cb [button $mstruct(menupath).pclose \
		-image pmclose -bd 1 -command "::MDI::mclient $name $parent close"]
	set nb [button $mstruct(menupath).pnorm  -image pmnorm  -bd 1 -command "::MDI::mclient $name $parent norm"]
	set mb [button $mstruct(menupath).pmin   -image pmmin   -bd 1 -command "::MDI::mclient $name $parent min"]
	pack $cb -side right -padx 2 -before $last
	pack $nb $mb -side right -before $last
	#foreach aname [array names tmp] {
	    #puts "$aname to menu"
	    #eval [subst {pack $aname $tmp($aname)}]
	#}
	#parray tmp
	#catch {unset tmp}
	$mstruct(path) coords     $cstruct(id) -5 -22
	$mstruct(path) itemconfig $cstruct(id) \
		-height [expr 24+[winfo height $mstruct(path)]] \
		-width [expr 8+[winfo width $mstruct(path)]]
	$cstruct(path).system.pfile.menu entryconfig 0 \
		-state normal -command [subst {::MDI::mclient $name $parent norm}]
	$cstruct(path).system.pfile.menu entryconfig 3 \
		-state normal -command [subst {::MDI::mclient $name $parent min}]
	$cstruct(path).system.pfile.menu entryconfig 6 \
		-state normal -command [subst {::MDI::mclient $name $parent close}]
	eval [subst {bind $mstruct(menupath).pfile <ButtonPress-1> { \
		$cstruct(path).system.pfile.menu post \[winfo rootx $mstruct(menupath).pfile\] \[expr \[winfo rooty $mstruct(menupath).pfile\]+\[winfo height $mstruct(menupath).pfile\]\]}}]
    }
}

proc normclient {name parent} {
    mclient $name $parent norm
}

proc _normclient {name parent} {
upvar #0 $parent$name cstruct $parent mstruct
#puts "normclient $name $parent"
$cstruct(path).system.pfile.menu entryconfig 4 -state normal
$cstruct(path).system.pfile.menu entryconfig 0 -state disabled
$cstruct(path).system.pfile.menu entryconfig 3 -state normal
$cstruct(path).system.title con -text $cstruct(title)
$mstruct(path) itemconfig $cstruct(id) -width $cstruct(width) -height $cstruct(height)
$mstruct(path) coords $cstruct(id) $cstruct(rootx) $cstruct(rooty)
#update idletasks
$cstruct(path).system.pmin configure -image pmin -command [subst {::MDI::minclient $name $parent}]
$cstruct(path).system.pmax configure -image pmax -command [subst {::MDI::maxclient $name $parent}]
set cstruct(status) "normal"
bind $cstruct(path).system <Double-1> ""
bind $cstruct(path).system.title <Double-1> "::MDI::maxclient $name $parent"
}

proc mclient {name parent command} {
upvar #0 $parent$name cstruct $parent mstruct
#puts "mclient $name $parent $command"
#puts "rootx $cstruct(rootx), rooty $cstruct(rooty)"
switch $command {
       close  {
              ::MDI::closeclient $name $parent
              # by cs: original stuff deleted. It was not needed and caused errors.
              }
       min    {
              ::MDI::minclient $name $parent
              }
       norm   {
	      ::MDI::_normclient $name $parent
              }
       }
foreach dims [winfo children $mstruct(menupath)] {
        if {"$dims" == "$mstruct(menupath).pfile"}  {destroy $dims}
        if {"$dims" == "$mstruct(menupath).pclose"} {destroy $dims}
        if {"$dims" == "$mstruct(menupath).pmin"}   {destroy $dims}
        if {"$dims" == "$mstruct(menupath).pnorm"}  {destroy $dims}
        }
}

proc setcurrent {name parent} {
upvar #0 $parent$name cstruct $parent mstruct
#puts "debug: setcurrent $name $parent"

#by cs: bugfix
if [empty $name] return
if {($cstruct(status)=="minimized") || ($cstruct(status)=="maximized")} return


set index [lsearch $mstruct(clientlist) $name ]
set mstruct(clientlist) "$name [lreplace $mstruct(clientlist) $index $index]"
foreach cli $mstruct(clientlist) {
        if {"$cli" == "$name"} {
	    $cstruct(path).system       con -bg $MDI::sysblue
	    $cstruct(path).system.title con -bg $MDI::sysblue -fg $MDI::syswhite
	    $cstruct(path).system.pfile con -bg $MDI::sysblue
	    focus $cstruct(clientpath)
           } else {
           upvar #0 $parent$cli newcurrentstruct
           $newcurrentstruct(path).system       con -bg $MDI::sysgray
           $newcurrentstruct(path).system.title con -bg $MDI::sysgray -fg $MDI::syslgray
           $newcurrentstruct(path).system.pfile con -bg $MDI::sysgray
           }
        }
raise $cstruct(path)
}
proc getcurrent {parent} {
upvar #0 ::${parent}:: mstruct
return [lindex $mstruct(clientlist) 0]
}
