
#checkutil::addCheck WebNodeActualParam.formalParam {
#    set actionWebnode [c::get "$obj.INCLUDING Formular.action.VALUE"]
#     set webnodeOfParam [c::getOrNull "$value.INCLUDING WebNode"]
#    if ![nullptr $webnodeOfParam] {
#       if ![equal $actionWebnode $webnodeOfParam ]  {
#        return "Formaler Parameter muss zu dem WebNode gehren, auf das Formular.action zeigt."
#	}
#    }
#    return ""
#}


checkutil::addCheck WebNodeVariableExpression.content {
    set error "Muss ein Feld des aktuellen Formulars oder einen formalen Parameter der aktuellen WebPage referenzieren"

    if [c::nodeIsSubtypeOf $value FormularElement] {
        set currentForm [c::get "$obj.INCLUDING Formular"]
        set referedForm [c::get "$value.INCLUDING Formular"]
        if ![equal $currentForm $referedForm] {
            return $error
        }
    }
    if [c::nodeIsSubtypeOf $value WebNodeFormalParam] {
        set currentWebnode [c::get "$obj.INCLUDING WebNode"]
        set referedWebnode [c::get "$value.INCLUDING WebNode"]
        if ![equal $currentWebnode $referedWebnode] {
            return $error
        }
    }
    return ""
}

checkutil::addCheck DataSourceProjectionFilter.sourceDataSource {
   set error "Quelle des ProjectionFilters muss eine DataSourceDB oder ein DataSourceJoin sein!"
   set className [c::getClassName $value]

   if [equal $className "DataSourceJoin"] {
	return ""
   }
   if [equal $className "DataSourceDB"] {
       return ""
   }

  return $error
}

checkutil::addCheck DataSourceModifyOperation {
 set name [c::get "$obj.name.VALUE"]
 set matchVar [string match "*-*" $name]
 if [equal $matchVar 1] {
  return "DataSourceModifyOperations duerfen keinen Bindestrich im Namen fuehren!"
 }
 return ""
}

checkutil::addCheck DataSourceFilter {
 set name [c::get "$obj.name.VALUE"]
 set matchVar [string match "*-*" $name]
 if [equal $matchVar 1] {
  return "DataSourceFilter duerfen keinen Bindestrich im Namen fuehren!"
 }
 return ""
}


checkutil::addCheck DataSourceJoin.dataSource1 {
  set className [c::getClassName $value]
  if [equal $className "DataSourceDB"] {

        set col [c::get "$obj.INCLUDING DataSourceJoin.columnRef1.VALUE"]
	if ![nullptr $col] {
 	set columnName [c::get "$obj.INCLUDING DataSourceJoin.columnRef1.VALUE.name.VALUE"]
	set columns [c::getList "$value.columns.CHILDREN.name.VALUE"]
	set index [lsearch -exact $columns $columnName]
	if [equal $index -1] {
	 return "Die Spalten fr die Verknpfung mssen aus der verknpften Datenbank stammen!"
	}
    }
  }
  return ""
}

checkutil::addCheck DataSourceInsert.targetDataSource {
 set className [c::getClassName "$value"]
 if ![equal $className "DataSourceDB"] {
   return "Ein DataSourceInsert darf nur mit einer DataSourceDB als Eingabequelle verbunden werden"
  }
 return ""
}

checkutil::addCheck DataSourceJoin {
 set class1 [c::get "$obj.dataSource1.VALUE"]
 set class2 [c::get "$obj.dataSource2.VALUE"]
 set className1 [c::getClassName "$class1"]
 set className2 [c::getClassName "$class2"]
 if [equal $className1 "DataSourceDB"] {
  if ![equal $className2 "DataSourceDB"] {
    return "Ein Join muss entweder aus zwei Datenbanken bestehen oder aus zwei Joins!"
  }
 }
 if [equal $className1 "DataSourceJoin"] {
  if ![equal $className2 "DataSourceJoin"] {
    return "Ein Join muss entweder aus zwei Datenbanken bestehen oder aus zwei Joins!"
  }
 }

 if [equal $className1 "DataSourceProjectionFilter"] {
   return "Ein Join darf nicht auf einen DataSourceProjectionFilter ausgefhrt werden!"
 }


 if [equal $className1 "LimitDataSource"] {
   return "Ein Join darf nicht auf eine LimitDataSource ausgefhrt werden!"
 }


 if [equal $className2 "DataSourceProjectionFilter"] {
   return "Ein Join darf nicht auf einen DataSourceProjectionFilter ausgefhrt werden!"
 }


 if [equal $className1 "LimitDataSource"] {
   return "Ein Join darf nicht auf einen LimitDataSource ausgefhrt werden!"
 }

 return ""
}
checkutil::addCheck DataSourceJoin.dataSource2 {
  set className [c::getClassName $value]
  if [equal $className "DataSourceDB"] {
       set col [c::get "$obj.INCLUDING DataSourceJoin.columnRef2.VALUE"]
       if ![nullptr $col] {
 	set columnName [c::get "$obj.INCLUDING DataSourceJoin.columnRef2.VALUE.name.VALUE"]
	set columns [c::getList "$value.columns.CHILDREN.name.VALUE"]
	set index [lsearch -exact $columns $columnName]
	if [equal $index -1] {
	 return "Die Spalten fr die Verknpfung mssen aus der verknpften Datenbank stammen!"
	}
    }
 }
  return ""
}

checkutil::addCheck DataSourceProjectionFilter {
  set columns [c::getList "$obj.projectionColumns.CHILDREN.column.VALUE.name.VALUE"]
  set sourceColumns [getColumnNames [c::get "$obj.sourceDataSource.VALUE"]]

  foreach {listEntry} $columns {
    set index [lsearch -exact $sourceColumns $listEntry]
    if [equal $index -1] {
     return "Die Spalten der Projektion mssen in der Datenquelle vorhanden sein!"
    }
  }

  set conditionColumns [getColumnNamesFromCondition [ lindex [c::getList "$obj.condition.CHILDREN"] 0]]
  foreach {listEntry} $conditionColumns {
   set index [lsearch -exact $sourceColumns $listEntry]
   if [equal $index -1] {
     return "Die Spalten der Bedingung mssen in der Datenquelle vorhanden sein!"
    }
  }


return ""
}

checkutil::addCheck ParameterValueExpression {
 set context [c::getOrNull "$obj.INCLUDING DataSourceModifyOperation"]
 if  ![ nullptr $context] {
  set parameter [c::get "$obj.parameter.VALUE.name.VALUE"]

  set paramList [c::getList "$context.formalParams.CHILDREN.name.VALUE"]
  set index [lsearch -exact $paramList $parameter]
  if [equal $index -1] {
   return "Formaler Parameter der Expression muss sich auf formalen Parameter der ModifyOperation beziehen"
  }

 }
 return ""
}

checkutil::addCheck DataSourceValue.column {
 if [nullptr $value] {
  return "Die Referenz der Spalte des DataSourceValues muss gesetzt sein!"
 }
 return ""
}
checkutil::addCheck DataSourceValue.column {
  set columnName [c::get "$value.name.VALUE"]
  if ![nullptr [c::get "$obj.INCLUDING DataSourceModifyOperation.targetDataSource.VALUE"] ] {
   set columns [c::getList "$obj.INCLUDING DataSourceModifyOperation.targetDataSource.VALUE.columns.CHILDREN.name.VALUE"]
   set index [lsearch -exact $columns $columnName]
   if [equal $index -1] {
    return "Die Referenz auf die Spalte stammt nicht aus der referenzierten DataSourceDB"
   }
  }
  return ""
}

checkutil::addCheck LimitDataSource.sourceDataSouce {
  set className [c::getClassName "$value"]

  if [equal $className "LimitDataSource"] {
   return "Die Quelle einer LimitDataSource darf keine LimitDataSource sein!"
  }
  return ""
}
proc getColumnNamesFromCondition {objId} {
  set className [c::getClassName "$objId"]
  if [equal $className "BinaryExpression"] {

    set leftOperand [c::getList "$objId.leftOperand.CHILDREN"]
    set rightOperand [c::getList "$objId.rightOperand.CHILDREN"]
    if ![nullptr leftOperand] {
      if ![nullptr rightOperand] {
       return [concat [getColumnNamesFromCondition [lindex $leftOperand 0]] " " [getColumnNamesFromCondition [lindex $rightOperand 0]]]
     }
    }
  }
  if [equal $className "ColumnValueExpression"] {

   return [c::get "$objId.column.VALUE.name.VALUE"]
  }
  return ""
}

checkutil::addCheck LimitDataSource {
 set formalParams [c::getList "$obj.formalParameters.CHILDREN.name.VALUE"]
 set minRow [c::getList "$obj.minRow.CHILDREN"]
 set maxRow [c::getList "$obj.maxRow.CHILDREN"]


 if ![nullptr $minRow] {
   if ![nullptr $maxRow] {
    set  min [lindex $minRow 0]
    set max [lindex $maxRow 0]
    set params [concat [getParameterNamesFromRow $min ] " " [getParameterNamesFromRow $max]]
  
    foreach {listEntry} $params {
    set index [lsearch -exact $formalParams $listEntry]
    if [equal $index -1] {
     return "Formale Parameter von MinRow/MaxRow der LimitDataSource mssen sich auf die formalen Parameter der LimitDataSource beziehen"
    }
    }
   }
 }
 return ""
}

proc getParameterNamesFromRow {objId} {
  set className [c::getClassName "$objId"]

  if [equal $className "BinaryExpression"] {

    set leftOperand [c::getList "$objId.leftOperand.CHILDREN"]
    set rightOperand [c::getList "$objId.rightOperand.CHILDREN"]

    if ![nullptr $leftOperand] {
      if ![nullptr $rightOperand] {
        return [concat [getParameterNamesFromRow [lindex $leftOperand 0]] " " [getParameterNamesFromRow [lindex $rightOperand 0]]]

     }
    }
  }
  if [equal $className "ParameterValueExpression"] {

    return [c::get "$objId.parameter.VALUE.name.VALUE"]

  }
  return ""
}


proc getColumnNames {objId} {
 set className [c::getClassName "$objId"]
 if [equal $className "DataSourceJoin"] {
   return [concat [getColumnNames [c::get "$objId.dataSource1.VALUE"]] " " [getColumnNames [c::get "$objId.dataSource2.VALUE"]]]
 }
 if [ equal $className "DataSourceDB"] {
  set columnList [c::getList "$objId.columns.CHILDREN"]
  set columns ""
  foreach {listEntry} $columnList {
    set name [c::get "$listEntry.name.VALUE"]
     set columns [concat $columns $name]
  }
  return "$columns"
 }
 return ""
}

checkutil::addCheck DataSourceFilter.dataSource {
  if ![nullptr $value] {
   if [c::nodeIsSubtypeOf $value DataSourceFilter] {
   	return "Als Datenquelle darf kein Filter angegeben werden!"
   }
  }
  return ""
}

checkutil::addCheck DataSourceFilter.column {

	if ![nullptr $value] {
	  set columnDatasource [c::get "$value.INCLUDING DataSourceDB"]
	  set connectedDatasource [c::get "$obj.INCLUDING DataSourceFilter.dataSource.VALUE"]
	  if ![nullptr $connectedDatasource] {
	   if ![equal $columnDatasource $connectedDatasource] {
	   return "Spalte mu aus der verbundenen Datenquelle stammen."
	   }
	}
      }

	return ""
}
