set body  	"font-family Arial \
             font-style italic \
             background-color #E0E0E0 \
             font-size 12 \
             color blue"


set h    	"font-family Arial \
             font-style italic \
             font-size 12 \
             color blue \
             background-color #E0E0E0"


set p       "font-family Arial \
             font-style italic \
             font-size 12 \
             color blue \
             background-color #E0E0E0"


set table  "font-family Arial \
		    font-style italic \
			font-size 12 \
			color blue \
			background-color #E0E0E0 \
			margin-top 1 \
			margin-bottom 1 \
			margin-left 1 \
			margin-right 1 \
	  		border-width 1 \
	   		border-style solid \
			border-spacing 5"


set td 		"vertical-align top \
  		 	 background-color #E0E0E0"


set tr 		"background-color #E0E0E0"


set div 	"margin-top 1 \
			 margin-bottom 1 \
			 margin-left 1 \
			 margin-right 1 \
             border-width 1 \
             border-style solid \
             border-color red \
      		 background-color #E0E0E0 "


proc synchook::StyleSheetPair {obj} {
    set attribute [c::get "$obj.attribute.VALUE"]
    set category [c::get "$obj.category.VALUE"]
    set valueCategory [c::get "$obj.valueCategory.VALUE"]
    set valueObject [c::get "$obj.value"]
    set file [c::getRoot $obj]
    set valueObjectList [c::getList $obj.value.CHILDREN]

    if {$category == "Custom"} {
      set valueClass [getValueCategoryClass $valueCategory]
    } {
      set valueClass [getValueClass $attribute]
    }

    if { [empty $valueObjectList] } {
      edit::insert [c::icBelow $valueObject] [edit::createObject $valueClass $file]
    } elseif {[c::getClassName $valueObjectList] != "$valueClass"} {
    	edit::delete $valueObjectList
    	edit::insert [c::icBelow $valueObject] [edit::createObject $valueClass $file]
    } else {
    #"Do nothing"
    }
 }


proc synchook::Table {obj} {
    set rowList    [c::get $obj.rows]
    set columnList [c::get $obj.columns]
    set file [c::getRoot $obj]

    ### 1. There must be at least one row
    if { [empty [c::getList $obj.rows.CHILDREN]] } {
        edit::insert [c::icBelow $rowList] [edit::createObject TableRow $file]
    }

    ### 2. There must be at least one column
    if { [empty [c::getList $obj.columns.CHILDREN]] } {
        edit::insert [c::icBelow $columnList] [edit::createObject TableColumn $file]
    }
}


proc synchook::TableRow {obj} {
    ### Enforce correct structure of table

    set defList [c::get "$obj.INCLUDING Table.columns"]
    set repList [c::get "$obj.cells"]

    syncutil::createMissing $defList $repList columnRef createMissingTableCell
    syncutil::deleteSuperfluous $defList $repList columnRef
    syncutil::order $defList $repList columnRef
}


proc createMissingTableCell {formalParameter} {
    set file [c::getRoot $formalParameter]
    return [edit::createObject TableCell $file]
}


proc edithook::create_Table {obj} {
    ### Initialize Table: Create a 1x2 structure

    set rowList    [c::get $obj.rows]
    set columnList [c::get $obj.columns]
    set file [c::getRoot $obj]

    edit::insert [c::icBelow $rowList] [edit::createObject TableRow $file]
    edit::insert [c::icBelow $columnList] [edit::createObject TableColumn $file]
    edit::insert [c::icBelow $columnList] [edit::createObject TableColumn $file]
}


proc edithook::create_FormularRadioGroupElement {obj} {
    set destination    [c::get $obj.elements]
    set file [c::getRoot $obj]

     edit::insert [c::icBelow $destination] [edit::createObject FormularRadioElement $file]
     edit::insert [c::icBelow $destination] [edit::createObject FormularRadioElement $file]
}


rename edit::setValue oldSetValue

proc edit::setValue {obj value} {

    oldSetValue $obj $value

    if [equal [c::getContext $obj] HtmlStyleSheetBlock.name] {
        set file [c::getRoot $obj]
        set pairs  [c::get $obj.PARENT.pairs]

        set pairsList [c::getList $obj.PARENT.pairs.CHILDREN]
        foreach {listEntry} $pairsList {
            edit::delete $listEntry
        }

		if {$value == "body"} {
            foreach {attr value} $::body {
            	### create pair and add to list
            	addPair $obj $attr $value
            }
		} elseif {$value == "p"} {
			foreach {attr value} $::p {
             	### create pair and add to list
            	addPair $obj $attr $value
 			}
		} elseif {$value == "h1" || $value == "h2" || $value == "h3" || $value == "h4" || $value == "h5" || $value == "h6"} {
			foreach {attr value} $::h {
            	### create pair and add to list
            	addPair $obj $attr $value
 			}
		} elseif {$value == "table"} {
			foreach {attr value} $::table {
             	### create pair and add to list
            	addPair $obj $attr $value
 			}
		} elseif {$value == "td"} {
			foreach {attr value} $::td {
            	### create pair and add to list
            	addPair $obj $attr $value
 			}
		} elseif {$value == "tr"} {
			foreach {attr value} $::tr {
             	### create pair and add to list
            	addPair $obj $attr $value
 			}
		} elseif {$value == "div"} {
			foreach {attr value} $::div {
            	### create pair and add to list
            	addPair $obj $attr $value
 			}
		}
    }
}

proc addPair {obj attr value} {
	# adds a new StyleSheetPair to the StyleSheetBlock

    set file [c::getRoot $obj]
    set pairs  [c::get $obj.PARENT.pairs]

    set pair [edit::createObject StyleSheetPair $file]
    edit::insert [c::icBelow $pairs] $pair

    ### set attribute
    set pair_attr [c::get $pair.attribute]
    oldSetValue $pair_attr $attr

    synchook::StyleSheetPair $pair
	setPairValue $pair $value
}


proc setPairValue {obj value} {
	# sets the value attr. of StyleSheetPair objects

    set valueObject [c::getList "$obj.value.CHILDREN"]

    if {[equal [c::getContext $valueObject] SizeValue]} {
    	# size
        edit::setValue [c::get $valueObject.value] $value
        # measure pt
	    edit::setValue [c::get $valueObject.measure] "pt"
	   	edit::setValue [c::get $obj.category] "none"
	} elseif  {[equal [c::getContext $valueObject] StyleValue]} {
		# style
        edit::setValue [c::get $valueObject.style] $value
	   	edit::setValue [c::get $obj.category] "Font"
	} elseif  {[equal [c::getContext $valueObject] FamilyValue]} {
		# family
        edit::setValue [c::get $valueObject.family] $value
	   	edit::setValue [c::get $obj.category] "Font"
	} elseif  {[equal [c::getContext $valueObject] ColorValue]} {
		# color
		edit::setValue [c::get $valueObject.color] $value
	   	edit::setValue [c::get $obj.category] "Color"
	} elseif  {[equal [c::getContext $valueObject] AlignmentValue]} {
		# alignment
		edit::setValue [c::get $valueObject.alignment] $value
	   	edit::setValue [c::get $obj.category] "none"
	} elseif  {[equal [c::getContext $valueObject] HeadingValue]} {
		# heading
		edit::setValue [c::get $valueObject.heading] $value
	   	edit::setValue [c::get $obj.category] "none"
	} elseif  {[equal [c::getContext $valueObject] ListValue]} {
		# listed
		edit::setValue [c::get $valueObject.listed] $value
	   	edit::setValue [c::get $obj.category] "none"
	}
}

proc isLimitDataSource {objId} {
 set dataSource [c::get "$objId.dataSource.VALUE"]
 if ![nullptr $dataSource] {
   set className [c::getClassName "$dataSource"]
  if [equal $className "LimitDataSource"] {
   return true
  } {
   return false
  }
 }
 return false
}

proc getJoinQuery {startDataSource} {
 set className [c::getClassName $startDataSource]
 if [equal $className "DataSourceJoin"] {
   set dataSource1 [c::get "$startDataSource.dataSource1.VALUE"]
   set dataSource2 [c::get "$startDataSource.dataSource2.VALUE"]

   if ![nullptr $dataSource1] {
     if ![nullptr $dataSource2] {

       set d1className [c::getClassName $dataSource1]
       set d2className [c::getClassName $dataSource2]
       if [equal $d1className "DataSourceJoin"] {
        if [equal $d2className "DataSourceJoin"] {
         return [concat [getJoinQuery $dataSource1] " AND " [getJoinQuery $dataSource2]]
	 }
       } {
        if [equal $d1className "DataSourceDB"] {
          if [equal $d2className "DataSourceDB"] {
	   set columnRef1 [c::get "$startDataSource.columnRef1.VALUE"]
	   set columnRef1Name [c::get "$startDataSource.columnRef1.VALUE.name.VALUE"]
	   set columnRef1Table [c::get "$columnRef1.INCLUDING DataSourceDB.name.VALUE"]
	   set columnRef2 [c::get "$startDataSource.columnRef2.VALUE"]
	   set columnRef2Name [c::get "$startDataSource.columnRef2.VALUE.name.VALUE"]
	   set columnRef2Table [c::get "$columnRef2.INCLUDING DataSourceDB.name.VALUE"]
	   return [concat [c::get "$dataSource1.name.VALUE"] " " [c::get "$startDataSource.joinOperator.VALUE"]  " "  [c::get "$dataSource2.name.VALUE"] " ON $columnRef1Table.$columnRef1Name = $columnRef2Table.$columnRef2Name"]
	  }
	}

       }
     }
   }


 }

 if [equal $className "DataSourceDB"] {
   return [c::get "$startDataSource.name.VALUE"]
 }

}

proc traverseConditionTree {objId} {

 set className [c::getClassName $objId]
 if [ equal $className "BinaryExpression" ] {
  set left [c::getList "$objId.leftOperand.CHILDREN"]
  set right [c::getList "$objId.rightOperand.CHILDREN"]
  set operator [c::get "$objId.operator.VALUE"]
  if ![nullptr $left] {
   if ![nullptr $right] {
     set query [ concat "(" [traverseConditionTree $left] $operator [traverseConditionTree $right] ")" ]
     return $query
   }
  }
 return ""
 }

 if [equal $className "ColumnValueExpression" ] {
      set column [c::get "$objId.column.VALUE.name.VALUE"]
      set columnObj [c::get "$objId.column.VALUE"]
      set dataSource [c::get "$columnObj.INCLUDING DataSourceDB.name.VALUE"]
   if ![nullptr $column] {
    return "$dataSource.$column"
    } {
      return ""
    }
 }

 if [equal $className "ConstantExpression"] {
  set typeClassList [c::getList "$objId.type.CHILDREN"]
  set length [llength  typeClassList]
  if [ expr  $length > 0 ] {

    set typeClass [lindex $typeClassList 0]
    set typeClassName [c::getClassName $typeClass]
    if [equal $typeClassName "DBString"] {
      return [concat "'" [c::get "$objId.value.VALUE"] "'"]
    }
  }
  return [c::get "$objId.value.VALUE"]
 }


 if [equal $className "ParameterValueExpression"] {
   set formalParameter [c::get "$objId.parameter.VALUE.name.VALUE"]
   if ![nullptr $formalParameter] {
   set fParam [c::get "$objId.parameter.VALUE"]
    set typeClassList [c::getList "$fParam.type.CHILDREN"]
    set typeClass [lindex $typeClassList 0]
    set typeClassName [c::getClassName $typeClass]
     if [equal $typeClassName "DBString"] {
      return "'\".\$$formalParameter.\"'"
     } {
       return "\".\$$formalParameter.\""
     }
   } {
    return ""
   }
 }

 if [equal $className "ComputationExpression"] {
   set column [c::get "$objId.column.VALUE.name.VALUE"]
   set columnObj [c::get "$objId.column.VALUE"]
   if ![nullptr $column] {
     set computation [c::get "$objId.computation.VALUE"]
     return [transformComputation $column $computation $columnObj]
    } {
      return ""
    }
 }

}

proc transformComputation { column computation columnObj} {
   set dataSource  [c::get "$columnObj.INCLUDING DataSourceDB.name.VALUE"]
	if [equal $computation "SUM"] {
	 return "SUM($dataSource.$column)"
        }

	if [equal $computation "AVG"] {
	 return "AVG($dataSource.$column)"
        }

	if [equal $computation "COUNT"] {
	 return "COUNT($dataSource.$column)"
        }

	if [equal $computation "MAX"] {
	 return "MAX($dataSource.$column)"
        }

	if [equal $computation "MIN"] {
	 return "MIN($dataSource.$column)"
        }
        return "$dataSource.$column"
}

proc getUpdateQuery {objId} {
  set valuesList [c::getList "$objId.values.CHILDREN"]
  set valuesLength [llength $valuesList]
  set values  ""
  set counter 1
  set condition [lindex [c::getList "$objId.conditions.CHILDREN"] 0]

  foreach {listEntry} $valuesList {

   set expression [c::getList "$listEntry.expression.CHILDREN"]
   set exprLength [llength $expression]
   if [expr $exprLength > 0] {
   set class [c::getClassName $expression]
   if [equal $class "ConstantExpression"] {
        set name [c::get "$expression.value.VALUE"]
	set typeList [c::getList "$expression.type.CHILDREN"]
	set typeListLength [llength $typeList]
	set columnRef [c::get "$listEntry.column.VALUE.name.VALUE"]
	set columnObj [c::get "$listEntry.column.VALUE"]
	set connectedDataSource [c::get "$columnObj.INCLUDING DataSourceDB.name.VALUE"]
	if [expr $typeListLength > 0] {
          set typeClassName [c::getClassName [lindex $typeList 0]]
           if [equal $typeClassName "DBString"] {
	    set values [concat $values "$connectedDataSource.$columnRef='" $name "'"]
	   } {
         set values [concat $values "$connectedDataSource.$columnRef=" $name ]
	 }
        } {
	    set values [concat $values "$connectedDataSource.$columnRef=" $name ]
	}

   }
   if [equal $class "ParameterValueExpression"] {
      set formalParameter [c::get "$expression.parameter.VALUE"]
      if ![nullptr $formalParameter] {
        set name [c::get "$formalParameter.name.VALUE"]
	set columnRef [c::get "$listEntry.column.VALUE.name.VALUE"]
	set columnObj [c::get "$listEntry.column.VALUE"]
	set connectedDataSource [c::get "$columnObj.INCLUDING DataSourceDB.name.VALUE"]
	set typeList [c::getList "$formalParameter.type.CHILDREN"]
	set typeListLength [llength $typeList]


        set values [concat $values "$connectedDataSource.$columnRef=\$$name"]
     }
   }
  }

  if ![equal $valuesLength $counter] {
    set values [concat $values ","]
  }
  set counter [expr $counter + 1]
 }
  set targetDataSource [c::get "$objId.targetDataSource.VALUE"]
  set target "N/A"
  if ![nullptr $targetDataSource] {
    set target [c::get "$targetDataSource.name.VALUE"]
  }

 # set whereCondition ""
 # set length [llength $condition]
 # if ![equal [llength $condition] 0] {
 #  set $whereCondition [traverseConditionTree $condition]
 # }
  set query [concat "update " $target " set " $values "where " [traverseConditionTree $condition]]
 return $query
}

proc getSelectQuery {objId} {
 ## Wir haben einen DataSourceProjectionFilter
   set condition [lindex [c::getList "$objId.condition.CHILDREN"] 0]
   set projectionColumns [c::getList "$objId.projectionColumns.CHILDREN"]
   set counter 1
   set projectionString ""
   foreach {listEntry} $projectionColumns {

	set class [c::getClassName $listEntry]
	if [equal $class "ColumnProjection"] {
	 set name [c::get "$listEntry.column.VALUE.name.VALUE"]
	 set columnObj [c::get "$listEntry.column.VALUE"]
	 set connectedDataSource [c::get "$columnObj.INCLUDING DataSourceDB.name.VALUE"]
         set projectionString [concat $projectionString "$connectedDataSource.$name"]
	}

	if [equal $class "ComputationProjection"] {
            set column [c::get "$listEntry.column.VALUE.name.VALUE"]
            set columnObj [c::get "$listEntry.column.VALUE"]

	    set transformation [transformComputation $column [c::get "$listEntry.computation.VALUE"]  $columnObj]
	    set projectionString [concat $projectionString $transformation]

	}
        set projLength [llength $projectionColumns]
	if ![equal $projLength $counter] {
	  set projectionString [concat $projectionString ","]
	}

	set counter [expr $counter + 1]

   }
   set sourceDataSource "N/A"
   if ![nullptr [c::get "$objId.sourceDataSource"]] {
   set sourceDataSource [ getJoinQuery [c::get "$objId.sourceDataSource.VALUE"]]
   }
   set query [concat "select " $projectionString " from " $sourceDataSource " where " [traverseConditionTree $condition] ]
  return $query
}

proc getInsertQuery {objId} {
  ## Wir haben einen DataSourceInsert
  set valuesList [c::getList "$objId.values.CHILDREN"]
  set valuesLength [llength $valuesList]
  set values  ""
  set counter 1

  foreach {listEntry} $valuesList {

   set expression [c::getList "$listEntry.expression.CHILDREN"]
   set exprLength [llength $expression]
   if [expr $exprLength > 0] {
   set class [c::getClassName $expression]
   if [equal $class "ConstantExpression"] {

	set name [c::get "$expression.value.VALUE"]
	set typeList [c::getList "$expression.type.CHILDREN"]
	set typeListLength [llength $typeList]
	if [expr $typeListLength > 0] {
        set typeClassName [c::getClassName [lindex $typeList 0]]
         if [equal $typeClassName "DBString"] {
	  set values [concat $values "'" $name "'"]
	 }
      } {
         set values [concat $values $name ]
      }
   }
   if [equal $class "ParameterValueExpression"] {
      set formalParameter [c::get "$expression.parameter.VALUE"]

     if ![nullptr $formalParameter] {
        set name [c::get "$formalParameter.name.VALUE"]
	set typeList [c::getList "$formalParameter.type.CHILDREN"]
	set typeListLength [llength $typeList]


        set values [concat $values "'\$$name'"]
     }
   }
  }

  if ![equal $valuesLength $counter] {
    set values [concat $values ","]
  }
  set counter [expr $counter + 1]
 }
  set targetDataSource [c::get "$objId.targetDataSource.VALUE"]
  set target "N/A"
  if ![nullptr $targetDataSource] {
    set target [c::get "$targetDataSource.name.VALUE"]
  }
  set query [concat "insert into " $target " values( " $values ")"]
  return $query
}


proc getDeleteQuery {objId} {
 set condition [lindex [c::getList "$objId.conditions.CHILDREN"] 0]
 set targetDataSource [c::get "$objId.targetDataSource.VALUE"]
  set target "N/A"
  if ![nullptr $targetDataSource] {
    set target [c::get "$targetDataSource.name.VALUE"]
  }
 if ![nullptr condition] {
  set query [concat "delete from " $target " where " [traverseConditionTree $condition] ]
  } {
   set query [concat "delete from " $target]
  }
  return $query
}

proc getLimitQuery {objId} {

 set minCondition [lindex [c::getList "$objId.minRow.CHILDREN"] 0]
 set maxCondition [lindex [c::getList "$objId.maxRow.CHILDREN"] 0]

 set minString [traverseConditionTree $minCondition]
 set maxString [traverseConditionTree $maxCondition]

 set sourceDataSource [c::get "$objId.sourceDataSouce.VALUE"]
 set className [c::getClassName $sourceDataSource]

 if [equal $className "DataSourceDB"] {
  set dataSourceName [c::get "$sourceDataSource.name.VALUE"]
  return "select * from $dataSourceName Limit $minString, $maxString"
 }

 if [equal $className "DataSourceProjectionFilter"] {
  set query [getSelectQuery $sourceDataSource]
  return "$query Limit $minString, $maxString"
 }
 return ""
}



proc getSQLQuery {objId} {
 set className [c::getClassName $objId]
 if [equal $className "DataSourceProjectionFilter"] {
   ## Wir haben einen DataSourceProjectionFilter
   set query [ getSelectQuery $objId ]
  }

 if [equal $className "DataSourceInsert"] {
  ## Wir haben einen DataSourceInsert
  set query [getInsertQuery $objId]
 }

  if [equal $className "DataSourceUpdate"] {
  ## Wir haben einen DataSourceUpdate
  set query [getUpdateQuery $objId]
  }

  if [equal $className "DataSourceDelete"] {
  ## Wir haben einen DataSourceDelete
  set query [getDeleteQuery $objId]
  }

  if [equal $className "LimitDataSource"] {
  ## Wir haben einen LimitDataSource
  set query [getLimitQuery $objId]
  }

 return $query
}

proc getAttribute {obj} {

    set valueObject [c::getList "$obj.value.CHILDREN"]
    set category [c::get $obj.category]

    if {[equal category Padding]} {
        # size
	return "padding-"
    }
}


proc getErrorLink {objId} {
	set className [c::getClassName $objId]

	if [equal $className "WebPage"] {
		set webzone_obj  [c::get $objId.PARENT.PARENT]
		set error_link_obj [c::get $webzone_obj.errorLink.VALUE]
		if ![nullptr $error_link_obj] {
			set link_name [c::get $error_link_obj.name.VALUE]
			return $link_name
		}
	}

	return ""
}


proc getRoles {objId} {
    set roleList ""
    set roles [c::getList "$objId.roles.CHILDREN"]
    foreach {listEntry} $roles {
        set roleList [concat $roleList [c::get $listEntry.role.VALUE.name.VALUE]]
    }
	return $roleList
}


#proc synchook::ProcedureCall {obj} {
 # set connectedProcedure [c::get "$obj.procedure.VALUE"]
 # if ![nullptr $connectedProcedure] {
 #    set portList [c::getList "$connectedProcedure.interface.CHILDREN"]
 #    set interfacePorts [c::getList "$obj.ports.CHILDREN"]
 #    set portListLength [llength $portList]
 #    set interfacePortsLength [llength $interfacePorts]
#
#     if ![equal $portListLength $interfacePortsLength] {
	## erst Objekte lschen
#	foreach {listEntry} $interfacePorts {
	# edit::delete $listEntry
#	}
#     	set interfacePorts [c::get $obj.ports]
#     	foreach {listEntry} $portList {
#       		set file [c::getRoot $obj]
#		set object [edit::createObject SubComponentPort $file]
#       		edit::insert [c::icBelow $interfacePorts] $object
#		set objectReference [c::get "$object.definition"]
#		edit::setValue $objectReference $listEntry
#
 #    	}
 #    }
 #   }
#}

proc synchook::FormularCondition {obj} {
    if [nullptr [c::get {$obj.condition.VALUE}]] {
        return
    }
    set defList [c::get {$obj.condition.VALUE.params}]
    set repList [c::get {$obj.params}]

    syncutil::createMissing $defList $repList formalparam createMissingParameter
    syncutil::deleteSuperfluous $defList $repList formalparam
    syncutil::order $defList $repList formalparam
}

proc createMissingParameter {definition} {
        return [edit::createObject FormularConditionActualParam [edit::getFile $definition]]
}


proc synchook::Formular {obj} {
    if [nullptr [c::get {$obj.action.VALUE}]] {
        return
    }
    set defList [c::get {$obj.action.VALUE.formalParameter}]
    set repList [c::get {$obj.actualParams}]

    syncutil::createMissing $defList $repList formalParam createMissingWebnodeActualParam
    syncutil::deleteSuperfluous $defList $repList formalParam
    syncutil::order $defList $repList formalParam
}

proc createMissingWebnodeActualParam {definition} {
        return [edit::createObject WebNodeActualParam [edit::getFile $definition]]
}


proc synchook::ActionHandler {obj} {
    if { [nullptr [c::get {$obj.targetpage.VALUE}]] } return

    set defList [c::get {$obj.targetpage.VALUE.formalParameter}]
    set repList [c::get {$obj.params}]

    syncutil::createMissing $defList $repList formalParam createMissingWebnodeActualParam
    syncutil::deleteSuperfluous $defList $repList formalParam
    syncutil::order $defList $repList formalParam
}

proc createMissingWebnodeActualParam {definition} {
        return [edit::createObject WebNodeActualParam [edit::getFile $definition]]
}


proc getWebpageName {objId} {
 set webpage [c::get "$objId.INCLUDING WebPage.name.VALUE"]
 if ![nullptr $webpage] {
  return $webpage
 } {
  return "undefined"
 }
}

proc getRoleList {objId} {
	set className [c::getClassName $objId]
	
 	if [equal $className "WebPage"] {
 		set webzone_obj  [c::get $objId.PARENT.PARENT]
 		
 		# special case: free zones gets an complete empty permission_list	
		set roles [getRoles $webzone_obj]			

		if [equal $roles ""] {
			# free zone
			set roleList ""
		} else {
        	set roleList [getRoleList $webzone_obj]
        }
 	} else {
      		if {[equal $className "SubWebZone"] || [equal $className "RootWebZone"]} {
	      		set roleList [getRoles $objId]
	      		
	           	# go down
	           	set target_list [c::getList $objId.webTargets.CHILDREN]
       			 foreach {listEntry} $target_list {
                	set name [c::getClassName $listEntry]
       				if {[equal $name "SubWebZone"] || [equal $name "RootWebZone"]} {
                 		set roleList [concat $roleList [getRoleList $listEntry]]
                 	} 
        		}
	        } else {   # no webzone!
				set roleList ""
	        }
  	}
	return $roleList
}

proc getStyleSheetBlock {objId} {
	set StyleSheetBlock [c::getOrNull "$objId.styleSheetBlock.VALUE"]
	if ![nullptr $StyleSheetBlock] {
		set StyleSheetBlock [c::getOrNull "$StyleSheetBlock.name.VALUE"]
		return $StyleSheetBlock
	} else {
		return ""
	}
}

proc copyFile {src_file dst_dir} {
	if [file exists $src_file] {
		file copy -force $src_file $dst_dir
	}
}
