

namespace eval outputDirectory {}

set outputDirectory::lastSelection "."


proc outputDirectory::copyFixFiles {dest} {
  set fixCode [file join $::main::appHome "fixCode"]
  foreach file [glob $fixCode/*] {
        file copy -force $file $dest
  }
}


proc outputDirectory::getOutputDirectory {} {
  variable lastSelection
  set dir [tk_chooseDirectory -title "Select output directory" -initialdir $lastSelection]
  if {$dir == ""} {
    return ""
  }
  set lastSelection $dir
  if {[file exists $dir] && ![file isdirectory $dir]} {
    tk_messageBox -title "Error" -message "File exists but is no directory"
    return ""
  }
  if {![file exists $dir]} {
    if [catch {
      file mkdir $dir
    }] {
      tk_messageBox -title "Error" -message "Can't create directory"
      return ""
    }
  }
  copyFixFiles $dir
  return $dir
}
