
namespace eval ::checkFkt {}


proc checkFkt::range {a b x} {
    if ![expr $a <= $x && $x <= $b] {
        return [i18n::text "Value must be in range %s..%s" $a $b]
    }
    return ""
}


proc checkFkt::greaterOrEqual {p1 x} {
    if ![expr $x >= p1] {
        return [i18n::text "Value must be greater or equal %s" $p1]
    }
    return ""
}


proc checkFkt::lessOrEqual {p1 x} {
    if ![expr $x <= p1] {
        return [i18n::text "Value must be less or equal %s" $p1]
    }
    return ""
}


proc checkFkt::regexp {pattern x} {
    if ![::regexp "^${pattern}\$" $x] {
        return [i18n::text "Value must match the regular expression '%s'" $pattern]
    }
    return ""
}


proc checkFkt::cIdent {x} {
    return [regexp {[A-Za-z_][A-Za-z0-9_]*} $x]
}


proc checkFkt::pointInside {a b c d val} {
    if ![vec::isInside $val "$a $b $c $d"] {
        return [i18n::text "Point must be inside of the region %s." "$a $b $c $d"]
    }
    return ""
}


proc checkFkt::stdPoint {val} {
    return [pointInside 0 0 1000 1000 $val]
}


proc checkFkt::endsWith {string x} {
    if ![::regexp "$string\[0-9\]*\$" $x] {
        return [i18n::text "Value must end with '%s'" $string]
    }
    return ""
}
