
namespace eval clipboard {
    set data(obj) ""
}


proc clipboard::cut {elem} {
    variable data
    change::extract $elem
    set data(obj) $elem
    set data(copy) 0
}


proc clipboard::copy {elem} {
    variable data
    set data(obj) [change::copy $elem [change::getFile $elem]]
    set data(copy) 1
}


proc clipboard::mark {elem} {
    variable data
    set data(obj) $elem
    set data(copy) 0
}


proc clipboard::linkExternalReferences {node} {
    # Die Referenzen des Teilbaums $node, die in die falsche Datei zeigen,
    # werden "intelligent" angepasst.
    
    if [c::isReference $node] {
        set file [d::getFile $node]
        set oldDest [c::getValue $node]
        if { ![nullptr $oldDest] && ![equal [d::getFile $oldDest] $file] } {
            if ![basiccomp::findByFullName $file [basiccomp::getFullName $oldDest] -var newDest] {
                set newDest 0x0
            }
            change::setValue $node $newDest
        }
    }
    foreach sub [c::getSubElements $node] {
        linkExternalReferences $sub
    }        
}


proc clipboard::paste {insContext} {
    variable data
    if $data(copy) {
        set inserted [change::copy $data(obj) [change::getFile $insContext]]
        edit::insert $insContext $inserted
        linkExternalReferences $inserted
    } else {
        if [equal [change::getFile $data(obj)] [change::getFile $insContext]] {
            set inserted [change::copy $data(obj) [change::getFile $insContext]]
        } else {
            set inserted $data(obj)
        }
        edit::insert $insContext $inserted
        linkExternalReferences $inserted
        set data(obj) ""
    }
    return $inserted
}


proc clipboard::canPaste {insContext} {
    variable data
    if [empty $data(obj)] {
        return 0
    }
    return [c::isSubtypeOf [c::getTypeId $data(obj)] [edit::getAcceptedType $insContext]]
}
