
/* definition of tree node structure */

#ifndef NODE_H
#define NODE_H
#include "err.h"
#include "nodeptr.h" /* defines NODEPTR */
#include "HEAD.h"

#ifdef MONITOR
#define _NODECOMMON int _prod; POSITION _coord;
#else
#define _NODECOMMON int _prod;
#endif
struct NODEPTR_struct {
        _NODECOMMON
#ifdef __cplusplus
        void* operator new(size_t size);
#endif
};

typedef struct _TSVIEWROOT* _TSPVIEWROOT;
typedef struct _TScodeGen_Root* _TSPcodeGen_Root;
typedef struct _TScodeGen_DataSourceDB* _TSPcodeGen_DataSourceDB;
typedef struct _TScodeGen_DataSourceDB_name* _TSPcodeGen_DataSourceDB_name;
typedef struct _TScodeGen_DataSourceDB_position* _TSPcodeGen_DataSourceDB_position;
typedef struct _TScodeGen_DataSourceDB_columns* _TSPcodeGen_DataSourceDB_columns;
typedef struct _TScodeGen_DBColumn* _TSPcodeGen_DBColumn;
typedef struct _TScodeGen_DataBase* _TSPcodeGen_DataBase;
typedef struct _TScodeGen_DataBase_name* _TSPcodeGen_DataBase_name;
typedef struct _TScodeGen_DataBase_userName* _TSPcodeGen_DataBase_userName;
typedef struct _TScodeGen_DataBase_userPassword* _TSPcodeGen_DataBase_userPassword;
typedef struct _TScodeGen_DataBase_hostName* _TSPcodeGen_DataBase_hostName;
typedef struct _TScodeGen_DataBase_port* _TSPcodeGen_DataBase_port;
typedef struct _TScodeGen_DataBase_dataBaseType* _TSPcodeGen_DataBase_dataBaseType;
typedef struct _TScodeGen_DataBase_dataSources* _TSPcodeGen_DataBase_dataSources;
typedef struct _TScodeGen_DataBase_dataSourceModifications* _TSPcodeGen_DataBase_dataSourceModifications;
typedef struct _TScodeGen_DataBase_setSize* _TSPcodeGen_DataBase_setSize;
typedef struct _TScodeGen_DataBase_modifySetSize* _TSPcodeGen_DataBase_modifySetSize;
typedef struct _TScodeGen_DataSourceJoin* _TSPcodeGen_DataSourceJoin;
typedef struct _TScodeGen_LimitDataSource* _TSPcodeGen_LimitDataSource;
typedef struct _TScodeGen_DataSourceProjectionFilter* _TSPcodeGen_DataSourceProjectionFilter;
typedef struct _TScodeGen_DataSourceDelete* _TSPcodeGen_DataSourceDelete;
typedef struct _TScodeGen_DataSourceUpdate* _TSPcodeGen_DataSourceUpdate;
typedef struct _TScodeGen_DataSourceInsert* _TSPcodeGen_DataSourceInsert;
typedef struct _TScodeGen_DBColumn_name* _TSPcodeGen_DBColumn_name;
typedef struct _TScodeGen_DBColumn_type* _TSPcodeGen_DBColumn_type;
typedef struct _TScodeGen_DBBlob* _TSPcodeGen_DBBlob;
typedef struct _TScodeGen_DBBoolean* _TSPcodeGen_DBBoolean;
typedef struct _TScodeGen_DBTimeStamp* _TSPcodeGen_DBTimeStamp;
typedef struct _TScodeGen_DBDate* _TSPcodeGen_DBDate;
typedef struct _TScodeGen_DBBigInt* _TSPcodeGen_DBBigInt;
typedef struct _TScodeGen_DBDouble* _TSPcodeGen_DBDouble;
typedef struct _TScodeGen_DBFloat* _TSPcodeGen_DBFloat;
typedef struct _TScodeGen_DBInteger* _TSPcodeGen_DBInteger;
typedef struct _TScodeGen_DBString* _TSPcodeGen_DBString;
typedef struct _TScodeGen_DataSourceProjectionFilter_name* _TSPcodeGen_DataSourceProjectionFilter_name;
typedef struct _TScodeGen_DataSourceProjectionFilter_position* _TSPcodeGen_DataSourceProjectionFilter_position;
typedef struct _TScodeGen_DataSourceProjectionFilter_sourceDataSource* _TSPcodeGen_DataSourceProjectionFilter_sourceDataSource;
typedef struct _TScodeGen_DataSourceProjectionFilter_condition* _TSPcodeGen_DataSourceProjectionFilter_condition;
typedef struct _TScodeGen_DataSourceProjectionFilter_formalParameters* _TSPcodeGen_DataSourceProjectionFilter_formalParameters;
typedef struct _TScodeGen_DataSourceProjectionFilter_projectionColumns* _TSPcodeGen_DataSourceProjectionFilter_projectionColumns;
typedef struct _TScodeGen_ComputationExpression* _TSPcodeGen_ComputationExpression;
typedef struct _TScodeGen_ParameterValueExpression* _TSPcodeGen_ParameterValueExpression;
typedef struct _TScodeGen_ColumnValueExpression* _TSPcodeGen_ColumnValueExpression;
typedef struct _TScodeGen_ConstantExpression* _TSPcodeGen_ConstantExpression;
typedef struct _TScodeGen_UnaryExpression* _TSPcodeGen_UnaryExpression;
typedef struct _TScodeGen_BinaryExpression* _TSPcodeGen_BinaryExpression;
typedef struct _TScodeGen_DataSourceFormalParam* _TSPcodeGen_DataSourceFormalParam;
typedef struct _TScodeGen_ComputationProjection* _TSPcodeGen_ComputationProjection;
typedef struct _TScodeGen_ColumnProjection* _TSPcodeGen_ColumnProjection;
typedef struct _TScodeGen_ColumnProjection_column* _TSPcodeGen_ColumnProjection_column;
typedef struct _TScodeGen_ComputationProjection_column* _TSPcodeGen_ComputationProjection_column;
typedef struct _TScodeGen_ComputationProjection_computation* _TSPcodeGen_ComputationProjection_computation;
typedef struct _TScodeGen_LimitDataSource_name* _TSPcodeGen_LimitDataSource_name;
typedef struct _TScodeGen_LimitDataSource_position* _TSPcodeGen_LimitDataSource_position;
typedef struct _TScodeGen_LimitDataSource_sourceDataSouce* _TSPcodeGen_LimitDataSource_sourceDataSouce;
typedef struct _TScodeGen_LimitDataSource_minRow* _TSPcodeGen_LimitDataSource_minRow;
typedef struct _TScodeGen_LimitDataSource_maxRow* _TSPcodeGen_LimitDataSource_maxRow;
typedef struct _TScodeGen_LimitDataSource_formalParameters* _TSPcodeGen_LimitDataSource_formalParameters;
typedef struct _TScodeGen_BinaryExpression_leftOperand* _TSPcodeGen_BinaryExpression_leftOperand;
typedef struct _TScodeGen_BinaryExpression_rightOperand* _TSPcodeGen_BinaryExpression_rightOperand;
typedef struct _TScodeGen_BinaryExpression_operator* _TSPcodeGen_BinaryExpression_operator;
typedef struct _TScodeGen_UnaryExpression_operand* _TSPcodeGen_UnaryExpression_operand;
typedef struct _TScodeGen_UnaryExpression_operator* _TSPcodeGen_UnaryExpression_operator;
typedef struct _TScodeGen_ConstantExpression_type* _TSPcodeGen_ConstantExpression_type;
typedef struct _TScodeGen_ConstantExpression_value* _TSPcodeGen_ConstantExpression_value;
typedef struct _TScodeGen_ColumnValueExpression_column* _TSPcodeGen_ColumnValueExpression_column;
typedef struct _TScodeGen_ParameterValueExpression_parameter* _TSPcodeGen_ParameterValueExpression_parameter;
typedef struct _TScodeGen_ComputationExpression_column* _TSPcodeGen_ComputationExpression_column;
typedef struct _TScodeGen_ComputationExpression_computation* _TSPcodeGen_ComputationExpression_computation;
typedef struct _TScodeGen_DataSourceValue* _TSPcodeGen_DataSourceValue;
typedef struct _TScodeGen_DataSourceValue_column* _TSPcodeGen_DataSourceValue_column;
typedef struct _TScodeGen_DataSourceValue_expression* _TSPcodeGen_DataSourceValue_expression;
typedef struct _TScodeGen_DataSourceJoin_name* _TSPcodeGen_DataSourceJoin_name;
typedef struct _TScodeGen_DataSourceJoin_position* _TSPcodeGen_DataSourceJoin_position;
typedef struct _TScodeGen_DataSourceJoin_dataSource1* _TSPcodeGen_DataSourceJoin_dataSource1;
typedef struct _TScodeGen_DataSourceJoin_dataSource2* _TSPcodeGen_DataSourceJoin_dataSource2;
typedef struct _TScodeGen_DataSourceJoin_columnRef1* _TSPcodeGen_DataSourceJoin_columnRef1;
typedef struct _TScodeGen_DataSourceJoin_columnRef2* _TSPcodeGen_DataSourceJoin_columnRef2;
typedef struct _TScodeGen_DataSourceJoin_joinOperator* _TSPcodeGen_DataSourceJoin_joinOperator;
typedef struct _TScodeGen_DataSourceInsert_targetDataSource* _TSPcodeGen_DataSourceInsert_targetDataSource;
typedef struct _TScodeGen_DataSourceInsert_formalParams* _TSPcodeGen_DataSourceInsert_formalParams;
typedef struct _TScodeGen_DataSourceInsert_name* _TSPcodeGen_DataSourceInsert_name;
typedef struct _TScodeGen_DataSourceInsert_position* _TSPcodeGen_DataSourceInsert_position;
typedef struct _TScodeGen_DataSourceInsert_values* _TSPcodeGen_DataSourceInsert_values;
typedef struct _TScodeGen_DataSourceUpdate_targetDataSource* _TSPcodeGen_DataSourceUpdate_targetDataSource;
typedef struct _TScodeGen_DataSourceUpdate_formalParams* _TSPcodeGen_DataSourceUpdate_formalParams;
typedef struct _TScodeGen_DataSourceUpdate_name* _TSPcodeGen_DataSourceUpdate_name;
typedef struct _TScodeGen_DataSourceUpdate_position* _TSPcodeGen_DataSourceUpdate_position;
typedef struct _TScodeGen_DataSourceUpdate_conditions* _TSPcodeGen_DataSourceUpdate_conditions;
typedef struct _TScodeGen_DataSourceUpdate_values* _TSPcodeGen_DataSourceUpdate_values;
typedef struct _TScodeGen_DataSourceDelete_targetDataSource* _TSPcodeGen_DataSourceDelete_targetDataSource;
typedef struct _TScodeGen_DataSourceDelete_formalParams* _TSPcodeGen_DataSourceDelete_formalParams;
typedef struct _TScodeGen_DataSourceDelete_name* _TSPcodeGen_DataSourceDelete_name;
typedef struct _TScodeGen_DataSourceDelete_position* _TSPcodeGen_DataSourceDelete_position;
typedef struct _TScodeGen_DataSourceDelete_conditions* _TSPcodeGen_DataSourceDelete_conditions;
typedef struct _TScodeGen_DataSourceActualParam* _TSPcodeGen_DataSourceActualParam;
typedef struct _TScodeGen_DataSourceActualParam_formalParam* _TSPcodeGen_DataSourceActualParam_formalParam;
typedef struct _TScodeGen_DataSourceActualParam_expressions* _TSPcodeGen_DataSourceActualParam_expressions;
typedef struct _TScodeGen_WebNodeColumnExpression* _TSPcodeGen_WebNodeColumnExpression;
typedef struct _TScodeGen_WebNodeVariableExpression* _TSPcodeGen_WebNodeVariableExpression;
typedef struct _TScodeGen_WebNodeConstantExpression* _TSPcodeGen_WebNodeConstantExpression;
typedef struct _TScodeGen_DataSourceFormalParam_name* _TSPcodeGen_DataSourceFormalParam_name;
typedef struct _TScodeGen_DataSourceFormalParam_type* _TSPcodeGen_DataSourceFormalParam_type;
typedef struct _TScodeGen_Formular* _TSPcodeGen_Formular;
typedef struct _TScodeGen_Formular_styleSheetBlock* _TSPcodeGen_Formular_styleSheetBlock;
typedef struct _TScodeGen_Formular_action* _TSPcodeGen_Formular_action;
typedef struct _TScodeGen_Formular_elements* _TSPcodeGen_Formular_elements;
typedef struct _TScodeGen_Formular_datasource* _TSPcodeGen_Formular_datasource;
typedef struct _TScodeGen_Formular_actualParams* _TSPcodeGen_Formular_actualParams;
typedef struct _TScodeGen_FormularSelectElement* _TSPcodeGen_FormularSelectElement;
typedef struct _TScodeGen_FormularCheckboxElement* _TSPcodeGen_FormularCheckboxElement;
typedef struct _TScodeGen_FormularPasswordElement* _TSPcodeGen_FormularPasswordElement;
typedef struct _TScodeGen_FormularTextAreaElement* _TSPcodeGen_FormularTextAreaElement;
typedef struct _TScodeGen_FormularTextElement* _TSPcodeGen_FormularTextElement;
typedef struct _TScodeGen_FormularRadioGroupElement* _TSPcodeGen_FormularRadioGroupElement;
typedef struct _TScodeGen_WebNodeActualParam* _TSPcodeGen_WebNodeActualParam;
typedef struct _TScodeGen_FormularRadioGroupElement_name* _TSPcodeGen_FormularRadioGroupElement_name;
typedef struct _TScodeGen_FormularRadioGroupElement_label* _TSPcodeGen_FormularRadioGroupElement_label;
typedef struct _TScodeGen_FormularRadioGroupElement_description* _TSPcodeGen_FormularRadioGroupElement_description;
typedef struct _TScodeGen_FormularRadioGroupElement_pvalue* _TSPcodeGen_FormularRadioGroupElement_pvalue;
typedef struct _TScodeGen_FormularRadioGroupElement_condition* _TSPcodeGen_FormularRadioGroupElement_condition;
typedef struct _TScodeGen_FormularRadioGroupElement_elements* _TSPcodeGen_FormularRadioGroupElement_elements;
typedef struct _TScodeGen_FormularRadioGroupElement_checked* _TSPcodeGen_FormularRadioGroupElement_checked;
typedef struct _TScodeGen_FormularCondition* _TSPcodeGen_FormularCondition;
typedef struct _TScodeGen_FormularRadioElement* _TSPcodeGen_FormularRadioElement;
typedef struct _TScodeGen_FormularTextElement_name* _TSPcodeGen_FormularTextElement_name;
typedef struct _TScodeGen_FormularTextElement_label* _TSPcodeGen_FormularTextElement_label;
typedef struct _TScodeGen_FormularTextElement_description* _TSPcodeGen_FormularTextElement_description;
typedef struct _TScodeGen_FormularTextElement_pvalue* _TSPcodeGen_FormularTextElement_pvalue;
typedef struct _TScodeGen_FormularTextElement_condition* _TSPcodeGen_FormularTextElement_condition;
typedef struct _TScodeGen_FormularTextAreaElement_name* _TSPcodeGen_FormularTextAreaElement_name;
typedef struct _TScodeGen_FormularTextAreaElement_label* _TSPcodeGen_FormularTextAreaElement_label;
typedef struct _TScodeGen_FormularTextAreaElement_description* _TSPcodeGen_FormularTextAreaElement_description;
typedef struct _TScodeGen_FormularTextAreaElement_pvalue* _TSPcodeGen_FormularTextAreaElement_pvalue;
typedef struct _TScodeGen_FormularTextAreaElement_condition* _TSPcodeGen_FormularTextAreaElement_condition;
typedef struct _TScodeGen_FormularPasswordElement_name* _TSPcodeGen_FormularPasswordElement_name;
typedef struct _TScodeGen_FormularPasswordElement_label* _TSPcodeGen_FormularPasswordElement_label;
typedef struct _TScodeGen_FormularPasswordElement_description* _TSPcodeGen_FormularPasswordElement_description;
typedef struct _TScodeGen_FormularPasswordElement_pvalue* _TSPcodeGen_FormularPasswordElement_pvalue;
typedef struct _TScodeGen_FormularPasswordElement_condition* _TSPcodeGen_FormularPasswordElement_condition;
typedef struct _TScodeGen_FormularCheckboxElement_name* _TSPcodeGen_FormularCheckboxElement_name;
typedef struct _TScodeGen_FormularCheckboxElement_label* _TSPcodeGen_FormularCheckboxElement_label;
typedef struct _TScodeGen_FormularCheckboxElement_description* _TSPcodeGen_FormularCheckboxElement_description;
typedef struct _TScodeGen_FormularCheckboxElement_pvalue* _TSPcodeGen_FormularCheckboxElement_pvalue;
typedef struct _TScodeGen_FormularCheckboxElement_condition* _TSPcodeGen_FormularCheckboxElement_condition;
typedef struct _TScodeGen_FormularCheckboxElement_value* _TSPcodeGen_FormularCheckboxElement_value;
typedef struct _TScodeGen_FormularCheckboxElement_checked* _TSPcodeGen_FormularCheckboxElement_checked;
typedef struct _TScodeGen_FormularSelectElement_name* _TSPcodeGen_FormularSelectElement_name;
typedef struct _TScodeGen_FormularSelectElement_label* _TSPcodeGen_FormularSelectElement_label;
typedef struct _TScodeGen_FormularSelectElement_description* _TSPcodeGen_FormularSelectElement_description;
typedef struct _TScodeGen_FormularSelectElement_pvalue* _TSPcodeGen_FormularSelectElement_pvalue;
typedef struct _TScodeGen_FormularSelectElement_condition* _TSPcodeGen_FormularSelectElement_condition;
typedef struct _TScodeGen_FormularSelectElement_options* _TSPcodeGen_FormularSelectElement_options;
typedef struct _TScodeGen_FormularSelectElement_size* _TSPcodeGen_FormularSelectElement_size;
typedef struct _TScodeGen_FormularSelectElement_multiple* _TSPcodeGen_FormularSelectElement_multiple;
typedef struct _TScodeGen_FormularPHPScriptSelectOption* _TSPcodeGen_FormularPHPScriptSelectOption;
typedef struct _TScodeGen_FormularDataSourceSelectOption* _TSPcodeGen_FormularDataSourceSelectOption;
typedef struct _TScodeGen_FormularConstantSelectOption* _TSPcodeGen_FormularConstantSelectOption;
typedef struct _TScodeGen_FormularConstantSelectOption_values* _TSPcodeGen_FormularConstantSelectOption_values;
typedef struct _TScodeGen_FormularDataSourceSelectOption_values* _TSPcodeGen_FormularDataSourceSelectOption_values;
typedef struct _TScodeGen_FormularDataSourceSelectOption_params* _TSPcodeGen_FormularDataSourceSelectOption_params;
typedef struct _TScodeGen_FormularPHPScriptSelectOption_script* _TSPcodeGen_FormularPHPScriptSelectOption_script;
typedef struct _TScodeGen_FormularRadioElement_value* _TSPcodeGen_FormularRadioElement_value;
typedef struct _TScodeGen_FormularRadioElement_label* _TSPcodeGen_FormularRadioElement_label;
typedef struct _TScodeGen_FormularRadioElement_name* _TSPcodeGen_FormularRadioElement_name;
typedef struct _TScodeGen_FormularCondition_condition* _TSPcodeGen_FormularCondition_condition;
typedef struct _TScodeGen_FormularCondition_params* _TSPcodeGen_FormularCondition_params;
typedef struct _TScodeGen_FormularConditionActualParam* _TSPcodeGen_FormularConditionActualParam;
typedef struct _TScodeGen_FormularConditionDefinition* _TSPcodeGen_FormularConditionDefinition;
typedef struct _TScodeGen_FormularConditionDefinition_name* _TSPcodeGen_FormularConditionDefinition_name;
typedef struct _TScodeGen_FormularConditionDefinition_params* _TSPcodeGen_FormularConditionDefinition_params;
typedef struct _TScodeGen_FormularConditionDefinition_body* _TSPcodeGen_FormularConditionDefinition_body;
typedef struct _TScodeGen_FormularConditionFormalParam* _TSPcodeGen_FormularConditionFormalParam;
typedef struct _TScodeGen_FormularConditionFormalParam_name* _TSPcodeGen_FormularConditionFormalParam_name;
typedef struct _TScodeGen_FormularConditionActualParam_value* _TSPcodeGen_FormularConditionActualParam_value;
typedef struct _TScodeGen_FormularConditionActualParam_formalparam* _TSPcodeGen_FormularConditionActualParam_formalparam;
typedef struct _TScodeGen_WebNodeActualParam_formalParam* _TSPcodeGen_WebNodeActualParam_formalParam;
typedef struct _TScodeGen_WebNodeActualParam_expressions* _TSPcodeGen_WebNodeActualParam_expressions;
typedef struct _TScodeGen_WebNodeFormalParam* _TSPcodeGen_WebNodeFormalParam;
typedef struct _TScodeGen_WebNodeFormalParam_name* _TSPcodeGen_WebNodeFormalParam_name;
typedef struct _TScodeGen_WebNodeFormalParam_type* _TSPcodeGen_WebNodeFormalParam_type;
typedef struct _TScodeGen_WebNodeConstantExpression_value* _TSPcodeGen_WebNodeConstantExpression_value;
typedef struct _TScodeGen_WebNodeVariableExpression_content* _TSPcodeGen_WebNodeVariableExpression_content;
typedef struct _TScodeGen_WebNodeColumnExpression_content* _TSPcodeGen_WebNodeColumnExpression_content;
typedef struct _TScodeGen_Paragraph* _TSPcodeGen_Paragraph;
typedef struct _TScodeGen_Paragraph_styleSheetBlock* _TSPcodeGen_Paragraph_styleSheetBlock;
typedef struct _TScodeGen_Paragraph_fragments* _TSPcodeGen_Paragraph_fragments;
typedef struct _TScodeGen_OutputElement* _TSPcodeGen_OutputElement;
typedef struct _TScodeGen_ImageFragment* _TSPcodeGen_ImageFragment;
typedef struct _TScodeGen_TextFragment* _TSPcodeGen_TextFragment;
typedef struct _TScodeGen_TextFragment_link* _TSPcodeGen_TextFragment_link;
typedef struct _TScodeGen_TextFragment_value* _TSPcodeGen_TextFragment_value;
typedef struct _TScodeGen_ImageFragment_link* _TSPcodeGen_ImageFragment_link;
typedef struct _TScodeGen_ImageFragment_width* _TSPcodeGen_ImageFragment_width;
typedef struct _TScodeGen_ImageFragment_height* _TSPcodeGen_ImageFragment_height;
typedef struct _TScodeGen_ImageFragment_text* _TSPcodeGen_ImageFragment_text;
typedef struct _TScodeGen_ImageFragment_imageName* _TSPcodeGen_ImageFragment_imageName;
typedef struct _TScodeGen_Heading* _TSPcodeGen_Heading;
typedef struct _TScodeGen_Heading_styleSheetBlock* _TSPcodeGen_Heading_styleSheetBlock;
typedef struct _TScodeGen_Heading_text* _TSPcodeGen_Heading_text;
typedef struct _TScodeGen_Heading_level* _TSPcodeGen_Heading_level;
typedef struct _TScodeGen_Table* _TSPcodeGen_Table;
typedef struct _TScodeGen_Table_styleSheetBlock* _TSPcodeGen_Table_styleSheetBlock;
typedef struct _TScodeGen_Table_rows* _TSPcodeGen_Table_rows;
typedef struct _TScodeGen_Table_columns* _TSPcodeGen_Table_columns;
typedef struct _TScodeGen_TableRow* _TSPcodeGen_TableRow;
typedef struct _TScodeGen_TableColumn* _TSPcodeGen_TableColumn;
typedef struct _TScodeGen_TableRow_cells* _TSPcodeGen_TableRow_cells;
typedef struct _TScodeGen_TableCell* _TSPcodeGen_TableCell;
typedef struct _TScodeGen_TableCell_columnRef* _TSPcodeGen_TableCell_columnRef;
typedef struct _TScodeGen_TableCell_content* _TSPcodeGen_TableCell_content;
typedef struct _TScodeGen_Frame* _TSPcodeGen_Frame;
typedef struct _TScodeGen_LinkTargetExtern* _TSPcodeGen_LinkTargetExtern;
typedef struct _TScodeGen_LinkTargetExtern_name* _TSPcodeGen_LinkTargetExtern_name;
typedef struct _TScodeGen_LinkTargetExtern_url* _TSPcodeGen_LinkTargetExtern_url;
typedef struct _TScodeGen_Root_webApp* _TSPcodeGen_Root_webApp;
typedef struct _TScodeGen_Root_library* _TSPcodeGen_Root_library;
typedef struct _TScodeGen_WebApplication* _TSPcodeGen_WebApplication;
typedef struct _TScodeGen_Library* _TSPcodeGen_Library;
typedef struct _TScodeGen_Library_name* _TSPcodeGen_Library_name;
typedef struct _TScodeGen_Library_formularconditions* _TSPcodeGen_Library_formularconditions;
typedef struct _TScodeGen_Library_navigationElement* _TSPcodeGen_Library_navigationElement;
typedef struct _TScodeGen_NavigationElement* _TSPcodeGen_NavigationElement;
typedef struct _TScodeGen_NavigationElement_code* _TSPcodeGen_NavigationElement_code;
typedef struct _TScodeGen_NavigationElement_name* _TSPcodeGen_NavigationElement_name;
typedef struct _TScodeGen_WebApplication_name* _TSPcodeGen_WebApplication_name;
typedef struct _TScodeGen_WebApplication_webZone* _TSPcodeGen_WebApplication_webZone;
typedef struct _TScodeGen_WebApplication_navigationBar* _TSPcodeGen_WebApplication_navigationBar;
typedef struct _TScodeGen_WebApplication_styleSheet* _TSPcodeGen_WebApplication_styleSheet;
typedef struct _TScodeGen_WebApplication_frames* _TSPcodeGen_WebApplication_frames;
typedef struct _TScodeGen_WebApplication_meta* _TSPcodeGen_WebApplication_meta;
typedef struct _TScodeGen_WebApplication_database* _TSPcodeGen_WebApplication_database;
typedef struct _TScodeGen_WebApplication_roles* _TSPcodeGen_WebApplication_roles;
typedef struct _TScodeGen_WebApplication_linksExtern* _TSPcodeGen_WebApplication_linksExtern;
typedef struct _TScodeGen_WebApplication_imagePath* _TSPcodeGen_WebApplication_imagePath;
typedef struct _TScodeGen_RootWebZone* _TSPcodeGen_RootWebZone;
typedef struct _TScodeGen_NavigationBar* _TSPcodeGen_NavigationBar;
typedef struct _TScodeGen_StyleSheet* _TSPcodeGen_StyleSheet;
typedef struct _TScodeGen_GlobalFrame* _TSPcodeGen_GlobalFrame;
typedef struct _TScodeGen_MetaInformation* _TSPcodeGen_MetaInformation;
typedef struct _TScodeGen_WebRole* _TSPcodeGen_WebRole;
typedef struct _TScodeGen_RootWebZone_webTargets* _TSPcodeGen_RootWebZone_webTargets;
typedef struct _TScodeGen_RootWebZone_errorLink* _TSPcodeGen_RootWebZone_errorLink;
typedef struct _TScodeGen_RootWebZone_roles* _TSPcodeGen_RootWebZone_roles;
typedef struct _TScodeGen_RootWebZone_setSize* _TSPcodeGen_RootWebZone_setSize;
typedef struct _TScodeGen_WebAction* _TSPcodeGen_WebAction;
typedef struct _TScodeGen_WebPage* _TSPcodeGen_WebPage;
typedef struct _TScodeGen_SubWebZone* _TSPcodeGen_SubWebZone;
typedef struct _TScodeGen_WebRoleRef* _TSPcodeGen_WebRoleRef;
typedef struct _TScodeGen_SubWebZone_name* _TSPcodeGen_SubWebZone_name;
typedef struct _TScodeGen_SubWebZone_webTargets* _TSPcodeGen_SubWebZone_webTargets;
typedef struct _TScodeGen_SubWebZone_errorLink* _TSPcodeGen_SubWebZone_errorLink;
typedef struct _TScodeGen_SubWebZone_globalparams* _TSPcodeGen_SubWebZone_globalparams;
typedef struct _TScodeGen_SubWebZone_roles* _TSPcodeGen_SubWebZone_roles;
typedef struct _TScodeGen_SubWebZone_setSize* _TSPcodeGen_SubWebZone_setSize;
typedef struct _TScodeGen_SubWebZone_position* _TSPcodeGen_SubWebZone_position;
typedef struct _TScodeGen_WebRole_name* _TSPcodeGen_WebRole_name;
typedef struct _TScodeGen_WebRole_color* _TSPcodeGen_WebRole_color;
typedef struct _TScodeGen_WebRoleRef_role* _TSPcodeGen_WebRoleRef_role;
typedef struct _TScodeGen_WebPage_name* _TSPcodeGen_WebPage_name;
typedef struct _TScodeGen_WebPage_formalParameter* _TSPcodeGen_WebPage_formalParameter;
typedef struct _TScodeGen_WebPage_title* _TSPcodeGen_WebPage_title;
typedef struct _TScodeGen_WebPage_frame* _TSPcodeGen_WebPage_frame;
typedef struct _TScodeGen_WebPage_styleSheetBlock* _TSPcodeGen_WebPage_styleSheetBlock;
typedef struct _TScodeGen_WebPage_position* _TSPcodeGen_WebPage_position;
typedef struct _TScodeGen_Frame_components* _TSPcodeGen_Frame_components;
typedef struct _TScodeGen_Frame_styleSheetBlock* _TSPcodeGen_Frame_styleSheetBlock;
typedef struct _TScodeGen_ListOutputElement* _TSPcodeGen_ListOutputElement;
typedef struct _TScodeGen_FrameRef* _TSPcodeGen_FrameRef;
typedef struct _TScodeGen_GlobalFrame_name* _TSPcodeGen_GlobalFrame_name;
typedef struct _TScodeGen_GlobalFrame_components* _TSPcodeGen_GlobalFrame_components;
typedef struct _TScodeGen_GlobalFrame_setSize* _TSPcodeGen_GlobalFrame_setSize;
typedef struct _TScodeGen_NavigationBar_styleSheetBlock* _TSPcodeGen_NavigationBar_styleSheetBlock;
typedef struct _TScodeGen_NavigationBar_elements* _TSPcodeGen_NavigationBar_elements;
typedef struct _TScodeGen_NavigationBar_alignment* _TSPcodeGen_NavigationBar_alignment;
typedef struct _TScodeGen_NavigationBarElement* _TSPcodeGen_NavigationBarElement;
typedef struct _TScodeGen_NavigationBarElement_target* _TSPcodeGen_NavigationBarElement_target;
typedef struct _TScodeGen_FrameRef_styleSheetBlock* _TSPcodeGen_FrameRef_styleSheetBlock;
typedef struct _TScodeGen_FrameRef_frame* _TSPcodeGen_FrameRef_frame;
typedef struct _TScodeGen_MetaInformation_name* _TSPcodeGen_MetaInformation_name;
typedef struct _TScodeGen_MetaInformation_elements* _TSPcodeGen_MetaInformation_elements;
typedef struct _TScodeGen_MetaInformationElement* _TSPcodeGen_MetaInformationElement;
typedef struct _TScodeGen_MetaInformationElement_property* _TSPcodeGen_MetaInformationElement_property;
typedef struct _TScodeGen_MetaInformationElement_value* _TSPcodeGen_MetaInformationElement_value;
typedef struct _TScodeGen_OutputElement_link* _TSPcodeGen_OutputElement_link;
typedef struct _TScodeGen_OutputElement_content* _TSPcodeGen_OutputElement_content;
typedef struct _TScodeGen_ListOutputElement_styleSheetBlock* _TSPcodeGen_ListOutputElement_styleSheetBlock;
typedef struct _TScodeGen_ListOutputElement_dataSourceActualParams* _TSPcodeGen_ListOutputElement_dataSourceActualParams;
typedef struct _TScodeGen_ListOutputElement_dataSource* _TSPcodeGen_ListOutputElement_dataSource;
typedef struct _TScodeGen_ListOutputElement_maxNumberOfElements* _TSPcodeGen_ListOutputElement_maxNumberOfElements;
typedef struct _TScodeGen_ListOutputElement_navigationElement* _TSPcodeGen_ListOutputElement_navigationElement;
typedef struct _TScodeGen_StyleSheet_name* _TSPcodeGen_StyleSheet_name;
typedef struct _TScodeGen_StyleSheet_custom* _TSPcodeGen_StyleSheet_custom;
typedef struct _TScodeGen_StyleSheet_default* _TSPcodeGen_StyleSheet_default;
typedef struct _TScodeGen_CustomStyleSheetBlock* _TSPcodeGen_CustomStyleSheetBlock;
typedef struct _TScodeGen_HtmlStyleSheetBlock* _TSPcodeGen_HtmlStyleSheetBlock;
typedef struct _TScodeGen_CustomStyleSheetBlock_pairs* _TSPcodeGen_CustomStyleSheetBlock_pairs;
typedef struct _TScodeGen_CustomStyleSheetBlock_name* _TSPcodeGen_CustomStyleSheetBlock_name;
typedef struct _TScodeGen_StyleSheetPair* _TSPcodeGen_StyleSheetPair;
typedef struct _TScodeGen_StyleSheetPair_category* _TSPcodeGen_StyleSheetPair_category;
typedef struct _TScodeGen_StyleSheetPair_attribute* _TSPcodeGen_StyleSheetPair_attribute;
typedef struct _TScodeGen_StyleSheetPair_valueCategory* _TSPcodeGen_StyleSheetPair_valueCategory;
typedef struct _TScodeGen_StyleSheetPair_value* _TSPcodeGen_StyleSheetPair_value;
typedef struct _TScodeGen_CustomValue* _TSPcodeGen_CustomValue;
typedef struct _TScodeGen_ListValue* _TSPcodeGen_ListValue;
typedef struct _TScodeGen_AlignmentValue* _TSPcodeGen_AlignmentValue;
typedef struct _TScodeGen_HeadingValue* _TSPcodeGen_HeadingValue;
typedef struct _TScodeGen_StyleValue* _TSPcodeGen_StyleValue;
typedef struct _TScodeGen_FamilyValue* _TSPcodeGen_FamilyValue;
typedef struct _TScodeGen_ColorValue* _TSPcodeGen_ColorValue;
typedef struct _TScodeGen_SizeValue* _TSPcodeGen_SizeValue;
typedef struct _TScodeGen_SizeValue_measure* _TSPcodeGen_SizeValue_measure;
typedef struct _TScodeGen_SizeValue_value* _TSPcodeGen_SizeValue_value;
typedef struct _TScodeGen_ColorValue_color* _TSPcodeGen_ColorValue_color;
typedef struct _TScodeGen_FamilyValue_family* _TSPcodeGen_FamilyValue_family;
typedef struct _TScodeGen_StyleValue_style* _TSPcodeGen_StyleValue_style;
typedef struct _TScodeGen_HeadingValue_heading* _TSPcodeGen_HeadingValue_heading;
typedef struct _TScodeGen_AlignmentValue_alignment* _TSPcodeGen_AlignmentValue_alignment;
typedef struct _TScodeGen_ListValue_listed* _TSPcodeGen_ListValue_listed;
typedef struct _TScodeGen_CustomValue_value* _TSPcodeGen_CustomValue_value;
typedef struct _TScodeGen_HtmlStyleSheetBlock_pairs* _TSPcodeGen_HtmlStyleSheetBlock_pairs;
typedef struct _TScodeGen_HtmlStyleSheetBlock_name* _TSPcodeGen_HtmlStyleSheetBlock_name;
typedef struct _TScodeGen_ActionHandler* _TSPcodeGen_ActionHandler;
typedef struct _TScodeGen_ActionHandler_targetpage* _TSPcodeGen_ActionHandler_targetpage;
typedef struct _TScodeGen_ActionHandler_params* _TSPcodeGen_ActionHandler_params;
typedef struct _TScodeGen_WebAction_name* _TSPcodeGen_WebAction_name;
typedef struct _TScodeGen_WebAction_formalParameter* _TSPcodeGen_WebAction_formalParameter;
typedef struct _TScodeGen_WebAction_successpage* _TSPcodeGen_WebAction_successpage;
typedef struct _TScodeGen_WebAction_operations* _TSPcodeGen_WebAction_operations;
typedef struct _TScodeGen_WebAction_position* _TSPcodeGen_WebAction_position;
typedef struct _TScodeGen_DataBaseOperation* _TSPcodeGen_DataBaseOperation;
typedef struct _TScodeGen_PHPOperation* _TSPcodeGen_PHPOperation;
typedef struct _TScodeGen_PHPOperation_errorhandler* _TSPcodeGen_PHPOperation_errorhandler;
typedef struct _TScodeGen_PHPOperation_content* _TSPcodeGen_PHPOperation_content;
typedef struct _TScodeGen_DataBaseOperation_errorhandler* _TSPcodeGen_DataBaseOperation_errorhandler;
typedef struct _TScodeGen_DataBaseOperation_filter* _TSPcodeGen_DataBaseOperation_filter;
typedef struct _TScodeGen_DataBaseOperation_params* _TSPcodeGen_DataBaseOperation_params;
typedef struct _TSdataBaseView_DataBase* _TSPdataBaseView_DataBase;
typedef struct _TSdataBaseView_DBColumn* _TSPdataBaseView_DBColumn;
typedef struct _TSdataBaseView_DBColumn_name* _TSPdataBaseView_DBColumn_name;
typedef struct _TSdataBaseView_DBColumn_keyword1* _TSPdataBaseView_DBColumn_keyword1;
typedef struct _TSdataBaseView_DBColumn_type* _TSPdataBaseView_DBColumn_type;
typedef struct _TSdataBaseView_DBBlob* _TSPdataBaseView_DBBlob;
typedef struct _TSdataBaseView_DBBoolean* _TSPdataBaseView_DBBoolean;
typedef struct _TSdataBaseView_DBTimeStamp* _TSPdataBaseView_DBTimeStamp;
typedef struct _TSdataBaseView_DBDate* _TSPdataBaseView_DBDate;
typedef struct _TSdataBaseView_DBBigInt* _TSPdataBaseView_DBBigInt;
typedef struct _TSdataBaseView_DBDouble* _TSPdataBaseView_DBDouble;
typedef struct _TSdataBaseView_DBFloat* _TSPdataBaseView_DBFloat;
typedef struct _TSdataBaseView_DBInteger* _TSPdataBaseView_DBInteger;
typedef struct _TSdataBaseView_DBString* _TSPdataBaseView_DBString;
typedef struct _TSdataBaseView_DataSourceFormalParam* _TSPdataBaseView_DataSourceFormalParam;
typedef struct _TSdataBaseView_DataSourceFormalParam_name* _TSPdataBaseView_DataSourceFormalParam_name;
typedef struct _TSdataBaseView_DataSourceFormalParam_keyword1* _TSPdataBaseView_DataSourceFormalParam_keyword1;
typedef struct _TSdataBaseView_DataSourceFormalParam_type* _TSPdataBaseView_DataSourceFormalParam_type;
typedef struct _TSdataBaseView_ColumnProjection* _TSPdataBaseView_ColumnProjection;
typedef struct _TSdataBaseView_ColumnProjection_keyword1* _TSPdataBaseView_ColumnProjection_keyword1;
typedef struct _TSdataBaseView_ColumnProjection_column* _TSPdataBaseView_ColumnProjection_column;
typedef struct _TSdataBaseView_ComputationProjection* _TSPdataBaseView_ComputationProjection;
typedef struct _TSdataBaseView_ComputationProjection_computation* _TSPdataBaseView_ComputationProjection_computation;
typedef struct _TSdataBaseView_ComputationProjection_keyword1* _TSPdataBaseView_ComputationProjection_keyword1;
typedef struct _TSdataBaseView_ComputationProjection_column* _TSPdataBaseView_ComputationProjection_column;
typedef struct _TSdataBaseView_ComputationProjection_keyword2* _TSPdataBaseView_ComputationProjection_keyword2;
typedef struct _TSdataBaseView_BinaryExpression* _TSPdataBaseView_BinaryExpression;
typedef struct _TSdataBaseView_BinaryExpression_keyword1* _TSPdataBaseView_BinaryExpression_keyword1;
typedef struct _TSdataBaseView_BinaryExpression_leftOperand* _TSPdataBaseView_BinaryExpression_leftOperand;
typedef struct _TSdataBaseView_BinaryExpression_operator* _TSPdataBaseView_BinaryExpression_operator;
typedef struct _TSdataBaseView_BinaryExpression_rightOperand* _TSPdataBaseView_BinaryExpression_rightOperand;
typedef struct _TSdataBaseView_BinaryExpression_keyword2* _TSPdataBaseView_BinaryExpression_keyword2;
typedef struct _TSdataBaseView_ComputationExpression* _TSPdataBaseView_ComputationExpression;
typedef struct _TSdataBaseView_ParameterValueExpression* _TSPdataBaseView_ParameterValueExpression;
typedef struct _TSdataBaseView_ColumnValueExpression* _TSPdataBaseView_ColumnValueExpression;
typedef struct _TSdataBaseView_ConstantExpression* _TSPdataBaseView_ConstantExpression;
typedef struct _TSdataBaseView_UnaryExpression* _TSPdataBaseView_UnaryExpression;
typedef struct _TSdataBaseView_UnaryExpression_operator* _TSPdataBaseView_UnaryExpression_operator;
typedef struct _TSdataBaseView_UnaryExpression_operand* _TSPdataBaseView_UnaryExpression_operand;
typedef struct _TSdataBaseView_ConstantExpression_keyword1* _TSPdataBaseView_ConstantExpression_keyword1;
typedef struct _TSdataBaseView_ConstantExpression_value* _TSPdataBaseView_ConstantExpression_value;
typedef struct _TSdataBaseView_ConstantExpression_keyword2* _TSPdataBaseView_ConstantExpression_keyword2;
typedef struct _TSdataBaseView_ColumnValueExpression_column* _TSPdataBaseView_ColumnValueExpression_column;
typedef struct _TSdataBaseView_ParameterValueExpression_parameter* _TSPdataBaseView_ParameterValueExpression_parameter;
typedef struct _TSdataBaseView_ComputationExpression_computation* _TSPdataBaseView_ComputationExpression_computation;
typedef struct _TSdataBaseView_ComputationExpression_keyword1* _TSPdataBaseView_ComputationExpression_keyword1;
typedef struct _TSdataBaseView_ComputationExpression_column* _TSPdataBaseView_ComputationExpression_column;
typedef struct _TSdataBaseView_ComputationExpression_keyword2* _TSPdataBaseView_ComputationExpression_keyword2;
typedef struct _TSdataBaseView_DBString_keyword1* _TSPdataBaseView_DBString_keyword1;
typedef struct _TSdataBaseView_DBInteger_keyword1* _TSPdataBaseView_DBInteger_keyword1;
typedef struct _TSdataBaseView_DBFloat_keyword1* _TSPdataBaseView_DBFloat_keyword1;
typedef struct _TSdataBaseView_DBDouble_keyword1* _TSPdataBaseView_DBDouble_keyword1;
typedef struct _TSdataBaseView_DBBigInt_keyword1* _TSPdataBaseView_DBBigInt_keyword1;
typedef struct _TSdataBaseView_DBDate_keyword1* _TSPdataBaseView_DBDate_keyword1;
typedef struct _TSdataBaseView_DBTimeStamp_keyword1* _TSPdataBaseView_DBTimeStamp_keyword1;
typedef struct _TSdataBaseView_DBBoolean_keyword1* _TSPdataBaseView_DBBoolean_keyword1;
typedef struct _TSdataBaseView_DBBlob_keyword1* _TSPdataBaseView_DBBlob_keyword1;
typedef struct _TSdataBaseView_DataSourceValue* _TSPdataBaseView_DataSourceValue;
typedef struct _TSdataBaseView_DataSourceValue_column* _TSPdataBaseView_DataSourceValue_column;
typedef struct _TSdataBaseView_DataSourceValue_keyword1* _TSPdataBaseView_DataSourceValue_keyword1;
typedef struct _TSdataBaseView_DataSourceValue_expression* _TSPdataBaseView_DataSourceValue_expression;
typedef struct _TSdataBaseView_DataSourceProjectionFilter* _TSPdataBaseView_DataSourceProjectionFilter;
typedef struct _TSdataBaseView_DataSourceProjectionFilter_name* _TSPdataBaseView_DataSourceProjectionFilter_name;
typedef struct _TSdataBaseView_DataSourceProjectionFilter_formalParameters* _TSPdataBaseView_DataSourceProjectionFilter_formalParameters;
typedef struct _TSdataBaseView_DataSourceProjectionFilter_projectionColumns* _TSPdataBaseView_DataSourceProjectionFilter_projectionColumns;
typedef struct _TSdataBaseView_DataSourceProjectionFilter_condition* _TSPdataBaseView_DataSourceProjectionFilter_condition;
typedef struct _TSdataBaseView_DataSourceProjectionFilter_connection* _TSPdataBaseView_DataSourceProjectionFilter_connection;
typedef struct _TSdataBaseView_DataSourceProjectionFilter_from* _TSPdataBaseView_DataSourceProjectionFilter_from;
typedef struct _TSdataBaseView_DataSourceProjectionFilter_sourceDataSource* _TSPdataBaseView_DataSourceProjectionFilter_sourceDataSource;
typedef struct _TSdataBaseView_LimitDataSource* _TSPdataBaseView_LimitDataSource;
typedef struct _TSdataBaseView_LimitDataSource_name* _TSPdataBaseView_LimitDataSource_name;
typedef struct _TSdataBaseView_LimitDataSource_formalParameters* _TSPdataBaseView_LimitDataSource_formalParameters;
typedef struct _TSdataBaseView_LimitDataSource_condition* _TSPdataBaseView_LimitDataSource_condition;
typedef struct _TSdataBaseView_LimitDataSource_connection* _TSPdataBaseView_LimitDataSource_connection;
typedef struct _TSdataBaseView_LimitDataSource_minRow* _TSPdataBaseView_LimitDataSource_minRow;
typedef struct _TSdataBaseView_LimitDataSource_dots* _TSPdataBaseView_LimitDataSource_dots;
typedef struct _TSdataBaseView_LimitDataSource_maxRow* _TSPdataBaseView_LimitDataSource_maxRow;
typedef struct _TSdataBaseView_LimitDataSource_from* _TSPdataBaseView_LimitDataSource_from;
typedef struct _TSdataBaseView_LimitDataSource_sourceDataSouce* _TSPdataBaseView_LimitDataSource_sourceDataSouce;
typedef struct _TSdataBaseView_DataSourceJoin* _TSPdataBaseView_DataSourceJoin;
typedef struct _TSdataBaseView_DataSourceJoin_name* _TSPdataBaseView_DataSourceJoin_name;
typedef struct _TSdataBaseView_DataSourceJoin_joinOperator* _TSPdataBaseView_DataSourceJoin_joinOperator;
typedef struct _TSdataBaseView_DataSourceJoin_connection1* _TSPdataBaseView_DataSourceJoin_connection1;
typedef struct _TSdataBaseView_DataSourceJoin_connection2* _TSPdataBaseView_DataSourceJoin_connection2;
typedef struct _TSdataBaseView_DataSourceJoin_from1* _TSPdataBaseView_DataSourceJoin_from1;
typedef struct _TSdataBaseView_DataSourceJoin_dataSource1* _TSPdataBaseView_DataSourceJoin_dataSource1;
typedef struct _TSdataBaseView_DataSourceJoin_from2* _TSPdataBaseView_DataSourceJoin_from2;
typedef struct _TSdataBaseView_DataSourceJoin_dataSource2* _TSPdataBaseView_DataSourceJoin_dataSource2;
typedef struct _TSdataBaseView_DataSourceInsert* _TSPdataBaseView_DataSourceInsert;
typedef struct _TSdataBaseView_DataSourceInsert_name* _TSPdataBaseView_DataSourceInsert_name;
typedef struct _TSdataBaseView_DataSourceInsert_formalParams* _TSPdataBaseView_DataSourceInsert_formalParams;
typedef struct _TSdataBaseView_DataSourceInsert_values* _TSPdataBaseView_DataSourceInsert_values;
typedef struct _TSdataBaseView_DataSourceInsert_connection* _TSPdataBaseView_DataSourceInsert_connection;
typedef struct _TSdataBaseView_DataSourceInsert_from* _TSPdataBaseView_DataSourceInsert_from;
typedef struct _TSdataBaseView_DataSourceInsert_targetDataSource* _TSPdataBaseView_DataSourceInsert_targetDataSource;
typedef struct _TSdataBaseView_DataSourceUpdate* _TSPdataBaseView_DataSourceUpdate;
typedef struct _TSdataBaseView_DataSourceUpdate_name* _TSPdataBaseView_DataSourceUpdate_name;
typedef struct _TSdataBaseView_DataSourceUpdate_formalParams* _TSPdataBaseView_DataSourceUpdate_formalParams;
typedef struct _TSdataBaseView_DataSourceUpdate_values* _TSPdataBaseView_DataSourceUpdate_values;
typedef struct _TSdataBaseView_DataSourceUpdate_conditions* _TSPdataBaseView_DataSourceUpdate_conditions;
typedef struct _TSdataBaseView_DataSourceUpdate_connection* _TSPdataBaseView_DataSourceUpdate_connection;
typedef struct _TSdataBaseView_DataSourceUpdate_from* _TSPdataBaseView_DataSourceUpdate_from;
typedef struct _TSdataBaseView_DataSourceUpdate_targetDataSource* _TSPdataBaseView_DataSourceUpdate_targetDataSource;
typedef struct _TSdataBaseView_DataSourceDelete* _TSPdataBaseView_DataSourceDelete;
typedef struct _TSdataBaseView_DataSourceDelete_name* _TSPdataBaseView_DataSourceDelete_name;
typedef struct _TSdataBaseView_DataSourceDelete_formalParams* _TSPdataBaseView_DataSourceDelete_formalParams;
typedef struct _TSdataBaseView_DataSourceDelete_conditions* _TSPdataBaseView_DataSourceDelete_conditions;
typedef struct _TSdataBaseView_DataSourceDelete_connection* _TSPdataBaseView_DataSourceDelete_connection;
typedef struct _TSdataBaseView_DataSourceDelete_from* _TSPdataBaseView_DataSourceDelete_from;
typedef struct _TSdataBaseView_DataSourceDelete_targetDataSource* _TSPdataBaseView_DataSourceDelete_targetDataSource;
typedef struct _TSdataBaseView_DataSourceDB* _TSPdataBaseView_DataSourceDB;
typedef struct _TSdataBaseView_DataSourceDB_name* _TSPdataBaseView_DataSourceDB_name;
typedef struct _TSdataBaseView_DataSourceDB_position* _TSPdataBaseView_DataSourceDB_position;
typedef struct _TSdataBaseView_DataSourceDB_columns* _TSPdataBaseView_DataSourceDB_columns;
typedef struct _TSdataBaseView_DataBase_name* _TSPdataBaseView_DataBase_name;
typedef struct _TSdataBaseView_DataBase_userName* _TSPdataBaseView_DataBase_userName;
typedef struct _TSdataBaseView_DataBase_userPassword* _TSPdataBaseView_DataBase_userPassword;
typedef struct _TSdataBaseView_DataBase_hostName* _TSPdataBaseView_DataBase_hostName;
typedef struct _TSdataBaseView_DataBase_port* _TSPdataBaseView_DataBase_port;
typedef struct _TSdataBaseView_DataBase_dataBaseType* _TSPdataBaseView_DataBase_dataBaseType;
typedef struct _TSdataBaseView_DataBase_dataSources* _TSPdataBaseView_DataBase_dataSources;
typedef struct _TSdataBaseView_DataBase_dataSourceModifications* _TSPdataBaseView_DataBase_dataSourceModifications;
typedef struct _TSdataBaseView_DataBase_setSize* _TSPdataBaseView_DataBase_setSize;
typedef struct _TSdataBaseView_DataBase_modifySetSize* _TSPdataBaseView_DataBase_modifySetSize;
typedef struct _TSfcDlg_FormularCondition* _TSPfcDlg_FormularCondition;
typedef struct _TSfcDlg_FormularCondition_condition* _TSPfcDlg_FormularCondition_condition;
typedef struct _TSfcDlg_FormularCondition_params* _TSPfcDlg_FormularCondition_params;
typedef struct _TSfcDlg_FormularConditionActualParam* _TSPfcDlg_FormularConditionActualParam;
typedef struct _TSfcDlg_FormularConditionActualParam_value* _TSPfcDlg_FormularConditionActualParam_value;
typedef struct _TSfcDlg_FormularConditionActualParam_formalparam* _TSPfcDlg_FormularConditionActualParam_formalparam;
typedef struct _TSglobalFrameView_GlobalFrame* _TSPglobalFrameView_GlobalFrame;
typedef struct _TSglobalFrameView_FormularCheckboxElement* _TSPglobalFrameView_FormularCheckboxElement;
typedef struct _TSglobalFrameView_FormularCheckboxElement_label* _TSPglobalFrameView_FormularCheckboxElement_label;
typedef struct _TSglobalFrameView_FormularCheckboxElement_type* _TSPglobalFrameView_FormularCheckboxElement_type;
typedef struct _TSglobalFrameView_FormularCheckboxElement_condition* _TSPglobalFrameView_FormularCheckboxElement_condition;
typedef struct _TSglobalFrameView_FormularCheckboxElement_description* _TSPglobalFrameView_FormularCheckboxElement_description;
typedef struct _TSglobalFrameView_FormularCheckboxElement_name* _TSPglobalFrameView_FormularCheckboxElement_name;
typedef struct _TSglobalFrameView_FormularCondition* _TSPglobalFrameView_FormularCondition;
typedef struct _TSglobalFrameView_FormularTextElement* _TSPglobalFrameView_FormularTextElement;
typedef struct _TSglobalFrameView_FormularTextElement_label* _TSPglobalFrameView_FormularTextElement_label;
typedef struct _TSglobalFrameView_FormularTextElement_type* _TSPglobalFrameView_FormularTextElement_type;
typedef struct _TSglobalFrameView_FormularTextElement_condition* _TSPglobalFrameView_FormularTextElement_condition;
typedef struct _TSglobalFrameView_FormularTextElement_description* _TSPglobalFrameView_FormularTextElement_description;
typedef struct _TSglobalFrameView_FormularPasswordElement* _TSPglobalFrameView_FormularPasswordElement;
typedef struct _TSglobalFrameView_FormularPasswordElement_label* _TSPglobalFrameView_FormularPasswordElement_label;
typedef struct _TSglobalFrameView_FormularPasswordElement_type* _TSPglobalFrameView_FormularPasswordElement_type;
typedef struct _TSglobalFrameView_FormularPasswordElement_condition* _TSPglobalFrameView_FormularPasswordElement_condition;
typedef struct _TSglobalFrameView_FormularPasswordElement_description* _TSPglobalFrameView_FormularPasswordElement_description;
typedef struct _TSglobalFrameView_FormularTextAreaElement* _TSPglobalFrameView_FormularTextAreaElement;
typedef struct _TSglobalFrameView_FormularTextAreaElement_label* _TSPglobalFrameView_FormularTextAreaElement_label;
typedef struct _TSglobalFrameView_FormularTextAreaElement_type* _TSPglobalFrameView_FormularTextAreaElement_type;
typedef struct _TSglobalFrameView_FormularTextAreaElement_condition* _TSPglobalFrameView_FormularTextAreaElement_condition;
typedef struct _TSglobalFrameView_FormularTextAreaElement_description* _TSPglobalFrameView_FormularTextAreaElement_description;
typedef struct _TSglobalFrameView_FormularSelectElement* _TSPglobalFrameView_FormularSelectElement;
typedef struct _TSglobalFrameView_FormularSelectElement_label* _TSPglobalFrameView_FormularSelectElement_label;
typedef struct _TSglobalFrameView_FormularSelectElement_multiple* _TSPglobalFrameView_FormularSelectElement_multiple;
typedef struct _TSglobalFrameView_FormularSelectElement_options* _TSPglobalFrameView_FormularSelectElement_options;
typedef struct _TSglobalFrameView_FormularSelectElement_description* _TSPglobalFrameView_FormularSelectElement_description;
typedef struct _TSglobalFrameView_FormularPHPScriptSelectOption* _TSPglobalFrameView_FormularPHPScriptSelectOption;
typedef struct _TSglobalFrameView_FormularDataSourceSelectOption* _TSPglobalFrameView_FormularDataSourceSelectOption;
typedef struct _TSglobalFrameView_FormularConstantSelectOption* _TSPglobalFrameView_FormularConstantSelectOption;
typedef struct _TSglobalFrameView_FormularRadioElement* _TSPglobalFrameView_FormularRadioElement;
typedef struct _TSglobalFrameView_FormularRadioElement_type* _TSPglobalFrameView_FormularRadioElement_type;
typedef struct _TSglobalFrameView_FormularRadioElement_label* _TSPglobalFrameView_FormularRadioElement_label;
typedef struct _TSglobalFrameView_FormularRadioElement_name* _TSPglobalFrameView_FormularRadioElement_name;
typedef struct _TSglobalFrameView_DataSourceActualParam* _TSPglobalFrameView_DataSourceActualParam;
typedef struct _TSglobalFrameView_DataSourceActualParam_formalParam* _TSPglobalFrameView_DataSourceActualParam_formalParam;
typedef struct _TSglobalFrameView_DataSourceActualParam_keyword1* _TSPglobalFrameView_DataSourceActualParam_keyword1;
typedef struct _TSglobalFrameView_DataSourceActualParam_expressions* _TSPglobalFrameView_DataSourceActualParam_expressions;
typedef struct _TSglobalFrameView_WebNodeColumnExpression* _TSPglobalFrameView_WebNodeColumnExpression;
typedef struct _TSglobalFrameView_WebNodeVariableExpression* _TSPglobalFrameView_WebNodeVariableExpression;
typedef struct _TSglobalFrameView_WebNodeConstantExpression* _TSPglobalFrameView_WebNodeConstantExpression;
typedef struct _TSglobalFrameView_WebNodeActualParam* _TSPglobalFrameView_WebNodeActualParam;
typedef struct _TSglobalFrameView_WebNodeActualParam_formalParam* _TSPglobalFrameView_WebNodeActualParam_formalParam;
typedef struct _TSglobalFrameView_WebNodeActualParam_keyword1* _TSPglobalFrameView_WebNodeActualParam_keyword1;
typedef struct _TSglobalFrameView_WebNodeActualParam_expressions* _TSPglobalFrameView_WebNodeActualParam_expressions;
typedef struct _TSglobalFrameView_WebNodeConstantExpression_keyword1* _TSPglobalFrameView_WebNodeConstantExpression_keyword1;
typedef struct _TSglobalFrameView_WebNodeConstantExpression_value* _TSPglobalFrameView_WebNodeConstantExpression_value;
typedef struct _TSglobalFrameView_WebNodeConstantExpression_keyword2* _TSPglobalFrameView_WebNodeConstantExpression_keyword2;
typedef struct _TSglobalFrameView_WebNodeVariableExpression_content* _TSPglobalFrameView_WebNodeVariableExpression_content;
typedef struct _TSglobalFrameView_WebNodeColumnExpression_content* _TSPglobalFrameView_WebNodeColumnExpression_content;
typedef struct _TSglobalFrameView_Formular* _TSPglobalFrameView_Formular;
typedef struct _TSglobalFrameView_Formular_styleSheetBlock* _TSPglobalFrameView_Formular_styleSheetBlock;
typedef struct _TSglobalFrameView_Formular_action* _TSPglobalFrameView_Formular_action;
typedef struct _TSglobalFrameView_Formular_elements* _TSPglobalFrameView_Formular_elements;
typedef struct _TSglobalFrameView_Formular_datasource* _TSPglobalFrameView_Formular_datasource;
typedef struct _TSglobalFrameView_Formular_actualParams* _TSPglobalFrameView_Formular_actualParams;
typedef struct _TSglobalFrameView_FormularRadioGroupElement* _TSPglobalFrameView_FormularRadioGroupElement;
typedef struct _TSglobalFrameView_FormularRadioGroupElement_name* _TSPglobalFrameView_FormularRadioGroupElement_name;
typedef struct _TSglobalFrameView_FormularRadioGroupElement_label* _TSPglobalFrameView_FormularRadioGroupElement_label;
typedef struct _TSglobalFrameView_FormularRadioGroupElement_description* _TSPglobalFrameView_FormularRadioGroupElement_description;
typedef struct _TSglobalFrameView_FormularRadioGroupElement_pvalue* _TSPglobalFrameView_FormularRadioGroupElement_pvalue;
typedef struct _TSglobalFrameView_FormularRadioGroupElement_condition* _TSPglobalFrameView_FormularRadioGroupElement_condition;
typedef struct _TSglobalFrameView_FormularRadioGroupElement_elements* _TSPglobalFrameView_FormularRadioGroupElement_elements;
typedef struct _TSglobalFrameView_FormularRadioGroupElement_checked* _TSPglobalFrameView_FormularRadioGroupElement_checked;
typedef struct _TSglobalFrameView_FormularConstantSelectOption_values* _TSPglobalFrameView_FormularConstantSelectOption_values;
typedef struct _TSglobalFrameView_FormularDataSourceSelectOption_values* _TSPglobalFrameView_FormularDataSourceSelectOption_values;
typedef struct _TSglobalFrameView_FormularDataSourceSelectOption_params* _TSPglobalFrameView_FormularDataSourceSelectOption_params;
typedef struct _TSglobalFrameView_FormularPHPScriptSelectOption_script* _TSPglobalFrameView_FormularPHPScriptSelectOption_script;
typedef struct _TSglobalFrameView_FormularCondition_condition* _TSPglobalFrameView_FormularCondition_condition;
typedef struct _TSglobalFrameView_FormularCondition_params* _TSPglobalFrameView_FormularCondition_params;
typedef struct _TSglobalFrameView_FormularConditionActualParam* _TSPglobalFrameView_FormularConditionActualParam;
typedef struct _TSglobalFrameView_FormularConditionActualParam_value* _TSPglobalFrameView_FormularConditionActualParam_value;
typedef struct _TSglobalFrameView_FormularConditionActualParam_formalparam* _TSPglobalFrameView_FormularConditionActualParam_formalparam;
typedef struct _TSglobalFrameView_Paragraph* _TSPglobalFrameView_Paragraph;
typedef struct _TSglobalFrameView_Paragraph_styleSheetBlock* _TSPglobalFrameView_Paragraph_styleSheetBlock;
typedef struct _TSglobalFrameView_Paragraph_fragments* _TSPglobalFrameView_Paragraph_fragments;
typedef struct _TSglobalFrameView_OutputElement* _TSPglobalFrameView_OutputElement;
typedef struct _TSglobalFrameView_ImageFragment* _TSPglobalFrameView_ImageFragment;
typedef struct _TSglobalFrameView_TextFragment* _TSPglobalFrameView_TextFragment;
typedef struct _TSglobalFrameView_TextFragment_link* _TSPglobalFrameView_TextFragment_link;
typedef struct _TSglobalFrameView_TextFragment_value* _TSPglobalFrameView_TextFragment_value;
typedef struct _TSglobalFrameView_ImageFragment_link* _TSPglobalFrameView_ImageFragment_link;
typedef struct _TSglobalFrameView_ImageFragment_width* _TSPglobalFrameView_ImageFragment_width;
typedef struct _TSglobalFrameView_ImageFragment_height* _TSPglobalFrameView_ImageFragment_height;
typedef struct _TSglobalFrameView_ImageFragment_text* _TSPglobalFrameView_ImageFragment_text;
typedef struct _TSglobalFrameView_ImageFragment_imageName* _TSPglobalFrameView_ImageFragment_imageName;
typedef struct _TSglobalFrameView_Heading* _TSPglobalFrameView_Heading;
typedef struct _TSglobalFrameView_Heading_styleSheetBlock* _TSPglobalFrameView_Heading_styleSheetBlock;
typedef struct _TSglobalFrameView_Heading_text* _TSPglobalFrameView_Heading_text;
typedef struct _TSglobalFrameView_Heading_level* _TSPglobalFrameView_Heading_level;
typedef struct _TSglobalFrameView_Table* _TSPglobalFrameView_Table;
typedef struct _TSglobalFrameView_Table_styleSheetBlock* _TSPglobalFrameView_Table_styleSheetBlock;
typedef struct _TSglobalFrameView_Table_rows* _TSPglobalFrameView_Table_rows;
typedef struct _TSglobalFrameView_Table_columns* _TSPglobalFrameView_Table_columns;
typedef struct _TSglobalFrameView_TableRow* _TSPglobalFrameView_TableRow;
typedef struct _TSglobalFrameView_TableColumn* _TSPglobalFrameView_TableColumn;
typedef struct _TSglobalFrameView_TableRow_cells* _TSPglobalFrameView_TableRow_cells;
typedef struct _TSglobalFrameView_TableCell* _TSPglobalFrameView_TableCell;
typedef struct _TSglobalFrameView_TableCell_columnRef* _TSPglobalFrameView_TableCell_columnRef;
typedef struct _TSglobalFrameView_TableCell_content* _TSPglobalFrameView_TableCell_content;
typedef struct _TSglobalFrameView_Frame* _TSPglobalFrameView_Frame;
typedef struct _TSglobalFrameView_Frame_components* _TSPglobalFrameView_Frame_components;
typedef struct _TSglobalFrameView_Frame_styleSheetBlock* _TSPglobalFrameView_Frame_styleSheetBlock;
typedef struct _TSglobalFrameView_ListOutputElement* _TSPglobalFrameView_ListOutputElement;
typedef struct _TSglobalFrameView_FrameRef* _TSPglobalFrameView_FrameRef;
typedef struct _TSglobalFrameView_GlobalFrame_name* _TSPglobalFrameView_GlobalFrame_name;
typedef struct _TSglobalFrameView_GlobalFrame_components* _TSPglobalFrameView_GlobalFrame_components;
typedef struct _TSglobalFrameView_GlobalFrame_setSize* _TSPglobalFrameView_GlobalFrame_setSize;
typedef struct _TSglobalFrameView_FrameRef_styleSheetBlock* _TSPglobalFrameView_FrameRef_styleSheetBlock;
typedef struct _TSglobalFrameView_FrameRef_frame* _TSPglobalFrameView_FrameRef_frame;
typedef struct _TSglobalFrameView_OutputElement_link* _TSPglobalFrameView_OutputElement_link;
typedef struct _TSglobalFrameView_OutputElement_content* _TSPglobalFrameView_OutputElement_content;
typedef struct _TSglobalFrameView_ListOutputElement_styleSheetBlock* _TSPglobalFrameView_ListOutputElement_styleSheetBlock;
typedef struct _TSglobalFrameView_ListOutputElement_dataSourceActualParams* _TSPglobalFrameView_ListOutputElement_dataSourceActualParams;
typedef struct _TSglobalFrameView_ListOutputElement_dataSource* _TSPglobalFrameView_ListOutputElement_dataSource;
typedef struct _TSglobalFrameView_ListOutputElement_maxNumberOfElements* _TSPglobalFrameView_ListOutputElement_maxNumberOfElements;
typedef struct _TSglobalFrameView_ListOutputElement_navigationElement* _TSPglobalFrameView_ListOutputElement_navigationElement;
typedef struct _TSmetaInformation_MetaInformation* _TSPmetaInformation_MetaInformation;
typedef struct _TSmetaInformation_MetaInformation_keyword1* _TSPmetaInformation_MetaInformation_keyword1;
typedef struct _TSmetaInformation_MetaInformation_keyword2* _TSPmetaInformation_MetaInformation_keyword2;
typedef struct _TSmetaInformation_MetaInformation_keyword3* _TSPmetaInformation_MetaInformation_keyword3;
typedef struct _TSmetaInformation_MetaInformation_elements* _TSPmetaInformation_MetaInformation_elements;
typedef struct _TSmetaInformation_MetaInformation_keyword4* _TSPmetaInformation_MetaInformation_keyword4;
typedef struct _TSmetaInformation_MetaInformationElement* _TSPmetaInformation_MetaInformationElement;
typedef struct _TSmetaInformation_MetaInformationElement_property* _TSPmetaInformation_MetaInformationElement_property;
typedef struct _TSmetaInformation_MetaInformationElement_keyword1* _TSPmetaInformation_MetaInformationElement_keyword1;
typedef struct _TSmetaInformation_MetaInformationElement_value* _TSPmetaInformation_MetaInformationElement_value;
typedef struct _TSmetaInformation_MetaInformationElement_keyword2* _TSPmetaInformation_MetaInformationElement_keyword2;
typedef struct _TSnavigationBarView_NavigationBar* _TSPnavigationBarView_NavigationBar;
typedef struct _TSnavigationBarView_NavigationBar_styleSheetBlock* _TSPnavigationBarView_NavigationBar_styleSheetBlock;
typedef struct _TSnavigationBarView_NavigationBar_elements* _TSPnavigationBarView_NavigationBar_elements;
typedef struct _TSnavigationBarView_NavigationBar_alignment* _TSPnavigationBarView_NavigationBar_alignment;
typedef struct _TSnavigationBarView_NavigationBarElement* _TSPnavigationBarView_NavigationBarElement;
typedef struct _TSnavigationBarView_NavigationBarElement_target* _TSPnavigationBarView_NavigationBarElement_target;
typedef struct _TSrootView_Root* _TSProotView_Root;
typedef struct _TSrootView_WebNodeFormalParam* _TSProotView_WebNodeFormalParam;
typedef struct _TSrootView_WebNodeFormalParam_name* _TSProotView_WebNodeFormalParam_name;
typedef struct _TSrootView_WebNodeFormalParam_keyword1* _TSProotView_WebNodeFormalParam_keyword1;
typedef struct _TSrootView_WebNodeFormalParam_type* _TSProotView_WebNodeFormalParam_type;
typedef struct _TSrootView_DBBlob* _TSProotView_DBBlob;
typedef struct _TSrootView_DBBoolean* _TSProotView_DBBoolean;
typedef struct _TSrootView_DBTimeStamp* _TSProotView_DBTimeStamp;
typedef struct _TSrootView_DBDate* _TSProotView_DBDate;
typedef struct _TSrootView_DBBigInt* _TSProotView_DBBigInt;
typedef struct _TSrootView_DBDouble* _TSProotView_DBDouble;
typedef struct _TSrootView_DBFloat* _TSProotView_DBFloat;
typedef struct _TSrootView_DBInteger* _TSProotView_DBInteger;
typedef struct _TSrootView_DBString* _TSProotView_DBString;
typedef struct _TSrootView_DataBase* _TSProotView_DataBase;
typedef struct _TSrootView_DBString_keyword1* _TSProotView_DBString_keyword1;
typedef struct _TSrootView_DBInteger_keyword1* _TSProotView_DBInteger_keyword1;
typedef struct _TSrootView_DBFloat_keyword1* _TSProotView_DBFloat_keyword1;
typedef struct _TSrootView_DBDouble_keyword1* _TSProotView_DBDouble_keyword1;
typedef struct _TSrootView_DBBigInt_keyword1* _TSProotView_DBBigInt_keyword1;
typedef struct _TSrootView_DBDate_keyword1* _TSProotView_DBDate_keyword1;
typedef struct _TSrootView_DBTimeStamp_keyword1* _TSProotView_DBTimeStamp_keyword1;
typedef struct _TSrootView_DBBoolean_keyword1* _TSProotView_DBBoolean_keyword1;
typedef struct _TSrootView_DBBlob_keyword1* _TSProotView_DBBlob_keyword1;
typedef struct _TSrootView_DataSourceActualParam* _TSProotView_DataSourceActualParam;
typedef struct _TSrootView_DataSourceActualParam_formalParam* _TSProotView_DataSourceActualParam_formalParam;
typedef struct _TSrootView_DataSourceActualParam_expressions* _TSProotView_DataSourceActualParam_expressions;
typedef struct _TSrootView_WebNodeColumnExpression* _TSProotView_WebNodeColumnExpression;
typedef struct _TSrootView_WebNodeVariableExpression* _TSProotView_WebNodeVariableExpression;
typedef struct _TSrootView_WebNodeConstantExpression* _TSProotView_WebNodeConstantExpression;
typedef struct _TSrootView_Formular* _TSProotView_Formular;
typedef struct _TSrootView_Formular_styleSheetBlock* _TSProotView_Formular_styleSheetBlock;
typedef struct _TSrootView_Formular_action* _TSProotView_Formular_action;
typedef struct _TSrootView_Formular_elements* _TSProotView_Formular_elements;
typedef struct _TSrootView_Formular_datasource* _TSProotView_Formular_datasource;
typedef struct _TSrootView_Formular_actualParams* _TSProotView_Formular_actualParams;
typedef struct _TSrootView_FormularSelectElement* _TSProotView_FormularSelectElement;
typedef struct _TSrootView_FormularCheckboxElement* _TSProotView_FormularCheckboxElement;
typedef struct _TSrootView_FormularPasswordElement* _TSProotView_FormularPasswordElement;
typedef struct _TSrootView_FormularTextAreaElement* _TSProotView_FormularTextAreaElement;
typedef struct _TSrootView_FormularTextElement* _TSProotView_FormularTextElement;
typedef struct _TSrootView_FormularRadioGroupElement* _TSProotView_FormularRadioGroupElement;
typedef struct _TSrootView_WebNodeActualParam* _TSProotView_WebNodeActualParam;
typedef struct _TSrootView_FormularRadioGroupElement_name* _TSProotView_FormularRadioGroupElement_name;
typedef struct _TSrootView_FormularRadioGroupElement_label* _TSProotView_FormularRadioGroupElement_label;
typedef struct _TSrootView_FormularRadioGroupElement_description* _TSProotView_FormularRadioGroupElement_description;
typedef struct _TSrootView_FormularRadioGroupElement_pvalue* _TSProotView_FormularRadioGroupElement_pvalue;
typedef struct _TSrootView_FormularRadioGroupElement_condition* _TSProotView_FormularRadioGroupElement_condition;
typedef struct _TSrootView_FormularRadioGroupElement_elements* _TSProotView_FormularRadioGroupElement_elements;
typedef struct _TSrootView_FormularRadioGroupElement_checked* _TSProotView_FormularRadioGroupElement_checked;
typedef struct _TSrootView_FormularCondition* _TSProotView_FormularCondition;
typedef struct _TSrootView_FormularRadioElement* _TSProotView_FormularRadioElement;
typedef struct _TSrootView_FormularTextElement_name* _TSProotView_FormularTextElement_name;
typedef struct _TSrootView_FormularTextElement_label* _TSProotView_FormularTextElement_label;
typedef struct _TSrootView_FormularTextElement_description* _TSProotView_FormularTextElement_description;
typedef struct _TSrootView_FormularTextElement_pvalue* _TSProotView_FormularTextElement_pvalue;
typedef struct _TSrootView_FormularTextElement_condition* _TSProotView_FormularTextElement_condition;
typedef struct _TSrootView_FormularTextAreaElement_name* _TSProotView_FormularTextAreaElement_name;
typedef struct _TSrootView_FormularTextAreaElement_label* _TSProotView_FormularTextAreaElement_label;
typedef struct _TSrootView_FormularTextAreaElement_description* _TSProotView_FormularTextAreaElement_description;
typedef struct _TSrootView_FormularTextAreaElement_pvalue* _TSProotView_FormularTextAreaElement_pvalue;
typedef struct _TSrootView_FormularTextAreaElement_condition* _TSProotView_FormularTextAreaElement_condition;
typedef struct _TSrootView_FormularPasswordElement_name* _TSProotView_FormularPasswordElement_name;
typedef struct _TSrootView_FormularPasswordElement_label* _TSProotView_FormularPasswordElement_label;
typedef struct _TSrootView_FormularPasswordElement_description* _TSProotView_FormularPasswordElement_description;
typedef struct _TSrootView_FormularPasswordElement_pvalue* _TSProotView_FormularPasswordElement_pvalue;
typedef struct _TSrootView_FormularPasswordElement_condition* _TSProotView_FormularPasswordElement_condition;
typedef struct _TSrootView_FormularCheckboxElement_name* _TSProotView_FormularCheckboxElement_name;
typedef struct _TSrootView_FormularCheckboxElement_label* _TSProotView_FormularCheckboxElement_label;
typedef struct _TSrootView_FormularCheckboxElement_description* _TSProotView_FormularCheckboxElement_description;
typedef struct _TSrootView_FormularCheckboxElement_pvalue* _TSProotView_FormularCheckboxElement_pvalue;
typedef struct _TSrootView_FormularCheckboxElement_condition* _TSProotView_FormularCheckboxElement_condition;
typedef struct _TSrootView_FormularCheckboxElement_value* _TSProotView_FormularCheckboxElement_value;
typedef struct _TSrootView_FormularCheckboxElement_checked* _TSProotView_FormularCheckboxElement_checked;
typedef struct _TSrootView_FormularSelectElement_name* _TSProotView_FormularSelectElement_name;
typedef struct _TSrootView_FormularSelectElement_label* _TSProotView_FormularSelectElement_label;
typedef struct _TSrootView_FormularSelectElement_description* _TSProotView_FormularSelectElement_description;
typedef struct _TSrootView_FormularSelectElement_pvalue* _TSProotView_FormularSelectElement_pvalue;
typedef struct _TSrootView_FormularSelectElement_condition* _TSProotView_FormularSelectElement_condition;
typedef struct _TSrootView_FormularSelectElement_options* _TSProotView_FormularSelectElement_options;
typedef struct _TSrootView_FormularSelectElement_size* _TSProotView_FormularSelectElement_size;
typedef struct _TSrootView_FormularSelectElement_multiple* _TSProotView_FormularSelectElement_multiple;
typedef struct _TSrootView_FormularPHPScriptSelectOption* _TSProotView_FormularPHPScriptSelectOption;
typedef struct _TSrootView_FormularDataSourceSelectOption* _TSProotView_FormularDataSourceSelectOption;
typedef struct _TSrootView_FormularConstantSelectOption* _TSProotView_FormularConstantSelectOption;
typedef struct _TSrootView_FormularConstantSelectOption_values* _TSProotView_FormularConstantSelectOption_values;
typedef struct _TSrootView_FormularDataSourceSelectOption_values* _TSProotView_FormularDataSourceSelectOption_values;
typedef struct _TSrootView_FormularDataSourceSelectOption_params* _TSProotView_FormularDataSourceSelectOption_params;
typedef struct _TSrootView_FormularPHPScriptSelectOption_script* _TSProotView_FormularPHPScriptSelectOption_script;
typedef struct _TSrootView_FormularRadioElement_value* _TSProotView_FormularRadioElement_value;
typedef struct _TSrootView_FormularRadioElement_label* _TSProotView_FormularRadioElement_label;
typedef struct _TSrootView_FormularRadioElement_name* _TSProotView_FormularRadioElement_name;
typedef struct _TSrootView_FormularCondition_condition* _TSProotView_FormularCondition_condition;
typedef struct _TSrootView_FormularCondition_params* _TSProotView_FormularCondition_params;
typedef struct _TSrootView_FormularConditionActualParam* _TSProotView_FormularConditionActualParam;
typedef struct _TSrootView_FormularConditionDefinition* _TSProotView_FormularConditionDefinition;
typedef struct _TSrootView_FormularConditionDefinition_name* _TSProotView_FormularConditionDefinition_name;
typedef struct _TSrootView_FormularConditionDefinition_params* _TSProotView_FormularConditionDefinition_params;
typedef struct _TSrootView_FormularConditionDefinition_body* _TSProotView_FormularConditionDefinition_body;
typedef struct _TSrootView_FormularConditionFormalParam* _TSProotView_FormularConditionFormalParam;
typedef struct _TSrootView_FormularConditionFormalParam_name* _TSProotView_FormularConditionFormalParam_name;
typedef struct _TSrootView_FormularConditionActualParam_value* _TSProotView_FormularConditionActualParam_value;
typedef struct _TSrootView_FormularConditionActualParam_formalparam* _TSProotView_FormularConditionActualParam_formalparam;
typedef struct _TSrootView_WebNodeActualParam_formalParam* _TSProotView_WebNodeActualParam_formalParam;
typedef struct _TSrootView_WebNodeActualParam_expressions* _TSProotView_WebNodeActualParam_expressions;
typedef struct _TSrootView_WebNodeConstantExpression_value* _TSProotView_WebNodeConstantExpression_value;
typedef struct _TSrootView_WebNodeVariableExpression_content* _TSProotView_WebNodeVariableExpression_content;
typedef struct _TSrootView_WebNodeColumnExpression_content* _TSProotView_WebNodeColumnExpression_content;
typedef struct _TSrootView_Paragraph* _TSProotView_Paragraph;
typedef struct _TSrootView_Paragraph_styleSheetBlock* _TSProotView_Paragraph_styleSheetBlock;
typedef struct _TSrootView_Paragraph_fragments* _TSProotView_Paragraph_fragments;
typedef struct _TSrootView_OutputElement* _TSProotView_OutputElement;
typedef struct _TSrootView_ImageFragment* _TSProotView_ImageFragment;
typedef struct _TSrootView_TextFragment* _TSProotView_TextFragment;
typedef struct _TSrootView_TextFragment_link* _TSProotView_TextFragment_link;
typedef struct _TSrootView_TextFragment_value* _TSProotView_TextFragment_value;
typedef struct _TSrootView_ImageFragment_link* _TSProotView_ImageFragment_link;
typedef struct _TSrootView_ImageFragment_width* _TSProotView_ImageFragment_width;
typedef struct _TSrootView_ImageFragment_height* _TSProotView_ImageFragment_height;
typedef struct _TSrootView_ImageFragment_text* _TSProotView_ImageFragment_text;
typedef struct _TSrootView_ImageFragment_imageName* _TSProotView_ImageFragment_imageName;
typedef struct _TSrootView_Heading* _TSProotView_Heading;
typedef struct _TSrootView_Heading_styleSheetBlock* _TSProotView_Heading_styleSheetBlock;
typedef struct _TSrootView_Heading_text* _TSProotView_Heading_text;
typedef struct _TSrootView_Heading_level* _TSProotView_Heading_level;
typedef struct _TSrootView_Table* _TSProotView_Table;
typedef struct _TSrootView_Table_styleSheetBlock* _TSProotView_Table_styleSheetBlock;
typedef struct _TSrootView_Table_rows* _TSProotView_Table_rows;
typedef struct _TSrootView_Table_columns* _TSProotView_Table_columns;
typedef struct _TSrootView_TableRow* _TSProotView_TableRow;
typedef struct _TSrootView_TableColumn* _TSProotView_TableColumn;
typedef struct _TSrootView_TableRow_cells* _TSProotView_TableRow_cells;
typedef struct _TSrootView_TableCell* _TSProotView_TableCell;
typedef struct _TSrootView_TableCell_columnRef* _TSProotView_TableCell_columnRef;
typedef struct _TSrootView_TableCell_content* _TSProotView_TableCell_content;
typedef struct _TSrootView_Frame* _TSProotView_Frame;
typedef struct _TSrootView_LinkTargetExtern* _TSProotView_LinkTargetExtern;
typedef struct _TSrootView_LinkTargetExtern_name* _TSProotView_LinkTargetExtern_name;
typedef struct _TSrootView_LinkTargetExtern_url* _TSProotView_LinkTargetExtern_url;
typedef struct _TSrootView_Root_webApp* _TSProotView_Root_webApp;
typedef struct _TSrootView_Root_library* _TSProotView_Root_library;
typedef struct _TSrootView_WebApplication* _TSProotView_WebApplication;
typedef struct _TSrootView_Library* _TSProotView_Library;
typedef struct _TSrootView_Library_name* _TSProotView_Library_name;
typedef struct _TSrootView_Library_formularconditions* _TSProotView_Library_formularconditions;
typedef struct _TSrootView_Library_navigationElement* _TSProotView_Library_navigationElement;
typedef struct _TSrootView_NavigationElement* _TSProotView_NavigationElement;
typedef struct _TSrootView_NavigationElement_code* _TSProotView_NavigationElement_code;
typedef struct _TSrootView_NavigationElement_name* _TSProotView_NavigationElement_name;
typedef struct _TSrootView_WebApplication_name* _TSProotView_WebApplication_name;
typedef struct _TSrootView_WebApplication_webZone* _TSProotView_WebApplication_webZone;
typedef struct _TSrootView_WebApplication_navigationBar* _TSProotView_WebApplication_navigationBar;
typedef struct _TSrootView_WebApplication_styleSheet* _TSProotView_WebApplication_styleSheet;
typedef struct _TSrootView_WebApplication_frames* _TSProotView_WebApplication_frames;
typedef struct _TSrootView_WebApplication_meta* _TSProotView_WebApplication_meta;
typedef struct _TSrootView_WebApplication_database* _TSProotView_WebApplication_database;
typedef struct _TSrootView_WebApplication_roles* _TSProotView_WebApplication_roles;
typedef struct _TSrootView_WebApplication_linksExtern* _TSProotView_WebApplication_linksExtern;
typedef struct _TSrootView_WebApplication_imagePath* _TSProotView_WebApplication_imagePath;
typedef struct _TSrootView_RootWebZone* _TSProotView_RootWebZone;
typedef struct _TSrootView_NavigationBar* _TSProotView_NavigationBar;
typedef struct _TSrootView_StyleSheet* _TSProotView_StyleSheet;
typedef struct _TSrootView_GlobalFrame* _TSProotView_GlobalFrame;
typedef struct _TSrootView_MetaInformation* _TSProotView_MetaInformation;
typedef struct _TSrootView_WebRole* _TSProotView_WebRole;
typedef struct _TSrootView_RootWebZone_webTargets* _TSProotView_RootWebZone_webTargets;
typedef struct _TSrootView_RootWebZone_errorLink* _TSProotView_RootWebZone_errorLink;
typedef struct _TSrootView_RootWebZone_roles* _TSProotView_RootWebZone_roles;
typedef struct _TSrootView_RootWebZone_setSize* _TSProotView_RootWebZone_setSize;
typedef struct _TSrootView_WebAction* _TSProotView_WebAction;
typedef struct _TSrootView_WebPage* _TSProotView_WebPage;
typedef struct _TSrootView_SubWebZone* _TSProotView_SubWebZone;
typedef struct _TSrootView_WebRoleRef* _TSProotView_WebRoleRef;
typedef struct _TSrootView_SubWebZone_name* _TSProotView_SubWebZone_name;
typedef struct _TSrootView_SubWebZone_webTargets* _TSProotView_SubWebZone_webTargets;
typedef struct _TSrootView_SubWebZone_errorLink* _TSProotView_SubWebZone_errorLink;
typedef struct _TSrootView_SubWebZone_globalparams* _TSProotView_SubWebZone_globalparams;
typedef struct _TSrootView_SubWebZone_roles* _TSProotView_SubWebZone_roles;
typedef struct _TSrootView_SubWebZone_setSize* _TSProotView_SubWebZone_setSize;
typedef struct _TSrootView_SubWebZone_position* _TSProotView_SubWebZone_position;
typedef struct _TSrootView_WebRole_name* _TSProotView_WebRole_name;
typedef struct _TSrootView_WebRole_color* _TSProotView_WebRole_color;
typedef struct _TSrootView_WebRoleRef_role* _TSProotView_WebRoleRef_role;
typedef struct _TSrootView_WebPage_name* _TSProotView_WebPage_name;
typedef struct _TSrootView_WebPage_formalParameter* _TSProotView_WebPage_formalParameter;
typedef struct _TSrootView_WebPage_title* _TSProotView_WebPage_title;
typedef struct _TSrootView_WebPage_frame* _TSProotView_WebPage_frame;
typedef struct _TSrootView_WebPage_styleSheetBlock* _TSProotView_WebPage_styleSheetBlock;
typedef struct _TSrootView_WebPage_position* _TSProotView_WebPage_position;
typedef struct _TSrootView_Frame_components* _TSProotView_Frame_components;
typedef struct _TSrootView_Frame_styleSheetBlock* _TSProotView_Frame_styleSheetBlock;
typedef struct _TSrootView_ListOutputElement* _TSProotView_ListOutputElement;
typedef struct _TSrootView_FrameRef* _TSProotView_FrameRef;
typedef struct _TSrootView_GlobalFrame_name* _TSProotView_GlobalFrame_name;
typedef struct _TSrootView_GlobalFrame_components* _TSProotView_GlobalFrame_components;
typedef struct _TSrootView_GlobalFrame_setSize* _TSProotView_GlobalFrame_setSize;
typedef struct _TSrootView_NavigationBar_styleSheetBlock* _TSProotView_NavigationBar_styleSheetBlock;
typedef struct _TSrootView_NavigationBar_elements* _TSProotView_NavigationBar_elements;
typedef struct _TSrootView_NavigationBar_alignment* _TSProotView_NavigationBar_alignment;
typedef struct _TSrootView_NavigationBarElement* _TSProotView_NavigationBarElement;
typedef struct _TSrootView_NavigationBarElement_target* _TSProotView_NavigationBarElement_target;
typedef struct _TSrootView_FrameRef_styleSheetBlock* _TSProotView_FrameRef_styleSheetBlock;
typedef struct _TSrootView_FrameRef_frame* _TSProotView_FrameRef_frame;
typedef struct _TSrootView_MetaInformation_name* _TSProotView_MetaInformation_name;
typedef struct _TSrootView_MetaInformation_elements* _TSProotView_MetaInformation_elements;
typedef struct _TSrootView_MetaInformationElement* _TSProotView_MetaInformationElement;
typedef struct _TSrootView_MetaInformationElement_property* _TSProotView_MetaInformationElement_property;
typedef struct _TSrootView_MetaInformationElement_value* _TSProotView_MetaInformationElement_value;
typedef struct _TSrootView_OutputElement_link* _TSProotView_OutputElement_link;
typedef struct _TSrootView_OutputElement_content* _TSProotView_OutputElement_content;
typedef struct _TSrootView_ListOutputElement_styleSheetBlock* _TSProotView_ListOutputElement_styleSheetBlock;
typedef struct _TSrootView_ListOutputElement_dataSourceActualParams* _TSProotView_ListOutputElement_dataSourceActualParams;
typedef struct _TSrootView_ListOutputElement_dataSource* _TSProotView_ListOutputElement_dataSource;
typedef struct _TSrootView_ListOutputElement_maxNumberOfElements* _TSProotView_ListOutputElement_maxNumberOfElements;
typedef struct _TSrootView_ListOutputElement_navigationElement* _TSProotView_ListOutputElement_navigationElement;
typedef struct _TSrootView_StyleSheet_name* _TSProotView_StyleSheet_name;
typedef struct _TSrootView_StyleSheet_custom* _TSProotView_StyleSheet_custom;
typedef struct _TSrootView_StyleSheet_default* _TSProotView_StyleSheet_default;
typedef struct _TSrootView_CustomStyleSheetBlock* _TSProotView_CustomStyleSheetBlock;
typedef struct _TSrootView_HtmlStyleSheetBlock* _TSProotView_HtmlStyleSheetBlock;
typedef struct _TSrootView_CustomStyleSheetBlock_pairs* _TSProotView_CustomStyleSheetBlock_pairs;
typedef struct _TSrootView_CustomStyleSheetBlock_name* _TSProotView_CustomStyleSheetBlock_name;
typedef struct _TSrootView_StyleSheetPair* _TSProotView_StyleSheetPair;
typedef struct _TSrootView_StyleSheetPair_category* _TSProotView_StyleSheetPair_category;
typedef struct _TSrootView_StyleSheetPair_attribute* _TSProotView_StyleSheetPair_attribute;
typedef struct _TSrootView_StyleSheetPair_valueCategory* _TSProotView_StyleSheetPair_valueCategory;
typedef struct _TSrootView_StyleSheetPair_value* _TSProotView_StyleSheetPair_value;
typedef struct _TSrootView_CustomValue* _TSProotView_CustomValue;
typedef struct _TSrootView_ListValue* _TSProotView_ListValue;
typedef struct _TSrootView_AlignmentValue* _TSProotView_AlignmentValue;
typedef struct _TSrootView_HeadingValue* _TSProotView_HeadingValue;
typedef struct _TSrootView_StyleValue* _TSProotView_StyleValue;
typedef struct _TSrootView_FamilyValue* _TSProotView_FamilyValue;
typedef struct _TSrootView_ColorValue* _TSProotView_ColorValue;
typedef struct _TSrootView_SizeValue* _TSProotView_SizeValue;
typedef struct _TSrootView_SizeValue_measure* _TSProotView_SizeValue_measure;
typedef struct _TSrootView_SizeValue_value* _TSProotView_SizeValue_value;
typedef struct _TSrootView_ColorValue_color* _TSProotView_ColorValue_color;
typedef struct _TSrootView_FamilyValue_family* _TSProotView_FamilyValue_family;
typedef struct _TSrootView_StyleValue_style* _TSProotView_StyleValue_style;
typedef struct _TSrootView_HeadingValue_heading* _TSProotView_HeadingValue_heading;
typedef struct _TSrootView_AlignmentValue_alignment* _TSProotView_AlignmentValue_alignment;
typedef struct _TSrootView_ListValue_listed* _TSProotView_ListValue_listed;
typedef struct _TSrootView_CustomValue_value* _TSProotView_CustomValue_value;
typedef struct _TSrootView_HtmlStyleSheetBlock_pairs* _TSProotView_HtmlStyleSheetBlock_pairs;
typedef struct _TSrootView_HtmlStyleSheetBlock_name* _TSProotView_HtmlStyleSheetBlock_name;
typedef struct _TSrootView_ActionHandler* _TSProotView_ActionHandler;
typedef struct _TSrootView_ActionHandler_targetpage* _TSProotView_ActionHandler_targetpage;
typedef struct _TSrootView_ActionHandler_params* _TSProotView_ActionHandler_params;
typedef struct _TSrootView_WebAction_name* _TSProotView_WebAction_name;
typedef struct _TSrootView_WebAction_formalParameter* _TSProotView_WebAction_formalParameter;
typedef struct _TSrootView_WebAction_successpage* _TSProotView_WebAction_successpage;
typedef struct _TSrootView_WebAction_operations* _TSProotView_WebAction_operations;
typedef struct _TSrootView_WebAction_position* _TSProotView_WebAction_position;
typedef struct _TSrootView_DataBaseOperation* _TSProotView_DataBaseOperation;
typedef struct _TSrootView_PHPOperation* _TSProotView_PHPOperation;
typedef struct _TSrootView_PHPOperation_errorhandler* _TSProotView_PHPOperation_errorhandler;
typedef struct _TSrootView_PHPOperation_content* _TSProotView_PHPOperation_content;
typedef struct _TSrootView_DataBaseOperation_errorhandler* _TSProotView_DataBaseOperation_errorhandler;
typedef struct _TSrootView_DataBaseOperation_filter* _TSProotView_DataBaseOperation_filter;
typedef struct _TSrootView_DataBaseOperation_params* _TSProotView_DataBaseOperation_params;
typedef struct _TSsspDlg_StyleSheetPair* _TSPsspDlg_StyleSheetPair;
typedef struct _TSsspDlg_StyleSheetPair_category* _TSPsspDlg_StyleSheetPair_category;
typedef struct _TSsspDlg_StyleSheetPair_attribute* _TSPsspDlg_StyleSheetPair_attribute;
typedef struct _TSsspDlg_StyleSheetPair_valueCategory* _TSPsspDlg_StyleSheetPair_valueCategory;
typedef struct _TSsspDlg_StyleSheetPair_value* _TSPsspDlg_StyleSheetPair_value;
typedef struct _TSsspDlg_CustomValue* _TSPsspDlg_CustomValue;
typedef struct _TSsspDlg_ListValue* _TSPsspDlg_ListValue;
typedef struct _TSsspDlg_AlignmentValue* _TSPsspDlg_AlignmentValue;
typedef struct _TSsspDlg_HeadingValue* _TSPsspDlg_HeadingValue;
typedef struct _TSsspDlg_StyleValue* _TSPsspDlg_StyleValue;
typedef struct _TSsspDlg_FamilyValue* _TSPsspDlg_FamilyValue;
typedef struct _TSsspDlg_ColorValue* _TSPsspDlg_ColorValue;
typedef struct _TSsspDlg_SizeValue* _TSPsspDlg_SizeValue;
typedef struct _TSsspDlg_SizeValue_measure* _TSPsspDlg_SizeValue_measure;
typedef struct _TSsspDlg_SizeValue_value* _TSPsspDlg_SizeValue_value;
typedef struct _TSsspDlg_ColorValue_color* _TSPsspDlg_ColorValue_color;
typedef struct _TSsspDlg_FamilyValue_family* _TSPsspDlg_FamilyValue_family;
typedef struct _TSsspDlg_StyleValue_style* _TSPsspDlg_StyleValue_style;
typedef struct _TSsspDlg_HeadingValue_heading* _TSPsspDlg_HeadingValue_heading;
typedef struct _TSsspDlg_AlignmentValue_alignment* _TSPsspDlg_AlignmentValue_alignment;
typedef struct _TSsspDlg_ListValue_listed* _TSPsspDlg_ListValue_listed;
typedef struct _TSsspDlg_CustomValue_value* _TSPsspDlg_CustomValue_value;
typedef struct _TSstylesheetView_StyleSheet* _TSPstylesheetView_StyleSheet;
typedef struct _TSstylesheetView_StyleSheet_name* _TSPstylesheetView_StyleSheet_name;
typedef struct _TSstylesheetView_StyleSheet_custom* _TSPstylesheetView_StyleSheet_custom;
typedef struct _TSstylesheetView_StyleSheet_default* _TSPstylesheetView_StyleSheet_default;
typedef struct _TSstylesheetView_CustomStyleSheetBlock* _TSPstylesheetView_CustomStyleSheetBlock;
typedef struct _TSstylesheetView_HtmlStyleSheetBlock* _TSPstylesheetView_HtmlStyleSheetBlock;
typedef struct _TSstylesheetView_CustomStyleSheetBlock_pairs* _TSPstylesheetView_CustomStyleSheetBlock_pairs;
typedef struct _TSstylesheetView_CustomStyleSheetBlock_name* _TSPstylesheetView_CustomStyleSheetBlock_name;
typedef struct _TSstylesheetView_StyleSheetPair* _TSPstylesheetView_StyleSheetPair;
typedef struct _TSstylesheetView_StyleSheetPair_category* _TSPstylesheetView_StyleSheetPair_category;
typedef struct _TSstylesheetView_StyleSheetPair_attribute* _TSPstylesheetView_StyleSheetPair_attribute;
typedef struct _TSstylesheetView_StyleSheetPair_valueCategory* _TSPstylesheetView_StyleSheetPair_valueCategory;
typedef struct _TSstylesheetView_StyleSheetPair_value* _TSPstylesheetView_StyleSheetPair_value;
typedef struct _TSstylesheetView_CustomValue* _TSPstylesheetView_CustomValue;
typedef struct _TSstylesheetView_ListValue* _TSPstylesheetView_ListValue;
typedef struct _TSstylesheetView_AlignmentValue* _TSPstylesheetView_AlignmentValue;
typedef struct _TSstylesheetView_HeadingValue* _TSPstylesheetView_HeadingValue;
typedef struct _TSstylesheetView_StyleValue* _TSPstylesheetView_StyleValue;
typedef struct _TSstylesheetView_FamilyValue* _TSPstylesheetView_FamilyValue;
typedef struct _TSstylesheetView_ColorValue* _TSPstylesheetView_ColorValue;
typedef struct _TSstylesheetView_SizeValue* _TSPstylesheetView_SizeValue;
typedef struct _TSstylesheetView_SizeValue_measure* _TSPstylesheetView_SizeValue_measure;
typedef struct _TSstylesheetView_SizeValue_value* _TSPstylesheetView_SizeValue_value;
typedef struct _TSstylesheetView_ColorValue_color* _TSPstylesheetView_ColorValue_color;
typedef struct _TSstylesheetView_FamilyValue_family* _TSPstylesheetView_FamilyValue_family;
typedef struct _TSstylesheetView_StyleValue_style* _TSPstylesheetView_StyleValue_style;
typedef struct _TSstylesheetView_HeadingValue_heading* _TSPstylesheetView_HeadingValue_heading;
typedef struct _TSstylesheetView_AlignmentValue_alignment* _TSPstylesheetView_AlignmentValue_alignment;
typedef struct _TSstylesheetView_ListValue_listed* _TSPstylesheetView_ListValue_listed;
typedef struct _TSstylesheetView_CustomValue_value* _TSPstylesheetView_CustomValue_value;
typedef struct _TSstylesheetView_HtmlStyleSheetBlock_pairs* _TSPstylesheetView_HtmlStyleSheetBlock_pairs;
typedef struct _TSstylesheetView_HtmlStyleSheetBlock_name* _TSPstylesheetView_HtmlStyleSheetBlock_name;
typedef struct _TSwebActionView_WebAction* _TSPwebActionView_WebAction;
typedef struct _TSwebActionView_WebNodeFormalParam* _TSPwebActionView_WebNodeFormalParam;
typedef struct _TSwebActionView_WebNodeFormalParam_name* _TSPwebActionView_WebNodeFormalParam_name;
typedef struct _TSwebActionView_WebNodeFormalParam_keyword1* _TSPwebActionView_WebNodeFormalParam_keyword1;
typedef struct _TSwebActionView_WebNodeFormalParam_type* _TSPwebActionView_WebNodeFormalParam_type;
typedef struct _TSwebActionView_DBBlob* _TSPwebActionView_DBBlob;
typedef struct _TSwebActionView_DBBoolean* _TSPwebActionView_DBBoolean;
typedef struct _TSwebActionView_DBTimeStamp* _TSPwebActionView_DBTimeStamp;
typedef struct _TSwebActionView_DBDate* _TSPwebActionView_DBDate;
typedef struct _TSwebActionView_DBBigInt* _TSPwebActionView_DBBigInt;
typedef struct _TSwebActionView_DBDouble* _TSPwebActionView_DBDouble;
typedef struct _TSwebActionView_DBFloat* _TSPwebActionView_DBFloat;
typedef struct _TSwebActionView_DBInteger* _TSPwebActionView_DBInteger;
typedef struct _TSwebActionView_DBString* _TSPwebActionView_DBString;
typedef struct _TSwebActionView_WebNodeActualParam* _TSPwebActionView_WebNodeActualParam;
typedef struct _TSwebActionView_WebNodeActualParam_formalParam* _TSPwebActionView_WebNodeActualParam_formalParam;
typedef struct _TSwebActionView_WebNodeActualParam_keyword1* _TSPwebActionView_WebNodeActualParam_keyword1;
typedef struct _TSwebActionView_WebNodeActualParam_expressions* _TSPwebActionView_WebNodeActualParam_expressions;
typedef struct _TSwebActionView_WebNodeColumnExpression* _TSPwebActionView_WebNodeColumnExpression;
typedef struct _TSwebActionView_WebNodeVariableExpression* _TSPwebActionView_WebNodeVariableExpression;
typedef struct _TSwebActionView_WebNodeConstantExpression* _TSPwebActionView_WebNodeConstantExpression;
typedef struct _TSwebActionView_WebNodeConstantExpression_keyword1* _TSPwebActionView_WebNodeConstantExpression_keyword1;
typedef struct _TSwebActionView_WebNodeConstantExpression_value* _TSPwebActionView_WebNodeConstantExpression_value;
typedef struct _TSwebActionView_WebNodeConstantExpression_keyword2* _TSPwebActionView_WebNodeConstantExpression_keyword2;
typedef struct _TSwebActionView_WebNodeVariableExpression_content* _TSPwebActionView_WebNodeVariableExpression_content;
typedef struct _TSwebActionView_WebNodeColumnExpression_content* _TSPwebActionView_WebNodeColumnExpression_content;
typedef struct _TSwebActionView_DBString_keyword1* _TSPwebActionView_DBString_keyword1;
typedef struct _TSwebActionView_DBInteger_keyword1* _TSPwebActionView_DBInteger_keyword1;
typedef struct _TSwebActionView_DBFloat_keyword1* _TSPwebActionView_DBFloat_keyword1;
typedef struct _TSwebActionView_DBDouble_keyword1* _TSPwebActionView_DBDouble_keyword1;
typedef struct _TSwebActionView_DBBigInt_keyword1* _TSPwebActionView_DBBigInt_keyword1;
typedef struct _TSwebActionView_DBDate_keyword1* _TSPwebActionView_DBDate_keyword1;
typedef struct _TSwebActionView_DBTimeStamp_keyword1* _TSPwebActionView_DBTimeStamp_keyword1;
typedef struct _TSwebActionView_DBBoolean_keyword1* _TSPwebActionView_DBBoolean_keyword1;
typedef struct _TSwebActionView_DBBlob_keyword1* _TSPwebActionView_DBBlob_keyword1;
typedef struct _TSwebActionView_DataSourceActualParam* _TSPwebActionView_DataSourceActualParam;
typedef struct _TSwebActionView_DataSourceActualParam_formalParam* _TSPwebActionView_DataSourceActualParam_formalParam;
typedef struct _TSwebActionView_DataSourceActualParam_keyword1* _TSPwebActionView_DataSourceActualParam_keyword1;
typedef struct _TSwebActionView_DataSourceActualParam_expressions* _TSPwebActionView_DataSourceActualParam_expressions;
typedef struct _TSwebActionView_ActionHandler* _TSPwebActionView_ActionHandler;
typedef struct _TSwebActionView_ActionHandler_targetpage* _TSPwebActionView_ActionHandler_targetpage;
typedef struct _TSwebActionView_ActionHandler_params* _TSPwebActionView_ActionHandler_params;
typedef struct _TSwebActionView_WebAction_name* _TSPwebActionView_WebAction_name;
typedef struct _TSwebActionView_WebAction_formalParameter* _TSPwebActionView_WebAction_formalParameter;
typedef struct _TSwebActionView_WebAction_successpage* _TSPwebActionView_WebAction_successpage;
typedef struct _TSwebActionView_WebAction_operations* _TSPwebActionView_WebAction_operations;
typedef struct _TSwebActionView_WebAction_position* _TSPwebActionView_WebAction_position;
typedef struct _TSwebActionView_DataBaseOperation* _TSPwebActionView_DataBaseOperation;
typedef struct _TSwebActionView_PHPOperation* _TSPwebActionView_PHPOperation;
typedef struct _TSwebActionView_PHPOperation_errorhandler* _TSPwebActionView_PHPOperation_errorhandler;
typedef struct _TSwebActionView_PHPOperation_content* _TSPwebActionView_PHPOperation_content;
typedef struct _TSwebActionView_DataBaseOperation_errorhandler* _TSPwebActionView_DataBaseOperation_errorhandler;
typedef struct _TSwebActionView_DataBaseOperation_filter* _TSPwebActionView_DataBaseOperation_filter;
typedef struct _TSwebActionView_DataBaseOperation_params* _TSPwebActionView_DataBaseOperation_params;
typedef struct _TSwebPageView_WebPage* _TSPwebPageView_WebPage;
typedef struct _TSwebPageView_FormularCheckboxElement* _TSPwebPageView_FormularCheckboxElement;
typedef struct _TSwebPageView_FormularCheckboxElement_label* _TSPwebPageView_FormularCheckboxElement_label;
typedef struct _TSwebPageView_FormularCheckboxElement_type* _TSPwebPageView_FormularCheckboxElement_type;
typedef struct _TSwebPageView_FormularCheckboxElement_condition* _TSPwebPageView_FormularCheckboxElement_condition;
typedef struct _TSwebPageView_FormularCheckboxElement_description* _TSPwebPageView_FormularCheckboxElement_description;
typedef struct _TSwebPageView_FormularCheckboxElement_name* _TSPwebPageView_FormularCheckboxElement_name;
typedef struct _TSwebPageView_FormularCondition* _TSPwebPageView_FormularCondition;
typedef struct _TSwebPageView_FormularTextElement* _TSPwebPageView_FormularTextElement;
typedef struct _TSwebPageView_FormularTextElement_label* _TSPwebPageView_FormularTextElement_label;
typedef struct _TSwebPageView_FormularTextElement_type* _TSPwebPageView_FormularTextElement_type;
typedef struct _TSwebPageView_FormularTextElement_condition* _TSPwebPageView_FormularTextElement_condition;
typedef struct _TSwebPageView_FormularTextElement_description* _TSPwebPageView_FormularTextElement_description;
typedef struct _TSwebPageView_FormularPasswordElement* _TSPwebPageView_FormularPasswordElement;
typedef struct _TSwebPageView_FormularPasswordElement_label* _TSPwebPageView_FormularPasswordElement_label;
typedef struct _TSwebPageView_FormularPasswordElement_type* _TSPwebPageView_FormularPasswordElement_type;
typedef struct _TSwebPageView_FormularPasswordElement_condition* _TSPwebPageView_FormularPasswordElement_condition;
typedef struct _TSwebPageView_FormularPasswordElement_description* _TSPwebPageView_FormularPasswordElement_description;
typedef struct _TSwebPageView_FormularTextAreaElement* _TSPwebPageView_FormularTextAreaElement;
typedef struct _TSwebPageView_FormularTextAreaElement_label* _TSPwebPageView_FormularTextAreaElement_label;
typedef struct _TSwebPageView_FormularTextAreaElement_type* _TSPwebPageView_FormularTextAreaElement_type;
typedef struct _TSwebPageView_FormularTextAreaElement_condition* _TSPwebPageView_FormularTextAreaElement_condition;
typedef struct _TSwebPageView_FormularTextAreaElement_description* _TSPwebPageView_FormularTextAreaElement_description;
typedef struct _TSwebPageView_FormularSelectElement* _TSPwebPageView_FormularSelectElement;
typedef struct _TSwebPageView_FormularSelectElement_label* _TSPwebPageView_FormularSelectElement_label;
typedef struct _TSwebPageView_FormularSelectElement_multiple* _TSPwebPageView_FormularSelectElement_multiple;
typedef struct _TSwebPageView_FormularSelectElement_options* _TSPwebPageView_FormularSelectElement_options;
typedef struct _TSwebPageView_FormularSelectElement_description* _TSPwebPageView_FormularSelectElement_description;
typedef struct _TSwebPageView_FormularPHPScriptSelectOption* _TSPwebPageView_FormularPHPScriptSelectOption;
typedef struct _TSwebPageView_FormularDataSourceSelectOption* _TSPwebPageView_FormularDataSourceSelectOption;
typedef struct _TSwebPageView_FormularConstantSelectOption* _TSPwebPageView_FormularConstantSelectOption;
typedef struct _TSwebPageView_FormularRadioElement* _TSPwebPageView_FormularRadioElement;
typedef struct _TSwebPageView_FormularRadioElement_type* _TSPwebPageView_FormularRadioElement_type;
typedef struct _TSwebPageView_FormularRadioElement_label* _TSPwebPageView_FormularRadioElement_label;
typedef struct _TSwebPageView_FormularRadioElement_name* _TSPwebPageView_FormularRadioElement_name;
typedef struct _TSwebPageView_DataSourceActualParam* _TSPwebPageView_DataSourceActualParam;
typedef struct _TSwebPageView_DataSourceActualParam_formalParam* _TSPwebPageView_DataSourceActualParam_formalParam;
typedef struct _TSwebPageView_DataSourceActualParam_keyword1* _TSPwebPageView_DataSourceActualParam_keyword1;
typedef struct _TSwebPageView_DataSourceActualParam_expressions* _TSPwebPageView_DataSourceActualParam_expressions;
typedef struct _TSwebPageView_WebNodeColumnExpression* _TSPwebPageView_WebNodeColumnExpression;
typedef struct _TSwebPageView_WebNodeVariableExpression* _TSPwebPageView_WebNodeVariableExpression;
typedef struct _TSwebPageView_WebNodeConstantExpression* _TSPwebPageView_WebNodeConstantExpression;
typedef struct _TSwebPageView_WebNodeActualParam* _TSPwebPageView_WebNodeActualParam;
typedef struct _TSwebPageView_WebNodeActualParam_formalParam* _TSPwebPageView_WebNodeActualParam_formalParam;
typedef struct _TSwebPageView_WebNodeActualParam_keyword1* _TSPwebPageView_WebNodeActualParam_keyword1;
typedef struct _TSwebPageView_WebNodeActualParam_expressions* _TSPwebPageView_WebNodeActualParam_expressions;
typedef struct _TSwebPageView_WebNodeConstantExpression_keyword1* _TSPwebPageView_WebNodeConstantExpression_keyword1;
typedef struct _TSwebPageView_WebNodeConstantExpression_value* _TSPwebPageView_WebNodeConstantExpression_value;
typedef struct _TSwebPageView_WebNodeConstantExpression_keyword2* _TSPwebPageView_WebNodeConstantExpression_keyword2;
typedef struct _TSwebPageView_WebNodeVariableExpression_content* _TSPwebPageView_WebNodeVariableExpression_content;
typedef struct _TSwebPageView_WebNodeColumnExpression_content* _TSPwebPageView_WebNodeColumnExpression_content;
typedef struct _TSwebPageView_WebNodeFormalParam* _TSPwebPageView_WebNodeFormalParam;
typedef struct _TSwebPageView_WebNodeFormalParam_name* _TSPwebPageView_WebNodeFormalParam_name;
typedef struct _TSwebPageView_WebNodeFormalParam_keyword1* _TSPwebPageView_WebNodeFormalParam_keyword1;
typedef struct _TSwebPageView_WebNodeFormalParam_type* _TSPwebPageView_WebNodeFormalParam_type;
typedef struct _TSwebPageView_DBBlob* _TSPwebPageView_DBBlob;
typedef struct _TSwebPageView_DBBoolean* _TSPwebPageView_DBBoolean;
typedef struct _TSwebPageView_DBTimeStamp* _TSPwebPageView_DBTimeStamp;
typedef struct _TSwebPageView_DBDate* _TSPwebPageView_DBDate;
typedef struct _TSwebPageView_DBBigInt* _TSPwebPageView_DBBigInt;
typedef struct _TSwebPageView_DBDouble* _TSPwebPageView_DBDouble;
typedef struct _TSwebPageView_DBFloat* _TSPwebPageView_DBFloat;
typedef struct _TSwebPageView_DBInteger* _TSPwebPageView_DBInteger;
typedef struct _TSwebPageView_DBString* _TSPwebPageView_DBString;
typedef struct _TSwebPageView_DBString_keyword1* _TSPwebPageView_DBString_keyword1;
typedef struct _TSwebPageView_DBInteger_keyword1* _TSPwebPageView_DBInteger_keyword1;
typedef struct _TSwebPageView_DBFloat_keyword1* _TSPwebPageView_DBFloat_keyword1;
typedef struct _TSwebPageView_DBDouble_keyword1* _TSPwebPageView_DBDouble_keyword1;
typedef struct _TSwebPageView_DBBigInt_keyword1* _TSPwebPageView_DBBigInt_keyword1;
typedef struct _TSwebPageView_DBDate_keyword1* _TSPwebPageView_DBDate_keyword1;
typedef struct _TSwebPageView_DBTimeStamp_keyword1* _TSPwebPageView_DBTimeStamp_keyword1;
typedef struct _TSwebPageView_DBBoolean_keyword1* _TSPwebPageView_DBBoolean_keyword1;
typedef struct _TSwebPageView_DBBlob_keyword1* _TSPwebPageView_DBBlob_keyword1;
typedef struct _TSwebPageView_Formular* _TSPwebPageView_Formular;
typedef struct _TSwebPageView_Formular_styleSheetBlock* _TSPwebPageView_Formular_styleSheetBlock;
typedef struct _TSwebPageView_Formular_action* _TSPwebPageView_Formular_action;
typedef struct _TSwebPageView_Formular_elements* _TSPwebPageView_Formular_elements;
typedef struct _TSwebPageView_Formular_datasource* _TSPwebPageView_Formular_datasource;
typedef struct _TSwebPageView_Formular_actualParams* _TSPwebPageView_Formular_actualParams;
typedef struct _TSwebPageView_FormularRadioGroupElement* _TSPwebPageView_FormularRadioGroupElement;
typedef struct _TSwebPageView_FormularRadioGroupElement_name* _TSPwebPageView_FormularRadioGroupElement_name;
typedef struct _TSwebPageView_FormularRadioGroupElement_label* _TSPwebPageView_FormularRadioGroupElement_label;
typedef struct _TSwebPageView_FormularRadioGroupElement_description* _TSPwebPageView_FormularRadioGroupElement_description;
typedef struct _TSwebPageView_FormularRadioGroupElement_pvalue* _TSPwebPageView_FormularRadioGroupElement_pvalue;
typedef struct _TSwebPageView_FormularRadioGroupElement_condition* _TSPwebPageView_FormularRadioGroupElement_condition;
typedef struct _TSwebPageView_FormularRadioGroupElement_elements* _TSPwebPageView_FormularRadioGroupElement_elements;
typedef struct _TSwebPageView_FormularRadioGroupElement_checked* _TSPwebPageView_FormularRadioGroupElement_checked;
typedef struct _TSwebPageView_FormularConstantSelectOption_values* _TSPwebPageView_FormularConstantSelectOption_values;
typedef struct _TSwebPageView_FormularDataSourceSelectOption_values* _TSPwebPageView_FormularDataSourceSelectOption_values;
typedef struct _TSwebPageView_FormularDataSourceSelectOption_params* _TSPwebPageView_FormularDataSourceSelectOption_params;
typedef struct _TSwebPageView_FormularPHPScriptSelectOption_script* _TSPwebPageView_FormularPHPScriptSelectOption_script;
typedef struct _TSwebPageView_FormularCondition_condition* _TSPwebPageView_FormularCondition_condition;
typedef struct _TSwebPageView_FormularCondition_params* _TSPwebPageView_FormularCondition_params;
typedef struct _TSwebPageView_FormularConditionActualParam* _TSPwebPageView_FormularConditionActualParam;
typedef struct _TSwebPageView_FormularConditionActualParam_value* _TSPwebPageView_FormularConditionActualParam_value;
typedef struct _TSwebPageView_FormularConditionActualParam_formalparam* _TSPwebPageView_FormularConditionActualParam_formalparam;
typedef struct _TSwebPageView_Paragraph* _TSPwebPageView_Paragraph;
typedef struct _TSwebPageView_Paragraph_styleSheetBlock* _TSPwebPageView_Paragraph_styleSheetBlock;
typedef struct _TSwebPageView_Paragraph_fragments* _TSPwebPageView_Paragraph_fragments;
typedef struct _TSwebPageView_OutputElement* _TSPwebPageView_OutputElement;
typedef struct _TSwebPageView_ImageFragment* _TSPwebPageView_ImageFragment;
typedef struct _TSwebPageView_TextFragment* _TSPwebPageView_TextFragment;
typedef struct _TSwebPageView_TextFragment_link* _TSPwebPageView_TextFragment_link;
typedef struct _TSwebPageView_TextFragment_value* _TSPwebPageView_TextFragment_value;
typedef struct _TSwebPageView_ImageFragment_link* _TSPwebPageView_ImageFragment_link;
typedef struct _TSwebPageView_ImageFragment_width* _TSPwebPageView_ImageFragment_width;
typedef struct _TSwebPageView_ImageFragment_height* _TSPwebPageView_ImageFragment_height;
typedef struct _TSwebPageView_ImageFragment_text* _TSPwebPageView_ImageFragment_text;
typedef struct _TSwebPageView_ImageFragment_imageName* _TSPwebPageView_ImageFragment_imageName;
typedef struct _TSwebPageView_Heading* _TSPwebPageView_Heading;
typedef struct _TSwebPageView_Heading_styleSheetBlock* _TSPwebPageView_Heading_styleSheetBlock;
typedef struct _TSwebPageView_Heading_text* _TSPwebPageView_Heading_text;
typedef struct _TSwebPageView_Heading_level* _TSPwebPageView_Heading_level;
typedef struct _TSwebPageView_Table* _TSPwebPageView_Table;
typedef struct _TSwebPageView_Table_styleSheetBlock* _TSPwebPageView_Table_styleSheetBlock;
typedef struct _TSwebPageView_Table_rows* _TSPwebPageView_Table_rows;
typedef struct _TSwebPageView_Table_columns* _TSPwebPageView_Table_columns;
typedef struct _TSwebPageView_TableRow* _TSPwebPageView_TableRow;
typedef struct _TSwebPageView_TableColumn* _TSPwebPageView_TableColumn;
typedef struct _TSwebPageView_TableRow_cells* _TSPwebPageView_TableRow_cells;
typedef struct _TSwebPageView_TableCell* _TSPwebPageView_TableCell;
typedef struct _TSwebPageView_TableCell_columnRef* _TSPwebPageView_TableCell_columnRef;
typedef struct _TSwebPageView_TableCell_content* _TSPwebPageView_TableCell_content;
typedef struct _TSwebPageView_Frame* _TSPwebPageView_Frame;
typedef struct _TSwebPageView_WebPage_name* _TSPwebPageView_WebPage_name;
typedef struct _TSwebPageView_WebPage_formalParameter* _TSPwebPageView_WebPage_formalParameter;
typedef struct _TSwebPageView_WebPage_title* _TSPwebPageView_WebPage_title;
typedef struct _TSwebPageView_WebPage_frame* _TSPwebPageView_WebPage_frame;
typedef struct _TSwebPageView_WebPage_styleSheetBlock* _TSPwebPageView_WebPage_styleSheetBlock;
typedef struct _TSwebPageView_WebPage_position* _TSPwebPageView_WebPage_position;
typedef struct _TSwebPageView_Frame_components* _TSPwebPageView_Frame_components;
typedef struct _TSwebPageView_Frame_styleSheetBlock* _TSPwebPageView_Frame_styleSheetBlock;
typedef struct _TSwebPageView_ListOutputElement* _TSPwebPageView_ListOutputElement;
typedef struct _TSwebPageView_FrameRef* _TSPwebPageView_FrameRef;
typedef struct _TSwebPageView_FrameRef_styleSheetBlock* _TSPwebPageView_FrameRef_styleSheetBlock;
typedef struct _TSwebPageView_FrameRef_frame* _TSPwebPageView_FrameRef_frame;
typedef struct _TSwebPageView_OutputElement_link* _TSPwebPageView_OutputElement_link;
typedef struct _TSwebPageView_OutputElement_content* _TSPwebPageView_OutputElement_content;
typedef struct _TSwebPageView_ListOutputElement_styleSheetBlock* _TSPwebPageView_ListOutputElement_styleSheetBlock;
typedef struct _TSwebPageView_ListOutputElement_dataSourceActualParams* _TSPwebPageView_ListOutputElement_dataSourceActualParams;
typedef struct _TSwebPageView_ListOutputElement_dataSource* _TSPwebPageView_ListOutputElement_dataSource;
typedef struct _TSwebPageView_ListOutputElement_maxNumberOfElements* _TSPwebPageView_ListOutputElement_maxNumberOfElements;
typedef struct _TSwebPageView_ListOutputElement_navigationElement* _TSPwebPageView_ListOutputElement_navigationElement;
typedef struct _TSLST_codeGen_DataSourceDB_columns* _TSPLST_codeGen_DataSourceDB_columns;
typedef struct _TSLST_codeGen_DataBase_dataSources* _TSPLST_codeGen_DataBase_dataSources;
typedef struct _TSLST_codeGen_DataBase_dataSourceModifications* _TSPLST_codeGen_DataBase_dataSourceModifications;
typedef struct _TSLST_codeGen_DataSourceProjectionFilter_formalParameters* _TSPLST_codeGen_DataSourceProjectionFilter_formalParameters;
typedef struct _TSLST_codeGen_DataSourceProjectionFilter_projectionColumns* _TSPLST_codeGen_DataSourceProjectionFilter_projectionColumns;
typedef struct _TSLST_codeGen_LimitDataSource_formalParameters* _TSPLST_codeGen_LimitDataSource_formalParameters;
typedef struct _TSLST_codeGen_DataSourceInsert_formalParams* _TSPLST_codeGen_DataSourceInsert_formalParams;
typedef struct _TSLST_codeGen_DataSourceInsert_values* _TSPLST_codeGen_DataSourceInsert_values;
typedef struct _TSLST_codeGen_DataSourceUpdate_formalParams* _TSPLST_codeGen_DataSourceUpdate_formalParams;
typedef struct _TSLST_codeGen_DataSourceUpdate_values* _TSPLST_codeGen_DataSourceUpdate_values;
typedef struct _TSLST_codeGen_DataSourceDelete_formalParams* _TSPLST_codeGen_DataSourceDelete_formalParams;
typedef struct _TSLST_codeGen_Formular_elements* _TSPLST_codeGen_Formular_elements;
typedef struct _TSLST_codeGen_Formular_actualParams* _TSPLST_codeGen_Formular_actualParams;
typedef struct _TSLST_codeGen_FormularRadioGroupElement_elements* _TSPLST_codeGen_FormularRadioGroupElement_elements;
typedef struct _TSLST_codeGen_FormularDataSourceSelectOption_params* _TSPLST_codeGen_FormularDataSourceSelectOption_params;
typedef struct _TSLST_codeGen_FormularCondition_params* _TSPLST_codeGen_FormularCondition_params;
typedef struct _TSLST_codeGen_FormularConditionDefinition_params* _TSPLST_codeGen_FormularConditionDefinition_params;
typedef struct _TSLST_codeGen_Paragraph_fragments* _TSPLST_codeGen_Paragraph_fragments;
typedef struct _TSLST_codeGen_Table_rows* _TSPLST_codeGen_Table_rows;
typedef struct _TSLST_codeGen_Table_columns* _TSPLST_codeGen_Table_columns;
typedef struct _TSLST_codeGen_TableRow_cells* _TSPLST_codeGen_TableRow_cells;
typedef struct _TSLST_codeGen_Root_library* _TSPLST_codeGen_Root_library;
typedef struct _TSLST_codeGen_Library_formularconditions* _TSPLST_codeGen_Library_formularconditions;
typedef struct _TSLST_codeGen_Library_navigationElement* _TSPLST_codeGen_Library_navigationElement;
typedef struct _TSLST_codeGen_WebApplication_frames* _TSPLST_codeGen_WebApplication_frames;
typedef struct _TSLST_codeGen_WebApplication_roles* _TSPLST_codeGen_WebApplication_roles;
typedef struct _TSLST_codeGen_WebApplication_linksExtern* _TSPLST_codeGen_WebApplication_linksExtern;
typedef struct _TSLST_codeGen_RootWebZone_webTargets* _TSPLST_codeGen_RootWebZone_webTargets;
typedef struct _TSLST_codeGen_RootWebZone_roles* _TSPLST_codeGen_RootWebZone_roles;
typedef struct _TSLST_codeGen_SubWebZone_webTargets* _TSPLST_codeGen_SubWebZone_webTargets;
typedef struct _TSLST_codeGen_SubWebZone_globalparams* _TSPLST_codeGen_SubWebZone_globalparams;
typedef struct _TSLST_codeGen_SubWebZone_roles* _TSPLST_codeGen_SubWebZone_roles;
typedef struct _TSLST_codeGen_WebPage_formalParameter* _TSPLST_codeGen_WebPage_formalParameter;
typedef struct _TSLST_codeGen_Frame_components* _TSPLST_codeGen_Frame_components;
typedef struct _TSLST_codeGen_GlobalFrame_components* _TSPLST_codeGen_GlobalFrame_components;
typedef struct _TSLST_codeGen_NavigationBar_elements* _TSPLST_codeGen_NavigationBar_elements;
typedef struct _TSLST_codeGen_MetaInformation_elements* _TSPLST_codeGen_MetaInformation_elements;
typedef struct _TSLST_codeGen_ListOutputElement_dataSourceActualParams* _TSPLST_codeGen_ListOutputElement_dataSourceActualParams;
typedef struct _TSLST_codeGen_StyleSheet_custom* _TSPLST_codeGen_StyleSheet_custom;
typedef struct _TSLST_codeGen_StyleSheet_default* _TSPLST_codeGen_StyleSheet_default;
typedef struct _TSLST_codeGen_CustomStyleSheetBlock_pairs* _TSPLST_codeGen_CustomStyleSheetBlock_pairs;
typedef struct _TSLST_codeGen_HtmlStyleSheetBlock_pairs* _TSPLST_codeGen_HtmlStyleSheetBlock_pairs;
typedef struct _TSLST_codeGen_ActionHandler_params* _TSPLST_codeGen_ActionHandler_params;
typedef struct _TSLST_codeGen_WebAction_formalParameter* _TSPLST_codeGen_WebAction_formalParameter;
typedef struct _TSLST_codeGen_WebAction_operations* _TSPLST_codeGen_WebAction_operations;
typedef struct _TSLST_codeGen_PHPOperation_errorhandler* _TSPLST_codeGen_PHPOperation_errorhandler;
typedef struct _TSLST_codeGen_DataBaseOperation_errorhandler* _TSPLST_codeGen_DataBaseOperation_errorhandler;
typedef struct _TSLST_codeGen_DataBaseOperation_params* _TSPLST_codeGen_DataBaseOperation_params;
typedef struct _TSLST_dataBaseView_DBColumn_type* _TSPLST_dataBaseView_DBColumn_type;
typedef struct _TSLST_dataBaseView_DataSourceFormalParam_type* _TSPLST_dataBaseView_DataSourceFormalParam_type;
typedef struct _TSLST_dataBaseView_BinaryExpression_leftOperand* _TSPLST_dataBaseView_BinaryExpression_leftOperand;
typedef struct _TSLST_dataBaseView_BinaryExpression_rightOperand* _TSPLST_dataBaseView_BinaryExpression_rightOperand;
typedef struct _TSLST_dataBaseView_UnaryExpression_operand* _TSPLST_dataBaseView_UnaryExpression_operand;
typedef struct _TSLST_dataBaseView_DataSourceValue_expression* _TSPLST_dataBaseView_DataSourceValue_expression;
typedef struct _TSLST_dataBaseView_DataSourceProjectionFilter_formalParameters* _TSPLST_dataBaseView_DataSourceProjectionFilter_formalParameters;
typedef struct _TSLST_dataBaseView_DataSourceProjectionFilter_projectionColumns* _TSPLST_dataBaseView_DataSourceProjectionFilter_projectionColumns;
typedef struct _TSLST_dataBaseView_DataSourceProjectionFilter_condition* _TSPLST_dataBaseView_DataSourceProjectionFilter_condition;
typedef struct _TSLST_dataBaseView_LimitDataSource_formalParameters* _TSPLST_dataBaseView_LimitDataSource_formalParameters;
typedef struct _TSLST_dataBaseView_LimitDataSource_minRow* _TSPLST_dataBaseView_LimitDataSource_minRow;
typedef struct _TSLST_dataBaseView_LimitDataSource_maxRow* _TSPLST_dataBaseView_LimitDataSource_maxRow;
typedef struct _TSLST_dataBaseView_DataSourceInsert_formalParams* _TSPLST_dataBaseView_DataSourceInsert_formalParams;
typedef struct _TSLST_dataBaseView_DataSourceInsert_values* _TSPLST_dataBaseView_DataSourceInsert_values;
typedef struct _TSLST_dataBaseView_DataSourceUpdate_formalParams* _TSPLST_dataBaseView_DataSourceUpdate_formalParams;
typedef struct _TSLST_dataBaseView_DataSourceUpdate_values* _TSPLST_dataBaseView_DataSourceUpdate_values;
typedef struct _TSLST_dataBaseView_DataSourceUpdate_conditions* _TSPLST_dataBaseView_DataSourceUpdate_conditions;
typedef struct _TSLST_dataBaseView_DataSourceDelete_formalParams* _TSPLST_dataBaseView_DataSourceDelete_formalParams;
typedef struct _TSLST_dataBaseView_DataSourceDelete_conditions* _TSPLST_dataBaseView_DataSourceDelete_conditions;
typedef struct _TSLST_dataBaseView_DataSourceDB_columns* _TSPLST_dataBaseView_DataSourceDB_columns;
typedef struct _TSLST_dataBaseView_DataBase_dataSources* _TSPLST_dataBaseView_DataBase_dataSources;
typedef struct _TSLST_dataBaseView_DataBase_dataSourceModifications* _TSPLST_dataBaseView_DataBase_dataSourceModifications;
typedef struct _TSLST_fcDlg_FormularCondition_params* _TSPLST_fcDlg_FormularCondition_params;
typedef struct _TSLST_globalFrameView_FormularSelectElement_options* _TSPLST_globalFrameView_FormularSelectElement_options;
typedef struct _TSLST_globalFrameView_DataSourceActualParam_expressions* _TSPLST_globalFrameView_DataSourceActualParam_expressions;
typedef struct _TSLST_globalFrameView_WebNodeActualParam_expressions* _TSPLST_globalFrameView_WebNodeActualParam_expressions;
typedef struct _TSLST_globalFrameView_Formular_elements* _TSPLST_globalFrameView_Formular_elements;
typedef struct _TSLST_globalFrameView_Formular_actualParams* _TSPLST_globalFrameView_Formular_actualParams;
typedef struct _TSLST_globalFrameView_FormularRadioGroupElement_elements* _TSPLST_globalFrameView_FormularRadioGroupElement_elements;
typedef struct _TSLST_globalFrameView_FormularDataSourceSelectOption_params* _TSPLST_globalFrameView_FormularDataSourceSelectOption_params;
typedef struct _TSLST_globalFrameView_FormularCondition_params* _TSPLST_globalFrameView_FormularCondition_params;
typedef struct _TSLST_globalFrameView_Paragraph_fragments* _TSPLST_globalFrameView_Paragraph_fragments;
typedef struct _TSLST_globalFrameView_Table_rows* _TSPLST_globalFrameView_Table_rows;
typedef struct _TSLST_globalFrameView_Table_columns* _TSPLST_globalFrameView_Table_columns;
typedef struct _TSLST_globalFrameView_TableRow_cells* _TSPLST_globalFrameView_TableRow_cells;
typedef struct _TSLST_globalFrameView_Frame_components* _TSPLST_globalFrameView_Frame_components;
typedef struct _TSLST_globalFrameView_GlobalFrame_components* _TSPLST_globalFrameView_GlobalFrame_components;
typedef struct _TSLST_globalFrameView_ListOutputElement_dataSourceActualParams* _TSPLST_globalFrameView_ListOutputElement_dataSourceActualParams;
typedef struct _TSLST_metaInformation_MetaInformation_elements* _TSPLST_metaInformation_MetaInformation_elements;
typedef struct _TSLST_navigationBarView_NavigationBar_elements* _TSPLST_navigationBarView_NavigationBar_elements;
typedef struct _TSLST_rootView_WebNodeFormalParam_type* _TSPLST_rootView_WebNodeFormalParam_type;
typedef struct _TSLST_rootView_DataSourceActualParam_expressions* _TSPLST_rootView_DataSourceActualParam_expressions;
typedef struct _TSLST_rootView_Formular_elements* _TSPLST_rootView_Formular_elements;
typedef struct _TSLST_rootView_Formular_actualParams* _TSPLST_rootView_Formular_actualParams;
typedef struct _TSLST_rootView_FormularRadioGroupElement_elements* _TSPLST_rootView_FormularRadioGroupElement_elements;
typedef struct _TSLST_rootView_FormularSelectElement_options* _TSPLST_rootView_FormularSelectElement_options;
typedef struct _TSLST_rootView_FormularDataSourceSelectOption_params* _TSPLST_rootView_FormularDataSourceSelectOption_params;
typedef struct _TSLST_rootView_FormularCondition_params* _TSPLST_rootView_FormularCondition_params;
typedef struct _TSLST_rootView_FormularConditionDefinition_params* _TSPLST_rootView_FormularConditionDefinition_params;
typedef struct _TSLST_rootView_WebNodeActualParam_expressions* _TSPLST_rootView_WebNodeActualParam_expressions;
typedef struct _TSLST_rootView_Paragraph_fragments* _TSPLST_rootView_Paragraph_fragments;
typedef struct _TSLST_rootView_Table_rows* _TSPLST_rootView_Table_rows;
typedef struct _TSLST_rootView_Table_columns* _TSPLST_rootView_Table_columns;
typedef struct _TSLST_rootView_TableRow_cells* _TSPLST_rootView_TableRow_cells;
typedef struct _TSLST_rootView_Root_library* _TSPLST_rootView_Root_library;
typedef struct _TSLST_rootView_Library_formularconditions* _TSPLST_rootView_Library_formularconditions;
typedef struct _TSLST_rootView_Library_navigationElement* _TSPLST_rootView_Library_navigationElement;
typedef struct _TSLST_rootView_WebApplication_frames* _TSPLST_rootView_WebApplication_frames;
typedef struct _TSLST_rootView_WebApplication_roles* _TSPLST_rootView_WebApplication_roles;
typedef struct _TSLST_rootView_WebApplication_linksExtern* _TSPLST_rootView_WebApplication_linksExtern;
typedef struct _TSLST_rootView_RootWebZone_webTargets* _TSPLST_rootView_RootWebZone_webTargets;
typedef struct _TSLST_rootView_RootWebZone_roles* _TSPLST_rootView_RootWebZone_roles;
typedef struct _TSLST_rootView_SubWebZone_webTargets* _TSPLST_rootView_SubWebZone_webTargets;
typedef struct _TSLST_rootView_SubWebZone_globalparams* _TSPLST_rootView_SubWebZone_globalparams;
typedef struct _TSLST_rootView_SubWebZone_roles* _TSPLST_rootView_SubWebZone_roles;
typedef struct _TSLST_rootView_WebPage_formalParameter* _TSPLST_rootView_WebPage_formalParameter;
typedef struct _TSLST_rootView_Frame_components* _TSPLST_rootView_Frame_components;
typedef struct _TSLST_rootView_GlobalFrame_components* _TSPLST_rootView_GlobalFrame_components;
typedef struct _TSLST_rootView_NavigationBar_elements* _TSPLST_rootView_NavigationBar_elements;
typedef struct _TSLST_rootView_MetaInformation_elements* _TSPLST_rootView_MetaInformation_elements;
typedef struct _TSLST_rootView_ListOutputElement_dataSourceActualParams* _TSPLST_rootView_ListOutputElement_dataSourceActualParams;
typedef struct _TSLST_rootView_StyleSheet_custom* _TSPLST_rootView_StyleSheet_custom;
typedef struct _TSLST_rootView_StyleSheet_default* _TSPLST_rootView_StyleSheet_default;
typedef struct _TSLST_rootView_CustomStyleSheetBlock_pairs* _TSPLST_rootView_CustomStyleSheetBlock_pairs;
typedef struct _TSLST_rootView_StyleSheetPair_value* _TSPLST_rootView_StyleSheetPair_value;
typedef struct _TSLST_rootView_HtmlStyleSheetBlock_pairs* _TSPLST_rootView_HtmlStyleSheetBlock_pairs;
typedef struct _TSLST_rootView_ActionHandler_params* _TSPLST_rootView_ActionHandler_params;
typedef struct _TSLST_rootView_WebAction_formalParameter* _TSPLST_rootView_WebAction_formalParameter;
typedef struct _TSLST_rootView_WebAction_operations* _TSPLST_rootView_WebAction_operations;
typedef struct _TSLST_rootView_PHPOperation_errorhandler* _TSPLST_rootView_PHPOperation_errorhandler;
typedef struct _TSLST_rootView_DataBaseOperation_errorhandler* _TSPLST_rootView_DataBaseOperation_errorhandler;
typedef struct _TSLST_rootView_DataBaseOperation_params* _TSPLST_rootView_DataBaseOperation_params;
typedef struct _TSLST_sspDlg_StyleSheetPair_value* _TSPLST_sspDlg_StyleSheetPair_value;
typedef struct _TSLST_stylesheetView_StyleSheet_custom* _TSPLST_stylesheetView_StyleSheet_custom;
typedef struct _TSLST_stylesheetView_StyleSheet_default* _TSPLST_stylesheetView_StyleSheet_default;
typedef struct _TSLST_stylesheetView_CustomStyleSheetBlock_pairs* _TSPLST_stylesheetView_CustomStyleSheetBlock_pairs;
typedef struct _TSLST_stylesheetView_StyleSheetPair_value* _TSPLST_stylesheetView_StyleSheetPair_value;
typedef struct _TSLST_stylesheetView_HtmlStyleSheetBlock_pairs* _TSPLST_stylesheetView_HtmlStyleSheetBlock_pairs;
typedef struct _TSLST_webActionView_WebNodeFormalParam_type* _TSPLST_webActionView_WebNodeFormalParam_type;
typedef struct _TSLST_webActionView_WebNodeActualParam_expressions* _TSPLST_webActionView_WebNodeActualParam_expressions;
typedef struct _TSLST_webActionView_DataSourceActualParam_expressions* _TSPLST_webActionView_DataSourceActualParam_expressions;
typedef struct _TSLST_webActionView_ActionHandler_params* _TSPLST_webActionView_ActionHandler_params;
typedef struct _TSLST_webActionView_WebAction_formalParameter* _TSPLST_webActionView_WebAction_formalParameter;
typedef struct _TSLST_webActionView_WebAction_operations* _TSPLST_webActionView_WebAction_operations;
typedef struct _TSLST_webActionView_PHPOperation_errorhandler* _TSPLST_webActionView_PHPOperation_errorhandler;
typedef struct _TSLST_webActionView_DataBaseOperation_errorhandler* _TSPLST_webActionView_DataBaseOperation_errorhandler;
typedef struct _TSLST_webActionView_DataBaseOperation_params* _TSPLST_webActionView_DataBaseOperation_params;
typedef struct _TSLST_webPageView_FormularSelectElement_options* _TSPLST_webPageView_FormularSelectElement_options;
typedef struct _TSLST_webPageView_DataSourceActualParam_expressions* _TSPLST_webPageView_DataSourceActualParam_expressions;
typedef struct _TSLST_webPageView_WebNodeActualParam_expressions* _TSPLST_webPageView_WebNodeActualParam_expressions;
typedef struct _TSLST_webPageView_WebNodeFormalParam_type* _TSPLST_webPageView_WebNodeFormalParam_type;
typedef struct _TSLST_webPageView_Formular_elements* _TSPLST_webPageView_Formular_elements;
typedef struct _TSLST_webPageView_Formular_actualParams* _TSPLST_webPageView_Formular_actualParams;
typedef struct _TSLST_webPageView_FormularRadioGroupElement_elements* _TSPLST_webPageView_FormularRadioGroupElement_elements;
typedef struct _TSLST_webPageView_FormularDataSourceSelectOption_params* _TSPLST_webPageView_FormularDataSourceSelectOption_params;
typedef struct _TSLST_webPageView_FormularCondition_params* _TSPLST_webPageView_FormularCondition_params;
typedef struct _TSLST_webPageView_Paragraph_fragments* _TSPLST_webPageView_Paragraph_fragments;
typedef struct _TSLST_webPageView_Table_rows* _TSPLST_webPageView_Table_rows;
typedef struct _TSLST_webPageView_Table_columns* _TSPLST_webPageView_Table_columns;
typedef struct _TSLST_webPageView_TableRow_cells* _TSPLST_webPageView_TableRow_cells;
typedef struct _TSLST_webPageView_WebPage_formalParameter* _TSPLST_webPageView_WebPage_formalParameter;
typedef struct _TSLST_webPageView_Frame_components* _TSPLST_webPageView_Frame_components;
typedef struct _TSLST_webPageView_ListOutputElement_dataSourceActualParams* _TSPLST_webPageView_ListOutputElement_dataSourceActualParams;
typedef struct _TPpEmpty* _TPPpEmpty;
typedef struct _TPpVIEWROOT_codeGen* _TPPpVIEWROOT_codeGen;
typedef struct _TPpcodeGen_DataSourceDB* _TPPpcodeGen_DataSourceDB;
typedef struct _TPpcodeGen_DataSourceDB_name* _TPPpcodeGen_DataSourceDB_name;
typedef struct _TPpcodeGen_DataSourceDB_position* _TPPpcodeGen_DataSourceDB_position;
typedef struct _TPpcodeGen_DataSourceDB_columns* _TPPpcodeGen_DataSourceDB_columns;
typedef struct _TPpcodeGen_DataBase* _TPPpcodeGen_DataBase;
typedef struct _TPpcodeGen_DataBase_name* _TPPpcodeGen_DataBase_name;
typedef struct _TPpcodeGen_DataBase_userName* _TPPpcodeGen_DataBase_userName;
typedef struct _TPpcodeGen_DataBase_userPassword* _TPPpcodeGen_DataBase_userPassword;
typedef struct _TPpcodeGen_DataBase_hostName* _TPPpcodeGen_DataBase_hostName;
typedef struct _TPpcodeGen_DataBase_port* _TPPpcodeGen_DataBase_port;
typedef struct _TPpcodeGen_DataBase_dataBaseType* _TPPpcodeGen_DataBase_dataBaseType;
typedef struct _TPpcodeGen_DataBase_dataSources* _TPPpcodeGen_DataBase_dataSources;
typedef struct _TPpcodeGen_DataBase_dataSourceModifications* _TPPpcodeGen_DataBase_dataSourceModifications;
typedef struct _TPpcodeGen_DataBase_setSize* _TPPpcodeGen_DataBase_setSize;
typedef struct _TPpcodeGen_DataBase_modifySetSize* _TPPpcodeGen_DataBase_modifySetSize;
typedef struct _TPpcodeGen_DBColumn* _TPPpcodeGen_DBColumn;
typedef struct _TPpcodeGen_DBColumn_name* _TPPpcodeGen_DBColumn_name;
typedef struct _TPpcodeGen_DBString* _TPPpcodeGen_DBString;
typedef struct _TPpcodeGen_DBInteger* _TPPpcodeGen_DBInteger;
typedef struct _TPpcodeGen_DBFloat* _TPPpcodeGen_DBFloat;
typedef struct _TPpcodeGen_DBDouble* _TPPpcodeGen_DBDouble;
typedef struct _TPpcodeGen_DBBigInt* _TPPpcodeGen_DBBigInt;
typedef struct _TPpcodeGen_DBDate* _TPPpcodeGen_DBDate;
typedef struct _TPpcodeGen_DBTimeStamp* _TPPpcodeGen_DBTimeStamp;
typedef struct _TPpcodeGen_DBBoolean* _TPPpcodeGen_DBBoolean;
typedef struct _TPpcodeGen_DBBlob* _TPPpcodeGen_DBBlob;
typedef struct _TPpcodeGen_DataSourceProjectionFilter* _TPPpcodeGen_DataSourceProjectionFilter;
typedef struct _TPpcodeGen_DataSourceProjectionFilter_name* _TPPpcodeGen_DataSourceProjectionFilter_name;
typedef struct _TPpcodeGen_DataSourceProjectionFilter_position* _TPPpcodeGen_DataSourceProjectionFilter_position;
typedef struct _TPpcodeGen_DataSourceProjectionFilter_sourceDataSource* _TPPpcodeGen_DataSourceProjectionFilter_sourceDataSource;
typedef struct _TPpcodeGen_DataSourceProjectionFilter_formalParameters* _TPPpcodeGen_DataSourceProjectionFilter_formalParameters;
typedef struct _TPpcodeGen_DataSourceProjectionFilter_projectionColumns* _TPPpcodeGen_DataSourceProjectionFilter_projectionColumns;
typedef struct _TPpcodeGen_ColumnProjection* _TPPpcodeGen_ColumnProjection;
typedef struct _TPpcodeGen_ColumnProjection_column* _TPPpcodeGen_ColumnProjection_column;
typedef struct _TPpcodeGen_ComputationProjection* _TPPpcodeGen_ComputationProjection;
typedef struct _TPpcodeGen_ComputationProjection_column* _TPPpcodeGen_ComputationProjection_column;
typedef struct _TPpcodeGen_ComputationProjection_computation* _TPPpcodeGen_ComputationProjection_computation;
typedef struct _TPpcodeGen_LimitDataSource* _TPPpcodeGen_LimitDataSource;
typedef struct _TPpcodeGen_LimitDataSource_name* _TPPpcodeGen_LimitDataSource_name;
typedef struct _TPpcodeGen_LimitDataSource_position* _TPPpcodeGen_LimitDataSource_position;
typedef struct _TPpcodeGen_LimitDataSource_sourceDataSouce* _TPPpcodeGen_LimitDataSource_sourceDataSouce;
typedef struct _TPpcodeGen_LimitDataSource_formalParameters* _TPPpcodeGen_LimitDataSource_formalParameters;
typedef struct _TPpcodeGen_BinaryExpression* _TPPpcodeGen_BinaryExpression;
typedef struct _TPpcodeGen_BinaryExpression_operator* _TPPpcodeGen_BinaryExpression_operator;
typedef struct _TPpcodeGen_UnaryExpression* _TPPpcodeGen_UnaryExpression;
typedef struct _TPpcodeGen_UnaryExpression_operator* _TPPpcodeGen_UnaryExpression_operator;
typedef struct _TPpcodeGen_ConstantExpression* _TPPpcodeGen_ConstantExpression;
typedef struct _TPpcodeGen_ConstantExpression_value* _TPPpcodeGen_ConstantExpression_value;
typedef struct _TPpcodeGen_ColumnValueExpression* _TPPpcodeGen_ColumnValueExpression;
typedef struct _TPpcodeGen_ColumnValueExpression_column* _TPPpcodeGen_ColumnValueExpression_column;
typedef struct _TPpcodeGen_ParameterValueExpression* _TPPpcodeGen_ParameterValueExpression;
typedef struct _TPpcodeGen_ParameterValueExpression_parameter* _TPPpcodeGen_ParameterValueExpression_parameter;
typedef struct _TPpcodeGen_ComputationExpression* _TPPpcodeGen_ComputationExpression;
typedef struct _TPpcodeGen_ComputationExpression_column* _TPPpcodeGen_ComputationExpression_column;
typedef struct _TPpcodeGen_ComputationExpression_computation* _TPPpcodeGen_ComputationExpression_computation;
typedef struct _TPpcodeGen_DataSourceValue* _TPPpcodeGen_DataSourceValue;
typedef struct _TPpcodeGen_DataSourceValue_column* _TPPpcodeGen_DataSourceValue_column;
typedef struct _TPpcodeGen_DataSourceJoin* _TPPpcodeGen_DataSourceJoin;
typedef struct _TPpcodeGen_DataSourceJoin_name* _TPPpcodeGen_DataSourceJoin_name;
typedef struct _TPpcodeGen_DataSourceJoin_position* _TPPpcodeGen_DataSourceJoin_position;
typedef struct _TPpcodeGen_DataSourceJoin_dataSource1* _TPPpcodeGen_DataSourceJoin_dataSource1;
typedef struct _TPpcodeGen_DataSourceJoin_dataSource2* _TPPpcodeGen_DataSourceJoin_dataSource2;
typedef struct _TPpcodeGen_DataSourceJoin_columnRef1* _TPPpcodeGen_DataSourceJoin_columnRef1;
typedef struct _TPpcodeGen_DataSourceJoin_columnRef2* _TPPpcodeGen_DataSourceJoin_columnRef2;
typedef struct _TPpcodeGen_DataSourceJoin_joinOperator* _TPPpcodeGen_DataSourceJoin_joinOperator;
typedef struct _TPpcodeGen_DataSourceInsert* _TPPpcodeGen_DataSourceInsert;
typedef struct _TPpcodeGen_DataSourceInsert_targetDataSource* _TPPpcodeGen_DataSourceInsert_targetDataSource;
typedef struct _TPpcodeGen_DataSourceInsert_formalParams* _TPPpcodeGen_DataSourceInsert_formalParams;
typedef struct _TPpcodeGen_DataSourceInsert_name* _TPPpcodeGen_DataSourceInsert_name;
typedef struct _TPpcodeGen_DataSourceInsert_position* _TPPpcodeGen_DataSourceInsert_position;
typedef struct _TPpcodeGen_DataSourceInsert_values* _TPPpcodeGen_DataSourceInsert_values;
typedef struct _TPpcodeGen_DataSourceUpdate* _TPPpcodeGen_DataSourceUpdate;
typedef struct _TPpcodeGen_DataSourceUpdate_targetDataSource* _TPPpcodeGen_DataSourceUpdate_targetDataSource;
typedef struct _TPpcodeGen_DataSourceUpdate_formalParams* _TPPpcodeGen_DataSourceUpdate_formalParams;
typedef struct _TPpcodeGen_DataSourceUpdate_name* _TPPpcodeGen_DataSourceUpdate_name;
typedef struct _TPpcodeGen_DataSourceUpdate_position* _TPPpcodeGen_DataSourceUpdate_position;
typedef struct _TPpcodeGen_DataSourceUpdate_values* _TPPpcodeGen_DataSourceUpdate_values;
typedef struct _TPpcodeGen_DataSourceDelete* _TPPpcodeGen_DataSourceDelete;
typedef struct _TPpcodeGen_DataSourceDelete_targetDataSource* _TPPpcodeGen_DataSourceDelete_targetDataSource;
typedef struct _TPpcodeGen_DataSourceDelete_formalParams* _TPPpcodeGen_DataSourceDelete_formalParams;
typedef struct _TPpcodeGen_DataSourceDelete_name* _TPPpcodeGen_DataSourceDelete_name;
typedef struct _TPpcodeGen_DataSourceDelete_position* _TPPpcodeGen_DataSourceDelete_position;
typedef struct _TPpcodeGen_DataSourceActualParam* _TPPpcodeGen_DataSourceActualParam;
typedef struct _TPpcodeGen_DataSourceActualParam_formalParam* _TPPpcodeGen_DataSourceActualParam_formalParam;
typedef struct _TPpcodeGen_DataSourceFormalParam* _TPPpcodeGen_DataSourceFormalParam;
typedef struct _TPpcodeGen_DataSourceFormalParam_name* _TPPpcodeGen_DataSourceFormalParam_name;
typedef struct _TPpcodeGen_Formular* _TPPpcodeGen_Formular;
typedef struct _TPpcodeGen_Formular_styleSheetBlock* _TPPpcodeGen_Formular_styleSheetBlock;
typedef struct _TPpcodeGen_Formular_action* _TPPpcodeGen_Formular_action;
typedef struct _TPpcodeGen_Formular_elements* _TPPpcodeGen_Formular_elements;
typedef struct _TPpcodeGen_Formular_datasource* _TPPpcodeGen_Formular_datasource;
typedef struct _TPpcodeGen_Formular_actualParams* _TPPpcodeGen_Formular_actualParams;
typedef struct _TPpcodeGen_FormularRadioGroupElement* _TPPpcodeGen_FormularRadioGroupElement;
typedef struct _TPpcodeGen_FormularRadioGroupElement_name* _TPPpcodeGen_FormularRadioGroupElement_name;
typedef struct _TPpcodeGen_FormularRadioGroupElement_label* _TPPpcodeGen_FormularRadioGroupElement_label;
typedef struct _TPpcodeGen_FormularRadioGroupElement_description* _TPPpcodeGen_FormularRadioGroupElement_description;
typedef struct _TPpcodeGen_FormularRadioGroupElement_pvalue* _TPPpcodeGen_FormularRadioGroupElement_pvalue;
typedef struct _TPpcodeGen_FormularRadioGroupElement_elements* _TPPpcodeGen_FormularRadioGroupElement_elements;
typedef struct _TPpcodeGen_FormularRadioGroupElement_checked* _TPPpcodeGen_FormularRadioGroupElement_checked;
typedef struct _TPpcodeGen_FormularTextElement* _TPPpcodeGen_FormularTextElement;
typedef struct _TPpcodeGen_FormularTextElement_name* _TPPpcodeGen_FormularTextElement_name;
typedef struct _TPpcodeGen_FormularTextElement_label* _TPPpcodeGen_FormularTextElement_label;
typedef struct _TPpcodeGen_FormularTextElement_description* _TPPpcodeGen_FormularTextElement_description;
typedef struct _TPpcodeGen_FormularTextElement_pvalue* _TPPpcodeGen_FormularTextElement_pvalue;
typedef struct _TPpcodeGen_FormularTextAreaElement* _TPPpcodeGen_FormularTextAreaElement;
typedef struct _TPpcodeGen_FormularTextAreaElement_name* _TPPpcodeGen_FormularTextAreaElement_name;
typedef struct _TPpcodeGen_FormularTextAreaElement_label* _TPPpcodeGen_FormularTextAreaElement_label;
typedef struct _TPpcodeGen_FormularTextAreaElement_description* _TPPpcodeGen_FormularTextAreaElement_description;
typedef struct _TPpcodeGen_FormularTextAreaElement_pvalue* _TPPpcodeGen_FormularTextAreaElement_pvalue;
typedef struct _TPpcodeGen_FormularPasswordElement* _TPPpcodeGen_FormularPasswordElement;
typedef struct _TPpcodeGen_FormularPasswordElement_name* _TPPpcodeGen_FormularPasswordElement_name;
typedef struct _TPpcodeGen_FormularPasswordElement_label* _TPPpcodeGen_FormularPasswordElement_label;
typedef struct _TPpcodeGen_FormularPasswordElement_description* _TPPpcodeGen_FormularPasswordElement_description;
typedef struct _TPpcodeGen_FormularPasswordElement_pvalue* _TPPpcodeGen_FormularPasswordElement_pvalue;
typedef struct _TPpcodeGen_FormularCheckboxElement* _TPPpcodeGen_FormularCheckboxElement;
typedef struct _TPpcodeGen_FormularCheckboxElement_name* _TPPpcodeGen_FormularCheckboxElement_name;
typedef struct _TPpcodeGen_FormularCheckboxElement_label* _TPPpcodeGen_FormularCheckboxElement_label;
typedef struct _TPpcodeGen_FormularCheckboxElement_description* _TPPpcodeGen_FormularCheckboxElement_description;
typedef struct _TPpcodeGen_FormularCheckboxElement_pvalue* _TPPpcodeGen_FormularCheckboxElement_pvalue;
typedef struct _TPpcodeGen_FormularCheckboxElement_value* _TPPpcodeGen_FormularCheckboxElement_value;
typedef struct _TPpcodeGen_FormularCheckboxElement_checked* _TPPpcodeGen_FormularCheckboxElement_checked;
typedef struct _TPpcodeGen_FormularSelectElement* _TPPpcodeGen_FormularSelectElement;
typedef struct _TPpcodeGen_FormularSelectElement_name* _TPPpcodeGen_FormularSelectElement_name;
typedef struct _TPpcodeGen_FormularSelectElement_label* _TPPpcodeGen_FormularSelectElement_label;
typedef struct _TPpcodeGen_FormularSelectElement_description* _TPPpcodeGen_FormularSelectElement_description;
typedef struct _TPpcodeGen_FormularSelectElement_pvalue* _TPPpcodeGen_FormularSelectElement_pvalue;
typedef struct _TPpcodeGen_FormularSelectElement_size* _TPPpcodeGen_FormularSelectElement_size;
typedef struct _TPpcodeGen_FormularSelectElement_multiple* _TPPpcodeGen_FormularSelectElement_multiple;
typedef struct _TPpcodeGen_FormularConstantSelectOption* _TPPpcodeGen_FormularConstantSelectOption;
typedef struct _TPpcodeGen_FormularConstantSelectOption_values* _TPPpcodeGen_FormularConstantSelectOption_values;
typedef struct _TPpcodeGen_FormularDataSourceSelectOption* _TPPpcodeGen_FormularDataSourceSelectOption;
typedef struct _TPpcodeGen_FormularDataSourceSelectOption_values* _TPPpcodeGen_FormularDataSourceSelectOption_values;
typedef struct _TPpcodeGen_FormularDataSourceSelectOption_params* _TPPpcodeGen_FormularDataSourceSelectOption_params;
typedef struct _TPpcodeGen_FormularPHPScriptSelectOption* _TPPpcodeGen_FormularPHPScriptSelectOption;
typedef struct _TPpcodeGen_FormularPHPScriptSelectOption_script* _TPPpcodeGen_FormularPHPScriptSelectOption_script;
typedef struct _TPpcodeGen_FormularRadioElement* _TPPpcodeGen_FormularRadioElement;
typedef struct _TPpcodeGen_FormularRadioElement_value* _TPPpcodeGen_FormularRadioElement_value;
typedef struct _TPpcodeGen_FormularRadioElement_label* _TPPpcodeGen_FormularRadioElement_label;
typedef struct _TPpcodeGen_FormularRadioElement_name* _TPPpcodeGen_FormularRadioElement_name;
typedef struct _TPpcodeGen_FormularCondition* _TPPpcodeGen_FormularCondition;
typedef struct _TPpcodeGen_FormularCondition_condition* _TPPpcodeGen_FormularCondition_condition;
typedef struct _TPpcodeGen_FormularCondition_params* _TPPpcodeGen_FormularCondition_params;
typedef struct _TPpcodeGen_FormularConditionDefinition* _TPPpcodeGen_FormularConditionDefinition;
typedef struct _TPpcodeGen_FormularConditionDefinition_name* _TPPpcodeGen_FormularConditionDefinition_name;
typedef struct _TPpcodeGen_FormularConditionDefinition_params* _TPPpcodeGen_FormularConditionDefinition_params;
typedef struct _TPpcodeGen_FormularConditionDefinition_body* _TPPpcodeGen_FormularConditionDefinition_body;
typedef struct _TPpcodeGen_FormularConditionFormalParam* _TPPpcodeGen_FormularConditionFormalParam;
typedef struct _TPpcodeGen_FormularConditionFormalParam_name* _TPPpcodeGen_FormularConditionFormalParam_name;
typedef struct _TPpcodeGen_FormularConditionActualParam* _TPPpcodeGen_FormularConditionActualParam;
typedef struct _TPpcodeGen_FormularConditionActualParam_value* _TPPpcodeGen_FormularConditionActualParam_value;
typedef struct _TPpcodeGen_FormularConditionActualParam_formalparam* _TPPpcodeGen_FormularConditionActualParam_formalparam;
typedef struct _TPpcodeGen_WebNodeActualParam* _TPPpcodeGen_WebNodeActualParam;
typedef struct _TPpcodeGen_WebNodeActualParam_formalParam* _TPPpcodeGen_WebNodeActualParam_formalParam;
typedef struct _TPpcodeGen_WebNodeFormalParam* _TPPpcodeGen_WebNodeFormalParam;
typedef struct _TPpcodeGen_WebNodeFormalParam_name* _TPPpcodeGen_WebNodeFormalParam_name;
typedef struct _TPpcodeGen_WebNodeConstantExpression* _TPPpcodeGen_WebNodeConstantExpression;
typedef struct _TPpcodeGen_WebNodeConstantExpression_value* _TPPpcodeGen_WebNodeConstantExpression_value;
typedef struct _TPpcodeGen_WebNodeVariableExpression* _TPPpcodeGen_WebNodeVariableExpression;
typedef struct _TPpcodeGen_WebNodeVariableExpression_content* _TPPpcodeGen_WebNodeVariableExpression_content;
typedef struct _TPpcodeGen_WebNodeColumnExpression* _TPPpcodeGen_WebNodeColumnExpression;
typedef struct _TPpcodeGen_WebNodeColumnExpression_content* _TPPpcodeGen_WebNodeColumnExpression_content;
typedef struct _TPpcodeGen_Paragraph* _TPPpcodeGen_Paragraph;
typedef struct _TPpcodeGen_Paragraph_styleSheetBlock* _TPPpcodeGen_Paragraph_styleSheetBlock;
typedef struct _TPpcodeGen_Paragraph_fragments* _TPPpcodeGen_Paragraph_fragments;
typedef struct _TPpcodeGen_TextFragment* _TPPpcodeGen_TextFragment;
typedef struct _TPpcodeGen_TextFragment_link* _TPPpcodeGen_TextFragment_link;
typedef struct _TPpcodeGen_TextFragment_value* _TPPpcodeGen_TextFragment_value;
typedef struct _TPpcodeGen_ImageFragment* _TPPpcodeGen_ImageFragment;
typedef struct _TPpcodeGen_ImageFragment_link* _TPPpcodeGen_ImageFragment_link;
typedef struct _TPpcodeGen_ImageFragment_width* _TPPpcodeGen_ImageFragment_width;
typedef struct _TPpcodeGen_ImageFragment_height* _TPPpcodeGen_ImageFragment_height;
typedef struct _TPpcodeGen_ImageFragment_text* _TPPpcodeGen_ImageFragment_text;
typedef struct _TPpcodeGen_ImageFragment_imageName* _TPPpcodeGen_ImageFragment_imageName;
typedef struct _TPpcodeGen_Heading* _TPPpcodeGen_Heading;
typedef struct _TPpcodeGen_Heading_styleSheetBlock* _TPPpcodeGen_Heading_styleSheetBlock;
typedef struct _TPpcodeGen_Heading_text* _TPPpcodeGen_Heading_text;
typedef struct _TPpcodeGen_Heading_level* _TPPpcodeGen_Heading_level;
typedef struct _TPpcodeGen_Table* _TPPpcodeGen_Table;
typedef struct _TPpcodeGen_Table_styleSheetBlock* _TPPpcodeGen_Table_styleSheetBlock;
typedef struct _TPpcodeGen_Table_rows* _TPPpcodeGen_Table_rows;
typedef struct _TPpcodeGen_Table_columns* _TPPpcodeGen_Table_columns;
typedef struct _TPpcodeGen_TableRow* _TPPpcodeGen_TableRow;
typedef struct _TPpcodeGen_TableRow_cells* _TPPpcodeGen_TableRow_cells;
typedef struct _TPpcodeGen_TableColumn* _TPPpcodeGen_TableColumn;
typedef struct _TPpcodeGen_TableCell* _TPPpcodeGen_TableCell;
typedef struct _TPpcodeGen_TableCell_columnRef* _TPPpcodeGen_TableCell_columnRef;
typedef struct _TPpcodeGen_LinkTargetExtern* _TPPpcodeGen_LinkTargetExtern;
typedef struct _TPpcodeGen_LinkTargetExtern_name* _TPPpcodeGen_LinkTargetExtern_name;
typedef struct _TPpcodeGen_LinkTargetExtern_url* _TPPpcodeGen_LinkTargetExtern_url;
typedef struct _TPpcodeGen_Root* _TPPpcodeGen_Root;
typedef struct _TPpcodeGen_Root_library* _TPPpcodeGen_Root_library;
typedef struct _TPpcodeGen_Library* _TPPpcodeGen_Library;
typedef struct _TPpcodeGen_Library_name* _TPPpcodeGen_Library_name;
typedef struct _TPpcodeGen_Library_formularconditions* _TPPpcodeGen_Library_formularconditions;
typedef struct _TPpcodeGen_Library_navigationElement* _TPPpcodeGen_Library_navigationElement;
typedef struct _TPpcodeGen_NavigationElement* _TPPpcodeGen_NavigationElement;
typedef struct _TPpcodeGen_NavigationElement_code* _TPPpcodeGen_NavigationElement_code;
typedef struct _TPpcodeGen_NavigationElement_name* _TPPpcodeGen_NavigationElement_name;
typedef struct _TPpcodeGen_WebApplication* _TPPpcodeGen_WebApplication;
typedef struct _TPpcodeGen_WebApplication_name* _TPPpcodeGen_WebApplication_name;
typedef struct _TPpcodeGen_WebApplication_frames* _TPPpcodeGen_WebApplication_frames;
typedef struct _TPpcodeGen_WebApplication_roles* _TPPpcodeGen_WebApplication_roles;
typedef struct _TPpcodeGen_WebApplication_linksExtern* _TPPpcodeGen_WebApplication_linksExtern;
typedef struct _TPpcodeGen_WebApplication_imagePath* _TPPpcodeGen_WebApplication_imagePath;
typedef struct _TPpcodeGen_RootWebZone* _TPPpcodeGen_RootWebZone;
typedef struct _TPpcodeGen_RootWebZone_webTargets* _TPPpcodeGen_RootWebZone_webTargets;
typedef struct _TPpcodeGen_RootWebZone_errorLink* _TPPpcodeGen_RootWebZone_errorLink;
typedef struct _TPpcodeGen_RootWebZone_roles* _TPPpcodeGen_RootWebZone_roles;
typedef struct _TPpcodeGen_RootWebZone_setSize* _TPPpcodeGen_RootWebZone_setSize;
typedef struct _TPpcodeGen_SubWebZone* _TPPpcodeGen_SubWebZone;
typedef struct _TPpcodeGen_SubWebZone_name* _TPPpcodeGen_SubWebZone_name;
typedef struct _TPpcodeGen_SubWebZone_webTargets* _TPPpcodeGen_SubWebZone_webTargets;
typedef struct _TPpcodeGen_SubWebZone_errorLink* _TPPpcodeGen_SubWebZone_errorLink;
typedef struct _TPpcodeGen_SubWebZone_globalparams* _TPPpcodeGen_SubWebZone_globalparams;
typedef struct _TPpcodeGen_SubWebZone_roles* _TPPpcodeGen_SubWebZone_roles;
typedef struct _TPpcodeGen_SubWebZone_setSize* _TPPpcodeGen_SubWebZone_setSize;
typedef struct _TPpcodeGen_SubWebZone_position* _TPPpcodeGen_SubWebZone_position;
typedef struct _TPpcodeGen_WebRole* _TPPpcodeGen_WebRole;
typedef struct _TPpcodeGen_WebRole_name* _TPPpcodeGen_WebRole_name;
typedef struct _TPpcodeGen_WebRole_color* _TPPpcodeGen_WebRole_color;
typedef struct _TPpcodeGen_WebRoleRef* _TPPpcodeGen_WebRoleRef;
typedef struct _TPpcodeGen_WebRoleRef_role* _TPPpcodeGen_WebRoleRef_role;
typedef struct _TPpcodeGen_WebPage* _TPPpcodeGen_WebPage;
typedef struct _TPpcodeGen_WebPage_name* _TPPpcodeGen_WebPage_name;
typedef struct _TPpcodeGen_WebPage_formalParameter* _TPPpcodeGen_WebPage_formalParameter;
typedef struct _TPpcodeGen_WebPage_title* _TPPpcodeGen_WebPage_title;
typedef struct _TPpcodeGen_WebPage_styleSheetBlock* _TPPpcodeGen_WebPage_styleSheetBlock;
typedef struct _TPpcodeGen_WebPage_position* _TPPpcodeGen_WebPage_position;
typedef struct _TPpcodeGen_Frame* _TPPpcodeGen_Frame;
typedef struct _TPpcodeGen_Frame_components* _TPPpcodeGen_Frame_components;
typedef struct _TPpcodeGen_Frame_styleSheetBlock* _TPPpcodeGen_Frame_styleSheetBlock;
typedef struct _TPpcodeGen_GlobalFrame* _TPPpcodeGen_GlobalFrame;
typedef struct _TPpcodeGen_GlobalFrame_name* _TPPpcodeGen_GlobalFrame_name;
typedef struct _TPpcodeGen_GlobalFrame_components* _TPPpcodeGen_GlobalFrame_components;
typedef struct _TPpcodeGen_GlobalFrame_setSize* _TPPpcodeGen_GlobalFrame_setSize;
typedef struct _TPpcodeGen_NavigationBar* _TPPpcodeGen_NavigationBar;
typedef struct _TPpcodeGen_NavigationBar_styleSheetBlock* _TPPpcodeGen_NavigationBar_styleSheetBlock;
typedef struct _TPpcodeGen_NavigationBar_elements* _TPPpcodeGen_NavigationBar_elements;
typedef struct _TPpcodeGen_NavigationBar_alignment* _TPPpcodeGen_NavigationBar_alignment;
typedef struct _TPpcodeGen_NavigationBarElement* _TPPpcodeGen_NavigationBarElement;
typedef struct _TPpcodeGen_NavigationBarElement_target* _TPPpcodeGen_NavigationBarElement_target;
typedef struct _TPpcodeGen_FrameRef* _TPPpcodeGen_FrameRef;
typedef struct _TPpcodeGen_FrameRef_styleSheetBlock* _TPPpcodeGen_FrameRef_styleSheetBlock;
typedef struct _TPpcodeGen_FrameRef_frame* _TPPpcodeGen_FrameRef_frame;
typedef struct _TPpcodeGen_MetaInformation* _TPPpcodeGen_MetaInformation;
typedef struct _TPpcodeGen_MetaInformation_name* _TPPpcodeGen_MetaInformation_name;
typedef struct _TPpcodeGen_MetaInformation_elements* _TPPpcodeGen_MetaInformation_elements;
typedef struct _TPpcodeGen_MetaInformationElement* _TPPpcodeGen_MetaInformationElement;
typedef struct _TPpcodeGen_MetaInformationElement_property* _TPPpcodeGen_MetaInformationElement_property;
typedef struct _TPpcodeGen_MetaInformationElement_value* _TPPpcodeGen_MetaInformationElement_value;
typedef struct _TPpcodeGen_OutputElement* _TPPpcodeGen_OutputElement;
typedef struct _TPpcodeGen_OutputElement_link* _TPPpcodeGen_OutputElement_link;
typedef struct _TPpcodeGen_OutputElement_content* _TPPpcodeGen_OutputElement_content;
typedef struct _TPpcodeGen_ListOutputElement* _TPPpcodeGen_ListOutputElement;
typedef struct _TPpcodeGen_ListOutputElement_styleSheetBlock* _TPPpcodeGen_ListOutputElement_styleSheetBlock;
typedef struct _TPpcodeGen_ListOutputElement_dataSourceActualParams* _TPPpcodeGen_ListOutputElement_dataSourceActualParams;
typedef struct _TPpcodeGen_ListOutputElement_dataSource* _TPPpcodeGen_ListOutputElement_dataSource;
typedef struct _TPpcodeGen_ListOutputElement_maxNumberOfElements* _TPPpcodeGen_ListOutputElement_maxNumberOfElements;
typedef struct _TPpcodeGen_ListOutputElement_navigationElement* _TPPpcodeGen_ListOutputElement_navigationElement;
typedef struct _TPpcodeGen_StyleSheet* _TPPpcodeGen_StyleSheet;
typedef struct _TPpcodeGen_StyleSheet_name* _TPPpcodeGen_StyleSheet_name;
typedef struct _TPpcodeGen_StyleSheet_custom* _TPPpcodeGen_StyleSheet_custom;
typedef struct _TPpcodeGen_StyleSheet_default* _TPPpcodeGen_StyleSheet_default;
typedef struct _TPpcodeGen_CustomStyleSheetBlock* _TPPpcodeGen_CustomStyleSheetBlock;
typedef struct _TPpcodeGen_CustomStyleSheetBlock_pairs* _TPPpcodeGen_CustomStyleSheetBlock_pairs;
typedef struct _TPpcodeGen_CustomStyleSheetBlock_name* _TPPpcodeGen_CustomStyleSheetBlock_name;
typedef struct _TPpcodeGen_StyleSheetPair* _TPPpcodeGen_StyleSheetPair;
typedef struct _TPpcodeGen_StyleSheetPair_category* _TPPpcodeGen_StyleSheetPair_category;
typedef struct _TPpcodeGen_StyleSheetPair_attribute* _TPPpcodeGen_StyleSheetPair_attribute;
typedef struct _TPpcodeGen_StyleSheetPair_valueCategory* _TPPpcodeGen_StyleSheetPair_valueCategory;
typedef struct _TPpcodeGen_SizeValue* _TPPpcodeGen_SizeValue;
typedef struct _TPpcodeGen_SizeValue_measure* _TPPpcodeGen_SizeValue_measure;
typedef struct _TPpcodeGen_SizeValue_value* _TPPpcodeGen_SizeValue_value;
typedef struct _TPpcodeGen_ColorValue* _TPPpcodeGen_ColorValue;
typedef struct _TPpcodeGen_ColorValue_color* _TPPpcodeGen_ColorValue_color;
typedef struct _TPpcodeGen_FamilyValue* _TPPpcodeGen_FamilyValue;
typedef struct _TPpcodeGen_FamilyValue_family* _TPPpcodeGen_FamilyValue_family;
typedef struct _TPpcodeGen_StyleValue* _TPPpcodeGen_StyleValue;
typedef struct _TPpcodeGen_StyleValue_style* _TPPpcodeGen_StyleValue_style;
typedef struct _TPpcodeGen_HeadingValue* _TPPpcodeGen_HeadingValue;
typedef struct _TPpcodeGen_HeadingValue_heading* _TPPpcodeGen_HeadingValue_heading;
typedef struct _TPpcodeGen_AlignmentValue* _TPPpcodeGen_AlignmentValue;
typedef struct _TPpcodeGen_AlignmentValue_alignment* _TPPpcodeGen_AlignmentValue_alignment;
typedef struct _TPpcodeGen_ListValue* _TPPpcodeGen_ListValue;
typedef struct _TPpcodeGen_ListValue_listed* _TPPpcodeGen_ListValue_listed;
typedef struct _TPpcodeGen_CustomValue* _TPPpcodeGen_CustomValue;
typedef struct _TPpcodeGen_CustomValue_value* _TPPpcodeGen_CustomValue_value;
typedef struct _TPpcodeGen_HtmlStyleSheetBlock* _TPPpcodeGen_HtmlStyleSheetBlock;
typedef struct _TPpcodeGen_HtmlStyleSheetBlock_pairs* _TPPpcodeGen_HtmlStyleSheetBlock_pairs;
typedef struct _TPpcodeGen_HtmlStyleSheetBlock_name* _TPPpcodeGen_HtmlStyleSheetBlock_name;
typedef struct _TPpcodeGen_ActionHandler* _TPPpcodeGen_ActionHandler;
typedef struct _TPpcodeGen_ActionHandler_targetpage* _TPPpcodeGen_ActionHandler_targetpage;
typedef struct _TPpcodeGen_ActionHandler_params* _TPPpcodeGen_ActionHandler_params;
typedef struct _TPpcodeGen_WebAction* _TPPpcodeGen_WebAction;
typedef struct _TPpcodeGen_WebAction_name* _TPPpcodeGen_WebAction_name;
typedef struct _TPpcodeGen_WebAction_formalParameter* _TPPpcodeGen_WebAction_formalParameter;
typedef struct _TPpcodeGen_WebAction_operations* _TPPpcodeGen_WebAction_operations;
typedef struct _TPpcodeGen_WebAction_position* _TPPpcodeGen_WebAction_position;
typedef struct _TPpcodeGen_PHPOperation* _TPPpcodeGen_PHPOperation;
typedef struct _TPpcodeGen_PHPOperation_errorhandler* _TPPpcodeGen_PHPOperation_errorhandler;
typedef struct _TPpcodeGen_PHPOperation_content* _TPPpcodeGen_PHPOperation_content;
typedef struct _TPpcodeGen_DataBaseOperation* _TPPpcodeGen_DataBaseOperation;
typedef struct _TPpcodeGen_DataBaseOperation_errorhandler* _TPPpcodeGen_DataBaseOperation_errorhandler;
typedef struct _TPpcodeGen_DataBaseOperation_filter* _TPPpcodeGen_DataBaseOperation_filter;
typedef struct _TPpcodeGen_DataBaseOperation_params* _TPPpcodeGen_DataBaseOperation_params;
typedef struct _TPpVIEWROOT_dataBaseView* _TPPpVIEWROOT_dataBaseView;
typedef struct _TPpdataBaseView_DBColumn* _TPPpdataBaseView_DBColumn;
typedef struct _TPpdataBaseView_DBColumn_name* _TPPpdataBaseView_DBColumn_name;
typedef struct _TPpdataBaseView_DBColumn_keyword1* _TPPpdataBaseView_DBColumn_keyword1;
typedef struct _TPpdataBaseView_DBColumn_type* _TPPpdataBaseView_DBColumn_type;
typedef struct _TPpdataBaseView_DataSourceFormalParam* _TPPpdataBaseView_DataSourceFormalParam;
typedef struct _TPpdataBaseView_DataSourceFormalParam_name* _TPPpdataBaseView_DataSourceFormalParam_name;
typedef struct _TPpdataBaseView_DataSourceFormalParam_keyword1* _TPPpdataBaseView_DataSourceFormalParam_keyword1;
typedef struct _TPpdataBaseView_DataSourceFormalParam_type* _TPPpdataBaseView_DataSourceFormalParam_type;
typedef struct _TPpdataBaseView_ColumnProjection* _TPPpdataBaseView_ColumnProjection;
typedef struct _TPpdataBaseView_ColumnProjection_keyword1* _TPPpdataBaseView_ColumnProjection_keyword1;
typedef struct _TPpdataBaseView_ColumnProjection_column* _TPPpdataBaseView_ColumnProjection_column;
typedef struct _TPpdataBaseView_ComputationProjection* _TPPpdataBaseView_ComputationProjection;
typedef struct _TPpdataBaseView_ComputationProjection_computation* _TPPpdataBaseView_ComputationProjection_computation;
typedef struct _TPpdataBaseView_ComputationProjection_keyword1* _TPPpdataBaseView_ComputationProjection_keyword1;
typedef struct _TPpdataBaseView_ComputationProjection_column* _TPPpdataBaseView_ComputationProjection_column;
typedef struct _TPpdataBaseView_ComputationProjection_keyword2* _TPPpdataBaseView_ComputationProjection_keyword2;
typedef struct _TPpdataBaseView_BinaryExpression* _TPPpdataBaseView_BinaryExpression;
typedef struct _TPpdataBaseView_BinaryExpression_keyword1* _TPPpdataBaseView_BinaryExpression_keyword1;
typedef struct _TPpdataBaseView_BinaryExpression_leftOperand* _TPPpdataBaseView_BinaryExpression_leftOperand;
typedef struct _TPpdataBaseView_BinaryExpression_operator* _TPPpdataBaseView_BinaryExpression_operator;
typedef struct _TPpdataBaseView_BinaryExpression_rightOperand* _TPPpdataBaseView_BinaryExpression_rightOperand;
typedef struct _TPpdataBaseView_BinaryExpression_keyword2* _TPPpdataBaseView_BinaryExpression_keyword2;
typedef struct _TPpdataBaseView_UnaryExpression* _TPPpdataBaseView_UnaryExpression;
typedef struct _TPpdataBaseView_UnaryExpression_operator* _TPPpdataBaseView_UnaryExpression_operator;
typedef struct _TPpdataBaseView_UnaryExpression_operand* _TPPpdataBaseView_UnaryExpression_operand;
typedef struct _TPpdataBaseView_ConstantExpression* _TPPpdataBaseView_ConstantExpression;
typedef struct _TPpdataBaseView_ConstantExpression_keyword1* _TPPpdataBaseView_ConstantExpression_keyword1;
typedef struct _TPpdataBaseView_ConstantExpression_value* _TPPpdataBaseView_ConstantExpression_value;
typedef struct _TPpdataBaseView_ConstantExpression_keyword2* _TPPpdataBaseView_ConstantExpression_keyword2;
typedef struct _TPpdataBaseView_ColumnValueExpression* _TPPpdataBaseView_ColumnValueExpression;
typedef struct _TPpdataBaseView_ColumnValueExpression_column* _TPPpdataBaseView_ColumnValueExpression_column;
typedef struct _TPpdataBaseView_ParameterValueExpression* _TPPpdataBaseView_ParameterValueExpression;
typedef struct _TPpdataBaseView_ParameterValueExpression_parameter* _TPPpdataBaseView_ParameterValueExpression_parameter;
typedef struct _TPpdataBaseView_ComputationExpression* _TPPpdataBaseView_ComputationExpression;
typedef struct _TPpdataBaseView_ComputationExpression_computation* _TPPpdataBaseView_ComputationExpression_computation;
typedef struct _TPpdataBaseView_ComputationExpression_keyword1* _TPPpdataBaseView_ComputationExpression_keyword1;
typedef struct _TPpdataBaseView_ComputationExpression_column* _TPPpdataBaseView_ComputationExpression_column;
typedef struct _TPpdataBaseView_ComputationExpression_keyword2* _TPPpdataBaseView_ComputationExpression_keyword2;
typedef struct _TPpdataBaseView_DBString* _TPPpdataBaseView_DBString;
typedef struct _TPpdataBaseView_DBString_keyword1* _TPPpdataBaseView_DBString_keyword1;
typedef struct _TPpdataBaseView_DBInteger* _TPPpdataBaseView_DBInteger;
typedef struct _TPpdataBaseView_DBInteger_keyword1* _TPPpdataBaseView_DBInteger_keyword1;
typedef struct _TPpdataBaseView_DBFloat* _TPPpdataBaseView_DBFloat;
typedef struct _TPpdataBaseView_DBFloat_keyword1* _TPPpdataBaseView_DBFloat_keyword1;
typedef struct _TPpdataBaseView_DBDouble* _TPPpdataBaseView_DBDouble;
typedef struct _TPpdataBaseView_DBDouble_keyword1* _TPPpdataBaseView_DBDouble_keyword1;
typedef struct _TPpdataBaseView_DBBigInt* _TPPpdataBaseView_DBBigInt;
typedef struct _TPpdataBaseView_DBBigInt_keyword1* _TPPpdataBaseView_DBBigInt_keyword1;
typedef struct _TPpdataBaseView_DBDate* _TPPpdataBaseView_DBDate;
typedef struct _TPpdataBaseView_DBDate_keyword1* _TPPpdataBaseView_DBDate_keyword1;
typedef struct _TPpdataBaseView_DBTimeStamp* _TPPpdataBaseView_DBTimeStamp;
typedef struct _TPpdataBaseView_DBTimeStamp_keyword1* _TPPpdataBaseView_DBTimeStamp_keyword1;
typedef struct _TPpdataBaseView_DBBoolean* _TPPpdataBaseView_DBBoolean;
typedef struct _TPpdataBaseView_DBBoolean_keyword1* _TPPpdataBaseView_DBBoolean_keyword1;
typedef struct _TPpdataBaseView_DBBlob* _TPPpdataBaseView_DBBlob;
typedef struct _TPpdataBaseView_DBBlob_keyword1* _TPPpdataBaseView_DBBlob_keyword1;
typedef struct _TPpdataBaseView_DataSourceValue* _TPPpdataBaseView_DataSourceValue;
typedef struct _TPpdataBaseView_DataSourceValue_column* _TPPpdataBaseView_DataSourceValue_column;
typedef struct _TPpdataBaseView_DataSourceValue_keyword1* _TPPpdataBaseView_DataSourceValue_keyword1;
typedef struct _TPpdataBaseView_DataSourceValue_expression* _TPPpdataBaseView_DataSourceValue_expression;
typedef struct _TPpdataBaseView_DataSourceProjectionFilter* _TPPpdataBaseView_DataSourceProjectionFilter;
typedef struct _TPpdataBaseView_DataSourceProjectionFilter_name* _TPPpdataBaseView_DataSourceProjectionFilter_name;
typedef struct _TPpdataBaseView_DataSourceProjectionFilter_formalParameters* _TPPpdataBaseView_DataSourceProjectionFilter_formalParameters;
typedef struct _TPpdataBaseView_DataSourceProjectionFilter_projectionColumns* _TPPpdataBaseView_DataSourceProjectionFilter_projectionColumns;
typedef struct _TPpdataBaseView_DataSourceProjectionFilter_condition* _TPPpdataBaseView_DataSourceProjectionFilter_condition;
typedef struct _TPpdataBaseView_DataSourceProjectionFilter_from* _TPPpdataBaseView_DataSourceProjectionFilter_from;
typedef struct _TPpdataBaseView_DataSourceProjectionFilter_sourceDataSource* _TPPpdataBaseView_DataSourceProjectionFilter_sourceDataSource;
typedef struct _TPpdataBaseView_DataSourceProjectionFilter_connection* _TPPpdataBaseView_DataSourceProjectionFilter_connection;
typedef struct _TPpdataBaseView_LimitDataSource* _TPPpdataBaseView_LimitDataSource;
typedef struct _TPpdataBaseView_LimitDataSource_name* _TPPpdataBaseView_LimitDataSource_name;
typedef struct _TPpdataBaseView_LimitDataSource_formalParameters* _TPPpdataBaseView_LimitDataSource_formalParameters;
typedef struct _TPpdataBaseView_LimitDataSource_minRow* _TPPpdataBaseView_LimitDataSource_minRow;
typedef struct _TPpdataBaseView_LimitDataSource_dots* _TPPpdataBaseView_LimitDataSource_dots;
typedef struct _TPpdataBaseView_LimitDataSource_maxRow* _TPPpdataBaseView_LimitDataSource_maxRow;
typedef struct _TPpdataBaseView_LimitDataSource_condition* _TPPpdataBaseView_LimitDataSource_condition;
typedef struct _TPpdataBaseView_LimitDataSource_from* _TPPpdataBaseView_LimitDataSource_from;
typedef struct _TPpdataBaseView_LimitDataSource_sourceDataSouce* _TPPpdataBaseView_LimitDataSource_sourceDataSouce;
typedef struct _TPpdataBaseView_LimitDataSource_connection* _TPPpdataBaseView_LimitDataSource_connection;
typedef struct _TPpdataBaseView_DataSourceJoin* _TPPpdataBaseView_DataSourceJoin;
typedef struct _TPpdataBaseView_DataSourceJoin_name* _TPPpdataBaseView_DataSourceJoin_name;
typedef struct _TPpdataBaseView_DataSourceJoin_joinOperator* _TPPpdataBaseView_DataSourceJoin_joinOperator;
typedef struct _TPpdataBaseView_DataSourceJoin_from1* _TPPpdataBaseView_DataSourceJoin_from1;
typedef struct _TPpdataBaseView_DataSourceJoin_dataSource1* _TPPpdataBaseView_DataSourceJoin_dataSource1;
typedef struct _TPpdataBaseView_DataSourceJoin_connection1* _TPPpdataBaseView_DataSourceJoin_connection1;
typedef struct _TPpdataBaseView_DataSourceJoin_from2* _TPPpdataBaseView_DataSourceJoin_from2;
typedef struct _TPpdataBaseView_DataSourceJoin_dataSource2* _TPPpdataBaseView_DataSourceJoin_dataSource2;
typedef struct _TPpdataBaseView_DataSourceJoin_connection2* _TPPpdataBaseView_DataSourceJoin_connection2;
typedef struct _TPpdataBaseView_DataSourceInsert* _TPPpdataBaseView_DataSourceInsert;
typedef struct _TPpdataBaseView_DataSourceInsert_name* _TPPpdataBaseView_DataSourceInsert_name;
typedef struct _TPpdataBaseView_DataSourceInsert_formalParams* _TPPpdataBaseView_DataSourceInsert_formalParams;
typedef struct _TPpdataBaseView_DataSourceInsert_values* _TPPpdataBaseView_DataSourceInsert_values;
typedef struct _TPpdataBaseView_DataSourceInsert_from* _TPPpdataBaseView_DataSourceInsert_from;
typedef struct _TPpdataBaseView_DataSourceInsert_targetDataSource* _TPPpdataBaseView_DataSourceInsert_targetDataSource;
typedef struct _TPpdataBaseView_DataSourceInsert_connection* _TPPpdataBaseView_DataSourceInsert_connection;
typedef struct _TPpdataBaseView_DataSourceUpdate* _TPPpdataBaseView_DataSourceUpdate;
typedef struct _TPpdataBaseView_DataSourceUpdate_name* _TPPpdataBaseView_DataSourceUpdate_name;
typedef struct _TPpdataBaseView_DataSourceUpdate_formalParams* _TPPpdataBaseView_DataSourceUpdate_formalParams;
typedef struct _TPpdataBaseView_DataSourceUpdate_values* _TPPpdataBaseView_DataSourceUpdate_values;
typedef struct _TPpdataBaseView_DataSourceUpdate_conditions* _TPPpdataBaseView_DataSourceUpdate_conditions;
typedef struct _TPpdataBaseView_DataSourceUpdate_from* _TPPpdataBaseView_DataSourceUpdate_from;
typedef struct _TPpdataBaseView_DataSourceUpdate_targetDataSource* _TPPpdataBaseView_DataSourceUpdate_targetDataSource;
typedef struct _TPpdataBaseView_DataSourceUpdate_connection* _TPPpdataBaseView_DataSourceUpdate_connection;
typedef struct _TPpdataBaseView_DataSourceDelete* _TPPpdataBaseView_DataSourceDelete;
typedef struct _TPpdataBaseView_DataSourceDelete_name* _TPPpdataBaseView_DataSourceDelete_name;
typedef struct _TPpdataBaseView_DataSourceDelete_formalParams* _TPPpdataBaseView_DataSourceDelete_formalParams;
typedef struct _TPpdataBaseView_DataSourceDelete_conditions* _TPPpdataBaseView_DataSourceDelete_conditions;
typedef struct _TPpdataBaseView_DataSourceDelete_from* _TPPpdataBaseView_DataSourceDelete_from;
typedef struct _TPpdataBaseView_DataSourceDelete_targetDataSource* _TPPpdataBaseView_DataSourceDelete_targetDataSource;
typedef struct _TPpdataBaseView_DataSourceDelete_connection* _TPPpdataBaseView_DataSourceDelete_connection;
typedef struct _TPpdataBaseView_DataSourceDB* _TPPpdataBaseView_DataSourceDB;
typedef struct _TPpdataBaseView_DataSourceDB_name* _TPPpdataBaseView_DataSourceDB_name;
typedef struct _TPpdataBaseView_DataSourceDB_position* _TPPpdataBaseView_DataSourceDB_position;
typedef struct _TPpdataBaseView_DataSourceDB_columns* _TPPpdataBaseView_DataSourceDB_columns;
typedef struct _TPpdataBaseView_DataBase* _TPPpdataBaseView_DataBase;
typedef struct _TPpdataBaseView_DataBase_name* _TPPpdataBaseView_DataBase_name;
typedef struct _TPpdataBaseView_DataBase_userName* _TPPpdataBaseView_DataBase_userName;
typedef struct _TPpdataBaseView_DataBase_userPassword* _TPPpdataBaseView_DataBase_userPassword;
typedef struct _TPpdataBaseView_DataBase_hostName* _TPPpdataBaseView_DataBase_hostName;
typedef struct _TPpdataBaseView_DataBase_port* _TPPpdataBaseView_DataBase_port;
typedef struct _TPpdataBaseView_DataBase_dataBaseType* _TPPpdataBaseView_DataBase_dataBaseType;
typedef struct _TPpdataBaseView_DataBase_dataSources* _TPPpdataBaseView_DataBase_dataSources;
typedef struct _TPpdataBaseView_DataBase_dataSourceModifications* _TPPpdataBaseView_DataBase_dataSourceModifications;
typedef struct _TPpdataBaseView_DataBase_setSize* _TPPpdataBaseView_DataBase_setSize;
typedef struct _TPpdataBaseView_DataBase_modifySetSize* _TPPpdataBaseView_DataBase_modifySetSize;
typedef struct _TPpVIEWROOT_fcDlg* _TPPpVIEWROOT_fcDlg;
typedef struct _TPpfcDlg_FormularCondition* _TPPpfcDlg_FormularCondition;
typedef struct _TPpfcDlg_FormularCondition_condition* _TPPpfcDlg_FormularCondition_condition;
typedef struct _TPpfcDlg_FormularCondition_params* _TPPpfcDlg_FormularCondition_params;
typedef struct _TPpfcDlg_FormularConditionActualParam* _TPPpfcDlg_FormularConditionActualParam;
typedef struct _TPpfcDlg_FormularConditionActualParam_value* _TPPpfcDlg_FormularConditionActualParam_value;
typedef struct _TPpfcDlg_FormularConditionActualParam_formalparam* _TPPpfcDlg_FormularConditionActualParam_formalparam;
typedef struct _TPpVIEWROOT_globalFrameView* _TPPpVIEWROOT_globalFrameView;
typedef struct _TPpglobalFrameView_FormularCheckboxElement* _TPPpglobalFrameView_FormularCheckboxElement;
typedef struct _TPpglobalFrameView_FormularCheckboxElement_label* _TPPpglobalFrameView_FormularCheckboxElement_label;
typedef struct _TPpglobalFrameView_FormularCheckboxElement_name* _TPPpglobalFrameView_FormularCheckboxElement_name;
typedef struct _TPpglobalFrameView_FormularCheckboxElement_type* _TPPpglobalFrameView_FormularCheckboxElement_type;
typedef struct _TPpglobalFrameView_FormularCheckboxElement_description* _TPPpglobalFrameView_FormularCheckboxElement_description;
typedef struct _TPpglobalFrameView_FormularTextElement* _TPPpglobalFrameView_FormularTextElement;
typedef struct _TPpglobalFrameView_FormularTextElement_label* _TPPpglobalFrameView_FormularTextElement_label;
typedef struct _TPpglobalFrameView_FormularTextElement_type* _TPPpglobalFrameView_FormularTextElement_type;
typedef struct _TPpglobalFrameView_FormularTextElement_description* _TPPpglobalFrameView_FormularTextElement_description;
typedef struct _TPpglobalFrameView_FormularPasswordElement* _TPPpglobalFrameView_FormularPasswordElement;
typedef struct _TPpglobalFrameView_FormularPasswordElement_label* _TPPpglobalFrameView_FormularPasswordElement_label;
typedef struct _TPpglobalFrameView_FormularPasswordElement_type* _TPPpglobalFrameView_FormularPasswordElement_type;
typedef struct _TPpglobalFrameView_FormularPasswordElement_description* _TPPpglobalFrameView_FormularPasswordElement_description;
typedef struct _TPpglobalFrameView_FormularTextAreaElement* _TPPpglobalFrameView_FormularTextAreaElement;
typedef struct _TPpglobalFrameView_FormularTextAreaElement_label* _TPPpglobalFrameView_FormularTextAreaElement_label;
typedef struct _TPpglobalFrameView_FormularTextAreaElement_type* _TPPpglobalFrameView_FormularTextAreaElement_type;
typedef struct _TPpglobalFrameView_FormularTextAreaElement_description* _TPPpglobalFrameView_FormularTextAreaElement_description;
typedef struct _TPpglobalFrameView_FormularSelectElement* _TPPpglobalFrameView_FormularSelectElement;
typedef struct _TPpglobalFrameView_FormularSelectElement_label* _TPPpglobalFrameView_FormularSelectElement_label;
typedef struct _TPpglobalFrameView_FormularSelectElement_multiple* _TPPpglobalFrameView_FormularSelectElement_multiple;
typedef struct _TPpglobalFrameView_FormularSelectElement_options* _TPPpglobalFrameView_FormularSelectElement_options;
typedef struct _TPpglobalFrameView_FormularSelectElement_description* _TPPpglobalFrameView_FormularSelectElement_description;
typedef struct _TPpglobalFrameView_FormularRadioElement* _TPPpglobalFrameView_FormularRadioElement;
typedef struct _TPpglobalFrameView_FormularRadioElement_type* _TPPpglobalFrameView_FormularRadioElement_type;
typedef struct _TPpglobalFrameView_FormularRadioElement_label* _TPPpglobalFrameView_FormularRadioElement_label;
typedef struct _TPpglobalFrameView_FormularRadioElement_name* _TPPpglobalFrameView_FormularRadioElement_name;
typedef struct _TPpglobalFrameView_DataSourceActualParam* _TPPpglobalFrameView_DataSourceActualParam;
typedef struct _TPpglobalFrameView_DataSourceActualParam_formalParam* _TPPpglobalFrameView_DataSourceActualParam_formalParam;
typedef struct _TPpglobalFrameView_DataSourceActualParam_keyword1* _TPPpglobalFrameView_DataSourceActualParam_keyword1;
typedef struct _TPpglobalFrameView_DataSourceActualParam_expressions* _TPPpglobalFrameView_DataSourceActualParam_expressions;
typedef struct _TPpglobalFrameView_WebNodeActualParam* _TPPpglobalFrameView_WebNodeActualParam;
typedef struct _TPpglobalFrameView_WebNodeActualParam_formalParam* _TPPpglobalFrameView_WebNodeActualParam_formalParam;
typedef struct _TPpglobalFrameView_WebNodeActualParam_keyword1* _TPPpglobalFrameView_WebNodeActualParam_keyword1;
typedef struct _TPpglobalFrameView_WebNodeActualParam_expressions* _TPPpglobalFrameView_WebNodeActualParam_expressions;
typedef struct _TPpglobalFrameView_WebNodeConstantExpression* _TPPpglobalFrameView_WebNodeConstantExpression;
typedef struct _TPpglobalFrameView_WebNodeConstantExpression_keyword1* _TPPpglobalFrameView_WebNodeConstantExpression_keyword1;
typedef struct _TPpglobalFrameView_WebNodeConstantExpression_value* _TPPpglobalFrameView_WebNodeConstantExpression_value;
typedef struct _TPpglobalFrameView_WebNodeConstantExpression_keyword2* _TPPpglobalFrameView_WebNodeConstantExpression_keyword2;
typedef struct _TPpglobalFrameView_WebNodeVariableExpression* _TPPpglobalFrameView_WebNodeVariableExpression;
typedef struct _TPpglobalFrameView_WebNodeVariableExpression_content* _TPPpglobalFrameView_WebNodeVariableExpression_content;
typedef struct _TPpglobalFrameView_WebNodeColumnExpression* _TPPpglobalFrameView_WebNodeColumnExpression;
typedef struct _TPpglobalFrameView_WebNodeColumnExpression_content* _TPPpglobalFrameView_WebNodeColumnExpression_content;
typedef struct _TPpglobalFrameView_Formular* _TPPpglobalFrameView_Formular;
typedef struct _TPpglobalFrameView_Formular_styleSheetBlock* _TPPpglobalFrameView_Formular_styleSheetBlock;
typedef struct _TPpglobalFrameView_Formular_action* _TPPpglobalFrameView_Formular_action;
typedef struct _TPpglobalFrameView_Formular_elements* _TPPpglobalFrameView_Formular_elements;
typedef struct _TPpglobalFrameView_Formular_datasource* _TPPpglobalFrameView_Formular_datasource;
typedef struct _TPpglobalFrameView_Formular_actualParams* _TPPpglobalFrameView_Formular_actualParams;
typedef struct _TPpglobalFrameView_FormularRadioGroupElement* _TPPpglobalFrameView_FormularRadioGroupElement;
typedef struct _TPpglobalFrameView_FormularRadioGroupElement_name* _TPPpglobalFrameView_FormularRadioGroupElement_name;
typedef struct _TPpglobalFrameView_FormularRadioGroupElement_label* _TPPpglobalFrameView_FormularRadioGroupElement_label;
typedef struct _TPpglobalFrameView_FormularRadioGroupElement_description* _TPPpglobalFrameView_FormularRadioGroupElement_description;
typedef struct _TPpglobalFrameView_FormularRadioGroupElement_pvalue* _TPPpglobalFrameView_FormularRadioGroupElement_pvalue;
typedef struct _TPpglobalFrameView_FormularRadioGroupElement_elements* _TPPpglobalFrameView_FormularRadioGroupElement_elements;
typedef struct _TPpglobalFrameView_FormularRadioGroupElement_checked* _TPPpglobalFrameView_FormularRadioGroupElement_checked;
typedef struct _TPpglobalFrameView_FormularConstantSelectOption* _TPPpglobalFrameView_FormularConstantSelectOption;
typedef struct _TPpglobalFrameView_FormularConstantSelectOption_values* _TPPpglobalFrameView_FormularConstantSelectOption_values;
typedef struct _TPpglobalFrameView_FormularDataSourceSelectOption* _TPPpglobalFrameView_FormularDataSourceSelectOption;
typedef struct _TPpglobalFrameView_FormularDataSourceSelectOption_values* _TPPpglobalFrameView_FormularDataSourceSelectOption_values;
typedef struct _TPpglobalFrameView_FormularDataSourceSelectOption_params* _TPPpglobalFrameView_FormularDataSourceSelectOption_params;
typedef struct _TPpglobalFrameView_FormularPHPScriptSelectOption* _TPPpglobalFrameView_FormularPHPScriptSelectOption;
typedef struct _TPpglobalFrameView_FormularPHPScriptSelectOption_script* _TPPpglobalFrameView_FormularPHPScriptSelectOption_script;
typedef struct _TPpglobalFrameView_FormularCondition* _TPPpglobalFrameView_FormularCondition;
typedef struct _TPpglobalFrameView_FormularCondition_condition* _TPPpglobalFrameView_FormularCondition_condition;
typedef struct _TPpglobalFrameView_FormularCondition_params* _TPPpglobalFrameView_FormularCondition_params;
typedef struct _TPpglobalFrameView_FormularConditionActualParam* _TPPpglobalFrameView_FormularConditionActualParam;
typedef struct _TPpglobalFrameView_FormularConditionActualParam_value* _TPPpglobalFrameView_FormularConditionActualParam_value;
typedef struct _TPpglobalFrameView_FormularConditionActualParam_formalparam* _TPPpglobalFrameView_FormularConditionActualParam_formalparam;
typedef struct _TPpglobalFrameView_Paragraph* _TPPpglobalFrameView_Paragraph;
typedef struct _TPpglobalFrameView_Paragraph_styleSheetBlock* _TPPpglobalFrameView_Paragraph_styleSheetBlock;
typedef struct _TPpglobalFrameView_Paragraph_fragments* _TPPpglobalFrameView_Paragraph_fragments;
typedef struct _TPpglobalFrameView_TextFragment* _TPPpglobalFrameView_TextFragment;
typedef struct _TPpglobalFrameView_TextFragment_link* _TPPpglobalFrameView_TextFragment_link;
typedef struct _TPpglobalFrameView_TextFragment_value* _TPPpglobalFrameView_TextFragment_value;
typedef struct _TPpglobalFrameView_ImageFragment* _TPPpglobalFrameView_ImageFragment;
typedef struct _TPpglobalFrameView_ImageFragment_link* _TPPpglobalFrameView_ImageFragment_link;
typedef struct _TPpglobalFrameView_ImageFragment_width* _TPPpglobalFrameView_ImageFragment_width;
typedef struct _TPpglobalFrameView_ImageFragment_height* _TPPpglobalFrameView_ImageFragment_height;
typedef struct _TPpglobalFrameView_ImageFragment_text* _TPPpglobalFrameView_ImageFragment_text;
typedef struct _TPpglobalFrameView_ImageFragment_imageName* _TPPpglobalFrameView_ImageFragment_imageName;
typedef struct _TPpglobalFrameView_Heading* _TPPpglobalFrameView_Heading;
typedef struct _TPpglobalFrameView_Heading_styleSheetBlock* _TPPpglobalFrameView_Heading_styleSheetBlock;
typedef struct _TPpglobalFrameView_Heading_text* _TPPpglobalFrameView_Heading_text;
typedef struct _TPpglobalFrameView_Heading_level* _TPPpglobalFrameView_Heading_level;
typedef struct _TPpglobalFrameView_Table* _TPPpglobalFrameView_Table;
typedef struct _TPpglobalFrameView_Table_styleSheetBlock* _TPPpglobalFrameView_Table_styleSheetBlock;
typedef struct _TPpglobalFrameView_Table_rows* _TPPpglobalFrameView_Table_rows;
typedef struct _TPpglobalFrameView_Table_columns* _TPPpglobalFrameView_Table_columns;
typedef struct _TPpglobalFrameView_TableRow* _TPPpglobalFrameView_TableRow;
typedef struct _TPpglobalFrameView_TableRow_cells* _TPPpglobalFrameView_TableRow_cells;
typedef struct _TPpglobalFrameView_TableColumn* _TPPpglobalFrameView_TableColumn;
typedef struct _TPpglobalFrameView_TableCell* _TPPpglobalFrameView_TableCell;
typedef struct _TPpglobalFrameView_TableCell_columnRef* _TPPpglobalFrameView_TableCell_columnRef;
typedef struct _TPpglobalFrameView_Frame* _TPPpglobalFrameView_Frame;
typedef struct _TPpglobalFrameView_Frame_components* _TPPpglobalFrameView_Frame_components;
typedef struct _TPpglobalFrameView_Frame_styleSheetBlock* _TPPpglobalFrameView_Frame_styleSheetBlock;
typedef struct _TPpglobalFrameView_GlobalFrame* _TPPpglobalFrameView_GlobalFrame;
typedef struct _TPpglobalFrameView_GlobalFrame_name* _TPPpglobalFrameView_GlobalFrame_name;
typedef struct _TPpglobalFrameView_GlobalFrame_components* _TPPpglobalFrameView_GlobalFrame_components;
typedef struct _TPpglobalFrameView_GlobalFrame_setSize* _TPPpglobalFrameView_GlobalFrame_setSize;
typedef struct _TPpglobalFrameView_FrameRef* _TPPpglobalFrameView_FrameRef;
typedef struct _TPpglobalFrameView_FrameRef_styleSheetBlock* _TPPpglobalFrameView_FrameRef_styleSheetBlock;
typedef struct _TPpglobalFrameView_FrameRef_frame* _TPPpglobalFrameView_FrameRef_frame;
typedef struct _TPpglobalFrameView_OutputElement* _TPPpglobalFrameView_OutputElement;
typedef struct _TPpglobalFrameView_OutputElement_link* _TPPpglobalFrameView_OutputElement_link;
typedef struct _TPpglobalFrameView_OutputElement_content* _TPPpglobalFrameView_OutputElement_content;
typedef struct _TPpglobalFrameView_ListOutputElement* _TPPpglobalFrameView_ListOutputElement;
typedef struct _TPpglobalFrameView_ListOutputElement_styleSheetBlock* _TPPpglobalFrameView_ListOutputElement_styleSheetBlock;
typedef struct _TPpglobalFrameView_ListOutputElement_dataSourceActualParams* _TPPpglobalFrameView_ListOutputElement_dataSourceActualParams;
typedef struct _TPpglobalFrameView_ListOutputElement_dataSource* _TPPpglobalFrameView_ListOutputElement_dataSource;
typedef struct _TPpglobalFrameView_ListOutputElement_maxNumberOfElements* _TPPpglobalFrameView_ListOutputElement_maxNumberOfElements;
typedef struct _TPpglobalFrameView_ListOutputElement_navigationElement* _TPPpglobalFrameView_ListOutputElement_navigationElement;
typedef struct _TPpVIEWROOT_metaInformation* _TPPpVIEWROOT_metaInformation;
typedef struct _TPpmetaInformation_MetaInformation* _TPPpmetaInformation_MetaInformation;
typedef struct _TPpmetaInformation_MetaInformation_keyword1* _TPPpmetaInformation_MetaInformation_keyword1;
typedef struct _TPpmetaInformation_MetaInformation_keyword2* _TPPpmetaInformation_MetaInformation_keyword2;
typedef struct _TPpmetaInformation_MetaInformation_keyword3* _TPPpmetaInformation_MetaInformation_keyword3;
typedef struct _TPpmetaInformation_MetaInformation_elements* _TPPpmetaInformation_MetaInformation_elements;
typedef struct _TPpmetaInformation_MetaInformation_keyword4* _TPPpmetaInformation_MetaInformation_keyword4;
typedef struct _TPpmetaInformation_MetaInformationElement* _TPPpmetaInformation_MetaInformationElement;
typedef struct _TPpmetaInformation_MetaInformationElement_property* _TPPpmetaInformation_MetaInformationElement_property;
typedef struct _TPpmetaInformation_MetaInformationElement_keyword1* _TPPpmetaInformation_MetaInformationElement_keyword1;
typedef struct _TPpmetaInformation_MetaInformationElement_value* _TPPpmetaInformation_MetaInformationElement_value;
typedef struct _TPpmetaInformation_MetaInformationElement_keyword2* _TPPpmetaInformation_MetaInformationElement_keyword2;
typedef struct _TPpVIEWROOT_navigationBarView* _TPPpVIEWROOT_navigationBarView;
typedef struct _TPpnavigationBarView_NavigationBar* _TPPpnavigationBarView_NavigationBar;
typedef struct _TPpnavigationBarView_NavigationBar_styleSheetBlock* _TPPpnavigationBarView_NavigationBar_styleSheetBlock;
typedef struct _TPpnavigationBarView_NavigationBar_elements* _TPPpnavigationBarView_NavigationBar_elements;
typedef struct _TPpnavigationBarView_NavigationBar_alignment* _TPPpnavigationBarView_NavigationBar_alignment;
typedef struct _TPpnavigationBarView_NavigationBarElement* _TPPpnavigationBarView_NavigationBarElement;
typedef struct _TPpnavigationBarView_NavigationBarElement_target* _TPPpnavigationBarView_NavigationBarElement_target;
typedef struct _TPpVIEWROOT_rootView* _TPPpVIEWROOT_rootView;
typedef struct _TPprootView_WebNodeFormalParam* _TPPprootView_WebNodeFormalParam;
typedef struct _TPprootView_WebNodeFormalParam_name* _TPPprootView_WebNodeFormalParam_name;
typedef struct _TPprootView_WebNodeFormalParam_keyword1* _TPPprootView_WebNodeFormalParam_keyword1;
typedef struct _TPprootView_WebNodeFormalParam_type* _TPPprootView_WebNodeFormalParam_type;
typedef struct _TPprootView_DataBase* _TPPprootView_DataBase;
typedef struct _TPprootView_DBString* _TPPprootView_DBString;
typedef struct _TPprootView_DBString_keyword1* _TPPprootView_DBString_keyword1;
typedef struct _TPprootView_DBInteger* _TPPprootView_DBInteger;
typedef struct _TPprootView_DBInteger_keyword1* _TPPprootView_DBInteger_keyword1;
typedef struct _TPprootView_DBFloat* _TPPprootView_DBFloat;
typedef struct _TPprootView_DBFloat_keyword1* _TPPprootView_DBFloat_keyword1;
typedef struct _TPprootView_DBDouble* _TPPprootView_DBDouble;
typedef struct _TPprootView_DBDouble_keyword1* _TPPprootView_DBDouble_keyword1;
typedef struct _TPprootView_DBBigInt* _TPPprootView_DBBigInt;
typedef struct _TPprootView_DBBigInt_keyword1* _TPPprootView_DBBigInt_keyword1;
typedef struct _TPprootView_DBDate* _TPPprootView_DBDate;
typedef struct _TPprootView_DBDate_keyword1* _TPPprootView_DBDate_keyword1;
typedef struct _TPprootView_DBTimeStamp* _TPPprootView_DBTimeStamp;
typedef struct _TPprootView_DBTimeStamp_keyword1* _TPPprootView_DBTimeStamp_keyword1;
typedef struct _TPprootView_DBBoolean* _TPPprootView_DBBoolean;
typedef struct _TPprootView_DBBoolean_keyword1* _TPPprootView_DBBoolean_keyword1;
typedef struct _TPprootView_DBBlob* _TPPprootView_DBBlob;
typedef struct _TPprootView_DBBlob_keyword1* _TPPprootView_DBBlob_keyword1;
typedef struct _TPprootView_DataSourceActualParam* _TPPprootView_DataSourceActualParam;
typedef struct _TPprootView_DataSourceActualParam_formalParam* _TPPprootView_DataSourceActualParam_formalParam;
typedef struct _TPprootView_DataSourceActualParam_expressions* _TPPprootView_DataSourceActualParam_expressions;
typedef struct _TPprootView_Formular* _TPPprootView_Formular;
typedef struct _TPprootView_Formular_styleSheetBlock* _TPPprootView_Formular_styleSheetBlock;
typedef struct _TPprootView_Formular_action* _TPPprootView_Formular_action;
typedef struct _TPprootView_Formular_elements* _TPPprootView_Formular_elements;
typedef struct _TPprootView_Formular_datasource* _TPPprootView_Formular_datasource;
typedef struct _TPprootView_Formular_actualParams* _TPPprootView_Formular_actualParams;
typedef struct _TPprootView_FormularRadioGroupElement* _TPPprootView_FormularRadioGroupElement;
typedef struct _TPprootView_FormularRadioGroupElement_name* _TPPprootView_FormularRadioGroupElement_name;
typedef struct _TPprootView_FormularRadioGroupElement_label* _TPPprootView_FormularRadioGroupElement_label;
typedef struct _TPprootView_FormularRadioGroupElement_description* _TPPprootView_FormularRadioGroupElement_description;
typedef struct _TPprootView_FormularRadioGroupElement_pvalue* _TPPprootView_FormularRadioGroupElement_pvalue;
typedef struct _TPprootView_FormularRadioGroupElement_elements* _TPPprootView_FormularRadioGroupElement_elements;
typedef struct _TPprootView_FormularRadioGroupElement_checked* _TPPprootView_FormularRadioGroupElement_checked;
typedef struct _TPprootView_FormularTextElement* _TPPprootView_FormularTextElement;
typedef struct _TPprootView_FormularTextElement_name* _TPPprootView_FormularTextElement_name;
typedef struct _TPprootView_FormularTextElement_label* _TPPprootView_FormularTextElement_label;
typedef struct _TPprootView_FormularTextElement_description* _TPPprootView_FormularTextElement_description;
typedef struct _TPprootView_FormularTextElement_pvalue* _TPPprootView_FormularTextElement_pvalue;
typedef struct _TPprootView_FormularTextAreaElement* _TPPprootView_FormularTextAreaElement;
typedef struct _TPprootView_FormularTextAreaElement_name* _TPPprootView_FormularTextAreaElement_name;
typedef struct _TPprootView_FormularTextAreaElement_label* _TPPprootView_FormularTextAreaElement_label;
typedef struct _TPprootView_FormularTextAreaElement_description* _TPPprootView_FormularTextAreaElement_description;
typedef struct _TPprootView_FormularTextAreaElement_pvalue* _TPPprootView_FormularTextAreaElement_pvalue;
typedef struct _TPprootView_FormularPasswordElement* _TPPprootView_FormularPasswordElement;
typedef struct _TPprootView_FormularPasswordElement_name* _TPPprootView_FormularPasswordElement_name;
typedef struct _TPprootView_FormularPasswordElement_label* _TPPprootView_FormularPasswordElement_label;
typedef struct _TPprootView_FormularPasswordElement_description* _TPPprootView_FormularPasswordElement_description;
typedef struct _TPprootView_FormularPasswordElement_pvalue* _TPPprootView_FormularPasswordElement_pvalue;
typedef struct _TPprootView_FormularCheckboxElement* _TPPprootView_FormularCheckboxElement;
typedef struct _TPprootView_FormularCheckboxElement_name* _TPPprootView_FormularCheckboxElement_name;
typedef struct _TPprootView_FormularCheckboxElement_label* _TPPprootView_FormularCheckboxElement_label;
typedef struct _TPprootView_FormularCheckboxElement_description* _TPPprootView_FormularCheckboxElement_description;
typedef struct _TPprootView_FormularCheckboxElement_pvalue* _TPPprootView_FormularCheckboxElement_pvalue;
typedef struct _TPprootView_FormularCheckboxElement_value* _TPPprootView_FormularCheckboxElement_value;
typedef struct _TPprootView_FormularCheckboxElement_checked* _TPPprootView_FormularCheckboxElement_checked;
typedef struct _TPprootView_FormularSelectElement* _TPPprootView_FormularSelectElement;
typedef struct _TPprootView_FormularSelectElement_name* _TPPprootView_FormularSelectElement_name;
typedef struct _TPprootView_FormularSelectElement_label* _TPPprootView_FormularSelectElement_label;
typedef struct _TPprootView_FormularSelectElement_description* _TPPprootView_FormularSelectElement_description;
typedef struct _TPprootView_FormularSelectElement_pvalue* _TPPprootView_FormularSelectElement_pvalue;
typedef struct _TPprootView_FormularSelectElement_options* _TPPprootView_FormularSelectElement_options;
typedef struct _TPprootView_FormularSelectElement_size* _TPPprootView_FormularSelectElement_size;
typedef struct _TPprootView_FormularSelectElement_multiple* _TPPprootView_FormularSelectElement_multiple;
typedef struct _TPprootView_FormularConstantSelectOption* _TPPprootView_FormularConstantSelectOption;
typedef struct _TPprootView_FormularConstantSelectOption_values* _TPPprootView_FormularConstantSelectOption_values;
typedef struct _TPprootView_FormularDataSourceSelectOption* _TPPprootView_FormularDataSourceSelectOption;
typedef struct _TPprootView_FormularDataSourceSelectOption_values* _TPPprootView_FormularDataSourceSelectOption_values;
typedef struct _TPprootView_FormularDataSourceSelectOption_params* _TPPprootView_FormularDataSourceSelectOption_params;
typedef struct _TPprootView_FormularPHPScriptSelectOption* _TPPprootView_FormularPHPScriptSelectOption;
typedef struct _TPprootView_FormularPHPScriptSelectOption_script* _TPPprootView_FormularPHPScriptSelectOption_script;
typedef struct _TPprootView_FormularRadioElement* _TPPprootView_FormularRadioElement;
typedef struct _TPprootView_FormularRadioElement_value* _TPPprootView_FormularRadioElement_value;
typedef struct _TPprootView_FormularRadioElement_label* _TPPprootView_FormularRadioElement_label;
typedef struct _TPprootView_FormularRadioElement_name* _TPPprootView_FormularRadioElement_name;
typedef struct _TPprootView_FormularCondition* _TPPprootView_FormularCondition;
typedef struct _TPprootView_FormularCondition_condition* _TPPprootView_FormularCondition_condition;
typedef struct _TPprootView_FormularCondition_params* _TPPprootView_FormularCondition_params;
typedef struct _TPprootView_FormularConditionDefinition* _TPPprootView_FormularConditionDefinition;
typedef struct _TPprootView_FormularConditionDefinition_name* _TPPprootView_FormularConditionDefinition_name;
typedef struct _TPprootView_FormularConditionDefinition_params* _TPPprootView_FormularConditionDefinition_params;
typedef struct _TPprootView_FormularConditionDefinition_body* _TPPprootView_FormularConditionDefinition_body;
typedef struct _TPprootView_FormularConditionFormalParam* _TPPprootView_FormularConditionFormalParam;
typedef struct _TPprootView_FormularConditionFormalParam_name* _TPPprootView_FormularConditionFormalParam_name;
typedef struct _TPprootView_FormularConditionActualParam* _TPPprootView_FormularConditionActualParam;
typedef struct _TPprootView_FormularConditionActualParam_value* _TPPprootView_FormularConditionActualParam_value;
typedef struct _TPprootView_FormularConditionActualParam_formalparam* _TPPprootView_FormularConditionActualParam_formalparam;
typedef struct _TPprootView_WebNodeActualParam* _TPPprootView_WebNodeActualParam;
typedef struct _TPprootView_WebNodeActualParam_formalParam* _TPPprootView_WebNodeActualParam_formalParam;
typedef struct _TPprootView_WebNodeActualParam_expressions* _TPPprootView_WebNodeActualParam_expressions;
typedef struct _TPprootView_WebNodeConstantExpression* _TPPprootView_WebNodeConstantExpression;
typedef struct _TPprootView_WebNodeConstantExpression_value* _TPPprootView_WebNodeConstantExpression_value;
typedef struct _TPprootView_WebNodeVariableExpression* _TPPprootView_WebNodeVariableExpression;
typedef struct _TPprootView_WebNodeVariableExpression_content* _TPPprootView_WebNodeVariableExpression_content;
typedef struct _TPprootView_WebNodeColumnExpression* _TPPprootView_WebNodeColumnExpression;
typedef struct _TPprootView_WebNodeColumnExpression_content* _TPPprootView_WebNodeColumnExpression_content;
typedef struct _TPprootView_Paragraph* _TPPprootView_Paragraph;
typedef struct _TPprootView_Paragraph_styleSheetBlock* _TPPprootView_Paragraph_styleSheetBlock;
typedef struct _TPprootView_Paragraph_fragments* _TPPprootView_Paragraph_fragments;
typedef struct _TPprootView_TextFragment* _TPPprootView_TextFragment;
typedef struct _TPprootView_TextFragment_link* _TPPprootView_TextFragment_link;
typedef struct _TPprootView_TextFragment_value* _TPPprootView_TextFragment_value;
typedef struct _TPprootView_ImageFragment* _TPPprootView_ImageFragment;
typedef struct _TPprootView_ImageFragment_link* _TPPprootView_ImageFragment_link;
typedef struct _TPprootView_ImageFragment_width* _TPPprootView_ImageFragment_width;
typedef struct _TPprootView_ImageFragment_height* _TPPprootView_ImageFragment_height;
typedef struct _TPprootView_ImageFragment_text* _TPPprootView_ImageFragment_text;
typedef struct _TPprootView_ImageFragment_imageName* _TPPprootView_ImageFragment_imageName;
typedef struct _TPprootView_Heading* _TPPprootView_Heading;
typedef struct _TPprootView_Heading_styleSheetBlock* _TPPprootView_Heading_styleSheetBlock;
typedef struct _TPprootView_Heading_text* _TPPprootView_Heading_text;
typedef struct _TPprootView_Heading_level* _TPPprootView_Heading_level;
typedef struct _TPprootView_Table* _TPPprootView_Table;
typedef struct _TPprootView_Table_styleSheetBlock* _TPPprootView_Table_styleSheetBlock;
typedef struct _TPprootView_Table_rows* _TPPprootView_Table_rows;
typedef struct _TPprootView_Table_columns* _TPPprootView_Table_columns;
typedef struct _TPprootView_TableRow* _TPPprootView_TableRow;
typedef struct _TPprootView_TableRow_cells* _TPPprootView_TableRow_cells;
typedef struct _TPprootView_TableColumn* _TPPprootView_TableColumn;
typedef struct _TPprootView_TableCell* _TPPprootView_TableCell;
typedef struct _TPprootView_TableCell_columnRef* _TPPprootView_TableCell_columnRef;
typedef struct _TPprootView_LinkTargetExtern* _TPPprootView_LinkTargetExtern;
typedef struct _TPprootView_LinkTargetExtern_name* _TPPprootView_LinkTargetExtern_name;
typedef struct _TPprootView_LinkTargetExtern_url* _TPPprootView_LinkTargetExtern_url;
typedef struct _TPprootView_Root* _TPPprootView_Root;
typedef struct _TPprootView_Root_library* _TPPprootView_Root_library;
typedef struct _TPprootView_Library* _TPPprootView_Library;
typedef struct _TPprootView_Library_name* _TPPprootView_Library_name;
typedef struct _TPprootView_Library_formularconditions* _TPPprootView_Library_formularconditions;
typedef struct _TPprootView_Library_navigationElement* _TPPprootView_Library_navigationElement;
typedef struct _TPprootView_NavigationElement* _TPPprootView_NavigationElement;
typedef struct _TPprootView_NavigationElement_code* _TPPprootView_NavigationElement_code;
typedef struct _TPprootView_NavigationElement_name* _TPPprootView_NavigationElement_name;
typedef struct _TPprootView_WebApplication* _TPPprootView_WebApplication;
typedef struct _TPprootView_WebApplication_name* _TPPprootView_WebApplication_name;
typedef struct _TPprootView_WebApplication_frames* _TPPprootView_WebApplication_frames;
typedef struct _TPprootView_WebApplication_roles* _TPPprootView_WebApplication_roles;
typedef struct _TPprootView_WebApplication_linksExtern* _TPPprootView_WebApplication_linksExtern;
typedef struct _TPprootView_WebApplication_imagePath* _TPPprootView_WebApplication_imagePath;
typedef struct _TPprootView_RootWebZone* _TPPprootView_RootWebZone;
typedef struct _TPprootView_RootWebZone_webTargets* _TPPprootView_RootWebZone_webTargets;
typedef struct _TPprootView_RootWebZone_errorLink* _TPPprootView_RootWebZone_errorLink;
typedef struct _TPprootView_RootWebZone_roles* _TPPprootView_RootWebZone_roles;
typedef struct _TPprootView_RootWebZone_setSize* _TPPprootView_RootWebZone_setSize;
typedef struct _TPprootView_SubWebZone* _TPPprootView_SubWebZone;
typedef struct _TPprootView_SubWebZone_name* _TPPprootView_SubWebZone_name;
typedef struct _TPprootView_SubWebZone_webTargets* _TPPprootView_SubWebZone_webTargets;
typedef struct _TPprootView_SubWebZone_errorLink* _TPPprootView_SubWebZone_errorLink;
typedef struct _TPprootView_SubWebZone_globalparams* _TPPprootView_SubWebZone_globalparams;
typedef struct _TPprootView_SubWebZone_roles* _TPPprootView_SubWebZone_roles;
typedef struct _TPprootView_SubWebZone_setSize* _TPPprootView_SubWebZone_setSize;
typedef struct _TPprootView_SubWebZone_position* _TPPprootView_SubWebZone_position;
typedef struct _TPprootView_WebRole* _TPPprootView_WebRole;
typedef struct _TPprootView_WebRole_name* _TPPprootView_WebRole_name;
typedef struct _TPprootView_WebRole_color* _TPPprootView_WebRole_color;
typedef struct _TPprootView_WebRoleRef* _TPPprootView_WebRoleRef;
typedef struct _TPprootView_WebRoleRef_role* _TPPprootView_WebRoleRef_role;
typedef struct _TPprootView_WebPage* _TPPprootView_WebPage;
typedef struct _TPprootView_WebPage_name* _TPPprootView_WebPage_name;
typedef struct _TPprootView_WebPage_formalParameter* _TPPprootView_WebPage_formalParameter;
typedef struct _TPprootView_WebPage_title* _TPPprootView_WebPage_title;
typedef struct _TPprootView_WebPage_styleSheetBlock* _TPPprootView_WebPage_styleSheetBlock;
typedef struct _TPprootView_WebPage_position* _TPPprootView_WebPage_position;
typedef struct _TPprootView_Frame* _TPPprootView_Frame;
typedef struct _TPprootView_Frame_components* _TPPprootView_Frame_components;
typedef struct _TPprootView_Frame_styleSheetBlock* _TPPprootView_Frame_styleSheetBlock;
typedef struct _TPprootView_GlobalFrame* _TPPprootView_GlobalFrame;
typedef struct _TPprootView_GlobalFrame_name* _TPPprootView_GlobalFrame_name;
typedef struct _TPprootView_GlobalFrame_components* _TPPprootView_GlobalFrame_components;
typedef struct _TPprootView_GlobalFrame_setSize* _TPPprootView_GlobalFrame_setSize;
typedef struct _TPprootView_NavigationBar* _TPPprootView_NavigationBar;
typedef struct _TPprootView_NavigationBar_styleSheetBlock* _TPPprootView_NavigationBar_styleSheetBlock;
typedef struct _TPprootView_NavigationBar_elements* _TPPprootView_NavigationBar_elements;
typedef struct _TPprootView_NavigationBar_alignment* _TPPprootView_NavigationBar_alignment;
typedef struct _TPprootView_NavigationBarElement* _TPPprootView_NavigationBarElement;
typedef struct _TPprootView_NavigationBarElement_target* _TPPprootView_NavigationBarElement_target;
typedef struct _TPprootView_FrameRef* _TPPprootView_FrameRef;
typedef struct _TPprootView_FrameRef_styleSheetBlock* _TPPprootView_FrameRef_styleSheetBlock;
typedef struct _TPprootView_FrameRef_frame* _TPPprootView_FrameRef_frame;
typedef struct _TPprootView_MetaInformation* _TPPprootView_MetaInformation;
typedef struct _TPprootView_MetaInformation_name* _TPPprootView_MetaInformation_name;
typedef struct _TPprootView_MetaInformation_elements* _TPPprootView_MetaInformation_elements;
typedef struct _TPprootView_MetaInformationElement* _TPPprootView_MetaInformationElement;
typedef struct _TPprootView_MetaInformationElement_property* _TPPprootView_MetaInformationElement_property;
typedef struct _TPprootView_MetaInformationElement_value* _TPPprootView_MetaInformationElement_value;
typedef struct _TPprootView_OutputElement* _TPPprootView_OutputElement;
typedef struct _TPprootView_OutputElement_link* _TPPprootView_OutputElement_link;
typedef struct _TPprootView_OutputElement_content* _TPPprootView_OutputElement_content;
typedef struct _TPprootView_ListOutputElement* _TPPprootView_ListOutputElement;
typedef struct _TPprootView_ListOutputElement_styleSheetBlock* _TPPprootView_ListOutputElement_styleSheetBlock;
typedef struct _TPprootView_ListOutputElement_dataSourceActualParams* _TPPprootView_ListOutputElement_dataSourceActualParams;
typedef struct _TPprootView_ListOutputElement_dataSource* _TPPprootView_ListOutputElement_dataSource;
typedef struct _TPprootView_ListOutputElement_maxNumberOfElements* _TPPprootView_ListOutputElement_maxNumberOfElements;
typedef struct _TPprootView_ListOutputElement_navigationElement* _TPPprootView_ListOutputElement_navigationElement;
typedef struct _TPprootView_StyleSheet* _TPPprootView_StyleSheet;
typedef struct _TPprootView_StyleSheet_name* _TPPprootView_StyleSheet_name;
typedef struct _TPprootView_StyleSheet_custom* _TPPprootView_StyleSheet_custom;
typedef struct _TPprootView_StyleSheet_default* _TPPprootView_StyleSheet_default;
typedef struct _TPprootView_CustomStyleSheetBlock* _TPPprootView_CustomStyleSheetBlock;
typedef struct _TPprootView_CustomStyleSheetBlock_pairs* _TPPprootView_CustomStyleSheetBlock_pairs;
typedef struct _TPprootView_CustomStyleSheetBlock_name* _TPPprootView_CustomStyleSheetBlock_name;
typedef struct _TPprootView_StyleSheetPair* _TPPprootView_StyleSheetPair;
typedef struct _TPprootView_StyleSheetPair_category* _TPPprootView_StyleSheetPair_category;
typedef struct _TPprootView_StyleSheetPair_attribute* _TPPprootView_StyleSheetPair_attribute;
typedef struct _TPprootView_StyleSheetPair_valueCategory* _TPPprootView_StyleSheetPair_valueCategory;
typedef struct _TPprootView_StyleSheetPair_value* _TPPprootView_StyleSheetPair_value;
typedef struct _TPprootView_SizeValue* _TPPprootView_SizeValue;
typedef struct _TPprootView_SizeValue_measure* _TPPprootView_SizeValue_measure;
typedef struct _TPprootView_SizeValue_value* _TPPprootView_SizeValue_value;
typedef struct _TPprootView_ColorValue* _TPPprootView_ColorValue;
typedef struct _TPprootView_ColorValue_color* _TPPprootView_ColorValue_color;
typedef struct _TPprootView_FamilyValue* _TPPprootView_FamilyValue;
typedef struct _TPprootView_FamilyValue_family* _TPPprootView_FamilyValue_family;
typedef struct _TPprootView_StyleValue* _TPPprootView_StyleValue;
typedef struct _TPprootView_StyleValue_style* _TPPprootView_StyleValue_style;
typedef struct _TPprootView_HeadingValue* _TPPprootView_HeadingValue;
typedef struct _TPprootView_HeadingValue_heading* _TPPprootView_HeadingValue_heading;
typedef struct _TPprootView_AlignmentValue* _TPPprootView_AlignmentValue;
typedef struct _TPprootView_AlignmentValue_alignment* _TPPprootView_AlignmentValue_alignment;
typedef struct _TPprootView_ListValue* _TPPprootView_ListValue;
typedef struct _TPprootView_ListValue_listed* _TPPprootView_ListValue_listed;
typedef struct _TPprootView_CustomValue* _TPPprootView_CustomValue;
typedef struct _TPprootView_CustomValue_value* _TPPprootView_CustomValue_value;
typedef struct _TPprootView_HtmlStyleSheetBlock* _TPPprootView_HtmlStyleSheetBlock;
typedef struct _TPprootView_HtmlStyleSheetBlock_pairs* _TPPprootView_HtmlStyleSheetBlock_pairs;
typedef struct _TPprootView_HtmlStyleSheetBlock_name* _TPPprootView_HtmlStyleSheetBlock_name;
typedef struct _TPprootView_ActionHandler* _TPPprootView_ActionHandler;
typedef struct _TPprootView_ActionHandler_targetpage* _TPPprootView_ActionHandler_targetpage;
typedef struct _TPprootView_ActionHandler_params* _TPPprootView_ActionHandler_params;
typedef struct _TPprootView_WebAction* _TPPprootView_WebAction;
typedef struct _TPprootView_WebAction_name* _TPPprootView_WebAction_name;
typedef struct _TPprootView_WebAction_formalParameter* _TPPprootView_WebAction_formalParameter;
typedef struct _TPprootView_WebAction_operations* _TPPprootView_WebAction_operations;
typedef struct _TPprootView_WebAction_position* _TPPprootView_WebAction_position;
typedef struct _TPprootView_PHPOperation* _TPPprootView_PHPOperation;
typedef struct _TPprootView_PHPOperation_errorhandler* _TPPprootView_PHPOperation_errorhandler;
typedef struct _TPprootView_PHPOperation_content* _TPPprootView_PHPOperation_content;
typedef struct _TPprootView_DataBaseOperation* _TPPprootView_DataBaseOperation;
typedef struct _TPprootView_DataBaseOperation_errorhandler* _TPPprootView_DataBaseOperation_errorhandler;
typedef struct _TPprootView_DataBaseOperation_filter* _TPPprootView_DataBaseOperation_filter;
typedef struct _TPprootView_DataBaseOperation_params* _TPPprootView_DataBaseOperation_params;
typedef struct _TPpVIEWROOT_sspDlg* _TPPpVIEWROOT_sspDlg;
typedef struct _TPpsspDlg_StyleSheetPair* _TPPpsspDlg_StyleSheetPair;
typedef struct _TPpsspDlg_StyleSheetPair_category* _TPPpsspDlg_StyleSheetPair_category;
typedef struct _TPpsspDlg_StyleSheetPair_attribute* _TPPpsspDlg_StyleSheetPair_attribute;
typedef struct _TPpsspDlg_StyleSheetPair_valueCategory* _TPPpsspDlg_StyleSheetPair_valueCategory;
typedef struct _TPpsspDlg_StyleSheetPair_value* _TPPpsspDlg_StyleSheetPair_value;
typedef struct _TPpsspDlg_SizeValue* _TPPpsspDlg_SizeValue;
typedef struct _TPpsspDlg_SizeValue_measure* _TPPpsspDlg_SizeValue_measure;
typedef struct _TPpsspDlg_SizeValue_value* _TPPpsspDlg_SizeValue_value;
typedef struct _TPpsspDlg_ColorValue* _TPPpsspDlg_ColorValue;
typedef struct _TPpsspDlg_ColorValue_color* _TPPpsspDlg_ColorValue_color;
typedef struct _TPpsspDlg_FamilyValue* _TPPpsspDlg_FamilyValue;
typedef struct _TPpsspDlg_FamilyValue_family* _TPPpsspDlg_FamilyValue_family;
typedef struct _TPpsspDlg_StyleValue* _TPPpsspDlg_StyleValue;
typedef struct _TPpsspDlg_StyleValue_style* _TPPpsspDlg_StyleValue_style;
typedef struct _TPpsspDlg_HeadingValue* _TPPpsspDlg_HeadingValue;
typedef struct _TPpsspDlg_HeadingValue_heading* _TPPpsspDlg_HeadingValue_heading;
typedef struct _TPpsspDlg_AlignmentValue* _TPPpsspDlg_AlignmentValue;
typedef struct _TPpsspDlg_AlignmentValue_alignment* _TPPpsspDlg_AlignmentValue_alignment;
typedef struct _TPpsspDlg_ListValue* _TPPpsspDlg_ListValue;
typedef struct _TPpsspDlg_ListValue_listed* _TPPpsspDlg_ListValue_listed;
typedef struct _TPpsspDlg_CustomValue* _TPPpsspDlg_CustomValue;
typedef struct _TPpsspDlg_CustomValue_value* _TPPpsspDlg_CustomValue_value;
typedef struct _TPpVIEWROOT_stylesheetView* _TPPpVIEWROOT_stylesheetView;
typedef struct _TPpstylesheetView_StyleSheet* _TPPpstylesheetView_StyleSheet;
typedef struct _TPpstylesheetView_StyleSheet_name* _TPPpstylesheetView_StyleSheet_name;
typedef struct _TPpstylesheetView_StyleSheet_custom* _TPPpstylesheetView_StyleSheet_custom;
typedef struct _TPpstylesheetView_StyleSheet_default* _TPPpstylesheetView_StyleSheet_default;
typedef struct _TPpstylesheetView_CustomStyleSheetBlock* _TPPpstylesheetView_CustomStyleSheetBlock;
typedef struct _TPpstylesheetView_CustomStyleSheetBlock_pairs* _TPPpstylesheetView_CustomStyleSheetBlock_pairs;
typedef struct _TPpstylesheetView_CustomStyleSheetBlock_name* _TPPpstylesheetView_CustomStyleSheetBlock_name;
typedef struct _TPpstylesheetView_StyleSheetPair* _TPPpstylesheetView_StyleSheetPair;
typedef struct _TPpstylesheetView_StyleSheetPair_category* _TPPpstylesheetView_StyleSheetPair_category;
typedef struct _TPpstylesheetView_StyleSheetPair_attribute* _TPPpstylesheetView_StyleSheetPair_attribute;
typedef struct _TPpstylesheetView_StyleSheetPair_valueCategory* _TPPpstylesheetView_StyleSheetPair_valueCategory;
typedef struct _TPpstylesheetView_StyleSheetPair_value* _TPPpstylesheetView_StyleSheetPair_value;
typedef struct _TPpstylesheetView_SizeValue* _TPPpstylesheetView_SizeValue;
typedef struct _TPpstylesheetView_SizeValue_measure* _TPPpstylesheetView_SizeValue_measure;
typedef struct _TPpstylesheetView_SizeValue_value* _TPPpstylesheetView_SizeValue_value;
typedef struct _TPpstylesheetView_ColorValue* _TPPpstylesheetView_ColorValue;
typedef struct _TPpstylesheetView_ColorValue_color* _TPPpstylesheetView_ColorValue_color;
typedef struct _TPpstylesheetView_FamilyValue* _TPPpstylesheetView_FamilyValue;
typedef struct _TPpstylesheetView_FamilyValue_family* _TPPpstylesheetView_FamilyValue_family;
typedef struct _TPpstylesheetView_StyleValue* _TPPpstylesheetView_StyleValue;
typedef struct _TPpstylesheetView_StyleValue_style* _TPPpstylesheetView_StyleValue_style;
typedef struct _TPpstylesheetView_HeadingValue* _TPPpstylesheetView_HeadingValue;
typedef struct _TPpstylesheetView_HeadingValue_heading* _TPPpstylesheetView_HeadingValue_heading;
typedef struct _TPpstylesheetView_AlignmentValue* _TPPpstylesheetView_AlignmentValue;
typedef struct _TPpstylesheetView_AlignmentValue_alignment* _TPPpstylesheetView_AlignmentValue_alignment;
typedef struct _TPpstylesheetView_ListValue* _TPPpstylesheetView_ListValue;
typedef struct _TPpstylesheetView_ListValue_listed* _TPPpstylesheetView_ListValue_listed;
typedef struct _TPpstylesheetView_CustomValue* _TPPpstylesheetView_CustomValue;
typedef struct _TPpstylesheetView_CustomValue_value* _TPPpstylesheetView_CustomValue_value;
typedef struct _TPpstylesheetView_HtmlStyleSheetBlock* _TPPpstylesheetView_HtmlStyleSheetBlock;
typedef struct _TPpstylesheetView_HtmlStyleSheetBlock_pairs* _TPPpstylesheetView_HtmlStyleSheetBlock_pairs;
typedef struct _TPpstylesheetView_HtmlStyleSheetBlock_name* _TPPpstylesheetView_HtmlStyleSheetBlock_name;
typedef struct _TPpVIEWROOT_webActionView* _TPPpVIEWROOT_webActionView;
typedef struct _TPpwebActionView_WebNodeFormalParam* _TPPpwebActionView_WebNodeFormalParam;
typedef struct _TPpwebActionView_WebNodeFormalParam_name* _TPPpwebActionView_WebNodeFormalParam_name;
typedef struct _TPpwebActionView_WebNodeFormalParam_keyword1* _TPPpwebActionView_WebNodeFormalParam_keyword1;
typedef struct _TPpwebActionView_WebNodeFormalParam_type* _TPPpwebActionView_WebNodeFormalParam_type;
typedef struct _TPpwebActionView_WebNodeActualParam* _TPPpwebActionView_WebNodeActualParam;
typedef struct _TPpwebActionView_WebNodeActualParam_formalParam* _TPPpwebActionView_WebNodeActualParam_formalParam;
typedef struct _TPpwebActionView_WebNodeActualParam_keyword1* _TPPpwebActionView_WebNodeActualParam_keyword1;
typedef struct _TPpwebActionView_WebNodeActualParam_expressions* _TPPpwebActionView_WebNodeActualParam_expressions;
typedef struct _TPpwebActionView_WebNodeConstantExpression* _TPPpwebActionView_WebNodeConstantExpression;
typedef struct _TPpwebActionView_WebNodeConstantExpression_keyword1* _TPPpwebActionView_WebNodeConstantExpression_keyword1;
typedef struct _TPpwebActionView_WebNodeConstantExpression_value* _TPPpwebActionView_WebNodeConstantExpression_value;
typedef struct _TPpwebActionView_WebNodeConstantExpression_keyword2* _TPPpwebActionView_WebNodeConstantExpression_keyword2;
typedef struct _TPpwebActionView_WebNodeVariableExpression* _TPPpwebActionView_WebNodeVariableExpression;
typedef struct _TPpwebActionView_WebNodeVariableExpression_content* _TPPpwebActionView_WebNodeVariableExpression_content;
typedef struct _TPpwebActionView_WebNodeColumnExpression* _TPPpwebActionView_WebNodeColumnExpression;
typedef struct _TPpwebActionView_WebNodeColumnExpression_content* _TPPpwebActionView_WebNodeColumnExpression_content;
typedef struct _TPpwebActionView_DBString* _TPPpwebActionView_DBString;
typedef struct _TPpwebActionView_DBString_keyword1* _TPPpwebActionView_DBString_keyword1;
typedef struct _TPpwebActionView_DBInteger* _TPPpwebActionView_DBInteger;
typedef struct _TPpwebActionView_DBInteger_keyword1* _TPPpwebActionView_DBInteger_keyword1;
typedef struct _TPpwebActionView_DBFloat* _TPPpwebActionView_DBFloat;
typedef struct _TPpwebActionView_DBFloat_keyword1* _TPPpwebActionView_DBFloat_keyword1;
typedef struct _TPpwebActionView_DBDouble* _TPPpwebActionView_DBDouble;
typedef struct _TPpwebActionView_DBDouble_keyword1* _TPPpwebActionView_DBDouble_keyword1;
typedef struct _TPpwebActionView_DBBigInt* _TPPpwebActionView_DBBigInt;
typedef struct _TPpwebActionView_DBBigInt_keyword1* _TPPpwebActionView_DBBigInt_keyword1;
typedef struct _TPpwebActionView_DBDate* _TPPpwebActionView_DBDate;
typedef struct _TPpwebActionView_DBDate_keyword1* _TPPpwebActionView_DBDate_keyword1;
typedef struct _TPpwebActionView_DBTimeStamp* _TPPpwebActionView_DBTimeStamp;
typedef struct _TPpwebActionView_DBTimeStamp_keyword1* _TPPpwebActionView_DBTimeStamp_keyword1;
typedef struct _TPpwebActionView_DBBoolean* _TPPpwebActionView_DBBoolean;
typedef struct _TPpwebActionView_DBBoolean_keyword1* _TPPpwebActionView_DBBoolean_keyword1;
typedef struct _TPpwebActionView_DBBlob* _TPPpwebActionView_DBBlob;
typedef struct _TPpwebActionView_DBBlob_keyword1* _TPPpwebActionView_DBBlob_keyword1;
typedef struct _TPpwebActionView_DataSourceActualParam* _TPPpwebActionView_DataSourceActualParam;
typedef struct _TPpwebActionView_DataSourceActualParam_formalParam* _TPPpwebActionView_DataSourceActualParam_formalParam;
typedef struct _TPpwebActionView_DataSourceActualParam_keyword1* _TPPpwebActionView_DataSourceActualParam_keyword1;
typedef struct _TPpwebActionView_DataSourceActualParam_expressions* _TPPpwebActionView_DataSourceActualParam_expressions;
typedef struct _TPpwebActionView_ActionHandler* _TPPpwebActionView_ActionHandler;
typedef struct _TPpwebActionView_ActionHandler_targetpage* _TPPpwebActionView_ActionHandler_targetpage;
typedef struct _TPpwebActionView_ActionHandler_params* _TPPpwebActionView_ActionHandler_params;
typedef struct _TPpwebActionView_WebAction* _TPPpwebActionView_WebAction;
typedef struct _TPpwebActionView_WebAction_name* _TPPpwebActionView_WebAction_name;
typedef struct _TPpwebActionView_WebAction_formalParameter* _TPPpwebActionView_WebAction_formalParameter;
typedef struct _TPpwebActionView_WebAction_operations* _TPPpwebActionView_WebAction_operations;
typedef struct _TPpwebActionView_WebAction_position* _TPPpwebActionView_WebAction_position;
typedef struct _TPpwebActionView_PHPOperation* _TPPpwebActionView_PHPOperation;
typedef struct _TPpwebActionView_PHPOperation_errorhandler* _TPPpwebActionView_PHPOperation_errorhandler;
typedef struct _TPpwebActionView_PHPOperation_content* _TPPpwebActionView_PHPOperation_content;
typedef struct _TPpwebActionView_DataBaseOperation* _TPPpwebActionView_DataBaseOperation;
typedef struct _TPpwebActionView_DataBaseOperation_errorhandler* _TPPpwebActionView_DataBaseOperation_errorhandler;
typedef struct _TPpwebActionView_DataBaseOperation_filter* _TPPpwebActionView_DataBaseOperation_filter;
typedef struct _TPpwebActionView_DataBaseOperation_params* _TPPpwebActionView_DataBaseOperation_params;
typedef struct _TPpVIEWROOT_webPageView* _TPPpVIEWROOT_webPageView;
typedef struct _TPpwebPageView_FormularCheckboxElement* _TPPpwebPageView_FormularCheckboxElement;
typedef struct _TPpwebPageView_FormularCheckboxElement_label* _TPPpwebPageView_FormularCheckboxElement_label;
typedef struct _TPpwebPageView_FormularCheckboxElement_name* _TPPpwebPageView_FormularCheckboxElement_name;
typedef struct _TPpwebPageView_FormularCheckboxElement_type* _TPPpwebPageView_FormularCheckboxElement_type;
typedef struct _TPpwebPageView_FormularCheckboxElement_description* _TPPpwebPageView_FormularCheckboxElement_description;
typedef struct _TPpwebPageView_FormularTextElement* _TPPpwebPageView_FormularTextElement;
typedef struct _TPpwebPageView_FormularTextElement_label* _TPPpwebPageView_FormularTextElement_label;
typedef struct _TPpwebPageView_FormularTextElement_type* _TPPpwebPageView_FormularTextElement_type;
typedef struct _TPpwebPageView_FormularTextElement_description* _TPPpwebPageView_FormularTextElement_description;
typedef struct _TPpwebPageView_FormularPasswordElement* _TPPpwebPageView_FormularPasswordElement;
typedef struct _TPpwebPageView_FormularPasswordElement_label* _TPPpwebPageView_FormularPasswordElement_label;
typedef struct _TPpwebPageView_FormularPasswordElement_type* _TPPpwebPageView_FormularPasswordElement_type;
typedef struct _TPpwebPageView_FormularPasswordElement_description* _TPPpwebPageView_FormularPasswordElement_description;
typedef struct _TPpwebPageView_FormularTextAreaElement* _TPPpwebPageView_FormularTextAreaElement;
typedef struct _TPpwebPageView_FormularTextAreaElement_label* _TPPpwebPageView_FormularTextAreaElement_label;
typedef struct _TPpwebPageView_FormularTextAreaElement_type* _TPPpwebPageView_FormularTextAreaElement_type;
typedef struct _TPpwebPageView_FormularTextAreaElement_description* _TPPpwebPageView_FormularTextAreaElement_description;
typedef struct _TPpwebPageView_FormularSelectElement* _TPPpwebPageView_FormularSelectElement;
typedef struct _TPpwebPageView_FormularSelectElement_label* _TPPpwebPageView_FormularSelectElement_label;
typedef struct _TPpwebPageView_FormularSelectElement_multiple* _TPPpwebPageView_FormularSelectElement_multiple;
typedef struct _TPpwebPageView_FormularSelectElement_options* _TPPpwebPageView_FormularSelectElement_options;
typedef struct _TPpwebPageView_FormularSelectElement_description* _TPPpwebPageView_FormularSelectElement_description;
typedef struct _TPpwebPageView_FormularRadioElement* _TPPpwebPageView_FormularRadioElement;
typedef struct _TPpwebPageView_FormularRadioElement_type* _TPPpwebPageView_FormularRadioElement_type;
typedef struct _TPpwebPageView_FormularRadioElement_label* _TPPpwebPageView_FormularRadioElement_label;
typedef struct _TPpwebPageView_FormularRadioElement_name* _TPPpwebPageView_FormularRadioElement_name;
typedef struct _TPpwebPageView_DataSourceActualParam* _TPPpwebPageView_DataSourceActualParam;
typedef struct _TPpwebPageView_DataSourceActualParam_formalParam* _TPPpwebPageView_DataSourceActualParam_formalParam;
typedef struct _TPpwebPageView_DataSourceActualParam_keyword1* _TPPpwebPageView_DataSourceActualParam_keyword1;
typedef struct _TPpwebPageView_DataSourceActualParam_expressions* _TPPpwebPageView_DataSourceActualParam_expressions;
typedef struct _TPpwebPageView_WebNodeActualParam* _TPPpwebPageView_WebNodeActualParam;
typedef struct _TPpwebPageView_WebNodeActualParam_formalParam* _TPPpwebPageView_WebNodeActualParam_formalParam;
typedef struct _TPpwebPageView_WebNodeActualParam_keyword1* _TPPpwebPageView_WebNodeActualParam_keyword1;
typedef struct _TPpwebPageView_WebNodeActualParam_expressions* _TPPpwebPageView_WebNodeActualParam_expressions;
typedef struct _TPpwebPageView_WebNodeConstantExpression* _TPPpwebPageView_WebNodeConstantExpression;
typedef struct _TPpwebPageView_WebNodeConstantExpression_keyword1* _TPPpwebPageView_WebNodeConstantExpression_keyword1;
typedef struct _TPpwebPageView_WebNodeConstantExpression_value* _TPPpwebPageView_WebNodeConstantExpression_value;
typedef struct _TPpwebPageView_WebNodeConstantExpression_keyword2* _TPPpwebPageView_WebNodeConstantExpression_keyword2;
typedef struct _TPpwebPageView_WebNodeVariableExpression* _TPPpwebPageView_WebNodeVariableExpression;
typedef struct _TPpwebPageView_WebNodeVariableExpression_content* _TPPpwebPageView_WebNodeVariableExpression_content;
typedef struct _TPpwebPageView_WebNodeColumnExpression* _TPPpwebPageView_WebNodeColumnExpression;
typedef struct _TPpwebPageView_WebNodeColumnExpression_content* _TPPpwebPageView_WebNodeColumnExpression_content;
typedef struct _TPpwebPageView_WebNodeFormalParam* _TPPpwebPageView_WebNodeFormalParam;
typedef struct _TPpwebPageView_WebNodeFormalParam_name* _TPPpwebPageView_WebNodeFormalParam_name;
typedef struct _TPpwebPageView_WebNodeFormalParam_keyword1* _TPPpwebPageView_WebNodeFormalParam_keyword1;
typedef struct _TPpwebPageView_WebNodeFormalParam_type* _TPPpwebPageView_WebNodeFormalParam_type;
typedef struct _TPpwebPageView_DBString* _TPPpwebPageView_DBString;
typedef struct _TPpwebPageView_DBString_keyword1* _TPPpwebPageView_DBString_keyword1;
typedef struct _TPpwebPageView_DBInteger* _TPPpwebPageView_DBInteger;
typedef struct _TPpwebPageView_DBInteger_keyword1* _TPPpwebPageView_DBInteger_keyword1;
typedef struct _TPpwebPageView_DBFloat* _TPPpwebPageView_DBFloat;
typedef struct _TPpwebPageView_DBFloat_keyword1* _TPPpwebPageView_DBFloat_keyword1;
typedef struct _TPpwebPageView_DBDouble* _TPPpwebPageView_DBDouble;
typedef struct _TPpwebPageView_DBDouble_keyword1* _TPPpwebPageView_DBDouble_keyword1;
typedef struct _TPpwebPageView_DBBigInt* _TPPpwebPageView_DBBigInt;
typedef struct _TPpwebPageView_DBBigInt_keyword1* _TPPpwebPageView_DBBigInt_keyword1;
typedef struct _TPpwebPageView_DBDate* _TPPpwebPageView_DBDate;
typedef struct _TPpwebPageView_DBDate_keyword1* _TPPpwebPageView_DBDate_keyword1;
typedef struct _TPpwebPageView_DBTimeStamp* _TPPpwebPageView_DBTimeStamp;
typedef struct _TPpwebPageView_DBTimeStamp_keyword1* _TPPpwebPageView_DBTimeStamp_keyword1;
typedef struct _TPpwebPageView_DBBoolean* _TPPpwebPageView_DBBoolean;
typedef struct _TPpwebPageView_DBBoolean_keyword1* _TPPpwebPageView_DBBoolean_keyword1;
typedef struct _TPpwebPageView_DBBlob* _TPPpwebPageView_DBBlob;
typedef struct _TPpwebPageView_DBBlob_keyword1* _TPPpwebPageView_DBBlob_keyword1;
typedef struct _TPpwebPageView_Formular* _TPPpwebPageView_Formular;
typedef struct _TPpwebPageView_Formular_styleSheetBlock* _TPPpwebPageView_Formular_styleSheetBlock;
typedef struct _TPpwebPageView_Formular_action* _TPPpwebPageView_Formular_action;
typedef struct _TPpwebPageView_Formular_elements* _TPPpwebPageView_Formular_elements;
typedef struct _TPpwebPageView_Formular_datasource* _TPPpwebPageView_Formular_datasource;
typedef struct _TPpwebPageView_Formular_actualParams* _TPPpwebPageView_Formular_actualParams;
typedef struct _TPpwebPageView_FormularRadioGroupElement* _TPPpwebPageView_FormularRadioGroupElement;
typedef struct _TPpwebPageView_FormularRadioGroupElement_name* _TPPpwebPageView_FormularRadioGroupElement_name;
typedef struct _TPpwebPageView_FormularRadioGroupElement_label* _TPPpwebPageView_FormularRadioGroupElement_label;
typedef struct _TPpwebPageView_FormularRadioGroupElement_description* _TPPpwebPageView_FormularRadioGroupElement_description;
typedef struct _TPpwebPageView_FormularRadioGroupElement_pvalue* _TPPpwebPageView_FormularRadioGroupElement_pvalue;
typedef struct _TPpwebPageView_FormularRadioGroupElement_elements* _TPPpwebPageView_FormularRadioGroupElement_elements;
typedef struct _TPpwebPageView_FormularRadioGroupElement_checked* _TPPpwebPageView_FormularRadioGroupElement_checked;
typedef struct _TPpwebPageView_FormularConstantSelectOption* _TPPpwebPageView_FormularConstantSelectOption;
typedef struct _TPpwebPageView_FormularConstantSelectOption_values* _TPPpwebPageView_FormularConstantSelectOption_values;
typedef struct _TPpwebPageView_FormularDataSourceSelectOption* _TPPpwebPageView_FormularDataSourceSelectOption;
typedef struct _TPpwebPageView_FormularDataSourceSelectOption_values* _TPPpwebPageView_FormularDataSourceSelectOption_values;
typedef struct _TPpwebPageView_FormularDataSourceSelectOption_params* _TPPpwebPageView_FormularDataSourceSelectOption_params;
typedef struct _TPpwebPageView_FormularPHPScriptSelectOption* _TPPpwebPageView_FormularPHPScriptSelectOption;
typedef struct _TPpwebPageView_FormularPHPScriptSelectOption_script* _TPPpwebPageView_FormularPHPScriptSelectOption_script;
typedef struct _TPpwebPageView_FormularCondition* _TPPpwebPageView_FormularCondition;
typedef struct _TPpwebPageView_FormularCondition_condition* _TPPpwebPageView_FormularCondition_condition;
typedef struct _TPpwebPageView_FormularCondition_params* _TPPpwebPageView_FormularCondition_params;
typedef struct _TPpwebPageView_FormularConditionActualParam* _TPPpwebPageView_FormularConditionActualParam;
typedef struct _TPpwebPageView_FormularConditionActualParam_value* _TPPpwebPageView_FormularConditionActualParam_value;
typedef struct _TPpwebPageView_FormularConditionActualParam_formalparam* _TPPpwebPageView_FormularConditionActualParam_formalparam;
typedef struct _TPpwebPageView_Paragraph* _TPPpwebPageView_Paragraph;
typedef struct _TPpwebPageView_Paragraph_styleSheetBlock* _TPPpwebPageView_Paragraph_styleSheetBlock;
typedef struct _TPpwebPageView_Paragraph_fragments* _TPPpwebPageView_Paragraph_fragments;
typedef struct _TPpwebPageView_TextFragment* _TPPpwebPageView_TextFragment;
typedef struct _TPpwebPageView_TextFragment_link* _TPPpwebPageView_TextFragment_link;
typedef struct _TPpwebPageView_TextFragment_value* _TPPpwebPageView_TextFragment_value;
typedef struct _TPpwebPageView_ImageFragment* _TPPpwebPageView_ImageFragment;
typedef struct _TPpwebPageView_ImageFragment_link* _TPPpwebPageView_ImageFragment_link;
typedef struct _TPpwebPageView_ImageFragment_width* _TPPpwebPageView_ImageFragment_width;
typedef struct _TPpwebPageView_ImageFragment_height* _TPPpwebPageView_ImageFragment_height;
typedef struct _TPpwebPageView_ImageFragment_text* _TPPpwebPageView_ImageFragment_text;
typedef struct _TPpwebPageView_ImageFragment_imageName* _TPPpwebPageView_ImageFragment_imageName;
typedef struct _TPpwebPageView_Heading* _TPPpwebPageView_Heading;
typedef struct _TPpwebPageView_Heading_styleSheetBlock* _TPPpwebPageView_Heading_styleSheetBlock;
typedef struct _TPpwebPageView_Heading_text* _TPPpwebPageView_Heading_text;
typedef struct _TPpwebPageView_Heading_level* _TPPpwebPageView_Heading_level;
typedef struct _TPpwebPageView_Table* _TPPpwebPageView_Table;
typedef struct _TPpwebPageView_Table_styleSheetBlock* _TPPpwebPageView_Table_styleSheetBlock;
typedef struct _TPpwebPageView_Table_rows* _TPPpwebPageView_Table_rows;
typedef struct _TPpwebPageView_Table_columns* _TPPpwebPageView_Table_columns;
typedef struct _TPpwebPageView_TableRow* _TPPpwebPageView_TableRow;
typedef struct _TPpwebPageView_TableRow_cells* _TPPpwebPageView_TableRow_cells;
typedef struct _TPpwebPageView_TableColumn* _TPPpwebPageView_TableColumn;
typedef struct _TPpwebPageView_TableCell* _TPPpwebPageView_TableCell;
typedef struct _TPpwebPageView_TableCell_columnRef* _TPPpwebPageView_TableCell_columnRef;
typedef struct _TPpwebPageView_WebPage* _TPPpwebPageView_WebPage;
typedef struct _TPpwebPageView_WebPage_name* _TPPpwebPageView_WebPage_name;
typedef struct _TPpwebPageView_WebPage_formalParameter* _TPPpwebPageView_WebPage_formalParameter;
typedef struct _TPpwebPageView_WebPage_title* _TPPpwebPageView_WebPage_title;
typedef struct _TPpwebPageView_WebPage_styleSheetBlock* _TPPpwebPageView_WebPage_styleSheetBlock;
typedef struct _TPpwebPageView_WebPage_position* _TPPpwebPageView_WebPage_position;
typedef struct _TPpwebPageView_Frame* _TPPpwebPageView_Frame;
typedef struct _TPpwebPageView_Frame_components* _TPPpwebPageView_Frame_components;
typedef struct _TPpwebPageView_Frame_styleSheetBlock* _TPPpwebPageView_Frame_styleSheetBlock;
typedef struct _TPpwebPageView_FrameRef* _TPPpwebPageView_FrameRef;
typedef struct _TPpwebPageView_FrameRef_styleSheetBlock* _TPPpwebPageView_FrameRef_styleSheetBlock;
typedef struct _TPpwebPageView_FrameRef_frame* _TPPpwebPageView_FrameRef_frame;
typedef struct _TPpwebPageView_OutputElement* _TPPpwebPageView_OutputElement;
typedef struct _TPpwebPageView_OutputElement_link* _TPPpwebPageView_OutputElement_link;
typedef struct _TPpwebPageView_OutputElement_content* _TPPpwebPageView_OutputElement_content;
typedef struct _TPpwebPageView_ListOutputElement* _TPPpwebPageView_ListOutputElement;
typedef struct _TPpwebPageView_ListOutputElement_styleSheetBlock* _TPPpwebPageView_ListOutputElement_styleSheetBlock;
typedef struct _TPpwebPageView_ListOutputElement_dataSourceActualParams* _TPPpwebPageView_ListOutputElement_dataSourceActualParams;
typedef struct _TPpwebPageView_ListOutputElement_dataSource* _TPPpwebPageView_ListOutputElement_dataSource;
typedef struct _TPpwebPageView_ListOutputElement_maxNumberOfElements* _TPPpwebPageView_ListOutputElement_maxNumberOfElements;
typedef struct _TPpwebPageView_ListOutputElement_navigationElement* _TPPpwebPageView_ListOutputElement_navigationElement;
typedef struct _TPrule_1* _TPPrule_1;
typedef struct _TPrule_2* _TPPrule_2;
typedef struct _TPrule_3* _TPPrule_3;
typedef struct _TPrule_4* _TPPrule_4;
typedef struct _TPrule_5* _TPPrule_5;
typedef struct _TPrule_6* _TPPrule_6;
typedef struct _TPrule_7* _TPPrule_7;
typedef struct _TPrule_8* _TPPrule_8;
typedef struct _TPrule_9* _TPPrule_9;
typedef struct _TPrule_10* _TPPrule_10;
typedef struct _TPrule_11* _TPPrule_11;
typedef struct _TPrule_12* _TPPrule_12;
typedef struct _TPrule_13* _TPPrule_13;
typedef struct _TPrule_14* _TPPrule_14;
typedef struct _TPrule_15* _TPPrule_15;
typedef struct _TPrule_16* _TPPrule_16;
typedef struct _TPrule_17* _TPPrule_17;
typedef struct _TPrule_18* _TPPrule_18;
typedef struct _TPrule_19* _TPPrule_19;
typedef struct _TPrule_20* _TPPrule_20;
typedef struct _TPrule_21* _TPPrule_21;
typedef struct _TPrule_22* _TPPrule_22;
typedef struct _TPrule_23* _TPPrule_23;
typedef struct _TPrule_24* _TPPrule_24;
typedef struct _TPrule_25* _TPPrule_25;
typedef struct _TPrule_26* _TPPrule_26;
typedef struct _TPrule_27* _TPPrule_27;
typedef struct _TPrule_28* _TPPrule_28;
typedef struct _TPrule_29* _TPPrule_29;
typedef struct _TPrule_30* _TPPrule_30;
typedef struct _TPrule_31* _TPPrule_31;
typedef struct _TPrule_32* _TPPrule_32;
typedef struct _TPrule_33* _TPPrule_33;
typedef struct _TPrule_34* _TPPrule_34;
typedef struct _TPrule_35* _TPPrule_35;
typedef struct _TPrule_36* _TPPrule_36;
typedef struct _TPrule_37* _TPPrule_37;
typedef struct _TPrule_38* _TPPrule_38;
typedef struct _TPrule_39* _TPPrule_39;
typedef struct _TPrule_40* _TPPrule_40;
typedef struct _TPrule_41* _TPPrule_41;
typedef struct _TPrule_42* _TPPrule_42;
typedef struct _TPrule_43* _TPPrule_43;
typedef struct _TPrule_44* _TPPrule_44;
typedef struct _TPrule_45* _TPPrule_45;
typedef struct _TPrule_46* _TPPrule_46;
typedef struct _TPrule_47* _TPPrule_47;
typedef struct _TPrule_48* _TPPrule_48;
typedef struct _TPrule_49* _TPPrule_49;
typedef struct _TPrule_50* _TPPrule_50;
typedef struct _TPrule_51* _TPPrule_51;
typedef struct _TPrule_52* _TPPrule_52;
typedef struct _TPrule_53* _TPPrule_53;
typedef struct _TPrule_54* _TPPrule_54;
typedef struct _TPrule_55* _TPPrule_55;
typedef struct _TPrule_56* _TPPrule_56;
typedef struct _TPrule_57* _TPPrule_57;
typedef struct _TPrule_58* _TPPrule_58;
typedef struct _TPrule_59* _TPPrule_59;
typedef struct _TPrule_60* _TPPrule_60;
typedef struct _TPrule_61* _TPPrule_61;
typedef struct _TPrule_62* _TPPrule_62;
typedef struct _TPrule_63* _TPPrule_63;
typedef struct _TPrule_64* _TPPrule_64;
typedef struct _TPrule_65* _TPPrule_65;
typedef struct _TPrule_66* _TPPrule_66;
typedef struct _TPrule_67* _TPPrule_67;
typedef struct _TPrule_68* _TPPrule_68;
typedef struct _TPrule_69* _TPPrule_69;
typedef struct _TPrule_70* _TPPrule_70;
typedef struct _TPrule_71* _TPPrule_71;
typedef struct _TPrule_72* _TPPrule_72;
typedef struct _TPrule_73* _TPPrule_73;
typedef struct _TPrule_74* _TPPrule_74;
typedef struct _TPrule_75* _TPPrule_75;
typedef struct _TPrule_76* _TPPrule_76;
typedef struct _TPrule_77* _TPPrule_77;
typedef struct _TPrule_78* _TPPrule_78;
typedef struct _TPrule_79* _TPPrule_79;
typedef struct _TPrule_80* _TPPrule_80;
typedef struct _TPrule_81* _TPPrule_81;
typedef struct _TPrule_82* _TPPrule_82;
typedef struct _TPrule_83* _TPPrule_83;
typedef struct _TPrule_84* _TPPrule_84;
typedef struct _TPrule_85* _TPPrule_85;
typedef struct _TPrule_86* _TPPrule_86;
typedef struct _TPrule_87* _TPPrule_87;
typedef struct _TPrule_88* _TPPrule_88;
typedef struct _TPrule_89* _TPPrule_89;
typedef struct _TPrule_90* _TPPrule_90;
typedef struct _TPrule_91* _TPPrule_91;
typedef struct _TPrule_92* _TPPrule_92;
typedef struct _TPrule_93* _TPPrule_93;
typedef struct _TPrule_94* _TPPrule_94;
typedef struct _TPrule_95* _TPPrule_95;
typedef struct _TPrule_96* _TPPrule_96;
typedef struct _TPrule_97* _TPPrule_97;
typedef struct _TPrule_98* _TPPrule_98;
typedef struct _TPrule_99* _TPPrule_99;
typedef struct _TPrule_100* _TPPrule_100;
typedef struct _TPrule_101* _TPPrule_101;
typedef struct _TPrule_102* _TPPrule_102;
typedef struct _TPrule_103* _TPPrule_103;
typedef struct _TPrule_104* _TPPrule_104;
typedef struct _TPrule_105* _TPPrule_105;
typedef struct _TPrule_106* _TPPrule_106;
typedef struct _TPrule_107* _TPPrule_107;
typedef struct _TPrule_108* _TPPrule_108;
typedef struct _TPrule_109* _TPPrule_109;
typedef struct _TPrule_110* _TPPrule_110;
typedef struct _TPrule_111* _TPPrule_111;
typedef struct _TPrule_112* _TPPrule_112;
typedef struct _TPrule_113* _TPPrule_113;
typedef struct _TPrule_114* _TPPrule_114;
typedef struct _TPrule_115* _TPPrule_115;
typedef struct _TPrule_116* _TPPrule_116;
typedef struct _TPrule_117* _TPPrule_117;
typedef struct _TPrule_118* _TPPrule_118;
typedef struct _TPrule_119* _TPPrule_119;
typedef struct _TPrule_120* _TPPrule_120;
typedef struct _TPrule_121* _TPPrule_121;
typedef struct _TPrule_122* _TPPrule_122;
typedef struct _TPrule_123* _TPPrule_123;
typedef struct _TPrule_124* _TPPrule_124;
typedef struct _TPrule_125* _TPPrule_125;
typedef struct _TPrule_126* _TPPrule_126;
typedef struct _TPrule_127* _TPPrule_127;
typedef struct _TPrule_128* _TPPrule_128;
typedef struct _TPrule_129* _TPPrule_129;
typedef struct _TPrule_130* _TPPrule_130;
typedef struct _TPrule_131* _TPPrule_131;
typedef struct _TPrule_132* _TPPrule_132;
typedef struct _TPrule_133* _TPPrule_133;
typedef struct _TPrule_134* _TPPrule_134;
typedef struct _TPrule_135* _TPPrule_135;
typedef struct _TPrule_136* _TPPrule_136;
typedef struct _TPrule_137* _TPPrule_137;
typedef struct _TPrule_138* _TPPrule_138;
typedef struct _TPrule_139* _TPPrule_139;
typedef struct _TPrule_140* _TPPrule_140;
typedef struct _TPrule_141* _TPPrule_141;
typedef struct _TPrule_142* _TPPrule_142;
typedef struct _TPrule_143* _TPPrule_143;
typedef struct _TPrule_144* _TPPrule_144;
typedef struct _TPrule_145* _TPPrule_145;
typedef struct _TPrule_146* _TPPrule_146;
typedef struct _TPrule_147* _TPPrule_147;
typedef struct _TPrule_148* _TPPrule_148;
typedef struct _TPrule_149* _TPPrule_149;
typedef struct _TPrule_150* _TPPrule_150;
typedef struct _TPrule_151* _TPPrule_151;
typedef struct _TPLST_codeGen_DBColumnpcodeGen_DataSourceDB_columns* _TPPLST_codeGen_DBColumnpcodeGen_DataSourceDB_columns;
typedef struct _TPLST_codeGen_DataSourceJoinpcodeGen_DataBase_dataSources* _TPPLST_codeGen_DataSourceJoinpcodeGen_DataBase_dataSources;
typedef struct _TPLST_codeGen_LimitDataSourcepcodeGen_DataBase_dataSources* _TPPLST_codeGen_LimitDataSourcepcodeGen_DataBase_dataSources;
typedef struct _TPLST_codeGen_DataSourceProjectionFilterpcodeGen_DataBase_dataSources* _TPPLST_codeGen_DataSourceProjectionFilterpcodeGen_DataBase_dataSources;
typedef struct _TPLST_codeGen_DataSourceDBpcodeGen_DataBase_dataSources* _TPPLST_codeGen_DataSourceDBpcodeGen_DataBase_dataSources;
typedef struct _TPLST_codeGen_DataSourceDeletepcodeGen_DataBase_dataSourceModifications* _TPPLST_codeGen_DataSourceDeletepcodeGen_DataBase_dataSourceModifications;
typedef struct _TPLST_codeGen_DataSourceUpdatepcodeGen_DataBase_dataSourceModifications* _TPPLST_codeGen_DataSourceUpdatepcodeGen_DataBase_dataSourceModifications;
typedef struct _TPLST_codeGen_DataSourceInsertpcodeGen_DataBase_dataSourceModifications* _TPPLST_codeGen_DataSourceInsertpcodeGen_DataBase_dataSourceModifications;
typedef struct _TPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceProjectionFilter_formalParameters* _TPPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceProjectionFilter_formalParameters;
typedef struct _TPLST_codeGen_ComputationProjectionpcodeGen_DataSourceProjectionFilter_projectionColumns* _TPPLST_codeGen_ComputationProjectionpcodeGen_DataSourceProjectionFilter_projectionColumns;
typedef struct _TPLST_codeGen_ColumnProjectionpcodeGen_DataSourceProjectionFilter_projectionColumns* _TPPLST_codeGen_ColumnProjectionpcodeGen_DataSourceProjectionFilter_projectionColumns;
typedef struct _TPLST_codeGen_DataSourceFormalParampcodeGen_LimitDataSource_formalParameters* _TPPLST_codeGen_DataSourceFormalParampcodeGen_LimitDataSource_formalParameters;
typedef struct _TPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceInsert_formalParams* _TPPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceInsert_formalParams;
typedef struct _TPLST_codeGen_DataSourceValuepcodeGen_DataSourceInsert_values* _TPPLST_codeGen_DataSourceValuepcodeGen_DataSourceInsert_values;
typedef struct _TPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceUpdate_formalParams* _TPPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceUpdate_formalParams;
typedef struct _TPLST_codeGen_DataSourceValuepcodeGen_DataSourceUpdate_values* _TPPLST_codeGen_DataSourceValuepcodeGen_DataSourceUpdate_values;
typedef struct _TPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceDelete_formalParams* _TPPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceDelete_formalParams;
typedef struct _TPLST_codeGen_FormularSelectElementpcodeGen_Formular_elements* _TPPLST_codeGen_FormularSelectElementpcodeGen_Formular_elements;
typedef struct _TPLST_codeGen_FormularCheckboxElementpcodeGen_Formular_elements* _TPPLST_codeGen_FormularCheckboxElementpcodeGen_Formular_elements;
typedef struct _TPLST_codeGen_FormularPasswordElementpcodeGen_Formular_elements* _TPPLST_codeGen_FormularPasswordElementpcodeGen_Formular_elements;
typedef struct _TPLST_codeGen_FormularTextAreaElementpcodeGen_Formular_elements* _TPPLST_codeGen_FormularTextAreaElementpcodeGen_Formular_elements;
typedef struct _TPLST_codeGen_FormularTextElementpcodeGen_Formular_elements* _TPPLST_codeGen_FormularTextElementpcodeGen_Formular_elements;
typedef struct _TPLST_codeGen_FormularRadioGroupElementpcodeGen_Formular_elements* _TPPLST_codeGen_FormularRadioGroupElementpcodeGen_Formular_elements;
typedef struct _TPLST_codeGen_WebNodeActualParampcodeGen_Formular_actualParams* _TPPLST_codeGen_WebNodeActualParampcodeGen_Formular_actualParams;
typedef struct _TPLST_codeGen_FormularRadioElementpcodeGen_FormularRadioGroupElement_elements* _TPPLST_codeGen_FormularRadioElementpcodeGen_FormularRadioGroupElement_elements;
typedef struct _TPLST_codeGen_DataSourceActualParampcodeGen_FormularDataSourceSelectOption_params* _TPPLST_codeGen_DataSourceActualParampcodeGen_FormularDataSourceSelectOption_params;
typedef struct _TPLST_codeGen_FormularConditionActualParampcodeGen_FormularCondition_params* _TPPLST_codeGen_FormularConditionActualParampcodeGen_FormularCondition_params;
typedef struct _TPLST_codeGen_FormularConditionFormalParampcodeGen_FormularConditionDefinition_params* _TPPLST_codeGen_FormularConditionFormalParampcodeGen_FormularConditionDefinition_params;
typedef struct _TPLST_codeGen_OutputElementpcodeGen_Paragraph_fragments* _TPPLST_codeGen_OutputElementpcodeGen_Paragraph_fragments;
typedef struct _TPLST_codeGen_ImageFragmentpcodeGen_Paragraph_fragments* _TPPLST_codeGen_ImageFragmentpcodeGen_Paragraph_fragments;
typedef struct _TPLST_codeGen_TextFragmentpcodeGen_Paragraph_fragments* _TPPLST_codeGen_TextFragmentpcodeGen_Paragraph_fragments;
typedef struct _TPLST_codeGen_TableRowpcodeGen_Table_rows* _TPPLST_codeGen_TableRowpcodeGen_Table_rows;
typedef struct _TPLST_codeGen_TableColumnpcodeGen_Table_columns* _TPPLST_codeGen_TableColumnpcodeGen_Table_columns;
typedef struct _TPLST_codeGen_TableCellpcodeGen_TableRow_cells* _TPPLST_codeGen_TableCellpcodeGen_TableRow_cells;
typedef struct _TPLST_codeGen_LibrarypcodeGen_Root_library* _TPPLST_codeGen_LibrarypcodeGen_Root_library;
typedef struct _TPLST_codeGen_FormularConditionDefinitionpcodeGen_Library_formularconditions* _TPPLST_codeGen_FormularConditionDefinitionpcodeGen_Library_formularconditions;
typedef struct _TPLST_codeGen_NavigationElementpcodeGen_Library_navigationElement* _TPPLST_codeGen_NavigationElementpcodeGen_Library_navigationElement;
typedef struct _TPLST_codeGen_GlobalFramepcodeGen_WebApplication_frames* _TPPLST_codeGen_GlobalFramepcodeGen_WebApplication_frames;
typedef struct _TPLST_codeGen_WebRolepcodeGen_WebApplication_roles* _TPPLST_codeGen_WebRolepcodeGen_WebApplication_roles;
typedef struct _TPLST_codeGen_LinkTargetExternpcodeGen_WebApplication_linksExtern* _TPPLST_codeGen_LinkTargetExternpcodeGen_WebApplication_linksExtern;
typedef struct _TPLST_codeGen_WebActionpcodeGen_RootWebZone_webTargets* _TPPLST_codeGen_WebActionpcodeGen_RootWebZone_webTargets;
typedef struct _TPLST_codeGen_WebPagepcodeGen_RootWebZone_webTargets* _TPPLST_codeGen_WebPagepcodeGen_RootWebZone_webTargets;
typedef struct _TPLST_codeGen_SubWebZonepcodeGen_RootWebZone_webTargets* _TPPLST_codeGen_SubWebZonepcodeGen_RootWebZone_webTargets;
typedef struct _TPLST_codeGen_WebRoleRefpcodeGen_RootWebZone_roles* _TPPLST_codeGen_WebRoleRefpcodeGen_RootWebZone_roles;
typedef struct _TPLST_codeGen_WebActionpcodeGen_SubWebZone_webTargets* _TPPLST_codeGen_WebActionpcodeGen_SubWebZone_webTargets;
typedef struct _TPLST_codeGen_WebPagepcodeGen_SubWebZone_webTargets* _TPPLST_codeGen_WebPagepcodeGen_SubWebZone_webTargets;
typedef struct _TPLST_codeGen_SubWebZonepcodeGen_SubWebZone_webTargets* _TPPLST_codeGen_SubWebZonepcodeGen_SubWebZone_webTargets;
typedef struct _TPLST_codeGen_WebNodeFormalParampcodeGen_SubWebZone_globalparams* _TPPLST_codeGen_WebNodeFormalParampcodeGen_SubWebZone_globalparams;
typedef struct _TPLST_codeGen_WebRoleRefpcodeGen_SubWebZone_roles* _TPPLST_codeGen_WebRoleRefpcodeGen_SubWebZone_roles;
typedef struct _TPLST_codeGen_WebNodeFormalParampcodeGen_WebPage_formalParameter* _TPPLST_codeGen_WebNodeFormalParampcodeGen_WebPage_formalParameter;
typedef struct _TPLST_codeGen_ListOutputElementpcodeGen_Frame_components* _TPPLST_codeGen_ListOutputElementpcodeGen_Frame_components;
typedef struct _TPLST_codeGen_FrameRefpcodeGen_Frame_components* _TPPLST_codeGen_FrameRefpcodeGen_Frame_components;
typedef struct _TPLST_codeGen_TablepcodeGen_Frame_components* _TPPLST_codeGen_TablepcodeGen_Frame_components;
typedef struct _TPLST_codeGen_HeadingpcodeGen_Frame_components* _TPPLST_codeGen_HeadingpcodeGen_Frame_components;
typedef struct _TPLST_codeGen_ParagraphpcodeGen_Frame_components* _TPPLST_codeGen_ParagraphpcodeGen_Frame_components;
typedef struct _TPLST_codeGen_FormularpcodeGen_Frame_components* _TPPLST_codeGen_FormularpcodeGen_Frame_components;
typedef struct _TPLST_codeGen_ListOutputElementpcodeGen_GlobalFrame_components* _TPPLST_codeGen_ListOutputElementpcodeGen_GlobalFrame_components;
typedef struct _TPLST_codeGen_FrameRefpcodeGen_GlobalFrame_components* _TPPLST_codeGen_FrameRefpcodeGen_GlobalFrame_components;
typedef struct _TPLST_codeGen_TablepcodeGen_GlobalFrame_components* _TPPLST_codeGen_TablepcodeGen_GlobalFrame_components;
typedef struct _TPLST_codeGen_HeadingpcodeGen_GlobalFrame_components* _TPPLST_codeGen_HeadingpcodeGen_GlobalFrame_components;
typedef struct _TPLST_codeGen_ParagraphpcodeGen_GlobalFrame_components* _TPPLST_codeGen_ParagraphpcodeGen_GlobalFrame_components;
typedef struct _TPLST_codeGen_FormularpcodeGen_GlobalFrame_components* _TPPLST_codeGen_FormularpcodeGen_GlobalFrame_components;
typedef struct _TPLST_codeGen_NavigationBarElementpcodeGen_NavigationBar_elements* _TPPLST_codeGen_NavigationBarElementpcodeGen_NavigationBar_elements;
typedef struct _TPLST_codeGen_MetaInformationElementpcodeGen_MetaInformation_elements* _TPPLST_codeGen_MetaInformationElementpcodeGen_MetaInformation_elements;
typedef struct _TPLST_codeGen_DataSourceActualParampcodeGen_ListOutputElement_dataSourceActualParams* _TPPLST_codeGen_DataSourceActualParampcodeGen_ListOutputElement_dataSourceActualParams;
typedef struct _TPLST_codeGen_CustomStyleSheetBlockpcodeGen_StyleSheet_custom* _TPPLST_codeGen_CustomStyleSheetBlockpcodeGen_StyleSheet_custom;
typedef struct _TPLST_codeGen_HtmlStyleSheetBlockpcodeGen_StyleSheet_default* _TPPLST_codeGen_HtmlStyleSheetBlockpcodeGen_StyleSheet_default;
typedef struct _TPLST_codeGen_StyleSheetPairpcodeGen_CustomStyleSheetBlock_pairs* _TPPLST_codeGen_StyleSheetPairpcodeGen_CustomStyleSheetBlock_pairs;
typedef struct _TPLST_codeGen_StyleSheetPairpcodeGen_HtmlStyleSheetBlock_pairs* _TPPLST_codeGen_StyleSheetPairpcodeGen_HtmlStyleSheetBlock_pairs;
typedef struct _TPLST_codeGen_WebNodeActualParampcodeGen_ActionHandler_params* _TPPLST_codeGen_WebNodeActualParampcodeGen_ActionHandler_params;
typedef struct _TPLST_codeGen_WebNodeFormalParampcodeGen_WebAction_formalParameter* _TPPLST_codeGen_WebNodeFormalParampcodeGen_WebAction_formalParameter;
typedef struct _TPLST_codeGen_DataBaseOperationpcodeGen_WebAction_operations* _TPPLST_codeGen_DataBaseOperationpcodeGen_WebAction_operations;
typedef struct _TPLST_codeGen_PHPOperationpcodeGen_WebAction_operations* _TPPLST_codeGen_PHPOperationpcodeGen_WebAction_operations;
typedef struct _TPLST_codeGen_ActionHandlerpcodeGen_PHPOperation_errorhandler* _TPPLST_codeGen_ActionHandlerpcodeGen_PHPOperation_errorhandler;
typedef struct _TPLST_codeGen_ActionHandlerpcodeGen_DataBaseOperation_errorhandler* _TPPLST_codeGen_ActionHandlerpcodeGen_DataBaseOperation_errorhandler;
typedef struct _TPLST_codeGen_DataSourceActualParampcodeGen_DataBaseOperation_params* _TPPLST_codeGen_DataSourceActualParampcodeGen_DataBaseOperation_params;
typedef struct _TPLST_dataBaseView_DBBlobpdataBaseView_DBColumn_type* _TPPLST_dataBaseView_DBBlobpdataBaseView_DBColumn_type;
typedef struct _TPLST_dataBaseView_DBBooleanpdataBaseView_DBColumn_type* _TPPLST_dataBaseView_DBBooleanpdataBaseView_DBColumn_type;
typedef struct _TPLST_dataBaseView_DBTimeStamppdataBaseView_DBColumn_type* _TPPLST_dataBaseView_DBTimeStamppdataBaseView_DBColumn_type;
typedef struct _TPLST_dataBaseView_DBDatepdataBaseView_DBColumn_type* _TPPLST_dataBaseView_DBDatepdataBaseView_DBColumn_type;
typedef struct _TPLST_dataBaseView_DBBigIntpdataBaseView_DBColumn_type* _TPPLST_dataBaseView_DBBigIntpdataBaseView_DBColumn_type;
typedef struct _TPLST_dataBaseView_DBDoublepdataBaseView_DBColumn_type* _TPPLST_dataBaseView_DBDoublepdataBaseView_DBColumn_type;
typedef struct _TPLST_dataBaseView_DBFloatpdataBaseView_DBColumn_type* _TPPLST_dataBaseView_DBFloatpdataBaseView_DBColumn_type;
typedef struct _TPLST_dataBaseView_DBIntegerpdataBaseView_DBColumn_type* _TPPLST_dataBaseView_DBIntegerpdataBaseView_DBColumn_type;
typedef struct _TPLST_dataBaseView_DBStringpdataBaseView_DBColumn_type* _TPPLST_dataBaseView_DBStringpdataBaseView_DBColumn_type;
typedef struct _TPLST_dataBaseView_DBBlobpdataBaseView_DataSourceFormalParam_type* _TPPLST_dataBaseView_DBBlobpdataBaseView_DataSourceFormalParam_type;
typedef struct _TPLST_dataBaseView_DBBooleanpdataBaseView_DataSourceFormalParam_type* _TPPLST_dataBaseView_DBBooleanpdataBaseView_DataSourceFormalParam_type;
typedef struct _TPLST_dataBaseView_DBTimeStamppdataBaseView_DataSourceFormalParam_type* _TPPLST_dataBaseView_DBTimeStamppdataBaseView_DataSourceFormalParam_type;
typedef struct _TPLST_dataBaseView_DBDatepdataBaseView_DataSourceFormalParam_type* _TPPLST_dataBaseView_DBDatepdataBaseView_DataSourceFormalParam_type;
typedef struct _TPLST_dataBaseView_DBBigIntpdataBaseView_DataSourceFormalParam_type* _TPPLST_dataBaseView_DBBigIntpdataBaseView_DataSourceFormalParam_type;
typedef struct _TPLST_dataBaseView_DBDoublepdataBaseView_DataSourceFormalParam_type* _TPPLST_dataBaseView_DBDoublepdataBaseView_DataSourceFormalParam_type;
typedef struct _TPLST_dataBaseView_DBFloatpdataBaseView_DataSourceFormalParam_type* _TPPLST_dataBaseView_DBFloatpdataBaseView_DataSourceFormalParam_type;
typedef struct _TPLST_dataBaseView_DBIntegerpdataBaseView_DataSourceFormalParam_type* _TPPLST_dataBaseView_DBIntegerpdataBaseView_DataSourceFormalParam_type;
typedef struct _TPLST_dataBaseView_DBStringpdataBaseView_DataSourceFormalParam_type* _TPPLST_dataBaseView_DBStringpdataBaseView_DataSourceFormalParam_type;
typedef struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_BinaryExpression_leftOperand* _TPPLST_dataBaseView_ComputationExpressionpdataBaseView_BinaryExpression_leftOperand;
typedef struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_BinaryExpression_leftOperand* _TPPLST_dataBaseView_ParameterValueExpressionpdataBaseView_BinaryExpression_leftOperand;
typedef struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_BinaryExpression_leftOperand* _TPPLST_dataBaseView_ColumnValueExpressionpdataBaseView_BinaryExpression_leftOperand;
typedef struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_BinaryExpression_leftOperand* _TPPLST_dataBaseView_ConstantExpressionpdataBaseView_BinaryExpression_leftOperand;
typedef struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_BinaryExpression_leftOperand* _TPPLST_dataBaseView_UnaryExpressionpdataBaseView_BinaryExpression_leftOperand;
typedef struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_BinaryExpression_leftOperand* _TPPLST_dataBaseView_BinaryExpressionpdataBaseView_BinaryExpression_leftOperand;
typedef struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_BinaryExpression_rightOperand* _TPPLST_dataBaseView_ComputationExpressionpdataBaseView_BinaryExpression_rightOperand;
typedef struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_BinaryExpression_rightOperand* _TPPLST_dataBaseView_ParameterValueExpressionpdataBaseView_BinaryExpression_rightOperand;
typedef struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_BinaryExpression_rightOperand* _TPPLST_dataBaseView_ColumnValueExpressionpdataBaseView_BinaryExpression_rightOperand;
typedef struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_BinaryExpression_rightOperand* _TPPLST_dataBaseView_ConstantExpressionpdataBaseView_BinaryExpression_rightOperand;
typedef struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_BinaryExpression_rightOperand* _TPPLST_dataBaseView_UnaryExpressionpdataBaseView_BinaryExpression_rightOperand;
typedef struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_BinaryExpression_rightOperand* _TPPLST_dataBaseView_BinaryExpressionpdataBaseView_BinaryExpression_rightOperand;
typedef struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_UnaryExpression_operand* _TPPLST_dataBaseView_ComputationExpressionpdataBaseView_UnaryExpression_operand;
typedef struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_UnaryExpression_operand* _TPPLST_dataBaseView_ParameterValueExpressionpdataBaseView_UnaryExpression_operand;
typedef struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_UnaryExpression_operand* _TPPLST_dataBaseView_ColumnValueExpressionpdataBaseView_UnaryExpression_operand;
typedef struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_UnaryExpression_operand* _TPPLST_dataBaseView_ConstantExpressionpdataBaseView_UnaryExpression_operand;
typedef struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_UnaryExpression_operand* _TPPLST_dataBaseView_UnaryExpressionpdataBaseView_UnaryExpression_operand;
typedef struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_UnaryExpression_operand* _TPPLST_dataBaseView_BinaryExpressionpdataBaseView_UnaryExpression_operand;
typedef struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceValue_expression* _TPPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceValue_expression;
typedef struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceValue_expression* _TPPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceValue_expression;
typedef struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceValue_expression* _TPPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceValue_expression;
typedef struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceValue_expression* _TPPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceValue_expression;
typedef struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceValue_expression* _TPPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceValue_expression;
typedef struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceValue_expression* _TPPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceValue_expression;
typedef struct _TPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceProjectionFilter_formalParameters* _TPPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceProjectionFilter_formalParameters;
typedef struct _TPLST_dataBaseView_ComputationProjectionpdataBaseView_DataSourceProjectionFilter_projectionColumns* _TPPLST_dataBaseView_ComputationProjectionpdataBaseView_DataSourceProjectionFilter_projectionColumns;
typedef struct _TPLST_dataBaseView_ColumnProjectionpdataBaseView_DataSourceProjectionFilter_projectionColumns* _TPPLST_dataBaseView_ColumnProjectionpdataBaseView_DataSourceProjectionFilter_projectionColumns;
typedef struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceProjectionFilter_condition* _TPPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceProjectionFilter_condition;
typedef struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceProjectionFilter_condition* _TPPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceProjectionFilter_condition;
typedef struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceProjectionFilter_condition* _TPPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceProjectionFilter_condition;
typedef struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceProjectionFilter_condition* _TPPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceProjectionFilter_condition;
typedef struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceProjectionFilter_condition* _TPPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceProjectionFilter_condition;
typedef struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceProjectionFilter_condition* _TPPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceProjectionFilter_condition;
typedef struct _TPLST_dataBaseView_DataSourceFormalParampdataBaseView_LimitDataSource_formalParameters* _TPPLST_dataBaseView_DataSourceFormalParampdataBaseView_LimitDataSource_formalParameters;
typedef struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_LimitDataSource_minRow* _TPPLST_dataBaseView_ComputationExpressionpdataBaseView_LimitDataSource_minRow;
typedef struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_LimitDataSource_minRow* _TPPLST_dataBaseView_ParameterValueExpressionpdataBaseView_LimitDataSource_minRow;
typedef struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_LimitDataSource_minRow* _TPPLST_dataBaseView_ColumnValueExpressionpdataBaseView_LimitDataSource_minRow;
typedef struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_LimitDataSource_minRow* _TPPLST_dataBaseView_ConstantExpressionpdataBaseView_LimitDataSource_minRow;
typedef struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_LimitDataSource_minRow* _TPPLST_dataBaseView_UnaryExpressionpdataBaseView_LimitDataSource_minRow;
typedef struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_LimitDataSource_minRow* _TPPLST_dataBaseView_BinaryExpressionpdataBaseView_LimitDataSource_minRow;
typedef struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_LimitDataSource_maxRow* _TPPLST_dataBaseView_ComputationExpressionpdataBaseView_LimitDataSource_maxRow;
typedef struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_LimitDataSource_maxRow* _TPPLST_dataBaseView_ParameterValueExpressionpdataBaseView_LimitDataSource_maxRow;
typedef struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_LimitDataSource_maxRow* _TPPLST_dataBaseView_ColumnValueExpressionpdataBaseView_LimitDataSource_maxRow;
typedef struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_LimitDataSource_maxRow* _TPPLST_dataBaseView_ConstantExpressionpdataBaseView_LimitDataSource_maxRow;
typedef struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_LimitDataSource_maxRow* _TPPLST_dataBaseView_UnaryExpressionpdataBaseView_LimitDataSource_maxRow;
typedef struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_LimitDataSource_maxRow* _TPPLST_dataBaseView_BinaryExpressionpdataBaseView_LimitDataSource_maxRow;
typedef struct _TPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceInsert_formalParams* _TPPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceInsert_formalParams;
typedef struct _TPLST_dataBaseView_DataSourceValuepdataBaseView_DataSourceInsert_values* _TPPLST_dataBaseView_DataSourceValuepdataBaseView_DataSourceInsert_values;
typedef struct _TPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceUpdate_formalParams* _TPPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceUpdate_formalParams;
typedef struct _TPLST_dataBaseView_DataSourceValuepdataBaseView_DataSourceUpdate_values* _TPPLST_dataBaseView_DataSourceValuepdataBaseView_DataSourceUpdate_values;
typedef struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceUpdate_conditions* _TPPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceUpdate_conditions;
typedef struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceUpdate_conditions* _TPPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceUpdate_conditions;
typedef struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceUpdate_conditions* _TPPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceUpdate_conditions;
typedef struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceUpdate_conditions* _TPPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceUpdate_conditions;
typedef struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceUpdate_conditions* _TPPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceUpdate_conditions;
typedef struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceUpdate_conditions* _TPPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceUpdate_conditions;
typedef struct _TPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceDelete_formalParams* _TPPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceDelete_formalParams;
typedef struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceDelete_conditions* _TPPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceDelete_conditions;
typedef struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceDelete_conditions* _TPPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceDelete_conditions;
typedef struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceDelete_conditions* _TPPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceDelete_conditions;
typedef struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceDelete_conditions* _TPPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceDelete_conditions;
typedef struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceDelete_conditions* _TPPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceDelete_conditions;
typedef struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceDelete_conditions* _TPPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceDelete_conditions;
typedef struct _TPLST_dataBaseView_DBColumnpdataBaseView_DataSourceDB_columns* _TPPLST_dataBaseView_DBColumnpdataBaseView_DataSourceDB_columns;
typedef struct _TPLST_dataBaseView_DataSourceJoinpdataBaseView_DataBase_dataSources* _TPPLST_dataBaseView_DataSourceJoinpdataBaseView_DataBase_dataSources;
typedef struct _TPLST_dataBaseView_LimitDataSourcepdataBaseView_DataBase_dataSources* _TPPLST_dataBaseView_LimitDataSourcepdataBaseView_DataBase_dataSources;
typedef struct _TPLST_dataBaseView_DataSourceProjectionFilterpdataBaseView_DataBase_dataSources* _TPPLST_dataBaseView_DataSourceProjectionFilterpdataBaseView_DataBase_dataSources;
typedef struct _TPLST_dataBaseView_DataSourceDBpdataBaseView_DataBase_dataSources* _TPPLST_dataBaseView_DataSourceDBpdataBaseView_DataBase_dataSources;
typedef struct _TPLST_dataBaseView_DataSourceDeletepdataBaseView_DataBase_dataSourceModifications* _TPPLST_dataBaseView_DataSourceDeletepdataBaseView_DataBase_dataSourceModifications;
typedef struct _TPLST_dataBaseView_DataSourceUpdatepdataBaseView_DataBase_dataSourceModifications* _TPPLST_dataBaseView_DataSourceUpdatepdataBaseView_DataBase_dataSourceModifications;
typedef struct _TPLST_dataBaseView_DataSourceInsertpdataBaseView_DataBase_dataSourceModifications* _TPPLST_dataBaseView_DataSourceInsertpdataBaseView_DataBase_dataSourceModifications;
typedef struct _TPLST_fcDlg_FormularConditionActualParampfcDlg_FormularCondition_params* _TPPLST_fcDlg_FormularConditionActualParampfcDlg_FormularCondition_params;
typedef struct _TPLST_globalFrameView_FormularPHPScriptSelectOptionpglobalFrameView_FormularSelectElement_options* _TPPLST_globalFrameView_FormularPHPScriptSelectOptionpglobalFrameView_FormularSelectElement_options;
typedef struct _TPLST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options* _TPPLST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options;
typedef struct _TPLST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options* _TPPLST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options;
typedef struct _TPLST_globalFrameView_WebNodeColumnExpressionpglobalFrameView_DataSourceActualParam_expressions* _TPPLST_globalFrameView_WebNodeColumnExpressionpglobalFrameView_DataSourceActualParam_expressions;
typedef struct _TPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions* _TPPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions;
typedef struct _TPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions* _TPPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions;
typedef struct _TPLST_globalFrameView_WebNodeColumnExpressionpglobalFrameView_WebNodeActualParam_expressions* _TPPLST_globalFrameView_WebNodeColumnExpressionpglobalFrameView_WebNodeActualParam_expressions;
typedef struct _TPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions* _TPPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions;
typedef struct _TPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions* _TPPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions;
typedef struct _TPLST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements* _TPPLST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements;
typedef struct _TPLST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements* _TPPLST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements;
typedef struct _TPLST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements* _TPPLST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements;
typedef struct _TPLST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements* _TPPLST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements;
typedef struct _TPLST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements* _TPPLST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements;
typedef struct _TPLST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements* _TPPLST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements;
typedef struct _TPLST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams* _TPPLST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams;
typedef struct _TPLST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements* _TPPLST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements;
typedef struct _TPLST_globalFrameView_DataSourceActualParampglobalFrameView_FormularDataSourceSelectOption_params* _TPPLST_globalFrameView_DataSourceActualParampglobalFrameView_FormularDataSourceSelectOption_params;
typedef struct _TPLST_globalFrameView_FormularConditionActualParampglobalFrameView_FormularCondition_params* _TPPLST_globalFrameView_FormularConditionActualParampglobalFrameView_FormularCondition_params;
typedef struct _TPLST_globalFrameView_OutputElementpglobalFrameView_Paragraph_fragments* _TPPLST_globalFrameView_OutputElementpglobalFrameView_Paragraph_fragments;
typedef struct _TPLST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments* _TPPLST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments;
typedef struct _TPLST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments* _TPPLST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments;
typedef struct _TPLST_globalFrameView_TableRowpglobalFrameView_Table_rows* _TPPLST_globalFrameView_TableRowpglobalFrameView_Table_rows;
typedef struct _TPLST_globalFrameView_TableColumnpglobalFrameView_Table_columns* _TPPLST_globalFrameView_TableColumnpglobalFrameView_Table_columns;
typedef struct _TPLST_globalFrameView_TableCellpglobalFrameView_TableRow_cells* _TPPLST_globalFrameView_TableCellpglobalFrameView_TableRow_cells;
typedef struct _TPLST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components* _TPPLST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components;
typedef struct _TPLST_globalFrameView_FrameRefpglobalFrameView_Frame_components* _TPPLST_globalFrameView_FrameRefpglobalFrameView_Frame_components;
typedef struct _TPLST_globalFrameView_TablepglobalFrameView_Frame_components* _TPPLST_globalFrameView_TablepglobalFrameView_Frame_components;
typedef struct _TPLST_globalFrameView_HeadingpglobalFrameView_Frame_components* _TPPLST_globalFrameView_HeadingpglobalFrameView_Frame_components;
typedef struct _TPLST_globalFrameView_ParagraphpglobalFrameView_Frame_components* _TPPLST_globalFrameView_ParagraphpglobalFrameView_Frame_components;
typedef struct _TPLST_globalFrameView_FormularpglobalFrameView_Frame_components* _TPPLST_globalFrameView_FormularpglobalFrameView_Frame_components;
typedef struct _TPLST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components* _TPPLST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components;
typedef struct _TPLST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components* _TPPLST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components;
typedef struct _TPLST_globalFrameView_TablepglobalFrameView_GlobalFrame_components* _TPPLST_globalFrameView_TablepglobalFrameView_GlobalFrame_components;
typedef struct _TPLST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components* _TPPLST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components;
typedef struct _TPLST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components* _TPPLST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components;
typedef struct _TPLST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components* _TPPLST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components;
typedef struct _TPLST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams* _TPPLST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams;
typedef struct _TPLST_metaInformation_MetaInformationElementpmetaInformation_MetaInformation_elements* _TPPLST_metaInformation_MetaInformationElementpmetaInformation_MetaInformation_elements;
typedef struct _TPLST_navigationBarView_NavigationBarElementpnavigationBarView_NavigationBar_elements* _TPPLST_navigationBarView_NavigationBarElementpnavigationBarView_NavigationBar_elements;
typedef struct _TPLST_rootView_DBBlobprootView_WebNodeFormalParam_type* _TPPLST_rootView_DBBlobprootView_WebNodeFormalParam_type;
typedef struct _TPLST_rootView_DBBooleanprootView_WebNodeFormalParam_type* _TPPLST_rootView_DBBooleanprootView_WebNodeFormalParam_type;
typedef struct _TPLST_rootView_DBTimeStampprootView_WebNodeFormalParam_type* _TPPLST_rootView_DBTimeStampprootView_WebNodeFormalParam_type;
typedef struct _TPLST_rootView_DBDateprootView_WebNodeFormalParam_type* _TPPLST_rootView_DBDateprootView_WebNodeFormalParam_type;
typedef struct _TPLST_rootView_DBBigIntprootView_WebNodeFormalParam_type* _TPPLST_rootView_DBBigIntprootView_WebNodeFormalParam_type;
typedef struct _TPLST_rootView_DBDoubleprootView_WebNodeFormalParam_type* _TPPLST_rootView_DBDoubleprootView_WebNodeFormalParam_type;
typedef struct _TPLST_rootView_DBFloatprootView_WebNodeFormalParam_type* _TPPLST_rootView_DBFloatprootView_WebNodeFormalParam_type;
typedef struct _TPLST_rootView_DBIntegerprootView_WebNodeFormalParam_type* _TPPLST_rootView_DBIntegerprootView_WebNodeFormalParam_type;
typedef struct _TPLST_rootView_DBStringprootView_WebNodeFormalParam_type* _TPPLST_rootView_DBStringprootView_WebNodeFormalParam_type;
typedef struct _TPLST_rootView_WebNodeColumnExpressionprootView_DataSourceActualParam_expressions* _TPPLST_rootView_WebNodeColumnExpressionprootView_DataSourceActualParam_expressions;
typedef struct _TPLST_rootView_WebNodeVariableExpressionprootView_DataSourceActualParam_expressions* _TPPLST_rootView_WebNodeVariableExpressionprootView_DataSourceActualParam_expressions;
typedef struct _TPLST_rootView_WebNodeConstantExpressionprootView_DataSourceActualParam_expressions* _TPPLST_rootView_WebNodeConstantExpressionprootView_DataSourceActualParam_expressions;
typedef struct _TPLST_rootView_FormularSelectElementprootView_Formular_elements* _TPPLST_rootView_FormularSelectElementprootView_Formular_elements;
typedef struct _TPLST_rootView_FormularCheckboxElementprootView_Formular_elements* _TPPLST_rootView_FormularCheckboxElementprootView_Formular_elements;
typedef struct _TPLST_rootView_FormularPasswordElementprootView_Formular_elements* _TPPLST_rootView_FormularPasswordElementprootView_Formular_elements;
typedef struct _TPLST_rootView_FormularTextAreaElementprootView_Formular_elements* _TPPLST_rootView_FormularTextAreaElementprootView_Formular_elements;
typedef struct _TPLST_rootView_FormularTextElementprootView_Formular_elements* _TPPLST_rootView_FormularTextElementprootView_Formular_elements;
typedef struct _TPLST_rootView_FormularRadioGroupElementprootView_Formular_elements* _TPPLST_rootView_FormularRadioGroupElementprootView_Formular_elements;
typedef struct _TPLST_rootView_WebNodeActualParamprootView_Formular_actualParams* _TPPLST_rootView_WebNodeActualParamprootView_Formular_actualParams;
typedef struct _TPLST_rootView_FormularRadioElementprootView_FormularRadioGroupElement_elements* _TPPLST_rootView_FormularRadioElementprootView_FormularRadioGroupElement_elements;
typedef struct _TPLST_rootView_FormularPHPScriptSelectOptionprootView_FormularSelectElement_options* _TPPLST_rootView_FormularPHPScriptSelectOptionprootView_FormularSelectElement_options;
typedef struct _TPLST_rootView_FormularDataSourceSelectOptionprootView_FormularSelectElement_options* _TPPLST_rootView_FormularDataSourceSelectOptionprootView_FormularSelectElement_options;
typedef struct _TPLST_rootView_FormularConstantSelectOptionprootView_FormularSelectElement_options* _TPPLST_rootView_FormularConstantSelectOptionprootView_FormularSelectElement_options;
typedef struct _TPLST_rootView_DataSourceActualParamprootView_FormularDataSourceSelectOption_params* _TPPLST_rootView_DataSourceActualParamprootView_FormularDataSourceSelectOption_params;
typedef struct _TPLST_rootView_FormularConditionActualParamprootView_FormularCondition_params* _TPPLST_rootView_FormularConditionActualParamprootView_FormularCondition_params;
typedef struct _TPLST_rootView_FormularConditionFormalParamprootView_FormularConditionDefinition_params* _TPPLST_rootView_FormularConditionFormalParamprootView_FormularConditionDefinition_params;
typedef struct _TPLST_rootView_WebNodeColumnExpressionprootView_WebNodeActualParam_expressions* _TPPLST_rootView_WebNodeColumnExpressionprootView_WebNodeActualParam_expressions;
typedef struct _TPLST_rootView_WebNodeVariableExpressionprootView_WebNodeActualParam_expressions* _TPPLST_rootView_WebNodeVariableExpressionprootView_WebNodeActualParam_expressions;
typedef struct _TPLST_rootView_WebNodeConstantExpressionprootView_WebNodeActualParam_expressions* _TPPLST_rootView_WebNodeConstantExpressionprootView_WebNodeActualParam_expressions;
typedef struct _TPLST_rootView_OutputElementprootView_Paragraph_fragments* _TPPLST_rootView_OutputElementprootView_Paragraph_fragments;
typedef struct _TPLST_rootView_ImageFragmentprootView_Paragraph_fragments* _TPPLST_rootView_ImageFragmentprootView_Paragraph_fragments;
typedef struct _TPLST_rootView_TextFragmentprootView_Paragraph_fragments* _TPPLST_rootView_TextFragmentprootView_Paragraph_fragments;
typedef struct _TPLST_rootView_TableRowprootView_Table_rows* _TPPLST_rootView_TableRowprootView_Table_rows;
typedef struct _TPLST_rootView_TableColumnprootView_Table_columns* _TPPLST_rootView_TableColumnprootView_Table_columns;
typedef struct _TPLST_rootView_TableCellprootView_TableRow_cells* _TPPLST_rootView_TableCellprootView_TableRow_cells;
typedef struct _TPLST_rootView_LibraryprootView_Root_library* _TPPLST_rootView_LibraryprootView_Root_library;
typedef struct _TPLST_rootView_FormularConditionDefinitionprootView_Library_formularconditions* _TPPLST_rootView_FormularConditionDefinitionprootView_Library_formularconditions;
typedef struct _TPLST_rootView_NavigationElementprootView_Library_navigationElement* _TPPLST_rootView_NavigationElementprootView_Library_navigationElement;
typedef struct _TPLST_rootView_GlobalFrameprootView_WebApplication_frames* _TPPLST_rootView_GlobalFrameprootView_WebApplication_frames;
typedef struct _TPLST_rootView_WebRoleprootView_WebApplication_roles* _TPPLST_rootView_WebRoleprootView_WebApplication_roles;
typedef struct _TPLST_rootView_LinkTargetExternprootView_WebApplication_linksExtern* _TPPLST_rootView_LinkTargetExternprootView_WebApplication_linksExtern;
typedef struct _TPLST_rootView_WebActionprootView_RootWebZone_webTargets* _TPPLST_rootView_WebActionprootView_RootWebZone_webTargets;
typedef struct _TPLST_rootView_WebPageprootView_RootWebZone_webTargets* _TPPLST_rootView_WebPageprootView_RootWebZone_webTargets;
typedef struct _TPLST_rootView_SubWebZoneprootView_RootWebZone_webTargets* _TPPLST_rootView_SubWebZoneprootView_RootWebZone_webTargets;
typedef struct _TPLST_rootView_WebRoleRefprootView_RootWebZone_roles* _TPPLST_rootView_WebRoleRefprootView_RootWebZone_roles;
typedef struct _TPLST_rootView_WebActionprootView_SubWebZone_webTargets* _TPPLST_rootView_WebActionprootView_SubWebZone_webTargets;
typedef struct _TPLST_rootView_WebPageprootView_SubWebZone_webTargets* _TPPLST_rootView_WebPageprootView_SubWebZone_webTargets;
typedef struct _TPLST_rootView_SubWebZoneprootView_SubWebZone_webTargets* _TPPLST_rootView_SubWebZoneprootView_SubWebZone_webTargets;
typedef struct _TPLST_rootView_WebNodeFormalParamprootView_SubWebZone_globalparams* _TPPLST_rootView_WebNodeFormalParamprootView_SubWebZone_globalparams;
typedef struct _TPLST_rootView_WebRoleRefprootView_SubWebZone_roles* _TPPLST_rootView_WebRoleRefprootView_SubWebZone_roles;
typedef struct _TPLST_rootView_WebNodeFormalParamprootView_WebPage_formalParameter* _TPPLST_rootView_WebNodeFormalParamprootView_WebPage_formalParameter;
typedef struct _TPLST_rootView_ListOutputElementprootView_Frame_components* _TPPLST_rootView_ListOutputElementprootView_Frame_components;
typedef struct _TPLST_rootView_FrameRefprootView_Frame_components* _TPPLST_rootView_FrameRefprootView_Frame_components;
typedef struct _TPLST_rootView_TableprootView_Frame_components* _TPPLST_rootView_TableprootView_Frame_components;
typedef struct _TPLST_rootView_HeadingprootView_Frame_components* _TPPLST_rootView_HeadingprootView_Frame_components;
typedef struct _TPLST_rootView_ParagraphprootView_Frame_components* _TPPLST_rootView_ParagraphprootView_Frame_components;
typedef struct _TPLST_rootView_FormularprootView_Frame_components* _TPPLST_rootView_FormularprootView_Frame_components;
typedef struct _TPLST_rootView_ListOutputElementprootView_GlobalFrame_components* _TPPLST_rootView_ListOutputElementprootView_GlobalFrame_components;
typedef struct _TPLST_rootView_FrameRefprootView_GlobalFrame_components* _TPPLST_rootView_FrameRefprootView_GlobalFrame_components;
typedef struct _TPLST_rootView_TableprootView_GlobalFrame_components* _TPPLST_rootView_TableprootView_GlobalFrame_components;
typedef struct _TPLST_rootView_HeadingprootView_GlobalFrame_components* _TPPLST_rootView_HeadingprootView_GlobalFrame_components;
typedef struct _TPLST_rootView_ParagraphprootView_GlobalFrame_components* _TPPLST_rootView_ParagraphprootView_GlobalFrame_components;
typedef struct _TPLST_rootView_FormularprootView_GlobalFrame_components* _TPPLST_rootView_FormularprootView_GlobalFrame_components;
typedef struct _TPLST_rootView_NavigationBarElementprootView_NavigationBar_elements* _TPPLST_rootView_NavigationBarElementprootView_NavigationBar_elements;
typedef struct _TPLST_rootView_MetaInformationElementprootView_MetaInformation_elements* _TPPLST_rootView_MetaInformationElementprootView_MetaInformation_elements;
typedef struct _TPLST_rootView_DataSourceActualParamprootView_ListOutputElement_dataSourceActualParams* _TPPLST_rootView_DataSourceActualParamprootView_ListOutputElement_dataSourceActualParams;
typedef struct _TPLST_rootView_CustomStyleSheetBlockprootView_StyleSheet_custom* _TPPLST_rootView_CustomStyleSheetBlockprootView_StyleSheet_custom;
typedef struct _TPLST_rootView_HtmlStyleSheetBlockprootView_StyleSheet_default* _TPPLST_rootView_HtmlStyleSheetBlockprootView_StyleSheet_default;
typedef struct _TPLST_rootView_StyleSheetPairprootView_CustomStyleSheetBlock_pairs* _TPPLST_rootView_StyleSheetPairprootView_CustomStyleSheetBlock_pairs;
typedef struct _TPLST_rootView_CustomValueprootView_StyleSheetPair_value* _TPPLST_rootView_CustomValueprootView_StyleSheetPair_value;
typedef struct _TPLST_rootView_ListValueprootView_StyleSheetPair_value* _TPPLST_rootView_ListValueprootView_StyleSheetPair_value;
typedef struct _TPLST_rootView_AlignmentValueprootView_StyleSheetPair_value* _TPPLST_rootView_AlignmentValueprootView_StyleSheetPair_value;
typedef struct _TPLST_rootView_HeadingValueprootView_StyleSheetPair_value* _TPPLST_rootView_HeadingValueprootView_StyleSheetPair_value;
typedef struct _TPLST_rootView_StyleValueprootView_StyleSheetPair_value* _TPPLST_rootView_StyleValueprootView_StyleSheetPair_value;
typedef struct _TPLST_rootView_FamilyValueprootView_StyleSheetPair_value* _TPPLST_rootView_FamilyValueprootView_StyleSheetPair_value;
typedef struct _TPLST_rootView_ColorValueprootView_StyleSheetPair_value* _TPPLST_rootView_ColorValueprootView_StyleSheetPair_value;
typedef struct _TPLST_rootView_SizeValueprootView_StyleSheetPair_value* _TPPLST_rootView_SizeValueprootView_StyleSheetPair_value;
typedef struct _TPLST_rootView_StyleSheetPairprootView_HtmlStyleSheetBlock_pairs* _TPPLST_rootView_StyleSheetPairprootView_HtmlStyleSheetBlock_pairs;
typedef struct _TPLST_rootView_WebNodeActualParamprootView_ActionHandler_params* _TPPLST_rootView_WebNodeActualParamprootView_ActionHandler_params;
typedef struct _TPLST_rootView_WebNodeFormalParamprootView_WebAction_formalParameter* _TPPLST_rootView_WebNodeFormalParamprootView_WebAction_formalParameter;
typedef struct _TPLST_rootView_DataBaseOperationprootView_WebAction_operations* _TPPLST_rootView_DataBaseOperationprootView_WebAction_operations;
typedef struct _TPLST_rootView_PHPOperationprootView_WebAction_operations* _TPPLST_rootView_PHPOperationprootView_WebAction_operations;
typedef struct _TPLST_rootView_ActionHandlerprootView_PHPOperation_errorhandler* _TPPLST_rootView_ActionHandlerprootView_PHPOperation_errorhandler;
typedef struct _TPLST_rootView_ActionHandlerprootView_DataBaseOperation_errorhandler* _TPPLST_rootView_ActionHandlerprootView_DataBaseOperation_errorhandler;
typedef struct _TPLST_rootView_DataSourceActualParamprootView_DataBaseOperation_params* _TPPLST_rootView_DataSourceActualParamprootView_DataBaseOperation_params;
typedef struct _TPLST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value* _TPPLST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value;
typedef struct _TPLST_sspDlg_ListValuepsspDlg_StyleSheetPair_value* _TPPLST_sspDlg_ListValuepsspDlg_StyleSheetPair_value;
typedef struct _TPLST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value* _TPPLST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value;
typedef struct _TPLST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value* _TPPLST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value;
typedef struct _TPLST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value* _TPPLST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value;
typedef struct _TPLST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value* _TPPLST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value;
typedef struct _TPLST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value* _TPPLST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value;
typedef struct _TPLST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value* _TPPLST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value;
typedef struct _TPLST_stylesheetView_CustomStyleSheetBlockpstylesheetView_StyleSheet_custom* _TPPLST_stylesheetView_CustomStyleSheetBlockpstylesheetView_StyleSheet_custom;
typedef struct _TPLST_stylesheetView_HtmlStyleSheetBlockpstylesheetView_StyleSheet_default* _TPPLST_stylesheetView_HtmlStyleSheetBlockpstylesheetView_StyleSheet_default;
typedef struct _TPLST_stylesheetView_StyleSheetPairpstylesheetView_CustomStyleSheetBlock_pairs* _TPPLST_stylesheetView_StyleSheetPairpstylesheetView_CustomStyleSheetBlock_pairs;
typedef struct _TPLST_stylesheetView_CustomValuepstylesheetView_StyleSheetPair_value* _TPPLST_stylesheetView_CustomValuepstylesheetView_StyleSheetPair_value;
typedef struct _TPLST_stylesheetView_ListValuepstylesheetView_StyleSheetPair_value* _TPPLST_stylesheetView_ListValuepstylesheetView_StyleSheetPair_value;
typedef struct _TPLST_stylesheetView_AlignmentValuepstylesheetView_StyleSheetPair_value* _TPPLST_stylesheetView_AlignmentValuepstylesheetView_StyleSheetPair_value;
typedef struct _TPLST_stylesheetView_HeadingValuepstylesheetView_StyleSheetPair_value* _TPPLST_stylesheetView_HeadingValuepstylesheetView_StyleSheetPair_value;
typedef struct _TPLST_stylesheetView_StyleValuepstylesheetView_StyleSheetPair_value* _TPPLST_stylesheetView_StyleValuepstylesheetView_StyleSheetPair_value;
typedef struct _TPLST_stylesheetView_FamilyValuepstylesheetView_StyleSheetPair_value* _TPPLST_stylesheetView_FamilyValuepstylesheetView_StyleSheetPair_value;
typedef struct _TPLST_stylesheetView_ColorValuepstylesheetView_StyleSheetPair_value* _TPPLST_stylesheetView_ColorValuepstylesheetView_StyleSheetPair_value;
typedef struct _TPLST_stylesheetView_SizeValuepstylesheetView_StyleSheetPair_value* _TPPLST_stylesheetView_SizeValuepstylesheetView_StyleSheetPair_value;
typedef struct _TPLST_stylesheetView_StyleSheetPairpstylesheetView_HtmlStyleSheetBlock_pairs* _TPPLST_stylesheetView_StyleSheetPairpstylesheetView_HtmlStyleSheetBlock_pairs;
typedef struct _TPLST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type* _TPPLST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type;
typedef struct _TPLST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type* _TPPLST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type;
typedef struct _TPLST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type* _TPPLST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type;
typedef struct _TPLST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type* _TPPLST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type;
typedef struct _TPLST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type* _TPPLST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type;
typedef struct _TPLST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type* _TPPLST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type;
typedef struct _TPLST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type* _TPPLST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type;
typedef struct _TPLST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type* _TPPLST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type;
typedef struct _TPLST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type* _TPPLST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type;
typedef struct _TPLST_webActionView_WebNodeColumnExpressionpwebActionView_WebNodeActualParam_expressions* _TPPLST_webActionView_WebNodeColumnExpressionpwebActionView_WebNodeActualParam_expressions;
typedef struct _TPLST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions* _TPPLST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions;
typedef struct _TPLST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions* _TPPLST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions;
typedef struct _TPLST_webActionView_WebNodeColumnExpressionpwebActionView_DataSourceActualParam_expressions* _TPPLST_webActionView_WebNodeColumnExpressionpwebActionView_DataSourceActualParam_expressions;
typedef struct _TPLST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions* _TPPLST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions;
typedef struct _TPLST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions* _TPPLST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions;
typedef struct _TPLST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params* _TPPLST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params;
typedef struct _TPLST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter* _TPPLST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter;
typedef struct _TPLST_webActionView_DataBaseOperationpwebActionView_WebAction_operations* _TPPLST_webActionView_DataBaseOperationpwebActionView_WebAction_operations;
typedef struct _TPLST_webActionView_PHPOperationpwebActionView_WebAction_operations* _TPPLST_webActionView_PHPOperationpwebActionView_WebAction_operations;
typedef struct _TPLST_webActionView_ActionHandlerpwebActionView_PHPOperation_errorhandler* _TPPLST_webActionView_ActionHandlerpwebActionView_PHPOperation_errorhandler;
typedef struct _TPLST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler* _TPPLST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler;
typedef struct _TPLST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params* _TPPLST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params;
typedef struct _TPLST_webPageView_FormularPHPScriptSelectOptionpwebPageView_FormularSelectElement_options* _TPPLST_webPageView_FormularPHPScriptSelectOptionpwebPageView_FormularSelectElement_options;
typedef struct _TPLST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options* _TPPLST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options;
typedef struct _TPLST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options* _TPPLST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options;
typedef struct _TPLST_webPageView_WebNodeColumnExpressionpwebPageView_DataSourceActualParam_expressions* _TPPLST_webPageView_WebNodeColumnExpressionpwebPageView_DataSourceActualParam_expressions;
typedef struct _TPLST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions* _TPPLST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions;
typedef struct _TPLST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions* _TPPLST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions;
typedef struct _TPLST_webPageView_WebNodeColumnExpressionpwebPageView_WebNodeActualParam_expressions* _TPPLST_webPageView_WebNodeColumnExpressionpwebPageView_WebNodeActualParam_expressions;
typedef struct _TPLST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions* _TPPLST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions;
typedef struct _TPLST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions* _TPPLST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions;
typedef struct _TPLST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type* _TPPLST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type;
typedef struct _TPLST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type* _TPPLST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type;
typedef struct _TPLST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type* _TPPLST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type;
typedef struct _TPLST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type* _TPPLST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type;
typedef struct _TPLST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type* _TPPLST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type;
typedef struct _TPLST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type* _TPPLST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type;
typedef struct _TPLST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type* _TPPLST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type;
typedef struct _TPLST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type* _TPPLST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type;
typedef struct _TPLST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type* _TPPLST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type;
typedef struct _TPLST_webPageView_FormularSelectElementpwebPageView_Formular_elements* _TPPLST_webPageView_FormularSelectElementpwebPageView_Formular_elements;
typedef struct _TPLST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements* _TPPLST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements;
typedef struct _TPLST_webPageView_FormularPasswordElementpwebPageView_Formular_elements* _TPPLST_webPageView_FormularPasswordElementpwebPageView_Formular_elements;
typedef struct _TPLST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements* _TPPLST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements;
typedef struct _TPLST_webPageView_FormularTextElementpwebPageView_Formular_elements* _TPPLST_webPageView_FormularTextElementpwebPageView_Formular_elements;
typedef struct _TPLST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements* _TPPLST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements;
typedef struct _TPLST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams* _TPPLST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams;
typedef struct _TPLST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements* _TPPLST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements;
typedef struct _TPLST_webPageView_DataSourceActualParampwebPageView_FormularDataSourceSelectOption_params* _TPPLST_webPageView_DataSourceActualParampwebPageView_FormularDataSourceSelectOption_params;
typedef struct _TPLST_webPageView_FormularConditionActualParampwebPageView_FormularCondition_params* _TPPLST_webPageView_FormularConditionActualParampwebPageView_FormularCondition_params;
typedef struct _TPLST_webPageView_OutputElementpwebPageView_Paragraph_fragments* _TPPLST_webPageView_OutputElementpwebPageView_Paragraph_fragments;
typedef struct _TPLST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments* _TPPLST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments;
typedef struct _TPLST_webPageView_TextFragmentpwebPageView_Paragraph_fragments* _TPPLST_webPageView_TextFragmentpwebPageView_Paragraph_fragments;
typedef struct _TPLST_webPageView_TableRowpwebPageView_Table_rows* _TPPLST_webPageView_TableRowpwebPageView_Table_rows;
typedef struct _TPLST_webPageView_TableColumnpwebPageView_Table_columns* _TPPLST_webPageView_TableColumnpwebPageView_Table_columns;
typedef struct _TPLST_webPageView_TableCellpwebPageView_TableRow_cells* _TPPLST_webPageView_TableCellpwebPageView_TableRow_cells;
typedef struct _TPLST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter* _TPPLST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter;
typedef struct _TPLST_webPageView_ListOutputElementpwebPageView_Frame_components* _TPPLST_webPageView_ListOutputElementpwebPageView_Frame_components;
typedef struct _TPLST_webPageView_FrameRefpwebPageView_Frame_components* _TPPLST_webPageView_FrameRefpwebPageView_Frame_components;
typedef struct _TPLST_webPageView_TablepwebPageView_Frame_components* _TPPLST_webPageView_TablepwebPageView_Frame_components;
typedef struct _TPLST_webPageView_HeadingpwebPageView_Frame_components* _TPPLST_webPageView_HeadingpwebPageView_Frame_components;
typedef struct _TPLST_webPageView_ParagraphpwebPageView_Frame_components* _TPPLST_webPageView_ParagraphpwebPageView_Frame_components;
typedef struct _TPLST_webPageView_FormularpwebPageView_Frame_components* _TPPLST_webPageView_FormularpwebPageView_Frame_components;
typedef struct _TPLST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams* _TPPLST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams;
typedef struct _TPLST_0pcodeGen_DataSourceDB_columns* _TPPLST_0pcodeGen_DataSourceDB_columns;
typedef struct _TPLST_0pcodeGen_DataBase_dataSources* _TPPLST_0pcodeGen_DataBase_dataSources;
typedef struct _TPLST_0pcodeGen_DataBase_dataSourceModifications* _TPPLST_0pcodeGen_DataBase_dataSourceModifications;
typedef struct _TPLST_0pcodeGen_DataSourceProjectionFilter_formalParameters* _TPPLST_0pcodeGen_DataSourceProjectionFilter_formalParameters;
typedef struct _TPLST_0pcodeGen_DataSourceProjectionFilter_projectionColumns* _TPPLST_0pcodeGen_DataSourceProjectionFilter_projectionColumns;
typedef struct _TPLST_0pcodeGen_LimitDataSource_formalParameters* _TPPLST_0pcodeGen_LimitDataSource_formalParameters;
typedef struct _TPLST_0pcodeGen_DataSourceInsert_formalParams* _TPPLST_0pcodeGen_DataSourceInsert_formalParams;
typedef struct _TPLST_0pcodeGen_DataSourceInsert_values* _TPPLST_0pcodeGen_DataSourceInsert_values;
typedef struct _TPLST_0pcodeGen_DataSourceUpdate_formalParams* _TPPLST_0pcodeGen_DataSourceUpdate_formalParams;
typedef struct _TPLST_0pcodeGen_DataSourceUpdate_values* _TPPLST_0pcodeGen_DataSourceUpdate_values;
typedef struct _TPLST_0pcodeGen_DataSourceDelete_formalParams* _TPPLST_0pcodeGen_DataSourceDelete_formalParams;
typedef struct _TPLST_0pcodeGen_Formular_elements* _TPPLST_0pcodeGen_Formular_elements;
typedef struct _TPLST_0pcodeGen_Formular_actualParams* _TPPLST_0pcodeGen_Formular_actualParams;
typedef struct _TPLST_0pcodeGen_FormularRadioGroupElement_elements* _TPPLST_0pcodeGen_FormularRadioGroupElement_elements;
typedef struct _TPLST_0pcodeGen_FormularDataSourceSelectOption_params* _TPPLST_0pcodeGen_FormularDataSourceSelectOption_params;
typedef struct _TPLST_0pcodeGen_FormularCondition_params* _TPPLST_0pcodeGen_FormularCondition_params;
typedef struct _TPLST_0pcodeGen_FormularConditionDefinition_params* _TPPLST_0pcodeGen_FormularConditionDefinition_params;
typedef struct _TPLST_0pcodeGen_Paragraph_fragments* _TPPLST_0pcodeGen_Paragraph_fragments;
typedef struct _TPLST_0pcodeGen_Table_rows* _TPPLST_0pcodeGen_Table_rows;
typedef struct _TPLST_0pcodeGen_Table_columns* _TPPLST_0pcodeGen_Table_columns;
typedef struct _TPLST_0pcodeGen_TableRow_cells* _TPPLST_0pcodeGen_TableRow_cells;
typedef struct _TPLST_0pcodeGen_Root_library* _TPPLST_0pcodeGen_Root_library;
typedef struct _TPLST_0pcodeGen_Library_formularconditions* _TPPLST_0pcodeGen_Library_formularconditions;
typedef struct _TPLST_0pcodeGen_Library_navigationElement* _TPPLST_0pcodeGen_Library_navigationElement;
typedef struct _TPLST_0pcodeGen_WebApplication_frames* _TPPLST_0pcodeGen_WebApplication_frames;
typedef struct _TPLST_0pcodeGen_WebApplication_roles* _TPPLST_0pcodeGen_WebApplication_roles;
typedef struct _TPLST_0pcodeGen_WebApplication_linksExtern* _TPPLST_0pcodeGen_WebApplication_linksExtern;
typedef struct _TPLST_0pcodeGen_RootWebZone_webTargets* _TPPLST_0pcodeGen_RootWebZone_webTargets;
typedef struct _TPLST_0pcodeGen_RootWebZone_roles* _TPPLST_0pcodeGen_RootWebZone_roles;
typedef struct _TPLST_0pcodeGen_SubWebZone_webTargets* _TPPLST_0pcodeGen_SubWebZone_webTargets;
typedef struct _TPLST_0pcodeGen_SubWebZone_globalparams* _TPPLST_0pcodeGen_SubWebZone_globalparams;
typedef struct _TPLST_0pcodeGen_SubWebZone_roles* _TPPLST_0pcodeGen_SubWebZone_roles;
typedef struct _TPLST_0pcodeGen_WebPage_formalParameter* _TPPLST_0pcodeGen_WebPage_formalParameter;
typedef struct _TPLST_0pcodeGen_Frame_components* _TPPLST_0pcodeGen_Frame_components;
typedef struct _TPLST_0pcodeGen_GlobalFrame_components* _TPPLST_0pcodeGen_GlobalFrame_components;
typedef struct _TPLST_0pcodeGen_NavigationBar_elements* _TPPLST_0pcodeGen_NavigationBar_elements;
typedef struct _TPLST_0pcodeGen_MetaInformation_elements* _TPPLST_0pcodeGen_MetaInformation_elements;
typedef struct _TPLST_0pcodeGen_ListOutputElement_dataSourceActualParams* _TPPLST_0pcodeGen_ListOutputElement_dataSourceActualParams;
typedef struct _TPLST_0pcodeGen_StyleSheet_custom* _TPPLST_0pcodeGen_StyleSheet_custom;
typedef struct _TPLST_0pcodeGen_StyleSheet_default* _TPPLST_0pcodeGen_StyleSheet_default;
typedef struct _TPLST_0pcodeGen_CustomStyleSheetBlock_pairs* _TPPLST_0pcodeGen_CustomStyleSheetBlock_pairs;
typedef struct _TPLST_0pcodeGen_HtmlStyleSheetBlock_pairs* _TPPLST_0pcodeGen_HtmlStyleSheetBlock_pairs;
typedef struct _TPLST_0pcodeGen_ActionHandler_params* _TPPLST_0pcodeGen_ActionHandler_params;
typedef struct _TPLST_0pcodeGen_WebAction_formalParameter* _TPPLST_0pcodeGen_WebAction_formalParameter;
typedef struct _TPLST_0pcodeGen_WebAction_operations* _TPPLST_0pcodeGen_WebAction_operations;
typedef struct _TPLST_0pcodeGen_PHPOperation_errorhandler* _TPPLST_0pcodeGen_PHPOperation_errorhandler;
typedef struct _TPLST_0pcodeGen_DataBaseOperation_errorhandler* _TPPLST_0pcodeGen_DataBaseOperation_errorhandler;
typedef struct _TPLST_0pcodeGen_DataBaseOperation_params* _TPPLST_0pcodeGen_DataBaseOperation_params;
typedef struct _TPLST_0pdataBaseView_DBColumn_type* _TPPLST_0pdataBaseView_DBColumn_type;
typedef struct _TPLST_0pdataBaseView_DataSourceFormalParam_type* _TPPLST_0pdataBaseView_DataSourceFormalParam_type;
typedef struct _TPLST_0pdataBaseView_BinaryExpression_leftOperand* _TPPLST_0pdataBaseView_BinaryExpression_leftOperand;
typedef struct _TPLST_0pdataBaseView_BinaryExpression_rightOperand* _TPPLST_0pdataBaseView_BinaryExpression_rightOperand;
typedef struct _TPLST_0pdataBaseView_UnaryExpression_operand* _TPPLST_0pdataBaseView_UnaryExpression_operand;
typedef struct _TPLST_0pdataBaseView_DataSourceValue_expression* _TPPLST_0pdataBaseView_DataSourceValue_expression;
typedef struct _TPLST_0pdataBaseView_DataSourceProjectionFilter_formalParameters* _TPPLST_0pdataBaseView_DataSourceProjectionFilter_formalParameters;
typedef struct _TPLST_0pdataBaseView_DataSourceProjectionFilter_projectionColumns* _TPPLST_0pdataBaseView_DataSourceProjectionFilter_projectionColumns;
typedef struct _TPLST_0pdataBaseView_DataSourceProjectionFilter_condition* _TPPLST_0pdataBaseView_DataSourceProjectionFilter_condition;
typedef struct _TPLST_0pdataBaseView_LimitDataSource_formalParameters* _TPPLST_0pdataBaseView_LimitDataSource_formalParameters;
typedef struct _TPLST_0pdataBaseView_LimitDataSource_minRow* _TPPLST_0pdataBaseView_LimitDataSource_minRow;
typedef struct _TPLST_0pdataBaseView_LimitDataSource_maxRow* _TPPLST_0pdataBaseView_LimitDataSource_maxRow;
typedef struct _TPLST_0pdataBaseView_DataSourceInsert_formalParams* _TPPLST_0pdataBaseView_DataSourceInsert_formalParams;
typedef struct _TPLST_0pdataBaseView_DataSourceInsert_values* _TPPLST_0pdataBaseView_DataSourceInsert_values;
typedef struct _TPLST_0pdataBaseView_DataSourceUpdate_formalParams* _TPPLST_0pdataBaseView_DataSourceUpdate_formalParams;
typedef struct _TPLST_0pdataBaseView_DataSourceUpdate_values* _TPPLST_0pdataBaseView_DataSourceUpdate_values;
typedef struct _TPLST_0pdataBaseView_DataSourceUpdate_conditions* _TPPLST_0pdataBaseView_DataSourceUpdate_conditions;
typedef struct _TPLST_0pdataBaseView_DataSourceDelete_formalParams* _TPPLST_0pdataBaseView_DataSourceDelete_formalParams;
typedef struct _TPLST_0pdataBaseView_DataSourceDelete_conditions* _TPPLST_0pdataBaseView_DataSourceDelete_conditions;
typedef struct _TPLST_0pdataBaseView_DataSourceDB_columns* _TPPLST_0pdataBaseView_DataSourceDB_columns;
typedef struct _TPLST_0pdataBaseView_DataBase_dataSources* _TPPLST_0pdataBaseView_DataBase_dataSources;
typedef struct _TPLST_0pdataBaseView_DataBase_dataSourceModifications* _TPPLST_0pdataBaseView_DataBase_dataSourceModifications;
typedef struct _TPLST_0pfcDlg_FormularCondition_params* _TPPLST_0pfcDlg_FormularCondition_params;
typedef struct _TPLST_0pglobalFrameView_FormularSelectElement_options* _TPPLST_0pglobalFrameView_FormularSelectElement_options;
typedef struct _TPLST_0pglobalFrameView_DataSourceActualParam_expressions* _TPPLST_0pglobalFrameView_DataSourceActualParam_expressions;
typedef struct _TPLST_0pglobalFrameView_WebNodeActualParam_expressions* _TPPLST_0pglobalFrameView_WebNodeActualParam_expressions;
typedef struct _TPLST_0pglobalFrameView_Formular_elements* _TPPLST_0pglobalFrameView_Formular_elements;
typedef struct _TPLST_0pglobalFrameView_Formular_actualParams* _TPPLST_0pglobalFrameView_Formular_actualParams;
typedef struct _TPLST_0pglobalFrameView_FormularRadioGroupElement_elements* _TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements;
typedef struct _TPLST_0pglobalFrameView_FormularDataSourceSelectOption_params* _TPPLST_0pglobalFrameView_FormularDataSourceSelectOption_params;
typedef struct _TPLST_0pglobalFrameView_FormularCondition_params* _TPPLST_0pglobalFrameView_FormularCondition_params;
typedef struct _TPLST_0pglobalFrameView_Paragraph_fragments* _TPPLST_0pglobalFrameView_Paragraph_fragments;
typedef struct _TPLST_0pglobalFrameView_Table_rows* _TPPLST_0pglobalFrameView_Table_rows;
typedef struct _TPLST_0pglobalFrameView_Table_columns* _TPPLST_0pglobalFrameView_Table_columns;
typedef struct _TPLST_0pglobalFrameView_TableRow_cells* _TPPLST_0pglobalFrameView_TableRow_cells;
typedef struct _TPLST_0pglobalFrameView_Frame_components* _TPPLST_0pglobalFrameView_Frame_components;
typedef struct _TPLST_0pglobalFrameView_GlobalFrame_components* _TPPLST_0pglobalFrameView_GlobalFrame_components;
typedef struct _TPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams* _TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams;
typedef struct _TPLST_0pmetaInformation_MetaInformation_elements* _TPPLST_0pmetaInformation_MetaInformation_elements;
typedef struct _TPLST_0pnavigationBarView_NavigationBar_elements* _TPPLST_0pnavigationBarView_NavigationBar_elements;
typedef struct _TPLST_0prootView_WebNodeFormalParam_type* _TPPLST_0prootView_WebNodeFormalParam_type;
typedef struct _TPLST_0prootView_DataSourceActualParam_expressions* _TPPLST_0prootView_DataSourceActualParam_expressions;
typedef struct _TPLST_0prootView_Formular_elements* _TPPLST_0prootView_Formular_elements;
typedef struct _TPLST_0prootView_Formular_actualParams* _TPPLST_0prootView_Formular_actualParams;
typedef struct _TPLST_0prootView_FormularRadioGroupElement_elements* _TPPLST_0prootView_FormularRadioGroupElement_elements;
typedef struct _TPLST_0prootView_FormularSelectElement_options* _TPPLST_0prootView_FormularSelectElement_options;
typedef struct _TPLST_0prootView_FormularDataSourceSelectOption_params* _TPPLST_0prootView_FormularDataSourceSelectOption_params;
typedef struct _TPLST_0prootView_FormularCondition_params* _TPPLST_0prootView_FormularCondition_params;
typedef struct _TPLST_0prootView_FormularConditionDefinition_params* _TPPLST_0prootView_FormularConditionDefinition_params;
typedef struct _TPLST_0prootView_WebNodeActualParam_expressions* _TPPLST_0prootView_WebNodeActualParam_expressions;
typedef struct _TPLST_0prootView_Paragraph_fragments* _TPPLST_0prootView_Paragraph_fragments;
typedef struct _TPLST_0prootView_Table_rows* _TPPLST_0prootView_Table_rows;
typedef struct _TPLST_0prootView_Table_columns* _TPPLST_0prootView_Table_columns;
typedef struct _TPLST_0prootView_TableRow_cells* _TPPLST_0prootView_TableRow_cells;
typedef struct _TPLST_0prootView_Root_library* _TPPLST_0prootView_Root_library;
typedef struct _TPLST_0prootView_Library_formularconditions* _TPPLST_0prootView_Library_formularconditions;
typedef struct _TPLST_0prootView_Library_navigationElement* _TPPLST_0prootView_Library_navigationElement;
typedef struct _TPLST_0prootView_WebApplication_frames* _TPPLST_0prootView_WebApplication_frames;
typedef struct _TPLST_0prootView_WebApplication_roles* _TPPLST_0prootView_WebApplication_roles;
typedef struct _TPLST_0prootView_WebApplication_linksExtern* _TPPLST_0prootView_WebApplication_linksExtern;
typedef struct _TPLST_0prootView_RootWebZone_webTargets* _TPPLST_0prootView_RootWebZone_webTargets;
typedef struct _TPLST_0prootView_RootWebZone_roles* _TPPLST_0prootView_RootWebZone_roles;
typedef struct _TPLST_0prootView_SubWebZone_webTargets* _TPPLST_0prootView_SubWebZone_webTargets;
typedef struct _TPLST_0prootView_SubWebZone_globalparams* _TPPLST_0prootView_SubWebZone_globalparams;
typedef struct _TPLST_0prootView_SubWebZone_roles* _TPPLST_0prootView_SubWebZone_roles;
typedef struct _TPLST_0prootView_WebPage_formalParameter* _TPPLST_0prootView_WebPage_formalParameter;
typedef struct _TPLST_0prootView_Frame_components* _TPPLST_0prootView_Frame_components;
typedef struct _TPLST_0prootView_GlobalFrame_components* _TPPLST_0prootView_GlobalFrame_components;
typedef struct _TPLST_0prootView_NavigationBar_elements* _TPPLST_0prootView_NavigationBar_elements;
typedef struct _TPLST_0prootView_MetaInformation_elements* _TPPLST_0prootView_MetaInformation_elements;
typedef struct _TPLST_0prootView_ListOutputElement_dataSourceActualParams* _TPPLST_0prootView_ListOutputElement_dataSourceActualParams;
typedef struct _TPLST_0prootView_StyleSheet_custom* _TPPLST_0prootView_StyleSheet_custom;
typedef struct _TPLST_0prootView_StyleSheet_default* _TPPLST_0prootView_StyleSheet_default;
typedef struct _TPLST_0prootView_CustomStyleSheetBlock_pairs* _TPPLST_0prootView_CustomStyleSheetBlock_pairs;
typedef struct _TPLST_0prootView_StyleSheetPair_value* _TPPLST_0prootView_StyleSheetPair_value;
typedef struct _TPLST_0prootView_HtmlStyleSheetBlock_pairs* _TPPLST_0prootView_HtmlStyleSheetBlock_pairs;
typedef struct _TPLST_0prootView_ActionHandler_params* _TPPLST_0prootView_ActionHandler_params;
typedef struct _TPLST_0prootView_WebAction_formalParameter* _TPPLST_0prootView_WebAction_formalParameter;
typedef struct _TPLST_0prootView_WebAction_operations* _TPPLST_0prootView_WebAction_operations;
typedef struct _TPLST_0prootView_PHPOperation_errorhandler* _TPPLST_0prootView_PHPOperation_errorhandler;
typedef struct _TPLST_0prootView_DataBaseOperation_errorhandler* _TPPLST_0prootView_DataBaseOperation_errorhandler;
typedef struct _TPLST_0prootView_DataBaseOperation_params* _TPPLST_0prootView_DataBaseOperation_params;
typedef struct _TPLST_0psspDlg_StyleSheetPair_value* _TPPLST_0psspDlg_StyleSheetPair_value;
typedef struct _TPLST_0pstylesheetView_StyleSheet_custom* _TPPLST_0pstylesheetView_StyleSheet_custom;
typedef struct _TPLST_0pstylesheetView_StyleSheet_default* _TPPLST_0pstylesheetView_StyleSheet_default;
typedef struct _TPLST_0pstylesheetView_CustomStyleSheetBlock_pairs* _TPPLST_0pstylesheetView_CustomStyleSheetBlock_pairs;
typedef struct _TPLST_0pstylesheetView_StyleSheetPair_value* _TPPLST_0pstylesheetView_StyleSheetPair_value;
typedef struct _TPLST_0pstylesheetView_HtmlStyleSheetBlock_pairs* _TPPLST_0pstylesheetView_HtmlStyleSheetBlock_pairs;
typedef struct _TPLST_0pwebActionView_WebNodeFormalParam_type* _TPPLST_0pwebActionView_WebNodeFormalParam_type;
typedef struct _TPLST_0pwebActionView_WebNodeActualParam_expressions* _TPPLST_0pwebActionView_WebNodeActualParam_expressions;
typedef struct _TPLST_0pwebActionView_DataSourceActualParam_expressions* _TPPLST_0pwebActionView_DataSourceActualParam_expressions;
typedef struct _TPLST_0pwebActionView_ActionHandler_params* _TPPLST_0pwebActionView_ActionHandler_params;
typedef struct _TPLST_0pwebActionView_WebAction_formalParameter* _TPPLST_0pwebActionView_WebAction_formalParameter;
typedef struct _TPLST_0pwebActionView_WebAction_operations* _TPPLST_0pwebActionView_WebAction_operations;
typedef struct _TPLST_0pwebActionView_PHPOperation_errorhandler* _TPPLST_0pwebActionView_PHPOperation_errorhandler;
typedef struct _TPLST_0pwebActionView_DataBaseOperation_errorhandler* _TPPLST_0pwebActionView_DataBaseOperation_errorhandler;
typedef struct _TPLST_0pwebActionView_DataBaseOperation_params* _TPPLST_0pwebActionView_DataBaseOperation_params;
typedef struct _TPLST_0pwebPageView_FormularSelectElement_options* _TPPLST_0pwebPageView_FormularSelectElement_options;
typedef struct _TPLST_0pwebPageView_DataSourceActualParam_expressions* _TPPLST_0pwebPageView_DataSourceActualParam_expressions;
typedef struct _TPLST_0pwebPageView_WebNodeActualParam_expressions* _TPPLST_0pwebPageView_WebNodeActualParam_expressions;
typedef struct _TPLST_0pwebPageView_WebNodeFormalParam_type* _TPPLST_0pwebPageView_WebNodeFormalParam_type;
typedef struct _TPLST_0pwebPageView_Formular_elements* _TPPLST_0pwebPageView_Formular_elements;
typedef struct _TPLST_0pwebPageView_Formular_actualParams* _TPPLST_0pwebPageView_Formular_actualParams;
typedef struct _TPLST_0pwebPageView_FormularRadioGroupElement_elements* _TPPLST_0pwebPageView_FormularRadioGroupElement_elements;
typedef struct _TPLST_0pwebPageView_FormularDataSourceSelectOption_params* _TPPLST_0pwebPageView_FormularDataSourceSelectOption_params;
typedef struct _TPLST_0pwebPageView_FormularCondition_params* _TPPLST_0pwebPageView_FormularCondition_params;
typedef struct _TPLST_0pwebPageView_Paragraph_fragments* _TPPLST_0pwebPageView_Paragraph_fragments;
typedef struct _TPLST_0pwebPageView_Table_rows* _TPPLST_0pwebPageView_Table_rows;
typedef struct _TPLST_0pwebPageView_Table_columns* _TPPLST_0pwebPageView_Table_columns;
typedef struct _TPLST_0pwebPageView_TableRow_cells* _TPPLST_0pwebPageView_TableRow_cells;
typedef struct _TPLST_0pwebPageView_WebPage_formalParameter* _TPPLST_0pwebPageView_WebPage_formalParameter;
typedef struct _TPLST_0pwebPageView_Frame_components* _TPPLST_0pwebPageView_Frame_components;
typedef struct _TPLST_0pwebPageView_ListOutputElement_dataSourceActualParams* _TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams;

struct _TSVIEWROOT
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Root
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATdummy;
VLString _AToutputDirectory;
MERootPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceDB
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceDBPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceDB_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceDB_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceDB_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DBColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDBColumnPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataBase
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataBasePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataBase_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBase_userName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBase_userPassword
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBase_hostName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBase_port
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBase_dataBaseType
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBase_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBase_modifySetSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceJoin
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceJoinPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_LimitDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELimitDataSourcePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceProjectionFilter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceProjectionFilterPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceDelete
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceDeletePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceUpdate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceUpdatePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceInsert
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceInsertPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DBColumn_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DBBlob
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DBBoolean
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DBTimeStamp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DBDate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DBBigInt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DBDouble
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DBFloat
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DBInteger
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DBString
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceProjectionFilter_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceProjectionFilter_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceProjectionFilter_sourceDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceProjectionFilter_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ComputationExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEComputationExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_ParameterValueExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParameterValueExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_ColumnValueExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColumnValueExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_ConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEConstantExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_UnaryExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEUnaryExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_BinaryExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEBinaryExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceFormalParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_ComputationProjection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEComputationProjectionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_ColumnProjection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColumnProjectionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_ColumnProjection_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ComputationProjection_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ComputationProjection_computation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_LimitDataSource_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_LimitDataSource_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_LimitDataSource_sourceDataSouce
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_LimitDataSource_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_BinaryExpression_operator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_UnaryExpression_operator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ConstantExpression_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ColumnValueExpression_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ParameterValueExpression_parameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ComputationExpression_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ComputationExpression_computation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceValue_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceJoin_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceJoin_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceJoin_dataSource1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceJoin_dataSource2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceJoin_columnRef1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceJoin_columnRef2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceJoin_joinOperator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceInsert_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceInsert_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceInsert_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceInsert_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceInsert_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceUpdate_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceUpdate_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceUpdate_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceUpdate_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceUpdate_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceDelete_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceDelete_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceDelete_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceDelete_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebNodeColumnExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeColumnExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_WebNodeVariableExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeVariableExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_WebNodeConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeConstantExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_DataSourceFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Formular
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_Formular_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Formular_action
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Formular_datasource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularSelectElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularSelectElementPtr _ATobjPtr;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularCheckboxElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularCheckboxElementPtr _ATobjPtr;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularPasswordElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPasswordElementPtr _ATobjPtr;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularTextAreaElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextAreaElementPtr _ATobjPtr;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularTextElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextElementPtr _ATobjPtr;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularRadioGroupElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioGroupElementPtr _ATobjPtr;
VLString _ATpers_name;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_WebNodeActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularRadioGroupElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularRadioGroupElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularRadioGroupElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularRadioGroupElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularRadioGroupElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularRadioGroupElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularCondition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularRadioElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularTextElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularTextElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularTextElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularTextElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularTextElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularTextAreaElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularTextAreaElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularTextAreaElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularTextAreaElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularTextAreaElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularPasswordElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularPasswordElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularPasswordElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularPasswordElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularPasswordElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularCheckboxElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularCheckboxElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularCheckboxElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularCheckboxElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularCheckboxElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularCheckboxElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularCheckboxElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularSelectElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularSelectElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularSelectElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularSelectElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularSelectElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularSelectElement_size
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularSelectElement_multiple
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularPHPScriptSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPHPScriptSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularDataSourceSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularDataSourceSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularConstantSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConstantSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularConstantSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularDataSourceSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularPHPScriptSelectOption_script
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularRadioElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularRadioElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularRadioElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularCondition_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularConditionActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularConditionDefinition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionDefinitionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularConditionDefinition_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularConditionDefinition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularConditionDefinition_body
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularConditionFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionFormalParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FormularConditionFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularConditionActualParam_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FormularConditionActualParam_formalparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebNodeActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebNodeFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeFormalParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_WebNodeFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebNodeConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebNodeVariableExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebNodeColumnExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Paragraph
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParagraphPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_Paragraph_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_OutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_ImageFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEImageFragmentPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_TextFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METextFragmentPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_TextFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_TextFragment_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ImageFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ImageFragment_width
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ImageFragment_height
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ImageFragment_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ImageFragment_imageName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_Heading_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Heading_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Heading_level
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Table
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METablePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_Table_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_TableRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableRowPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_TableColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TScodeGen_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_TableCell
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableCellPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_TableCell_columnRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_TableCell_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFramePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_LinkTargetExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELinkTargetExternPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_LinkTargetExtern_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_LinkTargetExtern_url
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Root_webApp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Root_library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebApplication
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
PTGNode _ATstyleSheetFileName;
PTGNode _ATmetaFileName;
VLString _ATimagePath;
MEWebApplicationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_Library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELibraryPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_Library_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Library_formularconditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Library_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_NavigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_NavigationElement_code
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_NavigationElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebApplication_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebApplication_webZone
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebApplication_navigationBar
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebApplication_styleSheet
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebApplication_frames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebApplication_meta
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebApplication_database
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebApplication_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
PTGNode _AT_const35;
};

struct _TScodeGen_WebApplication_linksExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebApplication_imagePath
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_RootWebZone
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MERootWebZonePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_NavigationBar
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarPtr _ATobjPtr;
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
};

struct _TScodeGen_StyleSheet
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_GlobalFrame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATfileName;
MEGlobalFramePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_MetaInformation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_WebRole
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebRolePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_RootWebZone_errorLink
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_RootWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_RootWebZone_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebAction
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATfileName;
MEWebActionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_WebPage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATfileName;
MEWebPagePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_SubWebZone
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESubWebZonePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_WebRoleRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebRoleRefPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_SubWebZone_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_SubWebZone_errorLink
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_SubWebZone_globalparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_SubWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_SubWebZone_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_SubWebZone_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebRole_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebRole_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebRoleRef_role
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebPage_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebPage_title
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebPage_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
PTGNode _AT_const38;
};

struct _TScodeGen_WebPage_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebPage_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_Frame_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ListOutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FrameRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFrameRefPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_GlobalFrame_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_GlobalFrame_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_NavigationBar_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_NavigationBar_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_NavigationBarElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
int _ATVPNumberedElement_number;
};

struct _TScodeGen_NavigationBarElement_target
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FrameRef_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FrameRef_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_MetaInformation_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_MetaInformationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_MetaInformationElement_property
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_MetaInformationElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_OutputElement_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_OutputElement_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ListOutputElement_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ListOutputElement_dataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ListOutputElement_maxNumberOfElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ListOutputElement_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_StyleSheet_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_CustomStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomStyleSheetBlockPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_HtmlStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHtmlStyleSheetBlockPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_CustomStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_StyleSheetPair
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPairPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_StyleSheetPair_category
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_StyleSheetPair_attribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_StyleSheetPair_valueCategory
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_CustomValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_ListValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_AlignmentValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEAlignmentValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_HeadingValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_StyleValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_FamilyValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFamilyValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_ColorValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColorValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_SizeValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESizeValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_SizeValue_measure
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_SizeValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ColorValue_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_FamilyValue_family
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_StyleValue_style
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_HeadingValue_heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_AlignmentValue_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ListValue_listed
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_CustomValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_HtmlStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ActionHandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEActionHandlerPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_ActionHandler_targetpage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebAction_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebAction_successpage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
PTGNode _AT_const47;
};

struct _TScodeGen_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_WebAction_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBaseOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataBaseOperationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_PHPOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEPHPOperationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TScodeGen_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_PHPOperation_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBaseOperation_filter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TScodeGen_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataBase
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtitle;
MEDataBasePtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLRegion _ATconnectionRegion;
};

struct _TSdataBaseView_DBColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDBColumnPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSdataBaseView_DBColumn_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBColumn_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSdataBaseView_DBBlob
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBBoolean
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBTimeStamp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBDate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBBigInt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBDouble
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBFloat
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBInteger
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBString
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceFormalParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSdataBaseView_DataSourceFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceFormalParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSdataBaseView_ColumnProjection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColumnProjectionPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ColumnProjection_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ColumnProjection_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ComputationProjection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEComputationProjectionPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ComputationProjection_computation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ComputationProjection_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ComputationProjection_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ComputationProjection_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_BinaryExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEBinaryExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_BinaryExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSdataBaseView_BinaryExpression_operator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSdataBaseView_BinaryExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ComputationExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEComputationExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ParameterValueExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParameterValueExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ColumnValueExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColumnValueExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEConstantExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_UnaryExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEUnaryExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_UnaryExpression_operator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSdataBaseView_ConstantExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ConstantExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ColumnValueExpression_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ParameterValueExpression_parameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ComputationExpression_computation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ComputationExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ComputationExpression_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_ComputationExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBString_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBInteger_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBFloat_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBDouble_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBBigInt_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBDate_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBTimeStamp_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBBoolean_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DBBlob_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSdataBaseView_DataSourceValue_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceValue_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSdataBaseView_DataSourceProjectionFilter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceProjectionFilterPtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _ATiFullPosition;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLRegion _ATiActualRegion;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceProjectionFilter_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TSdataBaseView_DataSourceProjectionFilter_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_DataSourceProjectionFilter_connection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
};

struct _TSdataBaseView_DataSourceProjectionFilter_from
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceProjectionFilter_sourceDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_LimitDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELimitDataSourcePtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _ATiFullPosition;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLRegion _ATiActualRegion;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_LimitDataSource_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TSdataBaseView_LimitDataSource_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_LimitDataSource_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_LimitDataSource_connection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
};

struct _TSdataBaseView_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSdataBaseView_LimitDataSource_dots
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSdataBaseView_LimitDataSource_from
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_LimitDataSource_sourceDataSouce
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceJoin
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceJoinPtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLObjectPointer _ATpers_columnRef1;
VLObjectPointer _ATpers_columnRef2;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _ATiFullPosition;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLRegion _ATiActualRegion;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceJoin_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TSdataBaseView_DataSourceJoin_joinOperator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_DataSourceJoin_connection1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
};

struct _TSdataBaseView_DataSourceJoin_connection2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
};

struct _TSdataBaseView_DataSourceJoin_from1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceJoin_dataSource1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceJoin_from2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceJoin_dataSource2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceInsert
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceInsertPtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceInsert_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TSdataBaseView_DataSourceInsert_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
int _ATelementDistance;
VLList _ATseparatorStyle;
int _ATflip;
int _ATactualWidth;
int _ATVPSpaceDistrib_pad;
VLPoint _ATiPreferedSize;
};

struct _TSdataBaseView_DataSourceInsert_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_DataSourceInsert_connection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
};

struct _TSdataBaseView_DataSourceInsert_from
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceInsert_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceUpdate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceUpdatePtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceUpdate_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TSdataBaseView_DataSourceUpdate_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
int _ATelementDistance;
VLList _ATseparatorStyle;
int _ATflip;
int _ATactualWidth;
int _ATVPSpaceDistrib_pad;
VLPoint _ATiPreferedSize;
};

struct _TSdataBaseView_DataSourceUpdate_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_DataSourceUpdate_connection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
};

struct _TSdataBaseView_DataSourceUpdate_from
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceUpdate_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceDelete
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceDeletePtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceDelete_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TSdataBaseView_DataSourceDelete_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
int _ATelementDistance;
VLList _ATseparatorStyle;
int _ATflip;
int _ATactualWidth;
int _ATVPSpaceDistrib_pad;
VLPoint _ATiPreferedSize;
};

struct _TSdataBaseView_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_DataSourceDelete_connection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
};

struct _TSdataBaseView_DataSourceDelete_from
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceDelete_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceDB
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceDBPtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLObjectPointer _ATobjId;
};

struct _TSdataBaseView_DataSourceDB_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TSdataBaseView_DataSourceDB_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataSourceDB_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSdataBaseView_DataBase_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataBase_userName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataBase_userPassword
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataBase_hostName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataBase_port
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataBase_dataBaseType
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPosition;
NonOverlappingSolverPtr _ATnonOverlappingSolver;
};

struct _TSdataBaseView_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPosition;
NonOverlappingSolverPtr _ATnonOverlappingSolver;
};

struct _TSdataBaseView_DataBase_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSdataBaseView_DataBase_modifySetSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSfcDlg_FormularCondition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
int _ATlabelWidth;
};

struct _TSfcDlg_FormularCondition_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSfcDlg_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSfcDlg_FormularConditionActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSfcDlg_FormularConditionActualParam_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TSfcDlg_FormularConditionActualParam_formalparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_GlobalFrame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEGlobalFramePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_FormularCheckboxElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularCheckboxElementPtr _ATobjPtr;
VLString _ATpers_name;
VLBoolean _ATpers_checked;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_FormularCheckboxElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularCheckboxElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
};

struct _TSglobalFrameView_FormularCheckboxElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPosition;
VLPoint _ATiActualSize;
VLPoint _ATpad;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularCheckboxElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularCheckboxElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSglobalFrameView_FormularCondition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
};

struct _TSglobalFrameView_FormularTextElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_FormularTextElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularTextElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TSglobalFrameView_FormularTextElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPosition;
VLPoint _ATiActualSize;
VLPoint _ATpad;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularTextElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularPasswordElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPasswordElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_FormularPasswordElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularPasswordElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TSglobalFrameView_FormularPasswordElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPosition;
VLPoint _ATiActualSize;
VLPoint _ATpad;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularPasswordElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularTextAreaElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextAreaElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_FormularTextAreaElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularTextAreaElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TSglobalFrameView_FormularTextAreaElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPosition;
VLPoint _ATiActualSize;
VLPoint _ATpad;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularTextAreaElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularSelectElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_reqLengthChain_pre;
MEFormularSelectElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_FormularSelectElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularSelectElement_multiple
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATcellName;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
};

struct _TSglobalFrameView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPContainer_showInsertionPoint;
};

struct _TSglobalFrameView_FormularSelectElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularPHPScriptSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPHPScriptSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
};

struct _TSglobalFrameView_FormularDataSourceSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedList_numberChain_pre;
MEFormularDataSourceSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
};

struct _TSglobalFrameView_FormularConstantSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConstantSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
};

struct _TSglobalFrameView_FormularRadioElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_FormularRadioElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularRadioElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularRadioElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSglobalFrameView_DataSourceActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedList_numberChain_post;
int _ATVPSpaceDistrib_reqLengthChain_post;
MEDataSourceActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_DataSourceActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_DataSourceActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSglobalFrameView_WebNodeColumnExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeColumnExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_WebNodeVariableExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeVariableExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_WebNodeConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeConstantExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_WebNodeActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_WebNodeActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_WebNodeActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSglobalFrameView_WebNodeConstantExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_WebNodeConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_WebNodeConstantExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_WebNodeVariableExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_WebNodeColumnExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_Formular
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_Formular_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_Formular_action
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATobjId;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSglobalFrameView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
VLHashtablePtr _ATabsPos;
VLHashtablePtr _ATcellWidth;
int _ATpreferedWidth;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSglobalFrameView_Formular_datasource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSglobalFrameView_FormularRadioGroupElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioGroupElementPtr _ATobjPtr;
VLString _ATpers_name;
VLObjectPointer _ATpers_checked;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_FormularRadioGroupElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularRadioGroupElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularRadioGroupElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularRadioGroupElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularRadioGroupElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPosition;
VLPoint _ATiActualSize;
VLPoint _ATpad;
VLString _ATcellName;
};

struct _TSglobalFrameView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
};

struct _TSglobalFrameView_FormularRadioGroupElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularConstantSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularDataSourceSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularPHPScriptSelectOption_script
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularCondition_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularConditionActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSglobalFrameView_FormularConditionActualParam_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FormularConditionActualParam_formalparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_Paragraph
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParagraphPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_Paragraph_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSglobalFrameView_OutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_ImageFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEImageFragmentPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_TextFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATfont;
VLString _ATcolor;
METextFragmentPtr _ATobjPtr;
VLObjectPointer _ATpers_link;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_TextFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_TextFragment_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSglobalFrameView_ImageFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_ImageFragment_width
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_ImageFragment_height
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_ImageFragment_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_ImageFragment_imageName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_Heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATfont;
MEHeadingPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_Heading_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_Heading_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSglobalFrameView_Heading_level
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_Table
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METablePtr _ATobjPtr;
VLPoint _ATpad;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
int _ATposY;
int _ATposX;
int _ATprovSizeY;
int _ATprovSizeX;
VLList _ATcellBorderAttrs;
VLPoint _ATminCellSize;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_Table_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
};

struct _TSglobalFrameView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
};

struct _TSglobalFrameView_TableRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableRowPtr _ATobjPtr;
VLObjectPointer _ATobjId;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
int _ATposY;
int _ATprovSizeY;
};

struct _TSglobalFrameView_TableColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_TableCell
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableCellPtr _ATobjPtr;
VLObjectPointer _ATobjId;
DefTableKey _ATcolumnKey;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
};

struct _TSglobalFrameView_TableCell_columnRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
};

struct _TSglobalFrameView_TableCell_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
};

struct _TSglobalFrameView_Frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFramePtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
};

struct _TSglobalFrameView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSglobalFrameView_Frame_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_ListOutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_FrameRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFrameRefPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
};

struct _TSglobalFrameView_GlobalFrame_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
};

struct _TSglobalFrameView_GlobalFrame_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FrameRef_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_FrameRef_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATobjId;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSglobalFrameView_OutputElement_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_OutputElement_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATobjId;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSglobalFrameView_ListOutputElement_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSglobalFrameView_ListOutputElement_dataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_ListOutputElement_maxNumberOfElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSglobalFrameView_ListOutputElement_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSmetaInformation_MetaInformation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSmetaInformation_MetaInformation_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSmetaInformation_MetaInformation_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSmetaInformation_MetaInformation_keyword3
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSmetaInformation_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLList _ATseparatorList;
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
};

struct _TSmetaInformation_MetaInformation_keyword4
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSmetaInformation_MetaInformationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
int _ATVPNumberedElement_number;
int _ATVPNumberedElement_isLast;
};

struct _TSmetaInformation_MetaInformationElement_property
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSmetaInformation_MetaInformationElement_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSmetaInformation_MetaInformationElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSmetaInformation_MetaInformationElement_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSnavigationBarView_NavigationBar
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarPtr _ATobjPtr;
VLString _ATpers_alignment;
VLObjectPointer _ATobjId;
};

struct _TSnavigationBarView_NavigationBar_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSnavigationBarView_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
};

struct _TSnavigationBarView_NavigationBar_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSnavigationBarView_NavigationBarElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarElementPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSnavigationBarView_NavigationBarElement_target
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TSrootView_Root
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MERootPtr _ATobjPtr;
VLRegion _ATiActualRegion;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebNodeFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeFormalParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
};

struct _TSrootView_WebNodeFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebNodeFormalParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSrootView_DBBlob
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBBoolean
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBTimeStamp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBDate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBBigInt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBDouble
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBFloat
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBInteger
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBString
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DataBase
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataBasePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBString_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBInteger_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBFloat_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBDouble_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBBigInt_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBDate_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBTimeStamp_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBBoolean_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DBBlob_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DataSourceActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_DataSourceActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebNodeColumnExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeColumnExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebNodeVariableExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeVariableExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebNodeConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeConstantExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_Formular
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_Formular_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Formular_action
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Formular_datasource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularSelectElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularSelectElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularCheckboxElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularCheckboxElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularPasswordElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPasswordElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularTextAreaElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextAreaElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularTextElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularRadioGroupElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioGroupElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebNodeActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularRadioGroupElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularRadioGroupElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularRadioGroupElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularRadioGroupElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularRadioGroupElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularRadioGroupElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularCondition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularRadioElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularTextElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularTextElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularTextElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularTextElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularTextElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularTextAreaElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularTextAreaElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularTextAreaElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularTextAreaElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularTextAreaElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularPasswordElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularPasswordElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularPasswordElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularPasswordElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularPasswordElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularCheckboxElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularCheckboxElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularCheckboxElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularCheckboxElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularCheckboxElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularCheckboxElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularCheckboxElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularSelectElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularSelectElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularSelectElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularSelectElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularSelectElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularSelectElement_size
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularSelectElement_multiple
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularPHPScriptSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPHPScriptSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularDataSourceSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularDataSourceSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularConstantSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConstantSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularConstantSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularDataSourceSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularPHPScriptSelectOption_script
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularRadioElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularRadioElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularRadioElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularCondition_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularConditionActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularConditionDefinition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionDefinitionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularConditionDefinition_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularConditionDefinition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularConditionDefinition_body
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularConditionFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionFormalParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FormularConditionFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularConditionActualParam_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FormularConditionActualParam_formalparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebNodeActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebNodeConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebNodeVariableExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebNodeColumnExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Paragraph
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParagraphPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_Paragraph_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_OutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_ImageFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEImageFragmentPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_TextFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METextFragmentPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_TextFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_TextFragment_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ImageFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ImageFragment_width
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ImageFragment_height
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ImageFragment_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ImageFragment_imageName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_Heading_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Heading_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Heading_level
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Table
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METablePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_Table_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_TableRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableRowPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_TableColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
};

struct _TSrootView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_TableCell
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableCellPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_TableCell_columnRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_TableCell_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFramePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_LinkTargetExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELinkTargetExternPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSrootView_LinkTargetExtern_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_LinkTargetExtern_url
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_Root_webApp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Root_library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebApplication
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebApplicationPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSrootView_Library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELibraryPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_Library_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Library_formularconditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Library_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_NavigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_NavigationElement_code
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_NavigationElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebApplication_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebApplication_webZone
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_WebApplication_navigationBar
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_WebApplication_styleSheet
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_WebApplication_frames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_WebApplication_meta
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_WebApplication_database
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_WebApplication_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_WebApplication_linksExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_WebApplication_imagePath
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_RootWebZone
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MERootWebZonePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSrootView_NavigationBar
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSrootView_StyleSheet
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSrootView_GlobalFrame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEGlobalFramePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSrootView_MetaInformation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebRole
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebRolePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSrootView_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
VLPoint _ATiPreferedSize;
NonOverlappingSolverPtr _ATnonOverlappingSolver;
VLObjectPointer _ATsizeAttr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSrootView_RootWebZone_errorLink
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_RootWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_RootWebZone_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebAction
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebActionPtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLPoint _ATpad;
VLRegion _ATiActualRegion;
VLPoint _ATiFullPosition;
VLPoint _AToPreferedSize;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLPoint _ATrelPosition;
VLRegionPtr _ATregionPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebPage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebPagePtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLPoint _ATpad;
VLRegion _ATiActualRegion;
VLPoint _ATiFullPosition;
VLPoint _AToPreferedSize;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLPoint _ATrelPosition;
VLRegionPtr _ATregionPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_SubWebZone
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESubWebZonePtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLPoint _ATpad;
VLPoint _AToPreferedSize;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLPoint _ATrelPosition;
VLRegionPtr _ATregionPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebRoleRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebRoleRefPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSrootView_SubWebZone_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSrootView_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
VLPoint _ATiPreferedSize;
NonOverlappingSolverPtr _ATnonOverlappingSolver;
VLObjectPointer _ATsizeAttr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSrootView_SubWebZone_errorLink
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_SubWebZone_globalparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_SubWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_SubWebZone_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_SubWebZone_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebRole_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebRole_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSrootView_WebRoleRef_role
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebPage_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_WebPage_title
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebPage_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebPage_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebPage_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_Frame_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ListOutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FrameRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFrameRefPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_GlobalFrame_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSrootView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_GlobalFrame_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_NavigationBar_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_NavigationBar_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_NavigationBarElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_NavigationBarElement_target
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FrameRef_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FrameRef_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_MetaInformation_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_MetaInformationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_MetaInformationElement_property
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_MetaInformationElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_OutputElement_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_OutputElement_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ListOutputElement_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ListOutputElement_dataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ListOutputElement_maxNumberOfElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ListOutputElement_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_StyleSheet_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_CustomStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomStyleSheetBlockPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_HtmlStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHtmlStyleSheetBlockPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_CustomStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_StyleSheetPair
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPairPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_StyleSheetPair_category
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_StyleSheetPair_attribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_StyleSheetPair_valueCategory
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_CustomValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_ListValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_AlignmentValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEAlignmentValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_HeadingValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_StyleValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_FamilyValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFamilyValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_ColorValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColorValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_SizeValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESizeValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_SizeValue_measure
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_SizeValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ColorValue_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_FamilyValue_family
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_StyleValue_style
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_HeadingValue_heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_AlignmentValue_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ListValue_listed
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_CustomValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_HtmlStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ActionHandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEActionHandlerPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_ActionHandler_targetpage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebAction_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSrootView_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSrootView_WebAction_successpage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLList _ATlineAttributes;
};

struct _TSrootView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_WebAction_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_DataBaseOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataBaseOperationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_PHPOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEPHPOperationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSrootView_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLList _ATlineAttributes;
};

struct _TSrootView_PHPOperation_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLList _ATlineAttributes;
};

struct _TSrootView_DataBaseOperation_filter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSrootView_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSsspDlg_StyleSheetPair
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPairPtr _ATobjPtr;
VLString _ATpers_category;
int _ATlabelWidth;
VLObjectPointer _ATobjId;
};

struct _TSsspDlg_StyleSheetPair_category
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSsspDlg_StyleSheetPair_attribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSsspDlg_StyleSheetPair_valueCategory
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSsspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSsspDlg_CustomValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSsspDlg_ListValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSsspDlg_AlignmentValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEAlignmentValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSsspDlg_HeadingValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSsspDlg_StyleValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSsspDlg_FamilyValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFamilyValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSsspDlg_ColorValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColorValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSsspDlg_SizeValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESizeValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSsspDlg_SizeValue_measure
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATnodeId;
VLString _ATlabel;
};

struct _TSsspDlg_SizeValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TSsspDlg_ColorValue_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TSsspDlg_FamilyValue_family
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TSsspDlg_StyleValue_style
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TSsspDlg_HeadingValue_heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TSsspDlg_AlignmentValue_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TSsspDlg_ListValue_listed
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TSsspDlg_CustomValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TSstylesheetView_StyleSheet
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_StyleSheet_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLList _ATseparatorStyle;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
};

struct _TSstylesheetView_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
};

struct _TSstylesheetView_CustomStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomStyleSheetBlockPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLPoint _ATpad;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_HtmlStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHtmlStyleSheetBlockPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLPoint _ATpad;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
int _ATpreferedWidth;
VLHashtablePtr _ATcellWidth;
VLHashtablePtr _ATabsPos;
VLPoint _ATiPreferedSize;
};

struct _TSstylesheetView_CustomStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerInterface2Ptr _ATcontainerSubElement;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_StyleSheetPair
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPairPtr _ATobjPtr;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_StyleSheetPair_category
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_StyleSheetPair_attribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATcellName;
VLPoint _ATpad;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATiPreferedSize;
};

struct _TSstylesheetView_StyleSheetPair_valueCategory
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_CustomValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_ListValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_AlignmentValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEAlignmentValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_HeadingValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_StyleValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_FamilyValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFamilyValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_ColorValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColorValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_SizeValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESizeValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSstylesheetView_SizeValue_measure
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_SizeValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_ColorValue_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_FamilyValue_family
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_StyleValue_style
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_HeadingValue_heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_AlignmentValue_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_ListValue_listed
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_CustomValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSstylesheetView_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
int _ATpreferedWidth;
VLHashtablePtr _ATcellWidth;
VLHashtablePtr _ATabsPos;
VLPoint _ATiPreferedSize;
};

struct _TSstylesheetView_HtmlStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerInterface2Ptr _ATcontainerSubElement;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebAction
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebActionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeFormalParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
};

struct _TSwebActionView_WebNodeFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeFormalParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSwebActionView_DBBlob
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBBoolean
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBTimeStamp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBDate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBBigInt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBDouble
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBFloat
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBInteger
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBString
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeActualParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
};

struct _TSwebActionView_WebNodeActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSwebActionView_WebNodeColumnExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeColumnExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeVariableExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeVariableExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeConstantExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeConstantExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeConstantExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeVariableExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_WebNodeColumnExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBString_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBInteger_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBFloat_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBDouble_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBBigInt_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBDate_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBTimeStamp_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBBoolean_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DBBlob_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DataSourceActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceActualParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
};

struct _TSwebActionView_DataSourceActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DataSourceActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSwebActionView_ActionHandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEActionHandlerPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_ActionHandler_targetpage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSwebActionView_WebAction_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebActionView_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
};

struct _TSwebActionView_WebAction_successpage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATisError;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
};

struct _TSwebActionView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
};

struct _TSwebActionView_WebAction_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebActionView_DataBaseOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataBaseOperationPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_PHPOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEPHPOperationPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATisError;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSwebActionView_PHPOperation_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSwebActionView_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATisError;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSwebActionView_DataBaseOperation_filter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSwebActionView_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSwebPageView_WebPage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebPagePtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularCheckboxElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularCheckboxElementPtr _ATobjPtr;
VLString _ATpers_name;
VLBoolean _ATpers_checked;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularCheckboxElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularCheckboxElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularCheckboxElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularCheckboxElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularCheckboxElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularCondition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularTextElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularTextElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularTextElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TSwebPageView_FormularTextElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularTextElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularPasswordElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPasswordElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularPasswordElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularPasswordElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TSwebPageView_FormularPasswordElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularPasswordElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularTextAreaElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextAreaElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularTextAreaElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularTextAreaElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TSwebPageView_FormularTextAreaElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularTextAreaElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularSelectElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_reqLengthChain_pre;
MEFormularSelectElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularSelectElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularSelectElement_multiple
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPContainer_showInsertionPoint;
};

struct _TSwebPageView_FormularSelectElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularPHPScriptSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPHPScriptSelectOptionPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularDataSourceSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedList_numberChain_pre;
MEFormularDataSourceSelectOptionPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularConstantSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConstantSelectOptionPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularRadioElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioElementPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularRadioElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularRadioElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularRadioElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DataSourceActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedList_numberChain_post;
int _ATVPSpaceDistrib_reqLengthChain_post;
MEDataSourceActualParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
};

struct _TSwebPageView_DataSourceActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DataSourceActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSwebPageView_WebNodeColumnExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeColumnExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeVariableExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeVariableExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeConstantExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeActualParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
};

struct _TSwebPageView_WebNodeActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSwebPageView_WebNodeConstantExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeConstantExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeVariableExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeColumnExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeFormalParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
};

struct _TSwebPageView_WebNodeFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeFormalParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
};

struct _TSwebPageView_DBBlob
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBBoolean
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBTimeStamp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBDate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBBigInt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBDouble
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBFloat
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBInteger
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBString
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBString_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBInteger_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBFloat_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBDouble_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBBigInt_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBDate_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBTimeStamp_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBBoolean_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_DBBlob_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_Formular
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_Formular_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_Formular_action
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
VLHashtablePtr _ATabsPos;
VLHashtablePtr _ATcellWidth;
int _ATpreferedWidth;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSwebPageView_Formular_datasource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSwebPageView_FormularRadioGroupElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioGroupElementPtr _ATobjPtr;
VLString _ATpers_name;
VLObjectPointer _ATpers_checked;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularRadioGroupElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularRadioGroupElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularRadioGroupElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularRadioGroupElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularRadioGroupElement_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TSwebPageView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
};

struct _TSwebPageView_FormularRadioGroupElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularConstantSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularDataSourceSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularPHPScriptSelectOption_script
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularCondition_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularConditionActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FormularConditionActualParam_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FormularConditionActualParam_formalparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_Paragraph
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParagraphPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_Paragraph_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSwebPageView_OutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEOutputElementPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_ImageFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEImageFragmentPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_TextFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METextFragmentPtr _ATobjPtr;
VLObjectPointer _ATpers_link;
VLString _ATfont;
VLString _ATcolor;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_TextFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_TextFragment_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSwebPageView_ImageFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_ImageFragment_width
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_ImageFragment_height
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_ImageFragment_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_ImageFragment_imageName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_Heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingPtr _ATobjPtr;
VLString _ATfont;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_Heading_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_Heading_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSwebPageView_Heading_level
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_Table
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METablePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
int _ATposY;
int _ATposX;
int _ATprovSizeY;
int _ATprovSizeX;
VLList _ATcellBorderAttrs;
VLPoint _ATminCellSize;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_Table_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
};

struct _TSwebPageView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
};

struct _TSwebPageView_TableRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableRowPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
int _ATposY;
int _ATprovSizeY;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_TableColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_TableCell
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableCellPtr _ATobjPtr;
DefTableKey _ATcolumnKey;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_TableCell_columnRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
};

struct _TSwebPageView_TableCell_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
};

struct _TSwebPageView_Frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFramePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_WebPage_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
};

struct _TSwebPageView_WebPage_title
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_WebPage_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_WebPage_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_WebPage_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TSwebPageView_Frame_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_ListOutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListOutputElementPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FrameRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFrameRefPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_FrameRef_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_FrameRef_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_OutputElement_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_OutputElement_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_ListOutputElement_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TSwebPageView_ListOutputElement_dataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TSwebPageView_ListOutputElement_maxNumberOfElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSwebPageView_ListOutputElement_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataSourceDB_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataSourceProjectionFilter_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_LimitDataSource_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataSourceInsert_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataSourceInsert_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataSourceUpdate_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataSourceUpdate_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataSourceDelete_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_FormularConditionDefinition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_Root_library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_Library_formularconditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_Library_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_WebApplication_frames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_WebApplication_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_WebApplication_linksExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_RootWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_SubWebZone_globalparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_SubWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_codeGen_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceProjectionFilter_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_LimitDataSource_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceInsert_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceInsert_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceUpdate_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceUpdate_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceDelete_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataSourceDB_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_dataBaseView_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_fcDlg_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_globalFrameView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_metaInformation_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_navigationBarView_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_FormularConditionDefinition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_Root_library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_Library_formularconditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_Library_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_WebApplication_frames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_WebApplication_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_WebApplication_linksExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_RootWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_SubWebZone_globalparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_SubWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_rootView_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_sspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_stylesheetView_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_stylesheetView_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_stylesheetView_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_stylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_stylesheetView_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webActionView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webActionView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webActionView_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webActionView_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webActionView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webActionView_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webActionView_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webActionView_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_webPageView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpEmpty
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpVIEWROOT_codeGen
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Root _desc1;
};

struct _TPpcodeGen_DataSourceDB
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceDBPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataSourceDB_name _desc1;
_TSPcodeGen_DataSourceDB_position _desc2;
_TSPcodeGen_DataSourceDB_columns _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_DataSourceDB_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceDB_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceDB_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataSourceDB_columns _desc1;
};

struct _TPpcodeGen_DataBase
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataBasePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataBase_name _desc1;
_TSPcodeGen_DataBase_userName _desc2;
_TSPcodeGen_DataBase_userPassword _desc3;
_TSPcodeGen_DataBase_hostName _desc4;
_TSPcodeGen_DataBase_port _desc5;
_TSPcodeGen_DataBase_dataBaseType _desc6;
_TSPcodeGen_DataBase_dataSources _desc7;
_TSPcodeGen_DataBase_dataSourceModifications _desc8;
_TSPcodeGen_DataBase_setSize _desc9;
_TSPcodeGen_DataBase_modifySetSize _desc10;
int _ATTERM_1;
};

struct _TPpcodeGen_DataBase_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataBase_userName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataBase_userPassword
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataBase_hostName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataBase_port
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataBase_dataBaseType
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataBase_dataSources _desc1;
};

struct _TPpcodeGen_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataBase_dataSourceModifications _desc1;
};

struct _TPpcodeGen_DataBase_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataBase_modifySetSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DBColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDBColumnPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DBColumn_name _desc1;
_TSPcodeGen_DBColumn_type _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_DBColumn_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DBString
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpcodeGen_DBInteger
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpcodeGen_DBFloat
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpcodeGen_DBDouble
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpcodeGen_DBBigInt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpcodeGen_DBDate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpcodeGen_DBTimeStamp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpcodeGen_DBBoolean
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpcodeGen_DBBlob
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpcodeGen_DataSourceProjectionFilter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceProjectionFilterPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataSourceProjectionFilter_name _desc1;
_TSPcodeGen_DataSourceProjectionFilter_position _desc2;
_TSPcodeGen_DataSourceProjectionFilter_sourceDataSource _desc3;
_TSPcodeGen_DataSourceProjectionFilter_condition _desc4;
_TSPcodeGen_DataSourceProjectionFilter_formalParameters _desc5;
_TSPcodeGen_DataSourceProjectionFilter_projectionColumns _desc6;
int _ATTERM_1;
};

struct _TPpcodeGen_DataSourceProjectionFilter_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceProjectionFilter_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceProjectionFilter_sourceDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceProjectionFilter_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataSourceProjectionFilter_formalParameters _desc1;
};

struct _TPpcodeGen_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataSourceProjectionFilter_projectionColumns _desc1;
};

struct _TPpcodeGen_ColumnProjection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColumnProjectionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ColumnProjection_column _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_ColumnProjection_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ComputationProjection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEComputationProjectionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ComputationProjection_column _desc1;
_TSPcodeGen_ComputationProjection_computation _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_ComputationProjection_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ComputationProjection_computation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_LimitDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELimitDataSourcePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_LimitDataSource_name _desc1;
_TSPcodeGen_LimitDataSource_position _desc2;
_TSPcodeGen_LimitDataSource_sourceDataSouce _desc3;
_TSPcodeGen_LimitDataSource_minRow _desc4;
_TSPcodeGen_LimitDataSource_maxRow _desc5;
_TSPcodeGen_LimitDataSource_formalParameters _desc6;
int _ATTERM_1;
};

struct _TPpcodeGen_LimitDataSource_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_LimitDataSource_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_LimitDataSource_sourceDataSouce
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_LimitDataSource_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_LimitDataSource_formalParameters _desc1;
};

struct _TPpcodeGen_BinaryExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEBinaryExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_BinaryExpression_leftOperand _desc1;
_TSPcodeGen_BinaryExpression_rightOperand _desc2;
_TSPcodeGen_BinaryExpression_operator _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_BinaryExpression_operator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_UnaryExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEUnaryExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_UnaryExpression_operand _desc1;
_TSPcodeGen_UnaryExpression_operator _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_UnaryExpression_operator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEConstantExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ConstantExpression_type _desc1;
_TSPcodeGen_ConstantExpression_value _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_ConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ColumnValueExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColumnValueExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ColumnValueExpression_column _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_ColumnValueExpression_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ParameterValueExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParameterValueExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ParameterValueExpression_parameter _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_ParameterValueExpression_parameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ComputationExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEComputationExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ComputationExpression_column _desc1;
_TSPcodeGen_ComputationExpression_computation _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_ComputationExpression_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ComputationExpression_computation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataSourceValue_column _desc1;
_TSPcodeGen_DataSourceValue_expression _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_DataSourceValue_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceJoin
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceJoinPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataSourceJoin_name _desc1;
_TSPcodeGen_DataSourceJoin_position _desc2;
_TSPcodeGen_DataSourceJoin_dataSource1 _desc3;
_TSPcodeGen_DataSourceJoin_dataSource2 _desc4;
_TSPcodeGen_DataSourceJoin_columnRef1 _desc5;
_TSPcodeGen_DataSourceJoin_columnRef2 _desc6;
_TSPcodeGen_DataSourceJoin_joinOperator _desc7;
int _ATTERM_1;
};

struct _TPpcodeGen_DataSourceJoin_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceJoin_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceJoin_dataSource1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceJoin_dataSource2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceJoin_columnRef1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceJoin_columnRef2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceJoin_joinOperator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceInsert
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceInsertPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataSourceInsert_targetDataSource _desc1;
_TSPcodeGen_DataSourceInsert_formalParams _desc2;
_TSPcodeGen_DataSourceInsert_name _desc3;
_TSPcodeGen_DataSourceInsert_position _desc4;
_TSPcodeGen_DataSourceInsert_values _desc5;
int _ATTERM_1;
};

struct _TPpcodeGen_DataSourceInsert_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceInsert_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataSourceInsert_formalParams _desc1;
};

struct _TPpcodeGen_DataSourceInsert_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceInsert_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceInsert_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataSourceInsert_values _desc1;
};

struct _TPpcodeGen_DataSourceUpdate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceUpdatePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataSourceUpdate_targetDataSource _desc1;
_TSPcodeGen_DataSourceUpdate_formalParams _desc2;
_TSPcodeGen_DataSourceUpdate_name _desc3;
_TSPcodeGen_DataSourceUpdate_position _desc4;
_TSPcodeGen_DataSourceUpdate_conditions _desc5;
_TSPcodeGen_DataSourceUpdate_values _desc6;
int _ATTERM_1;
};

struct _TPpcodeGen_DataSourceUpdate_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceUpdate_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataSourceUpdate_formalParams _desc1;
};

struct _TPpcodeGen_DataSourceUpdate_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceUpdate_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceUpdate_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataSourceUpdate_values _desc1;
};

struct _TPpcodeGen_DataSourceDelete
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceDeletePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataSourceDelete_targetDataSource _desc1;
_TSPcodeGen_DataSourceDelete_formalParams _desc2;
_TSPcodeGen_DataSourceDelete_name _desc3;
_TSPcodeGen_DataSourceDelete_position _desc4;
_TSPcodeGen_DataSourceDelete_conditions _desc5;
int _ATTERM_1;
};

struct _TPpcodeGen_DataSourceDelete_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceDelete_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataSourceDelete_formalParams _desc1;
};

struct _TPpcodeGen_DataSourceDelete_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceDelete_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataSourceActualParam_formalParam _desc1;
_TSPcodeGen_DataSourceActualParam_expressions _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_DataSourceActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataSourceFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceFormalParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataSourceFormalParam_name _desc1;
_TSPcodeGen_DataSourceFormalParam_type _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_DataSourceFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Formular
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_Formular_styleSheetBlock _desc1;
_TSPcodeGen_Formular_action _desc2;
_TSPcodeGen_Formular_elements _desc3;
_TSPcodeGen_Formular_datasource _desc4;
_TSPcodeGen_Formular_actualParams _desc5;
int _ATTERM_1;
};

struct _TPpcodeGen_Formular_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Formular_action
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_Formular_elements _desc1;
};

struct _TPpcodeGen_Formular_datasource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_Formular_actualParams _desc1;
};

struct _TPpcodeGen_FormularRadioGroupElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioGroupElementPtr _ATobjPtr;
VLString _ATpers_name;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularRadioGroupElement_name _desc1;
_TSPcodeGen_FormularRadioGroupElement_label _desc2;
_TSPcodeGen_FormularRadioGroupElement_description _desc3;
_TSPcodeGen_FormularRadioGroupElement_pvalue _desc4;
_TSPcodeGen_FormularRadioGroupElement_condition _desc5;
_TSPcodeGen_FormularRadioGroupElement_elements _desc6;
_TSPcodeGen_FormularRadioGroupElement_checked _desc7;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularRadioGroupElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularRadioGroupElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularRadioGroupElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularRadioGroupElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_FormularRadioGroupElement_elements _desc1;
};

struct _TPpcodeGen_FormularRadioGroupElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularTextElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextElementPtr _ATobjPtr;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularTextElement_name _desc1;
_TSPcodeGen_FormularTextElement_label _desc2;
_TSPcodeGen_FormularTextElement_description _desc3;
_TSPcodeGen_FormularTextElement_pvalue _desc4;
_TSPcodeGen_FormularTextElement_condition _desc5;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularTextElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularTextElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularTextElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularTextElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularTextAreaElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextAreaElementPtr _ATobjPtr;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularTextAreaElement_name _desc1;
_TSPcodeGen_FormularTextAreaElement_label _desc2;
_TSPcodeGen_FormularTextAreaElement_description _desc3;
_TSPcodeGen_FormularTextAreaElement_pvalue _desc4;
_TSPcodeGen_FormularTextAreaElement_condition _desc5;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularTextAreaElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularTextAreaElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularTextAreaElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularTextAreaElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularPasswordElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPasswordElementPtr _ATobjPtr;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularPasswordElement_name _desc1;
_TSPcodeGen_FormularPasswordElement_label _desc2;
_TSPcodeGen_FormularPasswordElement_description _desc3;
_TSPcodeGen_FormularPasswordElement_pvalue _desc4;
_TSPcodeGen_FormularPasswordElement_condition _desc5;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularPasswordElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularPasswordElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularPasswordElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularPasswordElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularCheckboxElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularCheckboxElementPtr _ATobjPtr;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularCheckboxElement_name _desc1;
_TSPcodeGen_FormularCheckboxElement_label _desc2;
_TSPcodeGen_FormularCheckboxElement_description _desc3;
_TSPcodeGen_FormularCheckboxElement_pvalue _desc4;
_TSPcodeGen_FormularCheckboxElement_condition _desc5;
_TSPcodeGen_FormularCheckboxElement_value _desc6;
_TSPcodeGen_FormularCheckboxElement_checked _desc7;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularCheckboxElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularCheckboxElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularCheckboxElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularCheckboxElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularCheckboxElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularCheckboxElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularSelectElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularSelectElementPtr _ATobjPtr;
PTGNode _ATlabel;
PTGNode _ATname;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularSelectElement_name _desc1;
_TSPcodeGen_FormularSelectElement_label _desc2;
_TSPcodeGen_FormularSelectElement_description _desc3;
_TSPcodeGen_FormularSelectElement_pvalue _desc4;
_TSPcodeGen_FormularSelectElement_condition _desc5;
_TSPcodeGen_FormularSelectElement_options _desc6;
_TSPcodeGen_FormularSelectElement_size _desc7;
_TSPcodeGen_FormularSelectElement_multiple _desc8;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularSelectElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularSelectElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularSelectElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularSelectElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularSelectElement_size
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularSelectElement_multiple
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularConstantSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConstantSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularConstantSelectOption_values _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularConstantSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularDataSourceSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularDataSourceSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularDataSourceSelectOption_values _desc1;
_TSPcodeGen_FormularDataSourceSelectOption_params _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularDataSourceSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_FormularDataSourceSelectOption_params _desc1;
};

struct _TPpcodeGen_FormularPHPScriptSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPHPScriptSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularPHPScriptSelectOption_script _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularPHPScriptSelectOption_script
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularRadioElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularRadioElement_value _desc1;
_TSPcodeGen_FormularRadioElement_label _desc2;
_TSPcodeGen_FormularRadioElement_name _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularRadioElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularRadioElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularRadioElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularCondition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularCondition_condition _desc1;
_TSPcodeGen_FormularCondition_params _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularCondition_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_FormularCondition_params _desc1;
};

struct _TPpcodeGen_FormularConditionDefinition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionDefinitionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularConditionDefinition_name _desc1;
_TSPcodeGen_FormularConditionDefinition_params _desc2;
_TSPcodeGen_FormularConditionDefinition_body _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularConditionDefinition_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularConditionDefinition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_FormularConditionDefinition_params _desc1;
};

struct _TPpcodeGen_FormularConditionDefinition_body
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularConditionFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionFormalParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularConditionFormalParam_name _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularConditionFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularConditionActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_FormularConditionActualParam_value _desc1;
_TSPcodeGen_FormularConditionActualParam_formalparam _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_FormularConditionActualParam_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FormularConditionActualParam_formalparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebNodeActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_WebNodeActualParam_formalParam _desc1;
_TSPcodeGen_WebNodeActualParam_expressions _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_WebNodeActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebNodeFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeFormalParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_WebNodeFormalParam_name _desc1;
_TSPcodeGen_WebNodeFormalParam_type _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_WebNodeFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebNodeConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeConstantExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_WebNodeConstantExpression_value _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_WebNodeConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebNodeVariableExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeVariableExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_WebNodeVariableExpression_content _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_WebNodeVariableExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebNodeColumnExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeColumnExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_WebNodeColumnExpression_content _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_WebNodeColumnExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Paragraph
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParagraphPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_Paragraph_styleSheetBlock _desc1;
_TSPcodeGen_Paragraph_fragments _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_Paragraph_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_Paragraph_fragments _desc1;
};

struct _TPpcodeGen_TextFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METextFragmentPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_TextFragment_link _desc1;
_TSPcodeGen_TextFragment_value _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_TextFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_TextFragment_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ImageFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEImageFragmentPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ImageFragment_link _desc1;
_TSPcodeGen_ImageFragment_width _desc2;
_TSPcodeGen_ImageFragment_height _desc3;
_TSPcodeGen_ImageFragment_text _desc4;
_TSPcodeGen_ImageFragment_imageName _desc5;
int _ATTERM_1;
};

struct _TPpcodeGen_ImageFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ImageFragment_width
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ImageFragment_height
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ImageFragment_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ImageFragment_imageName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_Heading_styleSheetBlock _desc1;
_TSPcodeGen_Heading_text _desc2;
_TSPcodeGen_Heading_level _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_Heading_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Heading_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Heading_level
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Table
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METablePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_Table_styleSheetBlock _desc1;
_TSPcodeGen_Table_rows _desc2;
_TSPcodeGen_Table_columns _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_Table_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_Table_rows _desc1;
};

struct _TPpcodeGen_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_Table_columns _desc1;
};

struct _TPpcodeGen_TableRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableRowPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_TableRow_cells _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_TableRow_cells _desc1;
};

struct _TPpcodeGen_TableColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpcodeGen_TableCell
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableCellPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_TableCell_columnRef _desc1;
_TSPcodeGen_TableCell_content _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_TableCell_columnRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_LinkTargetExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELinkTargetExternPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_LinkTargetExtern_name _desc1;
_TSPcodeGen_LinkTargetExtern_url _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_LinkTargetExtern_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_LinkTargetExtern_url
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Root
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATdummy;
VLString _AToutputDirectory;
MERootPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_Root_webApp _desc1;
_TSPcodeGen_Root_library _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_Root_library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_Root_library _desc1;
};

struct _TPpcodeGen_Library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELibraryPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_Library_name _desc1;
_TSPcodeGen_Library_formularconditions _desc2;
_TSPcodeGen_Library_navigationElement _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_Library_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Library_formularconditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_Library_formularconditions _desc1;
};

struct _TPpcodeGen_Library_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_Library_navigationElement _desc1;
};

struct _TPpcodeGen_NavigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_NavigationElement_code _desc1;
_TSPcodeGen_NavigationElement_name _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_NavigationElement_code
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_NavigationElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebApplication
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
PTGNode _ATstyleSheetFileName;
PTGNode _ATmetaFileName;
VLString _ATimagePath;
MEWebApplicationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_WebApplication_name _desc1;
_TSPcodeGen_WebApplication_webZone _desc2;
_TSPcodeGen_WebApplication_navigationBar _desc3;
_TSPcodeGen_WebApplication_styleSheet _desc4;
_TSPcodeGen_WebApplication_frames _desc5;
_TSPcodeGen_WebApplication_meta _desc6;
_TSPcodeGen_WebApplication_database _desc7;
_TSPcodeGen_WebApplication_roles _desc8;
_TSPcodeGen_WebApplication_linksExtern _desc9;
_TSPcodeGen_WebApplication_imagePath _desc10;
int _ATTERM_1;
};

struct _TPpcodeGen_WebApplication_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebApplication_frames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_WebApplication_frames _desc1;
};

struct _TPpcodeGen_WebApplication_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
PTGNode _AT_const35;
_TSPLST_codeGen_WebApplication_roles _desc1;
};

struct _TPpcodeGen_WebApplication_linksExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_WebApplication_linksExtern _desc1;
};

struct _TPpcodeGen_WebApplication_imagePath
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_RootWebZone
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MERootWebZonePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_RootWebZone_webTargets _desc1;
_TSPcodeGen_RootWebZone_errorLink _desc2;
_TSPcodeGen_RootWebZone_roles _desc3;
_TSPcodeGen_RootWebZone_setSize _desc4;
int _ATTERM_1;
};

struct _TPpcodeGen_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_RootWebZone_webTargets _desc1;
};

struct _TPpcodeGen_RootWebZone_errorLink
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_RootWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_RootWebZone_roles _desc1;
};

struct _TPpcodeGen_RootWebZone_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_SubWebZone
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESubWebZonePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_SubWebZone_name _desc1;
_TSPcodeGen_SubWebZone_webTargets _desc2;
_TSPcodeGen_SubWebZone_errorLink _desc3;
_TSPcodeGen_SubWebZone_globalparams _desc4;
_TSPcodeGen_SubWebZone_roles _desc5;
_TSPcodeGen_SubWebZone_setSize _desc6;
_TSPcodeGen_SubWebZone_position _desc7;
int _ATTERM_1;
};

struct _TPpcodeGen_SubWebZone_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_SubWebZone_webTargets _desc1;
};

struct _TPpcodeGen_SubWebZone_errorLink
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_SubWebZone_globalparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_SubWebZone_globalparams _desc1;
};

struct _TPpcodeGen_SubWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_SubWebZone_roles _desc1;
};

struct _TPpcodeGen_SubWebZone_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_SubWebZone_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebRole
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebRolePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_WebRole_name _desc1;
_TSPcodeGen_WebRole_color _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_WebRole_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebRole_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebRoleRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebRoleRefPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_WebRoleRef_role _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_WebRoleRef_role
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebPage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATfileName;
MEWebPagePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_WebPage_name _desc1;
_TSPcodeGen_WebPage_formalParameter _desc2;
_TSPcodeGen_WebPage_title _desc3;
_TSPcodeGen_WebPage_frame _desc4;
_TSPcodeGen_WebPage_styleSheetBlock _desc5;
_TSPcodeGen_WebPage_position _desc6;
int _ATTERM_1;
};

struct _TPpcodeGen_WebPage_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_WebPage_formalParameter _desc1;
};

struct _TPpcodeGen_WebPage_title
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebPage_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebPage_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_Frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFramePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_Frame_components _desc1;
_TSPcodeGen_Frame_styleSheetBlock _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_Frame_components _desc1;
};

struct _TPpcodeGen_Frame_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_GlobalFrame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATfileName;
MEGlobalFramePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_GlobalFrame_name _desc1;
_TSPcodeGen_GlobalFrame_components _desc2;
_TSPcodeGen_GlobalFrame_setSize _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_GlobalFrame_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_GlobalFrame_components _desc1;
};

struct _TPpcodeGen_GlobalFrame_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_NavigationBar
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarPtr _ATobjPtr;
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
_TSPcodeGen_NavigationBar_styleSheetBlock _desc1;
_TSPcodeGen_NavigationBar_elements _desc2;
_TSPcodeGen_NavigationBar_alignment _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_NavigationBar_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_NavigationBar_elements _desc1;
};

struct _TPpcodeGen_NavigationBar_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_NavigationBarElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
int _ATVPNumberedElement_number;
_TSPcodeGen_NavigationBarElement_target _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_NavigationBarElement_target
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FrameRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFrameRefPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_FrameRef_styleSheetBlock _desc1;
_TSPcodeGen_FrameRef_frame _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_FrameRef_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FrameRef_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_MetaInformation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_MetaInformation_name _desc1;
_TSPcodeGen_MetaInformation_elements _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_MetaInformation_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_MetaInformation_elements _desc1;
};

struct _TPpcodeGen_MetaInformationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_MetaInformationElement_property _desc1;
_TSPcodeGen_MetaInformationElement_value _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_MetaInformationElement_property
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_MetaInformationElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_OutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_OutputElement_link _desc1;
_TSPcodeGen_OutputElement_content _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_OutputElement_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_OutputElement_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ListOutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ListOutputElement_styleSheetBlock _desc1;
_TSPcodeGen_ListOutputElement_dataSourceActualParams _desc2;
_TSPcodeGen_ListOutputElement_dataSource _desc3;
_TSPcodeGen_ListOutputElement_maxNumberOfElements _desc4;
_TSPcodeGen_ListOutputElement_navigationElement _desc5;
int _ATTERM_1;
};

struct _TPpcodeGen_ListOutputElement_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_ListOutputElement_dataSourceActualParams _desc1;
};

struct _TPpcodeGen_ListOutputElement_dataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ListOutputElement_maxNumberOfElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ListOutputElement_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_StyleSheet
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_StyleSheet_name _desc1;
_TSPcodeGen_StyleSheet_custom _desc2;
_TSPcodeGen_StyleSheet_default _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_StyleSheet_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_StyleSheet_custom _desc1;
};

struct _TPpcodeGen_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_StyleSheet_default _desc1;
};

struct _TPpcodeGen_CustomStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomStyleSheetBlockPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_CustomStyleSheetBlock_pairs _desc1;
_TSPcodeGen_CustomStyleSheetBlock_name _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_CustomStyleSheetBlock_pairs _desc1;
};

struct _TPpcodeGen_CustomStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_StyleSheetPair
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPairPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_StyleSheetPair_category _desc1;
_TSPcodeGen_StyleSheetPair_attribute _desc2;
_TSPcodeGen_StyleSheetPair_valueCategory _desc3;
_TSPcodeGen_StyleSheetPair_value _desc4;
int _ATTERM_1;
};

struct _TPpcodeGen_StyleSheetPair_category
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_StyleSheetPair_attribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_StyleSheetPair_valueCategory
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_SizeValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESizeValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_SizeValue_measure _desc1;
_TSPcodeGen_SizeValue_value _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_SizeValue_measure
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_SizeValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ColorValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColorValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ColorValue_color _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_ColorValue_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_FamilyValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFamilyValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_FamilyValue_family _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_FamilyValue_family
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_StyleValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_StyleValue_style _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_StyleValue_style
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_HeadingValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_HeadingValue_heading _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_HeadingValue_heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_AlignmentValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEAlignmentValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_AlignmentValue_alignment _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_AlignmentValue_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ListValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ListValue_listed _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_ListValue_listed
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_CustomValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_CustomValue_value _desc1;
int _ATTERM_1;
};

struct _TPpcodeGen_CustomValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_HtmlStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHtmlStyleSheetBlockPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_HtmlStyleSheetBlock_pairs _desc1;
_TSPcodeGen_HtmlStyleSheetBlock_name _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_HtmlStyleSheetBlock_pairs _desc1;
};

struct _TPpcodeGen_HtmlStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ActionHandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEActionHandlerPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_ActionHandler_targetpage _desc1;
_TSPcodeGen_ActionHandler_params _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_ActionHandler_targetpage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_ActionHandler_params _desc1;
};

struct _TPpcodeGen_WebAction
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATfileName;
MEWebActionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_WebAction_name _desc1;
_TSPcodeGen_WebAction_formalParameter _desc2;
_TSPcodeGen_WebAction_successpage _desc3;
_TSPcodeGen_WebAction_operations _desc4;
_TSPcodeGen_WebAction_position _desc5;
int _ATTERM_1;
};

struct _TPpcodeGen_WebAction_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_WebAction_formalParameter _desc1;
};

struct _TPpcodeGen_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_WebAction_operations _desc1;
};

struct _TPpcodeGen_WebAction_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_PHPOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEPHPOperationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_PHPOperation_errorhandler _desc1;
_TSPcodeGen_PHPOperation_content _desc2;
int _ATTERM_1;
};

struct _TPpcodeGen_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_PHPOperation_errorhandler _desc1;
};

struct _TPpcodeGen_PHPOperation_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataBaseOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataBaseOperationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPcodeGen_DataBaseOperation_errorhandler _desc1;
_TSPcodeGen_DataBaseOperation_filter _desc2;
_TSPcodeGen_DataBaseOperation_params _desc3;
int _ATTERM_1;
};

struct _TPpcodeGen_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataBaseOperation_errorhandler _desc1;
};

struct _TPpcodeGen_DataBaseOperation_filter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpcodeGen_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_codeGen_DataBaseOperation_params _desc1;
};

struct _TPpVIEWROOT_dataBaseView
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataBase _desc1;
};

struct _TPpdataBaseView_DBColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDBColumnPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPdataBaseView_DBColumn_name _desc1;
_TSPdataBaseView_DBColumn_keyword1 _desc2;
_TSPdataBaseView_DBColumn_type _desc3;
int _ATTERM_1;
};

struct _TPpdataBaseView_DBColumn_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBColumn_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_dataBaseView_DBColumn_type _desc1;
};

struct _TPpdataBaseView_DataSourceFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceFormalParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPdataBaseView_DataSourceFormalParam_name _desc1;
_TSPdataBaseView_DataSourceFormalParam_keyword1 _desc2;
_TSPdataBaseView_DataSourceFormalParam_type _desc3;
int _ATTERM_1;
};

struct _TPpdataBaseView_DataSourceFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DataSourceFormalParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_dataBaseView_DataSourceFormalParam_type _desc1;
};

struct _TPpdataBaseView_ColumnProjection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColumnProjectionPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
_TSPdataBaseView_ColumnProjection_keyword1 _desc1;
_TSPdataBaseView_ColumnProjection_column _desc2;
int _ATTERM_1;
};

struct _TPpdataBaseView_ColumnProjection_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ColumnProjection_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ComputationProjection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEComputationProjectionPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
_TSPdataBaseView_ComputationProjection_computation _desc1;
_TSPdataBaseView_ComputationProjection_keyword1 _desc2;
_TSPdataBaseView_ComputationProjection_column _desc3;
_TSPdataBaseView_ComputationProjection_keyword2 _desc4;
int _ATTERM_1;
};

struct _TPpdataBaseView_ComputationProjection_computation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ComputationProjection_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ComputationProjection_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ComputationProjection_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_BinaryExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEBinaryExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_BinaryExpression_keyword1 _desc1;
_TSPdataBaseView_BinaryExpression_leftOperand _desc2;
_TSPdataBaseView_BinaryExpression_operator _desc3;
_TSPdataBaseView_BinaryExpression_rightOperand _desc4;
_TSPdataBaseView_BinaryExpression_keyword2 _desc5;
int _ATTERM_1;
};

struct _TPpdataBaseView_BinaryExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_dataBaseView_BinaryExpression_leftOperand _desc1;
};

struct _TPpdataBaseView_BinaryExpression_operator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_dataBaseView_BinaryExpression_rightOperand _desc1;
};

struct _TPpdataBaseView_BinaryExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_UnaryExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEUnaryExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_UnaryExpression_operator _desc1;
_TSPdataBaseView_UnaryExpression_operand _desc2;
int _ATTERM_1;
};

struct _TPpdataBaseView_UnaryExpression_operator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_dataBaseView_UnaryExpression_operand _desc1;
};

struct _TPpdataBaseView_ConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEConstantExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_ConstantExpression_keyword1 _desc1;
_TSPdataBaseView_ConstantExpression_value _desc2;
_TSPdataBaseView_ConstantExpression_keyword2 _desc3;
int _ATTERM_1;
};

struct _TPpdataBaseView_ConstantExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ConstantExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ColumnValueExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColumnValueExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_ColumnValueExpression_column _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_ColumnValueExpression_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ParameterValueExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParameterValueExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_ParameterValueExpression_parameter _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_ParameterValueExpression_parameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ComputationExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEComputationExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_ComputationExpression_computation _desc1;
_TSPdataBaseView_ComputationExpression_keyword1 _desc2;
_TSPdataBaseView_ComputationExpression_column _desc3;
_TSPdataBaseView_ComputationExpression_keyword2 _desc4;
int _ATTERM_1;
};

struct _TPpdataBaseView_ComputationExpression_computation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ComputationExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ComputationExpression_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_ComputationExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBString
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DBString_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_DBString_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBInteger
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DBInteger_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_DBInteger_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBFloat
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DBFloat_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_DBFloat_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBDouble
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DBDouble_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_DBDouble_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBBigInt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DBBigInt_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_DBBigInt_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBDate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DBDate_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_DBDate_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBTimeStamp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DBTimeStamp_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_DBTimeStamp_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBBoolean
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DBBoolean_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_DBBoolean_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DBBlob
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DBBlob_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpdataBaseView_DBBlob_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DataSourceValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPdataBaseView_DataSourceValue_column _desc1;
_TSPdataBaseView_DataSourceValue_keyword1 _desc2;
_TSPdataBaseView_DataSourceValue_expression _desc3;
int _ATTERM_1;
};

struct _TPpdataBaseView_DataSourceValue_column
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DataSourceValue_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_dataBaseView_DataSourceValue_expression _desc1;
};

struct _TPpdataBaseView_DataSourceProjectionFilter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceProjectionFilterPtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _ATiFullPosition;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLRegion _ATiActualRegion;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DataSourceProjectionFilter_name _desc1;
_TSPdataBaseView_DataSourceProjectionFilter_formalParameters _desc2;
_TSPdataBaseView_DataSourceProjectionFilter_projectionColumns _desc3;
_TSPdataBaseView_DataSourceProjectionFilter_condition _desc4;
_TSPdataBaseView_DataSourceProjectionFilter_connection _desc5;
int _ATTERM_1;
};

struct _TPpdataBaseView_DataSourceProjectionFilter_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TPpdataBaseView_DataSourceProjectionFilter_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_dataBaseView_DataSourceProjectionFilter_formalParameters _desc1;
};

struct _TPpdataBaseView_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_dataBaseView_DataSourceProjectionFilter_projectionColumns _desc1;
};

struct _TPpdataBaseView_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_dataBaseView_DataSourceProjectionFilter_condition _desc1;
};

struct _TPpdataBaseView_DataSourceProjectionFilter_from
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceProjectionFilter_sourceDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceProjectionFilter_connection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
_TSPdataBaseView_DataSourceProjectionFilter_from _desc1;
_TSPdataBaseView_DataSourceProjectionFilter_sourceDataSource _desc2;
};

struct _TPpdataBaseView_LimitDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELimitDataSourcePtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _ATiFullPosition;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLRegion _ATiActualRegion;
VLObjectPointer _ATobjId;
_TSPdataBaseView_LimitDataSource_name _desc1;
_TSPdataBaseView_LimitDataSource_formalParameters _desc2;
_TSPdataBaseView_LimitDataSource_condition _desc3;
_TSPdataBaseView_LimitDataSource_connection _desc4;
int _ATTERM_1;
};

struct _TPpdataBaseView_LimitDataSource_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TPpdataBaseView_LimitDataSource_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_dataBaseView_LimitDataSource_formalParameters _desc1;
};

struct _TPpdataBaseView_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_dataBaseView_LimitDataSource_minRow _desc1;
};

struct _TPpdataBaseView_LimitDataSource_dots
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpdataBaseView_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_dataBaseView_LimitDataSource_maxRow _desc1;
};

struct _TPpdataBaseView_LimitDataSource_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPdataBaseView_LimitDataSource_minRow _desc1;
_TSPdataBaseView_LimitDataSource_dots _desc2;
_TSPdataBaseView_LimitDataSource_maxRow _desc3;
};

struct _TPpdataBaseView_LimitDataSource_from
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_LimitDataSource_sourceDataSouce
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_LimitDataSource_connection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
_TSPdataBaseView_LimitDataSource_from _desc1;
_TSPdataBaseView_LimitDataSource_sourceDataSouce _desc2;
};

struct _TPpdataBaseView_DataSourceJoin
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceJoinPtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLObjectPointer _ATpers_columnRef1;
VLObjectPointer _ATpers_columnRef2;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _ATiFullPosition;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLRegion _ATiActualRegion;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DataSourceJoin_name _desc1;
_TSPdataBaseView_DataSourceJoin_joinOperator _desc2;
_TSPdataBaseView_DataSourceJoin_connection1 _desc3;
_TSPdataBaseView_DataSourceJoin_connection2 _desc4;
int _ATTERM_1;
};

struct _TPpdataBaseView_DataSourceJoin_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TPpdataBaseView_DataSourceJoin_joinOperator
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPpdataBaseView_DataSourceJoin_from1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceJoin_dataSource1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceJoin_connection1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
_TSPdataBaseView_DataSourceJoin_from1 _desc1;
_TSPdataBaseView_DataSourceJoin_dataSource1 _desc2;
};

struct _TPpdataBaseView_DataSourceJoin_from2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceJoin_dataSource2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceJoin_connection2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
_TSPdataBaseView_DataSourceJoin_from2 _desc1;
_TSPdataBaseView_DataSourceJoin_dataSource2 _desc2;
};

struct _TPpdataBaseView_DataSourceInsert
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceInsertPtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DataSourceInsert_name _desc1;
_TSPdataBaseView_DataSourceInsert_formalParams _desc2;
_TSPdataBaseView_DataSourceInsert_values _desc3;
_TSPdataBaseView_DataSourceInsert_connection _desc4;
int _ATTERM_1;
};

struct _TPpdataBaseView_DataSourceInsert_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TPpdataBaseView_DataSourceInsert_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
int _ATelementDistance;
VLList _ATseparatorStyle;
int _ATflip;
int _ATactualWidth;
int _ATVPSpaceDistrib_pad;
VLPoint _ATiPreferedSize;
_TSPLST_dataBaseView_DataSourceInsert_formalParams _desc1;
};

struct _TPpdataBaseView_DataSourceInsert_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_dataBaseView_DataSourceInsert_values _desc1;
};

struct _TPpdataBaseView_DataSourceInsert_from
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceInsert_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceInsert_connection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
_TSPdataBaseView_DataSourceInsert_from _desc1;
_TSPdataBaseView_DataSourceInsert_targetDataSource _desc2;
};

struct _TPpdataBaseView_DataSourceUpdate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceUpdatePtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DataSourceUpdate_name _desc1;
_TSPdataBaseView_DataSourceUpdate_formalParams _desc2;
_TSPdataBaseView_DataSourceUpdate_values _desc3;
_TSPdataBaseView_DataSourceUpdate_conditions _desc4;
_TSPdataBaseView_DataSourceUpdate_connection _desc5;
int _ATTERM_1;
};

struct _TPpdataBaseView_DataSourceUpdate_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TPpdataBaseView_DataSourceUpdate_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
int _ATelementDistance;
VLList _ATseparatorStyle;
int _ATflip;
int _ATactualWidth;
int _ATVPSpaceDistrib_pad;
VLPoint _ATiPreferedSize;
_TSPLST_dataBaseView_DataSourceUpdate_formalParams _desc1;
};

struct _TPpdataBaseView_DataSourceUpdate_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_dataBaseView_DataSourceUpdate_values _desc1;
};

struct _TPpdataBaseView_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_dataBaseView_DataSourceUpdate_conditions _desc1;
};

struct _TPpdataBaseView_DataSourceUpdate_from
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceUpdate_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceUpdate_connection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
_TSPdataBaseView_DataSourceUpdate_from _desc1;
_TSPdataBaseView_DataSourceUpdate_targetDataSource _desc2;
};

struct _TPpdataBaseView_DataSourceDelete
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceDeletePtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DataSourceDelete_name _desc1;
_TSPdataBaseView_DataSourceDelete_formalParams _desc2;
_TSPdataBaseView_DataSourceDelete_conditions _desc3;
_TSPdataBaseView_DataSourceDelete_connection _desc4;
int _ATTERM_1;
};

struct _TPpdataBaseView_DataSourceDelete_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TPpdataBaseView_DataSourceDelete_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
int _ATelementDistance;
VLList _ATseparatorStyle;
int _ATflip;
int _ATactualWidth;
int _ATVPSpaceDistrib_pad;
VLPoint _ATiPreferedSize;
_TSPLST_dataBaseView_DataSourceDelete_formalParams _desc1;
};

struct _TPpdataBaseView_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_dataBaseView_DataSourceDelete_conditions _desc1;
};

struct _TPpdataBaseView_DataSourceDelete_from
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceDelete_targetDataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceDelete_connection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATdefaultPosition;
VLPoint _ATlineFrom;
VLPoint _ATlineTo;
_TSPdataBaseView_DataSourceDelete_from _desc1;
_TSPdataBaseView_DataSourceDelete_targetDataSource _desc2;
};

struct _TPpdataBaseView_DataSourceDB
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceDBPtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLRegionPtr _ATregionPtr;
VLPoint _ATrelPosition;
VLPoint _ATpad;
VLPoint _AToPreferedSize;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLRegion _ATrefConnectionFrom;
VLObjectPointer _ATobjId;
_TSPdataBaseView_DataSourceDB_name _desc1;
_TSPdataBaseView_DataSourceDB_position _desc2;
_TSPdataBaseView_DataSourceDB_columns _desc3;
int _ATTERM_1;
};

struct _TPpdataBaseView_DataSourceDB_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
};

struct _TPpdataBaseView_DataSourceDB_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataSourceDB_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_dataBaseView_DataSourceDB_columns _desc1;
};

struct _TPpdataBaseView_DataBase
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtitle;
MEDataBasePtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLRegion _ATconnectionRegion;
_TSPdataBaseView_DataBase_name _desc1;
_TSPdataBaseView_DataBase_userName _desc2;
_TSPdataBaseView_DataBase_userPassword _desc3;
_TSPdataBaseView_DataBase_hostName _desc4;
_TSPdataBaseView_DataBase_port _desc5;
_TSPdataBaseView_DataBase_dataBaseType _desc6;
_TSPdataBaseView_DataBase_dataSources _desc7;
_TSPdataBaseView_DataBase_dataSourceModifications _desc8;
_TSPdataBaseView_DataBase_setSize _desc9;
_TSPdataBaseView_DataBase_modifySetSize _desc10;
int _ATTERM_1;
};

struct _TPpdataBaseView_DataBase_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataBase_userName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataBase_userPassword
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataBase_hostName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataBase_port
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataBase_dataBaseType
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPosition;
NonOverlappingSolverPtr _ATnonOverlappingSolver;
_TSPLST_dataBaseView_DataBase_dataSources _desc1;
};

struct _TPpdataBaseView_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPosition;
NonOverlappingSolverPtr _ATnonOverlappingSolver;
_TSPLST_dataBaseView_DataBase_dataSourceModifications _desc1;
};

struct _TPpdataBaseView_DataBase_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpdataBaseView_DataBase_modifySetSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpVIEWROOT_fcDlg
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPfcDlg_FormularCondition _desc1;
};

struct _TPpfcDlg_FormularCondition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
int _ATlabelWidth;
_TSPfcDlg_FormularCondition_condition _desc1;
_TSPfcDlg_FormularCondition_params _desc2;
int _ATTERM_1;
};

struct _TPpfcDlg_FormularCondition_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpfcDlg_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_fcDlg_FormularCondition_params _desc1;
};

struct _TPpfcDlg_FormularConditionActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPfcDlg_FormularConditionActualParam_value _desc1;
_TSPfcDlg_FormularConditionActualParam_formalparam _desc2;
int _ATTERM_1;
};

struct _TPpfcDlg_FormularConditionActualParam_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TPpfcDlg_FormularConditionActualParam_formalparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpVIEWROOT_globalFrameView
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_GlobalFrame _desc1;
};

struct _TPpglobalFrameView_FormularCheckboxElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularCheckboxElementPtr _ATobjPtr;
VLString _ATpers_name;
VLBoolean _ATpers_checked;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_FormularCheckboxElement_label _desc1;
_TSPglobalFrameView_FormularCheckboxElement_type _desc2;
_TSPglobalFrameView_FormularCheckboxElement_condition _desc3;
_TSPglobalFrameView_FormularCheckboxElement_description _desc4;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularCheckboxElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularCheckboxElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPpglobalFrameView_FormularCheckboxElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
_TSPglobalFrameView_FormularCheckboxElement_name _desc1;
};

struct _TPpglobalFrameView_FormularCheckboxElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularTextElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_FormularTextElement_label _desc1;
_TSPglobalFrameView_FormularTextElement_type _desc2;
_TSPglobalFrameView_FormularTextElement_condition _desc3;
_TSPglobalFrameView_FormularTextElement_description _desc4;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularTextElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularTextElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TPpglobalFrameView_FormularTextElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularPasswordElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPasswordElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_FormularPasswordElement_label _desc1;
_TSPglobalFrameView_FormularPasswordElement_type _desc2;
_TSPglobalFrameView_FormularPasswordElement_condition _desc3;
_TSPglobalFrameView_FormularPasswordElement_description _desc4;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularPasswordElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularPasswordElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TPpglobalFrameView_FormularPasswordElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularTextAreaElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextAreaElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_FormularTextAreaElement_label _desc1;
_TSPglobalFrameView_FormularTextAreaElement_type _desc2;
_TSPglobalFrameView_FormularTextAreaElement_condition _desc3;
_TSPglobalFrameView_FormularTextAreaElement_description _desc4;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularTextAreaElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularTextAreaElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TPpglobalFrameView_FormularTextAreaElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularSelectElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_reqLengthChain_pre;
MEFormularSelectElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_FormularSelectElement_label _desc1;
_TSPglobalFrameView_FormularSelectElement_multiple _desc2;
_TSPglobalFrameView_FormularSelectElement_options _desc3;
_TSPglobalFrameView_FormularSelectElement_description _desc4;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularSelectElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularSelectElement_multiple
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATcellName;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
};

struct _TPpglobalFrameView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPContainer_showInsertionPoint;
_TSPLST_globalFrameView_FormularSelectElement_options _desc1;
};

struct _TPpglobalFrameView_FormularSelectElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularRadioElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_FormularRadioElement_type _desc1;
_TSPglobalFrameView_FormularRadioElement_label _desc2;
_TSPglobalFrameView_FormularRadioElement_name _desc3;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularRadioElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FormularRadioElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FormularRadioElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPpglobalFrameView_DataSourceActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedList_numberChain_post;
int _ATVPSpaceDistrib_reqLengthChain_post;
MEDataSourceActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_DataSourceActualParam_formalParam _desc1;
_TSPglobalFrameView_DataSourceActualParam_keyword1 _desc2;
_TSPglobalFrameView_DataSourceActualParam_expressions _desc3;
int _ATTERM_1;
};

struct _TPpglobalFrameView_DataSourceActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpglobalFrameView_DataSourceActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpglobalFrameView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_globalFrameView_DataSourceActualParam_expressions _desc1;
};

struct _TPpglobalFrameView_WebNodeActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_WebNodeActualParam_formalParam _desc1;
_TSPglobalFrameView_WebNodeActualParam_keyword1 _desc2;
_TSPglobalFrameView_WebNodeActualParam_expressions _desc3;
int _ATTERM_1;
};

struct _TPpglobalFrameView_WebNodeActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpglobalFrameView_WebNodeActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpglobalFrameView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_globalFrameView_WebNodeActualParam_expressions _desc1;
};

struct _TPpglobalFrameView_WebNodeConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeConstantExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_WebNodeConstantExpression_keyword1 _desc1;
_TSPglobalFrameView_WebNodeConstantExpression_value _desc2;
_TSPglobalFrameView_WebNodeConstantExpression_keyword2 _desc3;
int _ATTERM_1;
};

struct _TPpglobalFrameView_WebNodeConstantExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpglobalFrameView_WebNodeConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpglobalFrameView_WebNodeConstantExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpglobalFrameView_WebNodeVariableExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeVariableExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_WebNodeVariableExpression_content _desc1;
int _ATTERM_1;
};

struct _TPpglobalFrameView_WebNodeVariableExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpglobalFrameView_WebNodeColumnExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeColumnExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_WebNodeColumnExpression_content _desc1;
int _ATTERM_1;
};

struct _TPpglobalFrameView_WebNodeColumnExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpglobalFrameView_Formular
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_Formular_styleSheetBlock _desc1;
_TSPglobalFrameView_Formular_action _desc2;
_TSPglobalFrameView_Formular_elements _desc3;
_TSPglobalFrameView_Formular_datasource _desc4;
_TSPglobalFrameView_Formular_actualParams _desc5;
int _ATTERM_1;
};

struct _TPpglobalFrameView_Formular_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_Formular_action
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATobjId;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPpglobalFrameView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
VLHashtablePtr _ATabsPos;
VLHashtablePtr _ATcellWidth;
int _ATpreferedWidth;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_globalFrameView_Formular_elements _desc1;
};

struct _TPpglobalFrameView_Formular_datasource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_globalFrameView_Formular_actualParams _desc1;
};

struct _TPpglobalFrameView_FormularRadioGroupElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioGroupElementPtr _ATobjPtr;
VLString _ATpers_name;
VLObjectPointer _ATpers_checked;
int _ATVPSpaceDistribElement_required;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_realPad;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_provided;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_FormularRadioGroupElement_name _desc1;
_TSPglobalFrameView_FormularRadioGroupElement_label _desc2;
_TSPglobalFrameView_FormularRadioGroupElement_description _desc3;
_TSPglobalFrameView_FormularRadioGroupElement_pvalue _desc4;
_TSPglobalFrameView_FormularRadioGroupElement_condition _desc5;
_TSPglobalFrameView_FormularRadioGroupElement_elements _desc6;
_TSPglobalFrameView_FormularRadioGroupElement_checked _desc7;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularRadioGroupElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FormularRadioGroupElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularRadioGroupElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpglobalFrameView_FormularRadioGroupElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
_TSPLST_globalFrameView_FormularRadioGroupElement_elements _desc1;
};

struct _TPpglobalFrameView_FormularRadioGroupElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FormularConstantSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConstantSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
_TSPglobalFrameView_FormularConstantSelectOption_values _desc1;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularConstantSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FormularDataSourceSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedList_numberChain_pre;
MEFormularDataSourceSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
_TSPglobalFrameView_FormularDataSourceSelectOption_values _desc1;
_TSPglobalFrameView_FormularDataSourceSelectOption_params _desc2;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularDataSourceSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_globalFrameView_FormularDataSourceSelectOption_params _desc1;
};

struct _TPpglobalFrameView_FormularPHPScriptSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPHPScriptSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
_TSPglobalFrameView_FormularPHPScriptSelectOption_script _desc1;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularPHPScriptSelectOption_script
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FormularCondition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
_TSPglobalFrameView_FormularCondition_condition _desc1;
_TSPglobalFrameView_FormularCondition_params _desc2;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularCondition_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_globalFrameView_FormularCondition_params _desc1;
};

struct _TPpglobalFrameView_FormularConditionActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_FormularConditionActualParam_value _desc1;
_TSPglobalFrameView_FormularConditionActualParam_formalparam _desc2;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FormularConditionActualParam_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FormularConditionActualParam_formalparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_Paragraph
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParagraphPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_Paragraph_styleSheetBlock _desc1;
_TSPglobalFrameView_Paragraph_fragments _desc2;
int _ATTERM_1;
};

struct _TPpglobalFrameView_Paragraph_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_globalFrameView_Paragraph_fragments _desc1;
};

struct _TPpglobalFrameView_TextFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATfont;
VLString _ATcolor;
METextFragmentPtr _ATobjPtr;
VLObjectPointer _ATpers_link;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_TextFragment_link _desc1;
_TSPglobalFrameView_TextFragment_value _desc2;
int _ATTERM_1;
};

struct _TPpglobalFrameView_TextFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_TextFragment_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPpglobalFrameView_ImageFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEImageFragmentPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_ImageFragment_link _desc1;
_TSPglobalFrameView_ImageFragment_width _desc2;
_TSPglobalFrameView_ImageFragment_height _desc3;
_TSPglobalFrameView_ImageFragment_text _desc4;
_TSPglobalFrameView_ImageFragment_imageName _desc5;
int _ATTERM_1;
};

struct _TPpglobalFrameView_ImageFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_ImageFragment_width
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_ImageFragment_height
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_ImageFragment_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_ImageFragment_imageName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_Heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATfont;
MEHeadingPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_Heading_styleSheetBlock _desc1;
_TSPglobalFrameView_Heading_text _desc2;
_TSPglobalFrameView_Heading_level _desc3;
int _ATTERM_1;
};

struct _TPpglobalFrameView_Heading_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_Heading_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPpglobalFrameView_Heading_level
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_Table
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METablePtr _ATobjPtr;
VLPoint _ATpad;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
int _ATposY;
int _ATposX;
int _ATprovSizeY;
int _ATprovSizeX;
VLList _ATcellBorderAttrs;
VLPoint _ATminCellSize;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_Table_styleSheetBlock _desc1;
_TSPglobalFrameView_Table_rows _desc2;
_TSPglobalFrameView_Table_columns _desc3;
int _ATTERM_1;
};

struct _TPpglobalFrameView_Table_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
_TSPLST_globalFrameView_Table_rows _desc1;
};

struct _TPpglobalFrameView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
_TSPLST_globalFrameView_Table_columns _desc1;
};

struct _TPpglobalFrameView_TableRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableRowPtr _ATobjPtr;
VLObjectPointer _ATobjId;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
int _ATposY;
int _ATprovSizeY;
_TSPglobalFrameView_TableRow_cells _desc1;
int _ATTERM_1;
};

struct _TPpglobalFrameView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_globalFrameView_TableRow_cells _desc1;
};

struct _TPpglobalFrameView_TableColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
int _ATTERM_1;
};

struct _TPpglobalFrameView_TableCell
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableCellPtr _ATobjPtr;
VLObjectPointer _ATobjId;
DefTableKey _ATcolumnKey;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
_TSPglobalFrameView_TableCell_columnRef _desc1;
_TSPglobalFrameView_TableCell_content _desc2;
int _ATTERM_1;
};

struct _TPpglobalFrameView_TableCell_columnRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
};

struct _TPpglobalFrameView_Frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFramePtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
_TSPglobalFrameView_Frame_components _desc1;
_TSPglobalFrameView_Frame_styleSheetBlock _desc2;
int _ATTERM_1;
};

struct _TPpglobalFrameView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_globalFrameView_Frame_components _desc1;
};

struct _TPpglobalFrameView_Frame_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_GlobalFrame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEGlobalFramePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPglobalFrameView_GlobalFrame_name _desc1;
_TSPglobalFrameView_GlobalFrame_components _desc2;
_TSPglobalFrameView_GlobalFrame_setSize _desc3;
int _ATTERM_1;
};

struct _TPpglobalFrameView_GlobalFrame_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
_TSPLST_globalFrameView_GlobalFrame_components _desc1;
};

struct _TPpglobalFrameView_GlobalFrame_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FrameRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFrameRefPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_FrameRef_styleSheetBlock _desc1;
_TSPglobalFrameView_FrameRef_frame _desc2;
int _ATTERM_1;
};

struct _TPpglobalFrameView_FrameRef_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_FrameRef_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATobjId;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPpglobalFrameView_OutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_OutputElement_link _desc1;
_TSPglobalFrameView_OutputElement_content _desc2;
int _ATTERM_1;
};

struct _TPpglobalFrameView_OutputElement_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_OutputElement_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATobjId;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPpglobalFrameView_ListOutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
_TSPglobalFrameView_ListOutputElement_styleSheetBlock _desc1;
_TSPglobalFrameView_ListOutputElement_dataSourceActualParams _desc2;
_TSPglobalFrameView_ListOutputElement_dataSource _desc3;
_TSPglobalFrameView_ListOutputElement_maxNumberOfElements _desc4;
_TSPglobalFrameView_ListOutputElement_navigationElement _desc5;
int _ATTERM_1;
};

struct _TPpglobalFrameView_ListOutputElement_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_globalFrameView_ListOutputElement_dataSourceActualParams _desc1;
};

struct _TPpglobalFrameView_ListOutputElement_dataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_ListOutputElement_maxNumberOfElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpglobalFrameView_ListOutputElement_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpVIEWROOT_metaInformation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPmetaInformation_MetaInformation _desc1;
};

struct _TPpmetaInformation_MetaInformation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPmetaInformation_MetaInformation_keyword1 _desc1;
_TSPmetaInformation_MetaInformation_keyword2 _desc2;
_TSPmetaInformation_MetaInformation_keyword3 _desc3;
_TSPmetaInformation_MetaInformation_elements _desc4;
_TSPmetaInformation_MetaInformation_keyword4 _desc5;
int _ATTERM_1;
};

struct _TPpmetaInformation_MetaInformation_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpmetaInformation_MetaInformation_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpmetaInformation_MetaInformation_keyword3
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpmetaInformation_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLList _ATseparatorList;
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
_TSPLST_metaInformation_MetaInformation_elements _desc1;
};

struct _TPpmetaInformation_MetaInformation_keyword4
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpmetaInformation_MetaInformationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
int _ATVPNumberedElement_number;
int _ATVPNumberedElement_isLast;
_TSPmetaInformation_MetaInformationElement_property _desc1;
_TSPmetaInformation_MetaInformationElement_keyword1 _desc2;
_TSPmetaInformation_MetaInformationElement_value _desc3;
_TSPmetaInformation_MetaInformationElement_keyword2 _desc4;
int _ATTERM_1;
};

struct _TPpmetaInformation_MetaInformationElement_property
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpmetaInformation_MetaInformationElement_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpmetaInformation_MetaInformationElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpmetaInformation_MetaInformationElement_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpVIEWROOT_navigationBarView
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPnavigationBarView_NavigationBar _desc1;
};

struct _TPpnavigationBarView_NavigationBar
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarPtr _ATobjPtr;
VLString _ATpers_alignment;
VLObjectPointer _ATobjId;
_TSPnavigationBarView_NavigationBar_styleSheetBlock _desc1;
_TSPnavigationBarView_NavigationBar_elements _desc2;
_TSPnavigationBarView_NavigationBar_alignment _desc3;
int _ATTERM_1;
};

struct _TPpnavigationBarView_NavigationBar_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpnavigationBarView_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
_TSPLST_navigationBarView_NavigationBar_elements _desc1;
};

struct _TPpnavigationBarView_NavigationBar_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpnavigationBarView_NavigationBarElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarElementPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPnavigationBarView_NavigationBarElement_target _desc1;
int _ATTERM_1;
};

struct _TPpnavigationBarView_NavigationBarElement_target
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TPpVIEWROOT_rootView
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Root _desc1;
};

struct _TPprootView_WebNodeFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeFormalParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
_TSProotView_WebNodeFormalParam_name _desc1;
_TSProotView_WebNodeFormalParam_keyword1 _desc2;
_TSProotView_WebNodeFormalParam_type _desc3;
int _ATTERM_1;
};

struct _TPprootView_WebNodeFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPprootView_WebNodeFormalParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPprootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_rootView_WebNodeFormalParam_type _desc1;
};

struct _TPprootView_DataBase
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataBasePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPprootView_DBString
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSProotView_DBString_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPprootView_DBString_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPprootView_DBInteger
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSProotView_DBInteger_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPprootView_DBInteger_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPprootView_DBFloat
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSProotView_DBFloat_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPprootView_DBFloat_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPprootView_DBDouble
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSProotView_DBDouble_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPprootView_DBDouble_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPprootView_DBBigInt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSProotView_DBBigInt_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPprootView_DBBigInt_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPprootView_DBDate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSProotView_DBDate_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPprootView_DBDate_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPprootView_DBTimeStamp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSProotView_DBTimeStamp_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPprootView_DBTimeStamp_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPprootView_DBBoolean
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSProotView_DBBoolean_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPprootView_DBBoolean_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPprootView_DBBlob
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSProotView_DBBlob_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPprootView_DBBlob_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPprootView_DataSourceActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_DataSourceActualParam_formalParam _desc1;
_TSProotView_DataSourceActualParam_expressions _desc2;
int _ATTERM_1;
};

struct _TPprootView_DataSourceActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_DataSourceActualParam_expressions _desc1;
};

struct _TPprootView_Formular
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_Formular_styleSheetBlock _desc1;
_TSProotView_Formular_action _desc2;
_TSProotView_Formular_elements _desc3;
_TSProotView_Formular_datasource _desc4;
_TSProotView_Formular_actualParams _desc5;
int _ATTERM_1;
};

struct _TPprootView_Formular_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Formular_action
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_Formular_elements _desc1;
};

struct _TPprootView_Formular_datasource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_Formular_actualParams _desc1;
};

struct _TPprootView_FormularRadioGroupElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioGroupElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularRadioGroupElement_name _desc1;
_TSProotView_FormularRadioGroupElement_label _desc2;
_TSProotView_FormularRadioGroupElement_description _desc3;
_TSProotView_FormularRadioGroupElement_pvalue _desc4;
_TSProotView_FormularRadioGroupElement_condition _desc5;
_TSProotView_FormularRadioGroupElement_elements _desc6;
_TSProotView_FormularRadioGroupElement_checked _desc7;
int _ATTERM_1;
};

struct _TPprootView_FormularRadioGroupElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularRadioGroupElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularRadioGroupElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularRadioGroupElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_FormularRadioGroupElement_elements _desc1;
};

struct _TPprootView_FormularRadioGroupElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularTextElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularTextElement_name _desc1;
_TSProotView_FormularTextElement_label _desc2;
_TSProotView_FormularTextElement_description _desc3;
_TSProotView_FormularTextElement_pvalue _desc4;
_TSProotView_FormularTextElement_condition _desc5;
int _ATTERM_1;
};

struct _TPprootView_FormularTextElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularTextElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularTextElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularTextElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularTextAreaElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextAreaElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularTextAreaElement_name _desc1;
_TSProotView_FormularTextAreaElement_label _desc2;
_TSProotView_FormularTextAreaElement_description _desc3;
_TSProotView_FormularTextAreaElement_pvalue _desc4;
_TSProotView_FormularTextAreaElement_condition _desc5;
int _ATTERM_1;
};

struct _TPprootView_FormularTextAreaElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularTextAreaElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularTextAreaElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularTextAreaElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularPasswordElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPasswordElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularPasswordElement_name _desc1;
_TSProotView_FormularPasswordElement_label _desc2;
_TSProotView_FormularPasswordElement_description _desc3;
_TSProotView_FormularPasswordElement_pvalue _desc4;
_TSProotView_FormularPasswordElement_condition _desc5;
int _ATTERM_1;
};

struct _TPprootView_FormularPasswordElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularPasswordElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularPasswordElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularPasswordElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularCheckboxElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularCheckboxElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularCheckboxElement_name _desc1;
_TSProotView_FormularCheckboxElement_label _desc2;
_TSProotView_FormularCheckboxElement_description _desc3;
_TSProotView_FormularCheckboxElement_pvalue _desc4;
_TSProotView_FormularCheckboxElement_condition _desc5;
_TSProotView_FormularCheckboxElement_value _desc6;
_TSProotView_FormularCheckboxElement_checked _desc7;
int _ATTERM_1;
};

struct _TPprootView_FormularCheckboxElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularCheckboxElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularCheckboxElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularCheckboxElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularCheckboxElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularCheckboxElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularSelectElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularSelectElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularSelectElement_name _desc1;
_TSProotView_FormularSelectElement_label _desc2;
_TSProotView_FormularSelectElement_description _desc3;
_TSProotView_FormularSelectElement_pvalue _desc4;
_TSProotView_FormularSelectElement_condition _desc5;
_TSProotView_FormularSelectElement_options _desc6;
_TSProotView_FormularSelectElement_size _desc7;
_TSProotView_FormularSelectElement_multiple _desc8;
int _ATTERM_1;
};

struct _TPprootView_FormularSelectElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularSelectElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularSelectElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularSelectElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_FormularSelectElement_options _desc1;
};

struct _TPprootView_FormularSelectElement_size
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularSelectElement_multiple
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularConstantSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConstantSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularConstantSelectOption_values _desc1;
int _ATTERM_1;
};

struct _TPprootView_FormularConstantSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularDataSourceSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularDataSourceSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularDataSourceSelectOption_values _desc1;
_TSProotView_FormularDataSourceSelectOption_params _desc2;
int _ATTERM_1;
};

struct _TPprootView_FormularDataSourceSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_FormularDataSourceSelectOption_params _desc1;
};

struct _TPprootView_FormularPHPScriptSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPHPScriptSelectOptionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularPHPScriptSelectOption_script _desc1;
int _ATTERM_1;
};

struct _TPprootView_FormularPHPScriptSelectOption_script
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularRadioElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularRadioElement_value _desc1;
_TSProotView_FormularRadioElement_label _desc2;
_TSProotView_FormularRadioElement_name _desc3;
int _ATTERM_1;
};

struct _TPprootView_FormularRadioElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularRadioElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularRadioElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularCondition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularCondition_condition _desc1;
_TSProotView_FormularCondition_params _desc2;
int _ATTERM_1;
};

struct _TPprootView_FormularCondition_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_FormularCondition_params _desc1;
};

struct _TPprootView_FormularConditionDefinition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionDefinitionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularConditionDefinition_name _desc1;
_TSProotView_FormularConditionDefinition_params _desc2;
_TSProotView_FormularConditionDefinition_body _desc3;
int _ATTERM_1;
};

struct _TPprootView_FormularConditionDefinition_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularConditionDefinition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_FormularConditionDefinition_params _desc1;
};

struct _TPprootView_FormularConditionDefinition_body
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularConditionFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionFormalParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularConditionFormalParam_name _desc1;
int _ATTERM_1;
};

struct _TPprootView_FormularConditionFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularConditionActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FormularConditionActualParam_value _desc1;
_TSProotView_FormularConditionActualParam_formalparam _desc2;
int _ATTERM_1;
};

struct _TPprootView_FormularConditionActualParam_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FormularConditionActualParam_formalparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_WebNodeActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_WebNodeActualParam_formalParam _desc1;
_TSProotView_WebNodeActualParam_expressions _desc2;
int _ATTERM_1;
};

struct _TPprootView_WebNodeActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_WebNodeActualParam_expressions _desc1;
};

struct _TPprootView_WebNodeConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeConstantExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_WebNodeConstantExpression_value _desc1;
int _ATTERM_1;
};

struct _TPprootView_WebNodeConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_WebNodeVariableExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeVariableExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_WebNodeVariableExpression_content _desc1;
int _ATTERM_1;
};

struct _TPprootView_WebNodeVariableExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_WebNodeColumnExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeColumnExpressionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_WebNodeColumnExpression_content _desc1;
int _ATTERM_1;
};

struct _TPprootView_WebNodeColumnExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Paragraph
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParagraphPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_Paragraph_styleSheetBlock _desc1;
_TSProotView_Paragraph_fragments _desc2;
int _ATTERM_1;
};

struct _TPprootView_Paragraph_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_Paragraph_fragments _desc1;
};

struct _TPprootView_TextFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METextFragmentPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_TextFragment_link _desc1;
_TSProotView_TextFragment_value _desc2;
int _ATTERM_1;
};

struct _TPprootView_TextFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_TextFragment_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ImageFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEImageFragmentPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_ImageFragment_link _desc1;
_TSProotView_ImageFragment_width _desc2;
_TSProotView_ImageFragment_height _desc3;
_TSProotView_ImageFragment_text _desc4;
_TSProotView_ImageFragment_imageName _desc5;
int _ATTERM_1;
};

struct _TPprootView_ImageFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ImageFragment_width
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ImageFragment_height
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ImageFragment_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ImageFragment_imageName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_Heading_styleSheetBlock _desc1;
_TSProotView_Heading_text _desc2;
_TSProotView_Heading_level _desc3;
int _ATTERM_1;
};

struct _TPprootView_Heading_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Heading_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Heading_level
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Table
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METablePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_Table_styleSheetBlock _desc1;
_TSProotView_Table_rows _desc2;
_TSProotView_Table_columns _desc3;
int _ATTERM_1;
};

struct _TPprootView_Table_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_Table_rows _desc1;
};

struct _TPprootView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_Table_columns _desc1;
};

struct _TPprootView_TableRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableRowPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_TableRow_cells _desc1;
int _ATTERM_1;
};

struct _TPprootView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_TableRow_cells _desc1;
};

struct _TPprootView_TableColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPprootView_TableCell
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableCellPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_TableCell_columnRef _desc1;
_TSProotView_TableCell_content _desc2;
int _ATTERM_1;
};

struct _TPprootView_TableCell_columnRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_LinkTargetExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELinkTargetExternPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSProotView_LinkTargetExtern_name _desc1;
_TSProotView_LinkTargetExtern_url _desc2;
int _ATTERM_1;
};

struct _TPprootView_LinkTargetExtern_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPprootView_LinkTargetExtern_url
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPprootView_Root
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MERootPtr _ATobjPtr;
VLRegion _ATiActualRegion;
VLObjectPointer _ATobjId;
_TSProotView_Root_webApp _desc1;
_TSProotView_Root_library _desc2;
int _ATTERM_1;
};

struct _TPprootView_Root_library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_Root_library _desc1;
};

struct _TPprootView_Library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MELibraryPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_Library_name _desc1;
_TSProotView_Library_formularconditions _desc2;
_TSProotView_Library_navigationElement _desc3;
int _ATTERM_1;
};

struct _TPprootView_Library_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Library_formularconditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_Library_formularconditions _desc1;
};

struct _TPprootView_Library_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_Library_navigationElement _desc1;
};

struct _TPprootView_NavigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_NavigationElement_code _desc1;
_TSProotView_NavigationElement_name _desc2;
int _ATTERM_1;
};

struct _TPprootView_NavigationElement_code
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_NavigationElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_WebApplication
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebApplicationPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
_TSProotView_WebApplication_name _desc1;
_TSProotView_WebApplication_webZone _desc2;
_TSProotView_WebApplication_navigationBar _desc3;
_TSProotView_WebApplication_styleSheet _desc4;
_TSProotView_WebApplication_frames _desc5;
_TSProotView_WebApplication_meta _desc6;
_TSProotView_WebApplication_database _desc7;
_TSProotView_WebApplication_roles _desc8;
_TSProotView_WebApplication_linksExtern _desc9;
_TSProotView_WebApplication_imagePath _desc10;
int _ATTERM_1;
};

struct _TPprootView_WebApplication_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPprootView_WebApplication_frames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_rootView_WebApplication_frames _desc1;
};

struct _TPprootView_WebApplication_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_rootView_WebApplication_roles _desc1;
};

struct _TPprootView_WebApplication_linksExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_rootView_WebApplication_linksExtern _desc1;
};

struct _TPprootView_WebApplication_imagePath
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_RootWebZone
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MERootWebZonePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
_TSProotView_RootWebZone_webTargets _desc1;
_TSProotView_RootWebZone_errorLink _desc2;
_TSProotView_RootWebZone_roles _desc3;
_TSProotView_RootWebZone_setSize _desc4;
int _ATTERM_1;
};

struct _TPprootView_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
VLPoint _ATiPreferedSize;
NonOverlappingSolverPtr _ATnonOverlappingSolver;
VLObjectPointer _ATsizeAttr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
_TSPLST_rootView_RootWebZone_webTargets _desc1;
};

struct _TPprootView_RootWebZone_errorLink
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_RootWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_rootView_RootWebZone_roles _desc1;
};

struct _TPprootView_RootWebZone_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_SubWebZone
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESubWebZonePtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLPoint _ATpad;
VLPoint _AToPreferedSize;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLPoint _ATrelPosition;
VLRegionPtr _ATregionPtr;
VLObjectPointer _ATobjId;
_TSProotView_SubWebZone_name _desc1;
_TSProotView_SubWebZone_webTargets _desc2;
_TSProotView_SubWebZone_errorLink _desc3;
_TSProotView_SubWebZone_globalparams _desc4;
_TSProotView_SubWebZone_roles _desc5;
_TSProotView_SubWebZone_setSize _desc6;
_TSProotView_SubWebZone_position _desc7;
int _ATTERM_1;
};

struct _TPprootView_SubWebZone_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPprootView_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
VLPoint _ATiPreferedSize;
NonOverlappingSolverPtr _ATnonOverlappingSolver;
VLObjectPointer _ATsizeAttr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
_TSPLST_rootView_SubWebZone_webTargets _desc1;
};

struct _TPprootView_SubWebZone_errorLink
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_SubWebZone_globalparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_rootView_SubWebZone_globalparams _desc1;
};

struct _TPprootView_SubWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_rootView_SubWebZone_roles _desc1;
};

struct _TPprootView_SubWebZone_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_SubWebZone_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_WebRole
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebRolePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSProotView_WebRole_name _desc1;
_TSProotView_WebRole_color _desc2;
int _ATTERM_1;
};

struct _TPprootView_WebRole_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPprootView_WebRole_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TPprootView_WebRoleRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebRoleRefPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSProotView_WebRoleRef_role _desc1;
int _ATTERM_1;
};

struct _TPprootView_WebRoleRef_role
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_WebPage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebPagePtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLPoint _ATpad;
VLRegion _ATiActualRegion;
VLPoint _ATiFullPosition;
VLPoint _AToPreferedSize;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLPoint _ATrelPosition;
VLRegionPtr _ATregionPtr;
VLObjectPointer _ATobjId;
_TSProotView_WebPage_name _desc1;
_TSProotView_WebPage_formalParameter _desc2;
_TSProotView_WebPage_title _desc3;
_TSProotView_WebPage_frame _desc4;
_TSProotView_WebPage_styleSheetBlock _desc5;
_TSProotView_WebPage_position _desc6;
int _ATTERM_1;
};

struct _TPprootView_WebPage_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPprootView_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_rootView_WebPage_formalParameter _desc1;
};

struct _TPprootView_WebPage_title
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_WebPage_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_WebPage_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_Frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFramePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_Frame_components _desc1;
_TSProotView_Frame_styleSheetBlock _desc2;
int _ATTERM_1;
};

struct _TPprootView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_Frame_components _desc1;
};

struct _TPprootView_Frame_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_GlobalFrame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEGlobalFramePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSProotView_GlobalFrame_name _desc1;
_TSProotView_GlobalFrame_components _desc2;
_TSProotView_GlobalFrame_setSize _desc3;
int _ATTERM_1;
};

struct _TPprootView_GlobalFrame_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPprootView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_GlobalFrame_components _desc1;
};

struct _TPprootView_GlobalFrame_setSize
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_NavigationBar
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
_TSProotView_NavigationBar_styleSheetBlock _desc1;
_TSProotView_NavigationBar_elements _desc2;
_TSProotView_NavigationBar_alignment _desc3;
int _ATTERM_1;
};

struct _TPprootView_NavigationBar_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_NavigationBar_elements _desc1;
};

struct _TPprootView_NavigationBar_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_NavigationBarElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MENavigationBarElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_NavigationBarElement_target _desc1;
int _ATTERM_1;
};

struct _TPprootView_NavigationBarElement_target
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FrameRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFrameRefPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FrameRef_styleSheetBlock _desc1;
_TSProotView_FrameRef_frame _desc2;
int _ATTERM_1;
};

struct _TPprootView_FrameRef_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FrameRef_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_MetaInformation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
_TSProotView_MetaInformation_name _desc1;
_TSProotView_MetaInformation_elements _desc2;
int _ATTERM_1;
};

struct _TPprootView_MetaInformation_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_MetaInformation_elements _desc1;
};

struct _TPprootView_MetaInformationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEMetaInformationElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_MetaInformationElement_property _desc1;
_TSProotView_MetaInformationElement_value _desc2;
int _ATTERM_1;
};

struct _TPprootView_MetaInformationElement_property
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_MetaInformationElement_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_OutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_OutputElement_link _desc1;
_TSProotView_OutputElement_content _desc2;
int _ATTERM_1;
};

struct _TPprootView_OutputElement_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_OutputElement_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ListOutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListOutputElementPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_ListOutputElement_styleSheetBlock _desc1;
_TSProotView_ListOutputElement_dataSourceActualParams _desc2;
_TSProotView_ListOutputElement_dataSource _desc3;
_TSProotView_ListOutputElement_maxNumberOfElements _desc4;
_TSProotView_ListOutputElement_navigationElement _desc5;
int _ATTERM_1;
};

struct _TPprootView_ListOutputElement_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_ListOutputElement_dataSourceActualParams _desc1;
};

struct _TPprootView_ListOutputElement_dataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ListOutputElement_maxNumberOfElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ListOutputElement_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_StyleSheet
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
_TSProotView_StyleSheet_name _desc1;
_TSProotView_StyleSheet_custom _desc2;
_TSProotView_StyleSheet_default _desc3;
int _ATTERM_1;
};

struct _TPprootView_StyleSheet_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_StyleSheet_custom _desc1;
};

struct _TPprootView_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_StyleSheet_default _desc1;
};

struct _TPprootView_CustomStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomStyleSheetBlockPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_CustomStyleSheetBlock_pairs _desc1;
_TSProotView_CustomStyleSheetBlock_name _desc2;
int _ATTERM_1;
};

struct _TPprootView_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_CustomStyleSheetBlock_pairs _desc1;
};

struct _TPprootView_CustomStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_StyleSheetPair
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPairPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_StyleSheetPair_category _desc1;
_TSProotView_StyleSheetPair_attribute _desc2;
_TSProotView_StyleSheetPair_valueCategory _desc3;
_TSProotView_StyleSheetPair_value _desc4;
int _ATTERM_1;
};

struct _TPprootView_StyleSheetPair_category
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_StyleSheetPair_attribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_StyleSheetPair_valueCategory
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_StyleSheetPair_value _desc1;
};

struct _TPprootView_SizeValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESizeValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_SizeValue_measure _desc1;
_TSProotView_SizeValue_value _desc2;
int _ATTERM_1;
};

struct _TPprootView_SizeValue_measure
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_SizeValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ColorValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColorValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_ColorValue_color _desc1;
int _ATTERM_1;
};

struct _TPprootView_ColorValue_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_FamilyValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFamilyValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_FamilyValue_family _desc1;
int _ATTERM_1;
};

struct _TPprootView_FamilyValue_family
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_StyleValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_StyleValue_style _desc1;
int _ATTERM_1;
};

struct _TPprootView_StyleValue_style
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_HeadingValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_HeadingValue_heading _desc1;
int _ATTERM_1;
};

struct _TPprootView_HeadingValue_heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_AlignmentValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEAlignmentValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_AlignmentValue_alignment _desc1;
int _ATTERM_1;
};

struct _TPprootView_AlignmentValue_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ListValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_ListValue_listed _desc1;
int _ATTERM_1;
};

struct _TPprootView_ListValue_listed
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_CustomValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_CustomValue_value _desc1;
int _ATTERM_1;
};

struct _TPprootView_CustomValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_HtmlStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHtmlStyleSheetBlockPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_HtmlStyleSheetBlock_pairs _desc1;
_TSProotView_HtmlStyleSheetBlock_name _desc2;
int _ATTERM_1;
};

struct _TPprootView_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_HtmlStyleSheetBlock_pairs _desc1;
};

struct _TPprootView_HtmlStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ActionHandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEActionHandlerPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_ActionHandler_targetpage _desc1;
_TSProotView_ActionHandler_params _desc2;
int _ATTERM_1;
};

struct _TPprootView_ActionHandler_targetpage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_ActionHandler_params _desc1;
};

struct _TPprootView_WebAction
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebActionPtr _ATobjPtr;
ObservedTypePtr _ATvar_position;
VLPoint _ATpad;
VLRegion _ATiActualRegion;
VLPoint _ATiFullPosition;
VLPoint _AToPreferedSize;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLPoint _ATrelPosition;
VLRegionPtr _ATregionPtr;
VLObjectPointer _ATobjId;
_TSProotView_WebAction_name _desc1;
_TSProotView_WebAction_formalParameter _desc2;
_TSProotView_WebAction_successpage _desc3;
_TSProotView_WebAction_operations _desc4;
_TSProotView_WebAction_position _desc5;
int _ATTERM_1;
};

struct _TPprootView_WebAction_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPprootView_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_rootView_WebAction_formalParameter _desc1;
};

struct _TPprootView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_WebAction_operations _desc1;
};

struct _TPprootView_WebAction_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_PHPOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEPHPOperationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_PHPOperation_errorhandler _desc1;
_TSProotView_PHPOperation_content _desc2;
int _ATTERM_1;
};

struct _TPprootView_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLList _ATlineAttributes;
_TSPLST_rootView_PHPOperation_errorhandler _desc1;
};

struct _TPprootView_PHPOperation_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_DataBaseOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataBaseOperationPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSProotView_DataBaseOperation_errorhandler _desc1;
_TSProotView_DataBaseOperation_filter _desc2;
_TSProotView_DataBaseOperation_params _desc3;
int _ATTERM_1;
};

struct _TPprootView_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLList _ATlineAttributes;
_TSPLST_rootView_DataBaseOperation_errorhandler _desc1;
};

struct _TPprootView_DataBaseOperation_filter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPprootView_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_rootView_DataBaseOperation_params _desc1;
};

struct _TPpVIEWROOT_sspDlg
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsspDlg_StyleSheetPair _desc1;
};

struct _TPpsspDlg_StyleSheetPair
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPairPtr _ATobjPtr;
VLString _ATpers_category;
int _ATlabelWidth;
VLObjectPointer _ATobjId;
_TSPsspDlg_StyleSheetPair_category _desc1;
_TSPsspDlg_StyleSheetPair_attribute _desc2;
_TSPsspDlg_StyleSheetPair_valueCategory _desc3;
_TSPsspDlg_StyleSheetPair_value _desc4;
int _ATTERM_1;
};

struct _TPpsspDlg_StyleSheetPair_category
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpsspDlg_StyleSheetPair_attribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpsspDlg_StyleSheetPair_valueCategory
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpsspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_sspDlg_StyleSheetPair_value _desc1;
};

struct _TPpsspDlg_SizeValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESizeValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPsspDlg_SizeValue_measure _desc1;
_TSPsspDlg_SizeValue_value _desc2;
int _ATTERM_1;
};

struct _TPpsspDlg_SizeValue_measure
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATnodeId;
VLString _ATlabel;
};

struct _TPpsspDlg_SizeValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TPpsspDlg_ColorValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColorValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPsspDlg_ColorValue_color _desc1;
int _ATTERM_1;
};

struct _TPpsspDlg_ColorValue_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TPpsspDlg_FamilyValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFamilyValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPsspDlg_FamilyValue_family _desc1;
int _ATTERM_1;
};

struct _TPpsspDlg_FamilyValue_family
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TPpsspDlg_StyleValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPsspDlg_StyleValue_style _desc1;
int _ATTERM_1;
};

struct _TPpsspDlg_StyleValue_style
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TPpsspDlg_HeadingValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPsspDlg_HeadingValue_heading _desc1;
int _ATTERM_1;
};

struct _TPpsspDlg_HeadingValue_heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TPpsspDlg_AlignmentValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEAlignmentValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPsspDlg_AlignmentValue_alignment _desc1;
int _ATTERM_1;
};

struct _TPpsspDlg_AlignmentValue_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TPpsspDlg_ListValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPsspDlg_ListValue_listed _desc1;
int _ATTERM_1;
};

struct _TPpsspDlg_ListValue_listed
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TPpsspDlg_CustomValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomValuePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPsspDlg_CustomValue_value _desc1;
int _ATTERM_1;
};

struct _TPpsspDlg_CustomValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATlabel;
};

struct _TPpVIEWROOT_stylesheetView
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_StyleSheet _desc1;
};

struct _TPpstylesheetView_StyleSheet
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPstylesheetView_StyleSheet_name _desc1;
_TSPstylesheetView_StyleSheet_custom _desc2;
_TSPstylesheetView_StyleSheet_default _desc3;
int _ATTERM_1;
};

struct _TPpstylesheetView_StyleSheet_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLList _ATseparatorStyle;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
_TSPLST_stylesheetView_StyleSheet_custom _desc1;
};

struct _TPpstylesheetView_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
_TSPLST_stylesheetView_StyleSheet_default _desc1;
};

struct _TPpstylesheetView_CustomStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomStyleSheetBlockPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLPoint _ATpad;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
_TSPstylesheetView_CustomStyleSheetBlock_pairs _desc1;
_TSPstylesheetView_CustomStyleSheetBlock_name _desc2;
int _ATTERM_1;
};

struct _TPpstylesheetView_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
int _ATpreferedWidth;
VLHashtablePtr _ATcellWidth;
VLHashtablePtr _ATabsPos;
VLPoint _ATiPreferedSize;
_TSPLST_stylesheetView_CustomStyleSheetBlock_pairs _desc1;
};

struct _TPpstylesheetView_CustomStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerInterface2Ptr _ATcontainerSubElement;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TPpstylesheetView_StyleSheetPair
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleSheetPairPtr _ATobjPtr;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPstylesheetView_StyleSheetPair_category _desc1;
_TSPstylesheetView_StyleSheetPair_attribute _desc2;
_TSPstylesheetView_StyleSheetPair_valueCategory _desc3;
_TSPstylesheetView_StyleSheetPair_value _desc4;
int _ATTERM_1;
};

struct _TPpstylesheetView_StyleSheetPair_category
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_StyleSheetPair_attribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATcellName;
VLPoint _ATpad;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATiPreferedSize;
};

struct _TPpstylesheetView_StyleSheetPair_valueCategory
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
_TSPLST_stylesheetView_StyleSheetPair_value _desc1;
};

struct _TPpstylesheetView_SizeValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MESizeValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
_TSPstylesheetView_SizeValue_measure _desc1;
_TSPstylesheetView_SizeValue_value _desc2;
int _ATTERM_1;
};

struct _TPpstylesheetView_SizeValue_measure
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_SizeValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_ColorValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEColorValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
_TSPstylesheetView_ColorValue_color _desc1;
int _ATTERM_1;
};

struct _TPpstylesheetView_ColorValue_color
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_FamilyValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFamilyValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
_TSPstylesheetView_FamilyValue_family _desc1;
int _ATTERM_1;
};

struct _TPpstylesheetView_FamilyValue_family
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_StyleValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEStyleValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
_TSPstylesheetView_StyleValue_style _desc1;
int _ATTERM_1;
};

struct _TPpstylesheetView_StyleValue_style
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_HeadingValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
_TSPstylesheetView_HeadingValue_heading _desc1;
int _ATTERM_1;
};

struct _TPpstylesheetView_HeadingValue_heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_AlignmentValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEAlignmentValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
_TSPstylesheetView_AlignmentValue_alignment _desc1;
int _ATTERM_1;
};

struct _TPpstylesheetView_AlignmentValue_alignment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_ListValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
_TSPstylesheetView_ListValue_listed _desc1;
int _ATTERM_1;
};

struct _TPpstylesheetView_ListValue_listed
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_CustomValue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MECustomValuePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
_TSPstylesheetView_CustomValue_value _desc1;
int _ATTERM_1;
};

struct _TPpstylesheetView_CustomValue_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpstylesheetView_HtmlStyleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHtmlStyleSheetBlockPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLPoint _ATpad;
VisDrawingTrafoPtr _ATdrawingTrafo;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
_TSPstylesheetView_HtmlStyleSheetBlock_pairs _desc1;
_TSPstylesheetView_HtmlStyleSheetBlock_name _desc2;
int _ATTERM_1;
};

struct _TPpstylesheetView_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
int _ATpreferedWidth;
VLHashtablePtr _ATcellWidth;
VLHashtablePtr _ATabsPos;
VLPoint _ATiPreferedSize;
_TSPLST_stylesheetView_HtmlStyleSheetBlock_pairs _desc1;
};

struct _TPpstylesheetView_HtmlStyleSheetBlock_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VisContainerInterface2Ptr _ATcontainerSubElement;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
};

struct _TPpVIEWROOT_webActionView
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_WebAction _desc1;
};

struct _TPpwebActionView_WebNodeFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeFormalParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
_TSPwebActionView_WebNodeFormalParam_name _desc1;
_TSPwebActionView_WebNodeFormalParam_keyword1 _desc2;
_TSPwebActionView_WebNodeFormalParam_type _desc3;
int _ATTERM_1;
};

struct _TPpwebActionView_WebNodeFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_WebNodeFormalParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_webActionView_WebNodeFormalParam_type _desc1;
};

struct _TPpwebActionView_WebNodeActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeActualParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
_TSPwebActionView_WebNodeActualParam_formalParam _desc1;
_TSPwebActionView_WebNodeActualParam_keyword1 _desc2;
_TSPwebActionView_WebNodeActualParam_expressions _desc3;
int _ATTERM_1;
};

struct _TPpwebActionView_WebNodeActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_WebNodeActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_webActionView_WebNodeActualParam_expressions _desc1;
};

struct _TPpwebActionView_WebNodeConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeConstantExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_WebNodeConstantExpression_keyword1 _desc1;
_TSPwebActionView_WebNodeConstantExpression_value _desc2;
_TSPwebActionView_WebNodeConstantExpression_keyword2 _desc3;
int _ATTERM_1;
};

struct _TPpwebActionView_WebNodeConstantExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_WebNodeConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_WebNodeConstantExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_WebNodeVariableExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeVariableExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_WebNodeVariableExpression_content _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_WebNodeVariableExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_WebNodeColumnExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeColumnExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_WebNodeColumnExpression_content _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_WebNodeColumnExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DBString
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_DBString_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_DBString_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DBInteger
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_DBInteger_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_DBInteger_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DBFloat
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_DBFloat_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_DBFloat_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DBDouble
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_DBDouble_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_DBDouble_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DBBigInt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_DBBigInt_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_DBBigInt_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DBDate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_DBDate_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_DBDate_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DBTimeStamp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_DBTimeStamp_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_DBTimeStamp_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DBBoolean
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_DBBoolean_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_DBBoolean_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DBBlob
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebActionView_DBBlob_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebActionView_DBBlob_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DataSourceActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataSourceActualParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
_TSPwebActionView_DataSourceActualParam_formalParam _desc1;
_TSPwebActionView_DataSourceActualParam_keyword1 _desc2;
_TSPwebActionView_DataSourceActualParam_expressions _desc3;
int _ATTERM_1;
};

struct _TPpwebActionView_DataSourceActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DataSourceActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_webActionView_DataSourceActualParam_expressions _desc1;
};

struct _TPpwebActionView_ActionHandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEActionHandlerPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
_TSPwebActionView_ActionHandler_targetpage _desc1;
_TSPwebActionView_ActionHandler_params _desc2;
int _ATTERM_1;
};

struct _TPpwebActionView_ActionHandler_targetpage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_webActionView_ActionHandler_params _desc1;
};

struct _TPpwebActionView_WebAction
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebActionPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPwebActionView_WebAction_name _desc1;
_TSPwebActionView_WebAction_formalParameter _desc2;
_TSPwebActionView_WebAction_successpage _desc3;
_TSPwebActionView_WebAction_operations _desc4;
_TSPwebActionView_WebAction_position _desc5;
int _ATTERM_1;
};

struct _TPpwebActionView_WebAction_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebActionView_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
_TSPLST_webActionView_WebAction_formalParameter _desc1;
};

struct _TPpwebActionView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
_TSPLST_webActionView_WebAction_operations _desc1;
};

struct _TPpwebActionView_WebAction_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebActionView_PHPOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEPHPOperationPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebActionView_PHPOperation_errorhandler _desc1;
_TSPwebActionView_PHPOperation_content _desc2;
int _ATTERM_1;
};

struct _TPpwebActionView_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATisError;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_webActionView_PHPOperation_errorhandler _desc1;
};

struct _TPpwebActionView_PHPOperation_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
VLString _ATfinalText;
VLString _ATinternalFont;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
};

struct _TPpwebActionView_DataBaseOperation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEDataBaseOperationPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebActionView_DataBaseOperation_errorhandler _desc1;
_TSPwebActionView_DataBaseOperation_filter _desc2;
_TSPwebActionView_DataBaseOperation_params _desc3;
int _ATTERM_1;
};

struct _TPpwebActionView_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATisError;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_webActionView_DataBaseOperation_errorhandler _desc1;
};

struct _TPpwebActionView_DataBaseOperation_filter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPpwebActionView_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_webActionView_DataBaseOperation_params _desc1;
};

struct _TPpVIEWROOT_webPageView
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_WebPage _desc1;
};

struct _TPpwebPageView_FormularCheckboxElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularCheckboxElementPtr _ATobjPtr;
VLString _ATpers_name;
VLBoolean _ATpers_checked;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularCheckboxElement_label _desc1;
_TSPwebPageView_FormularCheckboxElement_type _desc2;
_TSPwebPageView_FormularCheckboxElement_condition _desc3;
_TSPwebPageView_FormularCheckboxElement_description _desc4;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularCheckboxElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularCheckboxElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_FormularCheckboxElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularCheckboxElement_name _desc1;
};

struct _TPpwebPageView_FormularCheckboxElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularTextElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularTextElement_label _desc1;
_TSPwebPageView_FormularTextElement_type _desc2;
_TSPwebPageView_FormularTextElement_condition _desc3;
_TSPwebPageView_FormularTextElement_description _desc4;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularTextElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularTextElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TPpwebPageView_FormularTextElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularPasswordElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPasswordElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularPasswordElement_label _desc1;
_TSPwebPageView_FormularPasswordElement_type _desc2;
_TSPwebPageView_FormularPasswordElement_condition _desc3;
_TSPwebPageView_FormularPasswordElement_description _desc4;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularPasswordElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularPasswordElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TPpwebPageView_FormularPasswordElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularTextAreaElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularTextAreaElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularTextAreaElement_label _desc1;
_TSPwebPageView_FormularTextAreaElement_type _desc2;
_TSPwebPageView_FormularTextAreaElement_condition _desc3;
_TSPwebPageView_FormularTextAreaElement_description _desc4;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularTextAreaElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularTextAreaElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
};

struct _TPpwebPageView_FormularTextAreaElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularSelectElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_reqLengthChain_pre;
MEFormularSelectElementPtr _ATobjPtr;
VLString _ATpers_name;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularSelectElement_label _desc1;
_TSPwebPageView_FormularSelectElement_multiple _desc2;
_TSPwebPageView_FormularSelectElement_options _desc3;
_TSPwebPageView_FormularSelectElement_description _desc4;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularSelectElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularSelectElement_multiple
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPContainer_showInsertionPoint;
_TSPLST_webPageView_FormularSelectElement_options _desc1;
};

struct _TPpwebPageView_FormularSelectElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularRadioElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioElementPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularRadioElement_type _desc1;
_TSPwebPageView_FormularRadioElement_label _desc2;
_TSPwebPageView_FormularRadioElement_name _desc3;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularRadioElement_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FormularRadioElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FormularRadioElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DataSourceActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedList_numberChain_post;
int _ATVPSpaceDistrib_reqLengthChain_post;
MEDataSourceActualParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
_TSPwebPageView_DataSourceActualParam_formalParam _desc1;
_TSPwebPageView_DataSourceActualParam_keyword1 _desc2;
_TSPwebPageView_DataSourceActualParam_expressions _desc3;
int _ATTERM_1;
};

struct _TPpwebPageView_DataSourceActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DataSourceActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_webPageView_DataSourceActualParam_expressions _desc1;
};

struct _TPpwebPageView_WebNodeActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeActualParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
_TSPwebPageView_WebNodeActualParam_formalParam _desc1;
_TSPwebPageView_WebNodeActualParam_keyword1 _desc2;
_TSPwebPageView_WebNodeActualParam_expressions _desc3;
int _ATTERM_1;
};

struct _TPpwebPageView_WebNodeActualParam_formalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_WebNodeActualParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_webPageView_WebNodeActualParam_expressions _desc1;
};

struct _TPpwebPageView_WebNodeConstantExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeConstantExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_WebNodeConstantExpression_keyword1 _desc1;
_TSPwebPageView_WebNodeConstantExpression_value _desc2;
_TSPwebPageView_WebNodeConstantExpression_keyword2 _desc3;
int _ATTERM_1;
};

struct _TPpwebPageView_WebNodeConstantExpression_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_WebNodeConstantExpression_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_WebNodeConstantExpression_keyword2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_WebNodeVariableExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeVariableExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_WebNodeVariableExpression_content _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_WebNodeVariableExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_WebNodeColumnExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeColumnExpressionPtr _ATobjPtr;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_WebNodeColumnExpression_content _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_WebNodeColumnExpression_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_WebNodeFormalParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebNodeFormalParamPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
VLPoint _ATiPreferedSize;
VLPoint _ATpad;
_TSPwebPageView_WebNodeFormalParam_name _desc1;
_TSPwebPageView_WebNodeFormalParam_keyword1 _desc2;
_TSPwebPageView_WebNodeFormalParam_type _desc3;
int _ATTERM_1;
};

struct _TPpwebPageView_WebNodeFormalParam_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATpersValue;
VLList _ATtextList;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_WebNodeFormalParam_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLObjectPointer _ATobjId;
int _ATVPNumberedList_elementCount;
int _ATVPFlowContainer_show;
_TSPLST_webPageView_WebNodeFormalParam_type _desc1;
};

struct _TPpwebPageView_DBString
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_DBString_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_DBString_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DBInteger
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_DBInteger_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_DBInteger_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DBFloat
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_DBFloat_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_DBFloat_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DBDouble
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_DBDouble_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_DBDouble_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DBBigInt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_DBBigInt_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_DBBigInt_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DBDate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_DBDate_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_DBDate_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DBTimeStamp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_DBTimeStamp_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_DBTimeStamp_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DBBoolean
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_DBBoolean_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_DBBoolean_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_DBBlob
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_DBBlob_keyword1 _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_DBBlob_keyword1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATtext;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_Formular
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_Formular_styleSheetBlock _desc1;
_TSPwebPageView_Formular_action _desc2;
_TSPwebPageView_Formular_elements _desc3;
_TSPwebPageView_Formular_datasource _desc4;
_TSPwebPageView_Formular_actualParams _desc5;
int _ATTERM_1;
};

struct _TPpwebPageView_Formular_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_Formular_action
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
VLHashtablePtr _ATabsPos;
VLHashtablePtr _ATcellWidth;
int _ATpreferedWidth;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_webPageView_Formular_elements _desc1;
};

struct _TPpwebPageView_Formular_datasource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_webPageView_Formular_actualParams _desc1;
};

struct _TPpwebPageView_FormularRadioGroupElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularRadioGroupElementPtr _ATobjPtr;
VLString _ATpers_name;
VLObjectPointer _ATpers_checked;
int _ATVPSpaceDistribElement_provided;
int _ATVPSpaceDistribElement_relPos;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularRadioGroupElement_name _desc1;
_TSPwebPageView_FormularRadioGroupElement_label _desc2;
_TSPwebPageView_FormularRadioGroupElement_description _desc3;
_TSPwebPageView_FormularRadioGroupElement_pvalue _desc4;
_TSPwebPageView_FormularRadioGroupElement_condition _desc5;
_TSPwebPageView_FormularRadioGroupElement_elements _desc6;
_TSPwebPageView_FormularRadioGroupElement_checked _desc7;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularRadioGroupElement_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FormularRadioGroupElement_label
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularRadioGroupElement_description
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
};

struct _TPpwebPageView_FormularRadioGroupElement_pvalue
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _ATcellName;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
_TSPLST_webPageView_FormularRadioGroupElement_elements _desc1;
};

struct _TPpwebPageView_FormularRadioGroupElement_checked
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FormularConstantSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConstantSelectOptionPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularConstantSelectOption_values _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularConstantSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FormularDataSourceSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPNumberedList_numberChain_pre;
MEFormularDataSourceSelectOptionPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularDataSourceSelectOption_values _desc1;
_TSPwebPageView_FormularDataSourceSelectOption_params _desc2;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularDataSourceSelectOption_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_webPageView_FormularDataSourceSelectOption_params _desc1;
};

struct _TPpwebPageView_FormularPHPScriptSelectOption
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularPHPScriptSelectOptionPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularPHPScriptSelectOption_script _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularPHPScriptSelectOption_script
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FormularCondition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPNumberedElement_number;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularCondition_condition _desc1;
_TSPwebPageView_FormularCondition_params _desc2;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularCondition_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_webPageView_FormularCondition_params _desc1;
};

struct _TPpwebPageView_FormularConditionActualParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFormularConditionActualParamPtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPwebPageView_FormularConditionActualParam_value _desc1;
_TSPwebPageView_FormularConditionActualParam_formalparam _desc2;
int _ATTERM_1;
};

struct _TPpwebPageView_FormularConditionActualParam_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FormularConditionActualParam_formalparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_Paragraph
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEParagraphPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_Paragraph_styleSheetBlock _desc1;
_TSPwebPageView_Paragraph_fragments _desc2;
int _ATTERM_1;
};

struct _TPpwebPageView_Paragraph_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_webPageView_Paragraph_fragments _desc1;
};

struct _TPpwebPageView_TextFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METextFragmentPtr _ATobjPtr;
VLObjectPointer _ATpers_link;
VLString _ATfont;
VLString _ATcolor;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_TextFragment_link _desc1;
_TSPwebPageView_TextFragment_value _desc2;
int _ATTERM_1;
};

struct _TPpwebPageView_TextFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_TextFragment_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPpwebPageView_ImageFragment
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEImageFragmentPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLString _ATinternalImageName;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_ImageFragment_link _desc1;
_TSPwebPageView_ImageFragment_width _desc2;
_TSPwebPageView_ImageFragment_height _desc3;
_TSPwebPageView_ImageFragment_text _desc4;
_TSPwebPageView_ImageFragment_imageName _desc5;
int _ATTERM_1;
};

struct _TPpwebPageView_ImageFragment_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_ImageFragment_width
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_ImageFragment_height
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_ImageFragment_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_ImageFragment_imageName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_Heading
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEHeadingPtr _ATobjPtr;
VLString _ATfont;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_Heading_styleSheetBlock _desc1;
_TSPwebPageView_Heading_text _desc2;
_TSPwebPageView_Heading_level _desc3;
int _ATTERM_1;
};

struct _TPpwebPageView_Heading_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_Heading_text
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
};

struct _TPpwebPageView_Heading_level
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_Table
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METablePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
int _ATposY;
int _ATposX;
int _ATprovSizeY;
int _ATprovSizeX;
VLList _ATcellBorderAttrs;
VLPoint _ATminCellSize;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_Table_styleSheetBlock _desc1;
_TSPwebPageView_Table_rows _desc2;
_TSPwebPageView_Table_columns _desc3;
int _ATTERM_1;
};

struct _TPpwebPageView_Table_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
_TSPLST_webPageView_Table_rows _desc1;
};

struct _TPpwebPageView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistrib_pad;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
_TSPLST_webPageView_Table_columns _desc1;
};

struct _TPpwebPageView_TableRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableRowPtr _ATobjPtr;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
int _ATposY;
int _ATprovSizeY;
VLObjectPointer _ATobjId;
_TSPwebPageView_TableRow_cells _desc1;
int _ATTERM_1;
};

struct _TPpwebPageView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_webPageView_TableRow_cells _desc1;
};

struct _TPpwebPageView_TableColumn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
int _ATTERM_1;
};

struct _TPpwebPageView_TableCell
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
METableCellPtr _ATobjPtr;
DefTableKey _ATcolumnKey;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VLObjectPointer _ATobjId;
_TSPwebPageView_TableCell_columnRef _desc1;
_TSPwebPageView_TableCell_content _desc2;
int _ATTERM_1;
};

struct _TPpwebPageView_TableCell_columnRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLObjectPointer _ATpersValue;
};

struct _TPpwebPageView_WebPage
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEWebPagePtr _ATobjPtr;
VLObjectPointer _ATobjId;
_TSPwebPageView_WebPage_name _desc1;
_TSPwebPageView_WebPage_formalParameter _desc2;
_TSPwebPageView_WebPage_title _desc3;
_TSPwebPageView_WebPage_frame _desc4;
_TSPwebPageView_WebPage_styleSheetBlock _desc5;
_TSPwebPageView_WebPage_position _desc6;
int _ATTERM_1;
};

struct _TPpwebPageView_WebPage_name
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
_TSPLST_webPageView_WebPage_formalParameter _desc1;
};

struct _TPpwebPageView_WebPage_title
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_WebPage_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_WebPage_position
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_Frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFramePtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
VLObjectPointer _ATobjId;
_TSPwebPageView_Frame_components _desc1;
_TSPwebPageView_Frame_styleSheetBlock _desc2;
int _ATTERM_1;
};

struct _TPpwebPageView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATelementDistance;
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSPLST_webPageView_Frame_components _desc1;
};

struct _TPpwebPageView_Frame_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FrameRef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEFrameRefPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_FrameRef_styleSheetBlock _desc1;
_TSPwebPageView_FrameRef_frame _desc2;
int _ATTERM_1;
};

struct _TPpwebPageView_FrameRef_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_FrameRef_frame
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_OutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEOutputElementPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_OutputElement_link _desc1;
_TSPwebPageView_OutputElement_content _desc2;
int _ATTERM_1;
};

struct _TPpwebPageView_OutputElement_link
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_OutputElement_content
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_ListOutputElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
MEListOutputElementPtr _ATobjPtr;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerInterface2Ptr;
VisDrawingTrafoPtr _ATdrawingTrafo;
int _ATVPSpaceDistribElement_realPad;
int _ATVPNumberedElement_number;
int _ATVPSpaceDistribElement_required;
VLObjectPointer _ATobjId;
_TSPwebPageView_ListOutputElement_styleSheetBlock _desc1;
_TSPwebPageView_ListOutputElement_dataSourceActualParams _desc2;
_TSPwebPageView_ListOutputElement_dataSource _desc3;
_TSPwebPageView_ListOutputElement_maxNumberOfElements _desc4;
_TSPwebPageView_ListOutputElement_navigationElement _desc5;
int _ATTERM_1;
};

struct _TPpwebPageView_ListOutputElement_styleSheetBlock
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPosition;
int _ATVPSpaceDistrib_required;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPreferedSize;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
VisContainerInterface2Ptr _ATcontainerSubElement;
VisContainerPosition2Ptr _ATcontainerPosition2Ptr;
_TSPLST_webPageView_ListOutputElement_dataSourceActualParams _desc1;
};

struct _TPpwebPageView_ListOutputElement_dataSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
ObservedTypePtr _ATnodePtr;
VLString _ATinternalFont;
VLString _ATfinalText;
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
VLObjectPointer _ATobjId;
};

struct _TPpwebPageView_ListOutputElement_maxNumberOfElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpwebPageView_ListOutputElement_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBlob _desc1;
};

struct _TPrule_2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBoolean _desc1;
};

struct _TPrule_3
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBTimeStamp _desc1;
};

struct _TPrule_4
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBDate _desc1;
};

struct _TPrule_5
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBigInt _desc1;
};

struct _TPrule_6
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBDouble _desc1;
};

struct _TPrule_7
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBFloat _desc1;
};

struct _TPrule_8
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBInteger _desc1;
};

struct _TPrule_9
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBString _desc1;
};

struct _TPrule_10
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ComputationExpression _desc1;
};

struct _TPrule_11
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ParameterValueExpression _desc1;
};

struct _TPrule_12
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColumnValueExpression _desc1;
};

struct _TPrule_13
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ConstantExpression _desc1;
};

struct _TPrule_14
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_UnaryExpression _desc1;
};

struct _TPrule_15
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_BinaryExpression _desc1;
};

struct _TPrule_16
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ComputationExpression _desc1;
};

struct _TPrule_17
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ParameterValueExpression _desc1;
};

struct _TPrule_18
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColumnValueExpression _desc1;
};

struct _TPrule_19
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ConstantExpression _desc1;
};

struct _TPrule_20
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_UnaryExpression _desc1;
};

struct _TPrule_21
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_BinaryExpression _desc1;
};

struct _TPrule_22
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ComputationExpression _desc1;
};

struct _TPrule_23
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ParameterValueExpression _desc1;
};

struct _TPrule_24
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColumnValueExpression _desc1;
};

struct _TPrule_25
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ConstantExpression _desc1;
};

struct _TPrule_26
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_UnaryExpression _desc1;
};

struct _TPrule_27
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_BinaryExpression _desc1;
};

struct _TPrule_28
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ComputationExpression _desc1;
};

struct _TPrule_29
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ParameterValueExpression _desc1;
};

struct _TPrule_30
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColumnValueExpression _desc1;
};

struct _TPrule_31
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ConstantExpression _desc1;
};

struct _TPrule_32
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_UnaryExpression _desc1;
};

struct _TPrule_33
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_BinaryExpression _desc1;
};

struct _TPrule_34
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ComputationExpression _desc1;
};

struct _TPrule_35
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ParameterValueExpression _desc1;
};

struct _TPrule_36
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColumnValueExpression _desc1;
};

struct _TPrule_37
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ConstantExpression _desc1;
};

struct _TPrule_38
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_UnaryExpression _desc1;
};

struct _TPrule_39
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_BinaryExpression _desc1;
};

struct _TPrule_40
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ComputationExpression _desc1;
};

struct _TPrule_41
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ParameterValueExpression _desc1;
};

struct _TPrule_42
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColumnValueExpression _desc1;
};

struct _TPrule_43
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ConstantExpression _desc1;
};

struct _TPrule_44
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_UnaryExpression _desc1;
};

struct _TPrule_45
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_BinaryExpression _desc1;
};

struct _TPrule_46
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBlob _desc1;
};

struct _TPrule_47
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBoolean _desc1;
};

struct _TPrule_48
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBTimeStamp _desc1;
};

struct _TPrule_49
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBDate _desc1;
};

struct _TPrule_50
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBigInt _desc1;
};

struct _TPrule_51
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBDouble _desc1;
};

struct _TPrule_52
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBFloat _desc1;
};

struct _TPrule_53
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBInteger _desc1;
};

struct _TPrule_54
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBString _desc1;
};

struct _TPrule_55
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ComputationExpression _desc1;
};

struct _TPrule_56
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ParameterValueExpression _desc1;
};

struct _TPrule_57
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColumnValueExpression _desc1;
};

struct _TPrule_58
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ConstantExpression _desc1;
};

struct _TPrule_59
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_UnaryExpression _desc1;
};

struct _TPrule_60
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_BinaryExpression _desc1;
};

struct _TPrule_61
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ComputationExpression _desc1;
};

struct _TPrule_62
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ParameterValueExpression _desc1;
};

struct _TPrule_63
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColumnValueExpression _desc1;
};

struct _TPrule_64
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ConstantExpression _desc1;
};

struct _TPrule_65
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_UnaryExpression _desc1;
};

struct _TPrule_66
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_BinaryExpression _desc1;
};

struct _TPrule_67
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ComputationExpression _desc1;
};

struct _TPrule_68
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ParameterValueExpression _desc1;
};

struct _TPrule_69
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColumnValueExpression _desc1;
};

struct _TPrule_70
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ConstantExpression _desc1;
};

struct _TPrule_71
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_UnaryExpression _desc1;
};

struct _TPrule_72
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_BinaryExpression _desc1;
};

struct _TPrule_73
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeColumnExpression _desc1;
};

struct _TPrule_74
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeVariableExpression _desc1;
};

struct _TPrule_75
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeConstantExpression _desc1;
};

struct _TPrule_76
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBlob _desc1;
};

struct _TPrule_77
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBoolean _desc1;
};

struct _TPrule_78
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBTimeStamp _desc1;
};

struct _TPrule_79
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBDate _desc1;
};

struct _TPrule_80
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBigInt _desc1;
};

struct _TPrule_81
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBDouble _desc1;
};

struct _TPrule_82
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBFloat _desc1;
};

struct _TPrule_83
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBInteger _desc1;
};

struct _TPrule_84
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBString _desc1;
};

struct _TPrule_85
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularCondition _desc1;
};

struct _TPrule_86
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularCondition _desc1;
};

struct _TPrule_87
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularCondition _desc1;
};

struct _TPrule_88
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularCondition _desc1;
};

struct _TPrule_89
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularCondition _desc1;
};

struct _TPrule_90
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularCondition _desc1;
};

struct _TPrule_91
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularPHPScriptSelectOption _desc1;
};

struct _TPrule_92
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularDataSourceSelectOption _desc1;
};

struct _TPrule_93
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularConstantSelectOption _desc1;
};

struct _TPrule_94
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeColumnExpression _desc1;
};

struct _TPrule_95
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeVariableExpression _desc1;
};

struct _TPrule_96
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeConstantExpression _desc1;
};

struct _TPrule_97
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBlob _desc1;
};

struct _TPrule_98
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBoolean _desc1;
};

struct _TPrule_99
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBTimeStamp _desc1;
};

struct _TPrule_100
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBDate _desc1;
};

struct _TPrule_101
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBBigInt _desc1;
};

struct _TPrule_102
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBDouble _desc1;
};

struct _TPrule_103
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBFloat _desc1;
};

struct _TPrule_104
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBInteger _desc1;
};

struct _TPrule_105
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBString _desc1;
};

struct _TPrule_106
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Frame _desc1;
};

struct _TPrule_107
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebApplication _desc1;
};

struct _TPrule_108
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_RootWebZone _desc1;
};

struct _TPrule_109
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_NavigationBar _desc1;
};

struct _TPrule_110
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_StyleSheet _desc1;
};

struct _TPrule_111
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_MetaInformation _desc1;
};

struct _TPrule_112
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataBase _desc1;
};

struct _TPrule_113
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
PTGNode _AT_const38;
_TSPcodeGen_Frame _desc1;
};

struct _TPrule_114
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_CustomValue _desc1;
};

struct _TPrule_115
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ListValue _desc1;
};

struct _TPrule_116
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_AlignmentValue _desc1;
};

struct _TPrule_117
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_HeadingValue _desc1;
};

struct _TPrule_118
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_StyleValue _desc1;
};

struct _TPrule_119
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FamilyValue _desc1;
};

struct _TPrule_120
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColorValue _desc1;
};

struct _TPrule_121
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_SizeValue _desc1;
};

struct _TPrule_122
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
PTGNode _AT_const47;
_TSPcodeGen_ActionHandler _desc1;
};

struct _TPrule_123
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPosition;
VLPoint _ATiActualSize;
VLPoint _ATpad;
VLString _ATcellName;
_TSPglobalFrameView_FormularCondition _desc1;
};

struct _TPrule_124
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPosition;
VLPoint _ATiActualSize;
VLPoint _ATpad;
VLString _ATcellName;
_TSPglobalFrameView_FormularCondition _desc1;
};

struct _TPrule_125
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPosition;
VLPoint _ATiActualSize;
VLPoint _ATpad;
VLString _ATcellName;
_TSPglobalFrameView_FormularCondition _desc1;
};

struct _TPrule_126
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPosition;
VLPoint _ATiActualSize;
VLPoint _ATpad;
VLString _ATcellName;
_TSPglobalFrameView_FormularCondition _desc1;
};

struct _TPrule_127
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
int _ATVPNumberedList_elementCount;
VLPoint _ATiPosition;
VLPoint _ATiActualSize;
VLPoint _ATpad;
VLString _ATcellName;
_TSPglobalFrameView_FormularCondition _desc1;
};

struct _TPrule_128
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
_TSPglobalFrameView_Frame _desc1;
};

struct _TPrule_129
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularCondition _desc1;
};

struct _TPrule_130
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularCondition _desc1;
};

struct _TPrule_131
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularCondition _desc1;
};

struct _TPrule_132
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularCondition _desc1;
};

struct _TPrule_133
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularCondition _desc1;
};

struct _TPrule_134
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularCondition _desc1;
};

struct _TPrule_135
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Frame _desc1;
};

struct _TPrule_136
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebApplication _desc1;
};

struct _TPrule_137
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSProotView_RootWebZone _desc1;
};

struct _TPrule_138
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSProotView_NavigationBar _desc1;
};

struct _TPrule_139
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSProotView_StyleSheet _desc1;
};

struct _TPrule_140
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSProotView_MetaInformation _desc1;
};

struct _TPrule_141
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
VisContainerInterface2Ptr _ATcontainerSubElement;
_TSProotView_DataBase _desc1;
};

struct _TPrule_142
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Frame _desc1;
};

struct _TPrule_143
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLList _ATlineAttributes;
_TSProotView_ActionHandler _desc1;
};

struct _TPrule_144
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATisError;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPSpaceDistrib_pad;
int _ATactualWidth;
int _ATflip;
VLList _ATseparatorStyle;
int _ATelementDistance;
_TSPwebActionView_ActionHandler _desc1;
};

struct _TPrule_145
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
_TSPwebPageView_FormularCondition _desc1;
};

struct _TPrule_146
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
_TSPwebPageView_FormularCondition _desc1;
};

struct _TPrule_147
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
_TSPwebPageView_FormularCondition _desc1;
};

struct _TPrule_148
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
_TSPwebPageView_FormularCondition _desc1;
};

struct _TPrule_149
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiActualSize;
VLPoint _ATiPosition;
int _ATVPNumberedList_elementCount;
int _ATVPContainer_showInsertionPoint;
VLPoint _ATiPreferedSize;
VLString _ATcellName;
_TSPwebPageView_FormularCondition _desc1;
};

struct _TPrule_150
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPoint _ATpad;
VLPoint _ATiPreferedSize;
_TSPwebPageView_Frame _desc1;
};

struct _TPrule_151
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_Frame _desc1;
};

struct _TPLST_codeGen_DBColumnpcodeGen_DataSourceDB_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DBColumn _desc1;
_TSPLST_codeGen_DataSourceDB_columns _desc2;
};

struct _TPLST_codeGen_DataSourceJoinpcodeGen_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceJoin _desc1;
_TSPLST_codeGen_DataBase_dataSources _desc2;
};

struct _TPLST_codeGen_LimitDataSourcepcodeGen_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_LimitDataSource _desc1;
_TSPLST_codeGen_DataBase_dataSources _desc2;
};

struct _TPLST_codeGen_DataSourceProjectionFilterpcodeGen_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceProjectionFilter _desc1;
_TSPLST_codeGen_DataBase_dataSources _desc2;
};

struct _TPLST_codeGen_DataSourceDBpcodeGen_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceDB _desc1;
_TSPLST_codeGen_DataBase_dataSources _desc2;
};

struct _TPLST_codeGen_DataSourceDeletepcodeGen_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceDelete _desc1;
_TSPLST_codeGen_DataBase_dataSourceModifications _desc2;
};

struct _TPLST_codeGen_DataSourceUpdatepcodeGen_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceUpdate _desc1;
_TSPLST_codeGen_DataBase_dataSourceModifications _desc2;
};

struct _TPLST_codeGen_DataSourceInsertpcodeGen_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceInsert _desc1;
_TSPLST_codeGen_DataBase_dataSourceModifications _desc2;
};

struct _TPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceProjectionFilter_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceFormalParam _desc1;
_TSPLST_codeGen_DataSourceProjectionFilter_formalParameters _desc2;
};

struct _TPLST_codeGen_ComputationProjectionpcodeGen_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ComputationProjection _desc1;
_TSPLST_codeGen_DataSourceProjectionFilter_projectionColumns _desc2;
};

struct _TPLST_codeGen_ColumnProjectionpcodeGen_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ColumnProjection _desc1;
_TSPLST_codeGen_DataSourceProjectionFilter_projectionColumns _desc2;
};

struct _TPLST_codeGen_DataSourceFormalParampcodeGen_LimitDataSource_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceFormalParam _desc1;
_TSPLST_codeGen_LimitDataSource_formalParameters _desc2;
};

struct _TPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceInsert_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceFormalParam _desc1;
_TSPLST_codeGen_DataSourceInsert_formalParams _desc2;
};

struct _TPLST_codeGen_DataSourceValuepcodeGen_DataSourceInsert_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceValue _desc1;
_TSPLST_codeGen_DataSourceInsert_values _desc2;
};

struct _TPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceUpdate_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceFormalParam _desc1;
_TSPLST_codeGen_DataSourceUpdate_formalParams _desc2;
};

struct _TPLST_codeGen_DataSourceValuepcodeGen_DataSourceUpdate_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceValue _desc1;
_TSPLST_codeGen_DataSourceUpdate_values _desc2;
};

struct _TPLST_codeGen_DataSourceFormalParampcodeGen_DataSourceDelete_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceFormalParam _desc1;
_TSPLST_codeGen_DataSourceDelete_formalParams _desc2;
};

struct _TPLST_codeGen_FormularSelectElementpcodeGen_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularSelectElement _desc1;
_TSPLST_codeGen_Formular_elements _desc2;
};

struct _TPLST_codeGen_FormularCheckboxElementpcodeGen_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularCheckboxElement _desc1;
_TSPLST_codeGen_Formular_elements _desc2;
};

struct _TPLST_codeGen_FormularPasswordElementpcodeGen_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularPasswordElement _desc1;
_TSPLST_codeGen_Formular_elements _desc2;
};

struct _TPLST_codeGen_FormularTextAreaElementpcodeGen_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularTextAreaElement _desc1;
_TSPLST_codeGen_Formular_elements _desc2;
};

struct _TPLST_codeGen_FormularTextElementpcodeGen_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularTextElement _desc1;
_TSPLST_codeGen_Formular_elements _desc2;
};

struct _TPLST_codeGen_FormularRadioGroupElementpcodeGen_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularRadioGroupElement _desc1;
_TSPLST_codeGen_Formular_elements _desc2;
};

struct _TPLST_codeGen_WebNodeActualParampcodeGen_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeActualParam _desc1;
_TSPLST_codeGen_Formular_actualParams _desc2;
};

struct _TPLST_codeGen_FormularRadioElementpcodeGen_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularRadioElement _desc1;
_TSPLST_codeGen_FormularRadioGroupElement_elements _desc2;
};

struct _TPLST_codeGen_DataSourceActualParampcodeGen_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceActualParam _desc1;
_TSPLST_codeGen_FormularDataSourceSelectOption_params _desc2;
};

struct _TPLST_codeGen_FormularConditionActualParampcodeGen_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularConditionActualParam _desc1;
_TSPLST_codeGen_FormularCondition_params _desc2;
};

struct _TPLST_codeGen_FormularConditionFormalParampcodeGen_FormularConditionDefinition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularConditionFormalParam _desc1;
_TSPLST_codeGen_FormularConditionDefinition_params _desc2;
};

struct _TPLST_codeGen_OutputElementpcodeGen_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_OutputElement _desc1;
_TSPLST_codeGen_Paragraph_fragments _desc2;
};

struct _TPLST_codeGen_ImageFragmentpcodeGen_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ImageFragment _desc1;
_TSPLST_codeGen_Paragraph_fragments _desc2;
};

struct _TPLST_codeGen_TextFragmentpcodeGen_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_TextFragment _desc1;
_TSPLST_codeGen_Paragraph_fragments _desc2;
};

struct _TPLST_codeGen_TableRowpcodeGen_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_TableRow _desc1;
_TSPLST_codeGen_Table_rows _desc2;
};

struct _TPLST_codeGen_TableColumnpcodeGen_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_TableColumn _desc1;
_TSPLST_codeGen_Table_columns _desc2;
};

struct _TPLST_codeGen_TableCellpcodeGen_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_TableCell _desc1;
_TSPLST_codeGen_TableRow_cells _desc2;
};

struct _TPLST_codeGen_LibrarypcodeGen_Root_library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Library _desc1;
_TSPLST_codeGen_Root_library _desc2;
};

struct _TPLST_codeGen_FormularConditionDefinitionpcodeGen_Library_formularconditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FormularConditionDefinition _desc1;
_TSPLST_codeGen_Library_formularconditions _desc2;
};

struct _TPLST_codeGen_NavigationElementpcodeGen_Library_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_NavigationElement _desc1;
_TSPLST_codeGen_Library_navigationElement _desc2;
};

struct _TPLST_codeGen_GlobalFramepcodeGen_WebApplication_frames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_GlobalFrame _desc1;
_TSPLST_codeGen_WebApplication_frames _desc2;
};

struct _TPLST_codeGen_WebRolepcodeGen_WebApplication_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebRole _desc1;
_TSPLST_codeGen_WebApplication_roles _desc2;
};

struct _TPLST_codeGen_LinkTargetExternpcodeGen_WebApplication_linksExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_LinkTargetExtern _desc1;
_TSPLST_codeGen_WebApplication_linksExtern _desc2;
};

struct _TPLST_codeGen_WebActionpcodeGen_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebAction _desc1;
_TSPLST_codeGen_RootWebZone_webTargets _desc2;
};

struct _TPLST_codeGen_WebPagepcodeGen_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebPage _desc1;
_TSPLST_codeGen_RootWebZone_webTargets _desc2;
};

struct _TPLST_codeGen_SubWebZonepcodeGen_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_SubWebZone _desc1;
_TSPLST_codeGen_RootWebZone_webTargets _desc2;
};

struct _TPLST_codeGen_WebRoleRefpcodeGen_RootWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebRoleRef _desc1;
_TSPLST_codeGen_RootWebZone_roles _desc2;
};

struct _TPLST_codeGen_WebActionpcodeGen_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebAction _desc1;
_TSPLST_codeGen_SubWebZone_webTargets _desc2;
};

struct _TPLST_codeGen_WebPagepcodeGen_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebPage _desc1;
_TSPLST_codeGen_SubWebZone_webTargets _desc2;
};

struct _TPLST_codeGen_SubWebZonepcodeGen_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_SubWebZone _desc1;
_TSPLST_codeGen_SubWebZone_webTargets _desc2;
};

struct _TPLST_codeGen_WebNodeFormalParampcodeGen_SubWebZone_globalparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeFormalParam _desc1;
_TSPLST_codeGen_SubWebZone_globalparams _desc2;
};

struct _TPLST_codeGen_WebRoleRefpcodeGen_SubWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebRoleRef _desc1;
_TSPLST_codeGen_SubWebZone_roles _desc2;
};

struct _TPLST_codeGen_WebNodeFormalParampcodeGen_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeFormalParam _desc1;
_TSPLST_codeGen_WebPage_formalParameter _desc2;
};

struct _TPLST_codeGen_ListOutputElementpcodeGen_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ListOutputElement _desc1;
_TSPLST_codeGen_Frame_components _desc2;
};

struct _TPLST_codeGen_FrameRefpcodeGen_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FrameRef _desc1;
_TSPLST_codeGen_Frame_components _desc2;
};

struct _TPLST_codeGen_TablepcodeGen_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Table _desc1;
_TSPLST_codeGen_Frame_components _desc2;
};

struct _TPLST_codeGen_HeadingpcodeGen_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Heading _desc1;
_TSPLST_codeGen_Frame_components _desc2;
};

struct _TPLST_codeGen_ParagraphpcodeGen_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Paragraph _desc1;
_TSPLST_codeGen_Frame_components _desc2;
};

struct _TPLST_codeGen_FormularpcodeGen_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Formular _desc1;
_TSPLST_codeGen_Frame_components _desc2;
};

struct _TPLST_codeGen_ListOutputElementpcodeGen_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ListOutputElement _desc1;
_TSPLST_codeGen_GlobalFrame_components _desc2;
};

struct _TPLST_codeGen_FrameRefpcodeGen_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_FrameRef _desc1;
_TSPLST_codeGen_GlobalFrame_components _desc2;
};

struct _TPLST_codeGen_TablepcodeGen_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Table _desc1;
_TSPLST_codeGen_GlobalFrame_components _desc2;
};

struct _TPLST_codeGen_HeadingpcodeGen_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Heading _desc1;
_TSPLST_codeGen_GlobalFrame_components _desc2;
};

struct _TPLST_codeGen_ParagraphpcodeGen_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Paragraph _desc1;
_TSPLST_codeGen_GlobalFrame_components _desc2;
};

struct _TPLST_codeGen_FormularpcodeGen_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_Formular _desc1;
_TSPLST_codeGen_GlobalFrame_components _desc2;
};

struct _TPLST_codeGen_NavigationBarElementpcodeGen_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_NavigationBarElement _desc1;
_TSPLST_codeGen_NavigationBar_elements _desc2;
};

struct _TPLST_codeGen_MetaInformationElementpcodeGen_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_MetaInformationElement _desc1;
_TSPLST_codeGen_MetaInformation_elements _desc2;
};

struct _TPLST_codeGen_DataSourceActualParampcodeGen_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceActualParam _desc1;
_TSPLST_codeGen_ListOutputElement_dataSourceActualParams _desc2;
};

struct _TPLST_codeGen_CustomStyleSheetBlockpcodeGen_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_CustomStyleSheetBlock _desc1;
_TSPLST_codeGen_StyleSheet_custom _desc2;
};

struct _TPLST_codeGen_HtmlStyleSheetBlockpcodeGen_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_HtmlStyleSheetBlock _desc1;
_TSPLST_codeGen_StyleSheet_default _desc2;
};

struct _TPLST_codeGen_StyleSheetPairpcodeGen_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_StyleSheetPair _desc1;
_TSPLST_codeGen_CustomStyleSheetBlock_pairs _desc2;
};

struct _TPLST_codeGen_StyleSheetPairpcodeGen_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_StyleSheetPair _desc1;
_TSPLST_codeGen_HtmlStyleSheetBlock_pairs _desc2;
};

struct _TPLST_codeGen_WebNodeActualParampcodeGen_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeActualParam _desc1;
_TSPLST_codeGen_ActionHandler_params _desc2;
};

struct _TPLST_codeGen_WebNodeFormalParampcodeGen_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_WebNodeFormalParam _desc1;
_TSPLST_codeGen_WebAction_formalParameter _desc2;
};

struct _TPLST_codeGen_DataBaseOperationpcodeGen_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataBaseOperation _desc1;
_TSPLST_codeGen_WebAction_operations _desc2;
};

struct _TPLST_codeGen_PHPOperationpcodeGen_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_PHPOperation _desc1;
_TSPLST_codeGen_WebAction_operations _desc2;
};

struct _TPLST_codeGen_ActionHandlerpcodeGen_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ActionHandler _desc1;
_TSPLST_codeGen_PHPOperation_errorhandler _desc2;
};

struct _TPLST_codeGen_ActionHandlerpcodeGen_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_ActionHandler _desc1;
_TSPLST_codeGen_DataBaseOperation_errorhandler _desc2;
};

struct _TPLST_codeGen_DataSourceActualParampcodeGen_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPcodeGen_DataSourceActualParam _desc1;
_TSPLST_codeGen_DataBaseOperation_params _desc2;
};

struct _TPLST_dataBaseView_DBBlobpdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBBlob _desc1;
_TSPLST_dataBaseView_DBColumn_type _desc2;
};

struct _TPLST_dataBaseView_DBBooleanpdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBBoolean _desc1;
_TSPLST_dataBaseView_DBColumn_type _desc2;
};

struct _TPLST_dataBaseView_DBTimeStamppdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBTimeStamp _desc1;
_TSPLST_dataBaseView_DBColumn_type _desc2;
};

struct _TPLST_dataBaseView_DBDatepdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBDate _desc1;
_TSPLST_dataBaseView_DBColumn_type _desc2;
};

struct _TPLST_dataBaseView_DBBigIntpdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBBigInt _desc1;
_TSPLST_dataBaseView_DBColumn_type _desc2;
};

struct _TPLST_dataBaseView_DBDoublepdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBDouble _desc1;
_TSPLST_dataBaseView_DBColumn_type _desc2;
};

struct _TPLST_dataBaseView_DBFloatpdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBFloat _desc1;
_TSPLST_dataBaseView_DBColumn_type _desc2;
};

struct _TPLST_dataBaseView_DBIntegerpdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBInteger _desc1;
_TSPLST_dataBaseView_DBColumn_type _desc2;
};

struct _TPLST_dataBaseView_DBStringpdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBString _desc1;
_TSPLST_dataBaseView_DBColumn_type _desc2;
};

struct _TPLST_dataBaseView_DBBlobpdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBBlob _desc1;
_TSPLST_dataBaseView_DataSourceFormalParam_type _desc2;
};

struct _TPLST_dataBaseView_DBBooleanpdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBBoolean _desc1;
_TSPLST_dataBaseView_DataSourceFormalParam_type _desc2;
};

struct _TPLST_dataBaseView_DBTimeStamppdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBTimeStamp _desc1;
_TSPLST_dataBaseView_DataSourceFormalParam_type _desc2;
};

struct _TPLST_dataBaseView_DBDatepdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBDate _desc1;
_TSPLST_dataBaseView_DataSourceFormalParam_type _desc2;
};

struct _TPLST_dataBaseView_DBBigIntpdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBBigInt _desc1;
_TSPLST_dataBaseView_DataSourceFormalParam_type _desc2;
};

struct _TPLST_dataBaseView_DBDoublepdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBDouble _desc1;
_TSPLST_dataBaseView_DataSourceFormalParam_type _desc2;
};

struct _TPLST_dataBaseView_DBFloatpdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBFloat _desc1;
_TSPLST_dataBaseView_DataSourceFormalParam_type _desc2;
};

struct _TPLST_dataBaseView_DBIntegerpdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBInteger _desc1;
_TSPLST_dataBaseView_DataSourceFormalParam_type _desc2;
};

struct _TPLST_dataBaseView_DBStringpdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBString _desc1;
_TSPLST_dataBaseView_DataSourceFormalParam_type _desc2;
};

struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ComputationExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_leftOperand _desc2;
};

struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ParameterValueExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_leftOperand _desc2;
};

struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ColumnValueExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_leftOperand _desc2;
};

struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ConstantExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_leftOperand _desc2;
};

struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_UnaryExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_leftOperand _desc2;
};

struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_BinaryExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_leftOperand _desc2;
};

struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ComputationExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_rightOperand _desc2;
};

struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ParameterValueExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_rightOperand _desc2;
};

struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ColumnValueExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_rightOperand _desc2;
};

struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ConstantExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_rightOperand _desc2;
};

struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_UnaryExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_rightOperand _desc2;
};

struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_BinaryExpression _desc1;
_TSPLST_dataBaseView_BinaryExpression_rightOperand _desc2;
};

struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ComputationExpression _desc1;
_TSPLST_dataBaseView_UnaryExpression_operand _desc2;
};

struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ParameterValueExpression _desc1;
_TSPLST_dataBaseView_UnaryExpression_operand _desc2;
};

struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ColumnValueExpression _desc1;
_TSPLST_dataBaseView_UnaryExpression_operand _desc2;
};

struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ConstantExpression _desc1;
_TSPLST_dataBaseView_UnaryExpression_operand _desc2;
};

struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_UnaryExpression _desc1;
_TSPLST_dataBaseView_UnaryExpression_operand _desc2;
};

struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_BinaryExpression _desc1;
_TSPLST_dataBaseView_UnaryExpression_operand _desc2;
};

struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ComputationExpression _desc1;
_TSPLST_dataBaseView_DataSourceValue_expression _desc2;
};

struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ParameterValueExpression _desc1;
_TSPLST_dataBaseView_DataSourceValue_expression _desc2;
};

struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ColumnValueExpression _desc1;
_TSPLST_dataBaseView_DataSourceValue_expression _desc2;
};

struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ConstantExpression _desc1;
_TSPLST_dataBaseView_DataSourceValue_expression _desc2;
};

struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_UnaryExpression _desc1;
_TSPLST_dataBaseView_DataSourceValue_expression _desc2;
};

struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_BinaryExpression _desc1;
_TSPLST_dataBaseView_DataSourceValue_expression _desc2;
};

struct _TPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceProjectionFilter_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceFormalParam _desc1;
_TSPLST_dataBaseView_DataSourceProjectionFilter_formalParameters _desc2;
};

struct _TPLST_dataBaseView_ComputationProjectionpdataBaseView_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ComputationProjection _desc1;
_TSPLST_dataBaseView_DataSourceProjectionFilter_projectionColumns _desc2;
};

struct _TPLST_dataBaseView_ColumnProjectionpdataBaseView_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ColumnProjection _desc1;
_TSPLST_dataBaseView_DataSourceProjectionFilter_projectionColumns _desc2;
};

struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ComputationExpression _desc1;
_TSPLST_dataBaseView_DataSourceProjectionFilter_condition _desc2;
};

struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ParameterValueExpression _desc1;
_TSPLST_dataBaseView_DataSourceProjectionFilter_condition _desc2;
};

struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ColumnValueExpression _desc1;
_TSPLST_dataBaseView_DataSourceProjectionFilter_condition _desc2;
};

struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ConstantExpression _desc1;
_TSPLST_dataBaseView_DataSourceProjectionFilter_condition _desc2;
};

struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_UnaryExpression _desc1;
_TSPLST_dataBaseView_DataSourceProjectionFilter_condition _desc2;
};

struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_BinaryExpression _desc1;
_TSPLST_dataBaseView_DataSourceProjectionFilter_condition _desc2;
};

struct _TPLST_dataBaseView_DataSourceFormalParampdataBaseView_LimitDataSource_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceFormalParam _desc1;
_TSPLST_dataBaseView_LimitDataSource_formalParameters _desc2;
};

struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ComputationExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_minRow _desc2;
};

struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ParameterValueExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_minRow _desc2;
};

struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ColumnValueExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_minRow _desc2;
};

struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ConstantExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_minRow _desc2;
};

struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_UnaryExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_minRow _desc2;
};

struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_BinaryExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_minRow _desc2;
};

struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ComputationExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_maxRow _desc2;
};

struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ParameterValueExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_maxRow _desc2;
};

struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ColumnValueExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_maxRow _desc2;
};

struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ConstantExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_maxRow _desc2;
};

struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_UnaryExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_maxRow _desc2;
};

struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_BinaryExpression _desc1;
_TSPLST_dataBaseView_LimitDataSource_maxRow _desc2;
};

struct _TPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceInsert_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceFormalParam _desc1;
_TSPLST_dataBaseView_DataSourceInsert_formalParams _desc2;
};

struct _TPLST_dataBaseView_DataSourceValuepdataBaseView_DataSourceInsert_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceValue _desc1;
_TSPLST_dataBaseView_DataSourceInsert_values _desc2;
};

struct _TPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceUpdate_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceFormalParam _desc1;
_TSPLST_dataBaseView_DataSourceUpdate_formalParams _desc2;
};

struct _TPLST_dataBaseView_DataSourceValuepdataBaseView_DataSourceUpdate_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceValue _desc1;
_TSPLST_dataBaseView_DataSourceUpdate_values _desc2;
};

struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ComputationExpression _desc1;
_TSPLST_dataBaseView_DataSourceUpdate_conditions _desc2;
};

struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ParameterValueExpression _desc1;
_TSPLST_dataBaseView_DataSourceUpdate_conditions _desc2;
};

struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ColumnValueExpression _desc1;
_TSPLST_dataBaseView_DataSourceUpdate_conditions _desc2;
};

struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ConstantExpression _desc1;
_TSPLST_dataBaseView_DataSourceUpdate_conditions _desc2;
};

struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_UnaryExpression _desc1;
_TSPLST_dataBaseView_DataSourceUpdate_conditions _desc2;
};

struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_BinaryExpression _desc1;
_TSPLST_dataBaseView_DataSourceUpdate_conditions _desc2;
};

struct _TPLST_dataBaseView_DataSourceFormalParampdataBaseView_DataSourceDelete_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceFormalParam _desc1;
_TSPLST_dataBaseView_DataSourceDelete_formalParams _desc2;
};

struct _TPLST_dataBaseView_ComputationExpressionpdataBaseView_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ComputationExpression _desc1;
_TSPLST_dataBaseView_DataSourceDelete_conditions _desc2;
};

struct _TPLST_dataBaseView_ParameterValueExpressionpdataBaseView_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ParameterValueExpression _desc1;
_TSPLST_dataBaseView_DataSourceDelete_conditions _desc2;
};

struct _TPLST_dataBaseView_ColumnValueExpressionpdataBaseView_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ColumnValueExpression _desc1;
_TSPLST_dataBaseView_DataSourceDelete_conditions _desc2;
};

struct _TPLST_dataBaseView_ConstantExpressionpdataBaseView_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_ConstantExpression _desc1;
_TSPLST_dataBaseView_DataSourceDelete_conditions _desc2;
};

struct _TPLST_dataBaseView_UnaryExpressionpdataBaseView_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_UnaryExpression _desc1;
_TSPLST_dataBaseView_DataSourceDelete_conditions _desc2;
};

struct _TPLST_dataBaseView_BinaryExpressionpdataBaseView_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_BinaryExpression _desc1;
_TSPLST_dataBaseView_DataSourceDelete_conditions _desc2;
};

struct _TPLST_dataBaseView_DBColumnpdataBaseView_DataSourceDB_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DBColumn _desc1;
_TSPLST_dataBaseView_DataSourceDB_columns _desc2;
};

struct _TPLST_dataBaseView_DataSourceJoinpdataBaseView_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceJoin _desc1;
_TSPLST_dataBaseView_DataBase_dataSources _desc2;
};

struct _TPLST_dataBaseView_LimitDataSourcepdataBaseView_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_LimitDataSource _desc1;
_TSPLST_dataBaseView_DataBase_dataSources _desc2;
};

struct _TPLST_dataBaseView_DataSourceProjectionFilterpdataBaseView_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceProjectionFilter _desc1;
_TSPLST_dataBaseView_DataBase_dataSources _desc2;
};

struct _TPLST_dataBaseView_DataSourceDBpdataBaseView_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceDB _desc1;
_TSPLST_dataBaseView_DataBase_dataSources _desc2;
};

struct _TPLST_dataBaseView_DataSourceDeletepdataBaseView_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceDelete _desc1;
_TSPLST_dataBaseView_DataBase_dataSourceModifications _desc2;
};

struct _TPLST_dataBaseView_DataSourceUpdatepdataBaseView_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceUpdate _desc1;
_TSPLST_dataBaseView_DataBase_dataSourceModifications _desc2;
};

struct _TPLST_dataBaseView_DataSourceInsertpdataBaseView_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPdataBaseView_DataSourceInsert _desc1;
_TSPLST_dataBaseView_DataBase_dataSourceModifications _desc2;
};

struct _TPLST_fcDlg_FormularConditionActualParampfcDlg_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPfcDlg_FormularConditionActualParam _desc1;
_TSPLST_fcDlg_FormularCondition_params _desc2;
};

struct _TPLST_globalFrameView_FormularPHPScriptSelectOptionpglobalFrameView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularPHPScriptSelectOption _desc1;
_TSPLST_globalFrameView_FormularSelectElement_options _desc2;
};

struct _TPLST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularDataSourceSelectOption _desc1;
_TSPLST_globalFrameView_FormularSelectElement_options _desc2;
};

struct _TPLST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularConstantSelectOption _desc1;
_TSPLST_globalFrameView_FormularSelectElement_options _desc2;
};

struct _TPLST_globalFrameView_WebNodeColumnExpressionpglobalFrameView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_WebNodeColumnExpression _desc1;
_TSPLST_globalFrameView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_WebNodeVariableExpression _desc1;
_TSPLST_globalFrameView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_WebNodeConstantExpression _desc1;
_TSPLST_globalFrameView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_globalFrameView_WebNodeColumnExpressionpglobalFrameView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_WebNodeColumnExpression _desc1;
_TSPLST_globalFrameView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_WebNodeVariableExpression _desc1;
_TSPLST_globalFrameView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_WebNodeConstantExpression _desc1;
_TSPLST_globalFrameView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularSelectElement _desc1;
_TSPLST_globalFrameView_Formular_elements _desc2;
};

struct _TPLST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularCheckboxElement _desc1;
_TSPLST_globalFrameView_Formular_elements _desc2;
};

struct _TPLST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularPasswordElement _desc1;
_TSPLST_globalFrameView_Formular_elements _desc2;
};

struct _TPLST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularTextAreaElement _desc1;
_TSPLST_globalFrameView_Formular_elements _desc2;
};

struct _TPLST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularTextElement _desc1;
_TSPLST_globalFrameView_Formular_elements _desc2;
};

struct _TPLST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularRadioGroupElement _desc1;
_TSPLST_globalFrameView_Formular_elements _desc2;
};

struct _TPLST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_WebNodeActualParam _desc1;
_TSPLST_globalFrameView_Formular_actualParams _desc2;
};

struct _TPLST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularRadioElement _desc1;
_TSPLST_globalFrameView_FormularRadioGroupElement_elements _desc2;
};

struct _TPLST_globalFrameView_DataSourceActualParampglobalFrameView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_DataSourceActualParam _desc1;
_TSPLST_globalFrameView_FormularDataSourceSelectOption_params _desc2;
};

struct _TPLST_globalFrameView_FormularConditionActualParampglobalFrameView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FormularConditionActualParam _desc1;
_TSPLST_globalFrameView_FormularCondition_params _desc2;
};

struct _TPLST_globalFrameView_OutputElementpglobalFrameView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_OutputElement _desc1;
_TSPLST_globalFrameView_Paragraph_fragments _desc2;
};

struct _TPLST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_ImageFragment _desc1;
_TSPLST_globalFrameView_Paragraph_fragments _desc2;
};

struct _TPLST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_TextFragment _desc1;
_TSPLST_globalFrameView_Paragraph_fragments _desc2;
};

struct _TPLST_globalFrameView_TableRowpglobalFrameView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_TableRow _desc1;
_TSPLST_globalFrameView_Table_rows _desc2;
};

struct _TPLST_globalFrameView_TableColumnpglobalFrameView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_TableColumn _desc1;
_TSPLST_globalFrameView_Table_columns _desc2;
};

struct _TPLST_globalFrameView_TableCellpglobalFrameView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_TableCell _desc1;
_TSPLST_globalFrameView_TableRow_cells _desc2;
};

struct _TPLST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_ListOutputElement _desc1;
_TSPLST_globalFrameView_Frame_components _desc2;
};

struct _TPLST_globalFrameView_FrameRefpglobalFrameView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FrameRef _desc1;
_TSPLST_globalFrameView_Frame_components _desc2;
};

struct _TPLST_globalFrameView_TablepglobalFrameView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_Table _desc1;
_TSPLST_globalFrameView_Frame_components _desc2;
};

struct _TPLST_globalFrameView_HeadingpglobalFrameView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_Heading _desc1;
_TSPLST_globalFrameView_Frame_components _desc2;
};

struct _TPLST_globalFrameView_ParagraphpglobalFrameView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_Paragraph _desc1;
_TSPLST_globalFrameView_Frame_components _desc2;
};

struct _TPLST_globalFrameView_FormularpglobalFrameView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_Formular _desc1;
_TSPLST_globalFrameView_Frame_components _desc2;
};

struct _TPLST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_ListOutputElement _desc1;
_TSPLST_globalFrameView_GlobalFrame_components _desc2;
};

struct _TPLST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_FrameRef _desc1;
_TSPLST_globalFrameView_GlobalFrame_components _desc2;
};

struct _TPLST_globalFrameView_TablepglobalFrameView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_Table _desc1;
_TSPLST_globalFrameView_GlobalFrame_components _desc2;
};

struct _TPLST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_Heading _desc1;
_TSPLST_globalFrameView_GlobalFrame_components _desc2;
};

struct _TPLST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_Paragraph _desc1;
_TSPLST_globalFrameView_GlobalFrame_components _desc2;
};

struct _TPLST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_Formular _desc1;
_TSPLST_globalFrameView_GlobalFrame_components _desc2;
};

struct _TPLST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPglobalFrameView_DataSourceActualParam _desc1;
_TSPLST_globalFrameView_ListOutputElement_dataSourceActualParams _desc2;
};

struct _TPLST_metaInformation_MetaInformationElementpmetaInformation_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPmetaInformation_MetaInformationElement _desc1;
_TSPLST_metaInformation_MetaInformation_elements _desc2;
};

struct _TPLST_navigationBarView_NavigationBarElementpnavigationBarView_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPnavigationBarView_NavigationBarElement _desc1;
_TSPLST_navigationBarView_NavigationBar_elements _desc2;
};

struct _TPLST_rootView_DBBlobprootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DBBlob _desc1;
_TSPLST_rootView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_rootView_DBBooleanprootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DBBoolean _desc1;
_TSPLST_rootView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_rootView_DBTimeStampprootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DBTimeStamp _desc1;
_TSPLST_rootView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_rootView_DBDateprootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DBDate _desc1;
_TSPLST_rootView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_rootView_DBBigIntprootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DBBigInt _desc1;
_TSPLST_rootView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_rootView_DBDoubleprootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DBDouble _desc1;
_TSPLST_rootView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_rootView_DBFloatprootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DBFloat _desc1;
_TSPLST_rootView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_rootView_DBIntegerprootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DBInteger _desc1;
_TSPLST_rootView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_rootView_DBStringprootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DBString _desc1;
_TSPLST_rootView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_rootView_WebNodeColumnExpressionprootView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeColumnExpression _desc1;
_TSPLST_rootView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_rootView_WebNodeVariableExpressionprootView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeVariableExpression _desc1;
_TSPLST_rootView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_rootView_WebNodeConstantExpressionprootView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeConstantExpression _desc1;
_TSPLST_rootView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_rootView_FormularSelectElementprootView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularSelectElement _desc1;
_TSPLST_rootView_Formular_elements _desc2;
};

struct _TPLST_rootView_FormularCheckboxElementprootView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularCheckboxElement _desc1;
_TSPLST_rootView_Formular_elements _desc2;
};

struct _TPLST_rootView_FormularPasswordElementprootView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularPasswordElement _desc1;
_TSPLST_rootView_Formular_elements _desc2;
};

struct _TPLST_rootView_FormularTextAreaElementprootView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularTextAreaElement _desc1;
_TSPLST_rootView_Formular_elements _desc2;
};

struct _TPLST_rootView_FormularTextElementprootView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularTextElement _desc1;
_TSPLST_rootView_Formular_elements _desc2;
};

struct _TPLST_rootView_FormularRadioGroupElementprootView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularRadioGroupElement _desc1;
_TSPLST_rootView_Formular_elements _desc2;
};

struct _TPLST_rootView_WebNodeActualParamprootView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeActualParam _desc1;
_TSPLST_rootView_Formular_actualParams _desc2;
};

struct _TPLST_rootView_FormularRadioElementprootView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularRadioElement _desc1;
_TSPLST_rootView_FormularRadioGroupElement_elements _desc2;
};

struct _TPLST_rootView_FormularPHPScriptSelectOptionprootView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularPHPScriptSelectOption _desc1;
_TSPLST_rootView_FormularSelectElement_options _desc2;
};

struct _TPLST_rootView_FormularDataSourceSelectOptionprootView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularDataSourceSelectOption _desc1;
_TSPLST_rootView_FormularSelectElement_options _desc2;
};

struct _TPLST_rootView_FormularConstantSelectOptionprootView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularConstantSelectOption _desc1;
_TSPLST_rootView_FormularSelectElement_options _desc2;
};

struct _TPLST_rootView_DataSourceActualParamprootView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DataSourceActualParam _desc1;
_TSPLST_rootView_FormularDataSourceSelectOption_params _desc2;
};

struct _TPLST_rootView_FormularConditionActualParamprootView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularConditionActualParam _desc1;
_TSPLST_rootView_FormularCondition_params _desc2;
};

struct _TPLST_rootView_FormularConditionFormalParamprootView_FormularConditionDefinition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularConditionFormalParam _desc1;
_TSPLST_rootView_FormularConditionDefinition_params _desc2;
};

struct _TPLST_rootView_WebNodeColumnExpressionprootView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeColumnExpression _desc1;
_TSPLST_rootView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_rootView_WebNodeVariableExpressionprootView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeVariableExpression _desc1;
_TSPLST_rootView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_rootView_WebNodeConstantExpressionprootView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeConstantExpression _desc1;
_TSPLST_rootView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_rootView_OutputElementprootView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_OutputElement _desc1;
_TSPLST_rootView_Paragraph_fragments _desc2;
};

struct _TPLST_rootView_ImageFragmentprootView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_ImageFragment _desc1;
_TSPLST_rootView_Paragraph_fragments _desc2;
};

struct _TPLST_rootView_TextFragmentprootView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_TextFragment _desc1;
_TSPLST_rootView_Paragraph_fragments _desc2;
};

struct _TPLST_rootView_TableRowprootView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_TableRow _desc1;
_TSPLST_rootView_Table_rows _desc2;
};

struct _TPLST_rootView_TableColumnprootView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_TableColumn _desc1;
_TSPLST_rootView_Table_columns _desc2;
};

struct _TPLST_rootView_TableCellprootView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_TableCell _desc1;
_TSPLST_rootView_TableRow_cells _desc2;
};

struct _TPLST_rootView_LibraryprootView_Root_library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Library _desc1;
_TSPLST_rootView_Root_library _desc2;
};

struct _TPLST_rootView_FormularConditionDefinitionprootView_Library_formularconditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FormularConditionDefinition _desc1;
_TSPLST_rootView_Library_formularconditions _desc2;
};

struct _TPLST_rootView_NavigationElementprootView_Library_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_NavigationElement _desc1;
_TSPLST_rootView_Library_navigationElement _desc2;
};

struct _TPLST_rootView_GlobalFrameprootView_WebApplication_frames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_GlobalFrame _desc1;
_TSPLST_rootView_WebApplication_frames _desc2;
};

struct _TPLST_rootView_WebRoleprootView_WebApplication_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebRole _desc1;
_TSPLST_rootView_WebApplication_roles _desc2;
};

struct _TPLST_rootView_LinkTargetExternprootView_WebApplication_linksExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_LinkTargetExtern _desc1;
_TSPLST_rootView_WebApplication_linksExtern _desc2;
};

struct _TPLST_rootView_WebActionprootView_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebAction _desc1;
_TSPLST_rootView_RootWebZone_webTargets _desc2;
};

struct _TPLST_rootView_WebPageprootView_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebPage _desc1;
_TSPLST_rootView_RootWebZone_webTargets _desc2;
};

struct _TPLST_rootView_SubWebZoneprootView_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_SubWebZone _desc1;
_TSPLST_rootView_RootWebZone_webTargets _desc2;
};

struct _TPLST_rootView_WebRoleRefprootView_RootWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebRoleRef _desc1;
_TSPLST_rootView_RootWebZone_roles _desc2;
};

struct _TPLST_rootView_WebActionprootView_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebAction _desc1;
_TSPLST_rootView_SubWebZone_webTargets _desc2;
};

struct _TPLST_rootView_WebPageprootView_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebPage _desc1;
_TSPLST_rootView_SubWebZone_webTargets _desc2;
};

struct _TPLST_rootView_SubWebZoneprootView_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_SubWebZone _desc1;
_TSPLST_rootView_SubWebZone_webTargets _desc2;
};

struct _TPLST_rootView_WebNodeFormalParamprootView_SubWebZone_globalparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeFormalParam _desc1;
_TSPLST_rootView_SubWebZone_globalparams _desc2;
};

struct _TPLST_rootView_WebRoleRefprootView_SubWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebRoleRef _desc1;
_TSPLST_rootView_SubWebZone_roles _desc2;
};

struct _TPLST_rootView_WebNodeFormalParamprootView_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeFormalParam _desc1;
_TSPLST_rootView_WebPage_formalParameter _desc2;
};

struct _TPLST_rootView_ListOutputElementprootView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_ListOutputElement _desc1;
_TSPLST_rootView_Frame_components _desc2;
};

struct _TPLST_rootView_FrameRefprootView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FrameRef _desc1;
_TSPLST_rootView_Frame_components _desc2;
};

struct _TPLST_rootView_TableprootView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Table _desc1;
_TSPLST_rootView_Frame_components _desc2;
};

struct _TPLST_rootView_HeadingprootView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Heading _desc1;
_TSPLST_rootView_Frame_components _desc2;
};

struct _TPLST_rootView_ParagraphprootView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Paragraph _desc1;
_TSPLST_rootView_Frame_components _desc2;
};

struct _TPLST_rootView_FormularprootView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Formular _desc1;
_TSPLST_rootView_Frame_components _desc2;
};

struct _TPLST_rootView_ListOutputElementprootView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_ListOutputElement _desc1;
_TSPLST_rootView_GlobalFrame_components _desc2;
};

struct _TPLST_rootView_FrameRefprootView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FrameRef _desc1;
_TSPLST_rootView_GlobalFrame_components _desc2;
};

struct _TPLST_rootView_TableprootView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Table _desc1;
_TSPLST_rootView_GlobalFrame_components _desc2;
};

struct _TPLST_rootView_HeadingprootView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Heading _desc1;
_TSPLST_rootView_GlobalFrame_components _desc2;
};

struct _TPLST_rootView_ParagraphprootView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Paragraph _desc1;
_TSPLST_rootView_GlobalFrame_components _desc2;
};

struct _TPLST_rootView_FormularprootView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_Formular _desc1;
_TSPLST_rootView_GlobalFrame_components _desc2;
};

struct _TPLST_rootView_NavigationBarElementprootView_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_NavigationBarElement _desc1;
_TSPLST_rootView_NavigationBar_elements _desc2;
};

struct _TPLST_rootView_MetaInformationElementprootView_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_MetaInformationElement _desc1;
_TSPLST_rootView_MetaInformation_elements _desc2;
};

struct _TPLST_rootView_DataSourceActualParamprootView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DataSourceActualParam _desc1;
_TSPLST_rootView_ListOutputElement_dataSourceActualParams _desc2;
};

struct _TPLST_rootView_CustomStyleSheetBlockprootView_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_CustomStyleSheetBlock _desc1;
_TSPLST_rootView_StyleSheet_custom _desc2;
};

struct _TPLST_rootView_HtmlStyleSheetBlockprootView_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_HtmlStyleSheetBlock _desc1;
_TSPLST_rootView_StyleSheet_default _desc2;
};

struct _TPLST_rootView_StyleSheetPairprootView_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_StyleSheetPair _desc1;
_TSPLST_rootView_CustomStyleSheetBlock_pairs _desc2;
};

struct _TPLST_rootView_CustomValueprootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_CustomValue _desc1;
_TSPLST_rootView_StyleSheetPair_value _desc2;
};

struct _TPLST_rootView_ListValueprootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_ListValue _desc1;
_TSPLST_rootView_StyleSheetPair_value _desc2;
};

struct _TPLST_rootView_AlignmentValueprootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_AlignmentValue _desc1;
_TSPLST_rootView_StyleSheetPair_value _desc2;
};

struct _TPLST_rootView_HeadingValueprootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_HeadingValue _desc1;
_TSPLST_rootView_StyleSheetPair_value _desc2;
};

struct _TPLST_rootView_StyleValueprootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_StyleValue _desc1;
_TSPLST_rootView_StyleSheetPair_value _desc2;
};

struct _TPLST_rootView_FamilyValueprootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_FamilyValue _desc1;
_TSPLST_rootView_StyleSheetPair_value _desc2;
};

struct _TPLST_rootView_ColorValueprootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_ColorValue _desc1;
_TSPLST_rootView_StyleSheetPair_value _desc2;
};

struct _TPLST_rootView_SizeValueprootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_SizeValue _desc1;
_TSPLST_rootView_StyleSheetPair_value _desc2;
};

struct _TPLST_rootView_StyleSheetPairprootView_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_StyleSheetPair _desc1;
_TSPLST_rootView_HtmlStyleSheetBlock_pairs _desc2;
};

struct _TPLST_rootView_WebNodeActualParamprootView_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeActualParam _desc1;
_TSPLST_rootView_ActionHandler_params _desc2;
};

struct _TPLST_rootView_WebNodeFormalParamprootView_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_WebNodeFormalParam _desc1;
_TSPLST_rootView_WebAction_formalParameter _desc2;
};

struct _TPLST_rootView_DataBaseOperationprootView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DataBaseOperation _desc1;
_TSPLST_rootView_WebAction_operations _desc2;
};

struct _TPLST_rootView_PHPOperationprootView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_PHPOperation _desc1;
_TSPLST_rootView_WebAction_operations _desc2;
};

struct _TPLST_rootView_ActionHandlerprootView_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_ActionHandler _desc1;
_TSPLST_rootView_PHPOperation_errorhandler _desc2;
};

struct _TPLST_rootView_ActionHandlerprootView_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_ActionHandler _desc1;
_TSPLST_rootView_DataBaseOperation_errorhandler _desc2;
};

struct _TPLST_rootView_DataSourceActualParamprootView_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSProotView_DataSourceActualParam _desc1;
_TSPLST_rootView_DataBaseOperation_params _desc2;
};

struct _TPLST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsspDlg_CustomValue _desc1;
_TSPLST_sspDlg_StyleSheetPair_value _desc2;
};

struct _TPLST_sspDlg_ListValuepsspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsspDlg_ListValue _desc1;
_TSPLST_sspDlg_StyleSheetPair_value _desc2;
};

struct _TPLST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsspDlg_AlignmentValue _desc1;
_TSPLST_sspDlg_StyleSheetPair_value _desc2;
};

struct _TPLST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsspDlg_HeadingValue _desc1;
_TSPLST_sspDlg_StyleSheetPair_value _desc2;
};

struct _TPLST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsspDlg_StyleValue _desc1;
_TSPLST_sspDlg_StyleSheetPair_value _desc2;
};

struct _TPLST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsspDlg_FamilyValue _desc1;
_TSPLST_sspDlg_StyleSheetPair_value _desc2;
};

struct _TPLST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsspDlg_ColorValue _desc1;
_TSPLST_sspDlg_StyleSheetPair_value _desc2;
};

struct _TPLST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsspDlg_SizeValue _desc1;
_TSPLST_sspDlg_StyleSheetPair_value _desc2;
};

struct _TPLST_stylesheetView_CustomStyleSheetBlockpstylesheetView_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_CustomStyleSheetBlock _desc1;
_TSPLST_stylesheetView_StyleSheet_custom _desc2;
};

struct _TPLST_stylesheetView_HtmlStyleSheetBlockpstylesheetView_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_HtmlStyleSheetBlock _desc1;
_TSPLST_stylesheetView_StyleSheet_default _desc2;
};

struct _TPLST_stylesheetView_StyleSheetPairpstylesheetView_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_StyleSheetPair _desc1;
_TSPLST_stylesheetView_CustomStyleSheetBlock_pairs _desc2;
};

struct _TPLST_stylesheetView_CustomValuepstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_CustomValue _desc1;
_TSPLST_stylesheetView_StyleSheetPair_value _desc2;
};

struct _TPLST_stylesheetView_ListValuepstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_ListValue _desc1;
_TSPLST_stylesheetView_StyleSheetPair_value _desc2;
};

struct _TPLST_stylesheetView_AlignmentValuepstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_AlignmentValue _desc1;
_TSPLST_stylesheetView_StyleSheetPair_value _desc2;
};

struct _TPLST_stylesheetView_HeadingValuepstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_HeadingValue _desc1;
_TSPLST_stylesheetView_StyleSheetPair_value _desc2;
};

struct _TPLST_stylesheetView_StyleValuepstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_StyleValue _desc1;
_TSPLST_stylesheetView_StyleSheetPair_value _desc2;
};

struct _TPLST_stylesheetView_FamilyValuepstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_FamilyValue _desc1;
_TSPLST_stylesheetView_StyleSheetPair_value _desc2;
};

struct _TPLST_stylesheetView_ColorValuepstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_ColorValue _desc1;
_TSPLST_stylesheetView_StyleSheetPair_value _desc2;
};

struct _TPLST_stylesheetView_SizeValuepstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_SizeValue _desc1;
_TSPLST_stylesheetView_StyleSheetPair_value _desc2;
};

struct _TPLST_stylesheetView_StyleSheetPairpstylesheetView_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPstylesheetView_StyleSheetPair _desc1;
_TSPLST_stylesheetView_HtmlStyleSheetBlock_pairs _desc2;
};

struct _TPLST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DBBlob _desc1;
_TSPLST_webActionView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DBBoolean _desc1;
_TSPLST_webActionView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DBTimeStamp _desc1;
_TSPLST_webActionView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DBDate _desc1;
_TSPLST_webActionView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DBBigInt _desc1;
_TSPLST_webActionView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DBDouble _desc1;
_TSPLST_webActionView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DBFloat _desc1;
_TSPLST_webActionView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DBInteger _desc1;
_TSPLST_webActionView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DBString _desc1;
_TSPLST_webActionView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webActionView_WebNodeColumnExpressionpwebActionView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_WebNodeColumnExpression _desc1;
_TSPLST_webActionView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_WebNodeVariableExpression _desc1;
_TSPLST_webActionView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_WebNodeConstantExpression _desc1;
_TSPLST_webActionView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_webActionView_WebNodeColumnExpressionpwebActionView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_WebNodeColumnExpression _desc1;
_TSPLST_webActionView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_WebNodeVariableExpression _desc1;
_TSPLST_webActionView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_WebNodeConstantExpression _desc1;
_TSPLST_webActionView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_WebNodeActualParam _desc1;
_TSPLST_webActionView_ActionHandler_params _desc2;
};

struct _TPLST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_WebNodeFormalParam _desc1;
_TSPLST_webActionView_WebAction_formalParameter _desc2;
};

struct _TPLST_webActionView_DataBaseOperationpwebActionView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DataBaseOperation _desc1;
_TSPLST_webActionView_WebAction_operations _desc2;
};

struct _TPLST_webActionView_PHPOperationpwebActionView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_PHPOperation _desc1;
_TSPLST_webActionView_WebAction_operations _desc2;
};

struct _TPLST_webActionView_ActionHandlerpwebActionView_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_ActionHandler _desc1;
_TSPLST_webActionView_PHPOperation_errorhandler _desc2;
};

struct _TPLST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_ActionHandler _desc1;
_TSPLST_webActionView_DataBaseOperation_errorhandler _desc2;
};

struct _TPLST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebActionView_DataSourceActualParam _desc1;
_TSPLST_webActionView_DataBaseOperation_params _desc2;
};

struct _TPLST_webPageView_FormularPHPScriptSelectOptionpwebPageView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularPHPScriptSelectOption _desc1;
_TSPLST_webPageView_FormularSelectElement_options _desc2;
};

struct _TPLST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularDataSourceSelectOption _desc1;
_TSPLST_webPageView_FormularSelectElement_options _desc2;
};

struct _TPLST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularConstantSelectOption _desc1;
_TSPLST_webPageView_FormularSelectElement_options _desc2;
};

struct _TPLST_webPageView_WebNodeColumnExpressionpwebPageView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_WebNodeColumnExpression _desc1;
_TSPLST_webPageView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_WebNodeVariableExpression _desc1;
_TSPLST_webPageView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_WebNodeConstantExpression _desc1;
_TSPLST_webPageView_DataSourceActualParam_expressions _desc2;
};

struct _TPLST_webPageView_WebNodeColumnExpressionpwebPageView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_WebNodeColumnExpression _desc1;
_TSPLST_webPageView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_WebNodeVariableExpression _desc1;
_TSPLST_webPageView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_WebNodeConstantExpression _desc1;
_TSPLST_webPageView_WebNodeActualParam_expressions _desc2;
};

struct _TPLST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DBBlob _desc1;
_TSPLST_webPageView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DBBoolean _desc1;
_TSPLST_webPageView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DBTimeStamp _desc1;
_TSPLST_webPageView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DBDate _desc1;
_TSPLST_webPageView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DBBigInt _desc1;
_TSPLST_webPageView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DBDouble _desc1;
_TSPLST_webPageView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DBFloat _desc1;
_TSPLST_webPageView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DBInteger _desc1;
_TSPLST_webPageView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DBString _desc1;
_TSPLST_webPageView_WebNodeFormalParam_type _desc2;
};

struct _TPLST_webPageView_FormularSelectElementpwebPageView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularSelectElement _desc1;
_TSPLST_webPageView_Formular_elements _desc2;
};

struct _TPLST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularCheckboxElement _desc1;
_TSPLST_webPageView_Formular_elements _desc2;
};

struct _TPLST_webPageView_FormularPasswordElementpwebPageView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularPasswordElement _desc1;
_TSPLST_webPageView_Formular_elements _desc2;
};

struct _TPLST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularTextAreaElement _desc1;
_TSPLST_webPageView_Formular_elements _desc2;
};

struct _TPLST_webPageView_FormularTextElementpwebPageView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularTextElement _desc1;
_TSPLST_webPageView_Formular_elements _desc2;
};

struct _TPLST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularRadioGroupElement _desc1;
_TSPLST_webPageView_Formular_elements _desc2;
};

struct _TPLST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_WebNodeActualParam _desc1;
_TSPLST_webPageView_Formular_actualParams _desc2;
};

struct _TPLST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularRadioElement _desc1;
_TSPLST_webPageView_FormularRadioGroupElement_elements _desc2;
};

struct _TPLST_webPageView_DataSourceActualParampwebPageView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DataSourceActualParam _desc1;
_TSPLST_webPageView_FormularDataSourceSelectOption_params _desc2;
};

struct _TPLST_webPageView_FormularConditionActualParampwebPageView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FormularConditionActualParam _desc1;
_TSPLST_webPageView_FormularCondition_params _desc2;
};

struct _TPLST_webPageView_OutputElementpwebPageView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_OutputElement _desc1;
_TSPLST_webPageView_Paragraph_fragments _desc2;
};

struct _TPLST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_ImageFragment _desc1;
_TSPLST_webPageView_Paragraph_fragments _desc2;
};

struct _TPLST_webPageView_TextFragmentpwebPageView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_TextFragment _desc1;
_TSPLST_webPageView_Paragraph_fragments _desc2;
};

struct _TPLST_webPageView_TableRowpwebPageView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_TableRow _desc1;
_TSPLST_webPageView_Table_rows _desc2;
};

struct _TPLST_webPageView_TableColumnpwebPageView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_TableColumn _desc1;
_TSPLST_webPageView_Table_columns _desc2;
};

struct _TPLST_webPageView_TableCellpwebPageView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_TableCell _desc1;
_TSPLST_webPageView_TableRow_cells _desc2;
};

struct _TPLST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_WebNodeFormalParam _desc1;
_TSPLST_webPageView_WebPage_formalParameter _desc2;
};

struct _TPLST_webPageView_ListOutputElementpwebPageView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_ListOutputElement _desc1;
_TSPLST_webPageView_Frame_components _desc2;
};

struct _TPLST_webPageView_FrameRefpwebPageView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_FrameRef _desc1;
_TSPLST_webPageView_Frame_components _desc2;
};

struct _TPLST_webPageView_TablepwebPageView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_Table _desc1;
_TSPLST_webPageView_Frame_components _desc2;
};

struct _TPLST_webPageView_HeadingpwebPageView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_Heading _desc1;
_TSPLST_webPageView_Frame_components _desc2;
};

struct _TPLST_webPageView_ParagraphpwebPageView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_Paragraph _desc1;
_TSPLST_webPageView_Frame_components _desc2;
};

struct _TPLST_webPageView_FormularpwebPageView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_Formular _desc1;
_TSPLST_webPageView_Frame_components _desc2;
};

struct _TPLST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPwebPageView_DataSourceActualParam _desc1;
_TSPLST_webPageView_ListOutputElement_dataSourceActualParams _desc2;
};

struct _TPLST_0pcodeGen_DataSourceDB_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataSourceProjectionFilter_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_LimitDataSource_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataSourceInsert_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataSourceInsert_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataSourceUpdate_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataSourceUpdate_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataSourceDelete_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_FormularConditionDefinition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_Root_library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_Library_formularconditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_Library_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_WebApplication_frames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_WebApplication_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_WebApplication_linksExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_RootWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_SubWebZone_globalparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_SubWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pcodeGen_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DBColumn_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_BinaryExpression_leftOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_BinaryExpression_rightOperand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_UnaryExpression_operand
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceValue_expression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceProjectionFilter_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceProjectionFilter_projectionColumns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceProjectionFilter_condition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_LimitDataSource_formalParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_LimitDataSource_minRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_LimitDataSource_maxRow
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceInsert_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceInsert_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceUpdate_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceUpdate_values
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceUpdate_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceDelete_formalParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceDelete_conditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataSourceDB_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataBase_dataSources
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pdataBaseView_DataBase_dataSourceModifications
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pfcDlg_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pmetaInformation_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pnavigationBarView_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_FormularConditionDefinition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_Root_library
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_Library_formularconditions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_Library_navigationElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_WebApplication_frames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_WebApplication_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_WebApplication_linksExtern
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_RootWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_RootWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_SubWebZone_webTargets
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_SubWebZone_globalparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_SubWebZone_roles
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_GlobalFrame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_NavigationBar_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_MetaInformation_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0prootView_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0psspDlg_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pstylesheetView_StyleSheet_custom
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pstylesheetView_StyleSheet_default
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pstylesheetView_CustomStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pstylesheetView_StyleSheetPair_value
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pstylesheetView_HtmlStyleSheetBlock_pairs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebActionView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebActionView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebActionView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebActionView_ActionHandler_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebActionView_WebAction_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebActionView_WebAction_operations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebActionView_PHPOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebActionView_DataBaseOperation_errorhandler
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebActionView_DataBaseOperation_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_FormularSelectElement_options
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_DataSourceActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_WebNodeActualParam_expressions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_WebNodeFormalParam_type
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_Formular_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_Formular_actualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_FormularRadioGroupElement_elements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_FormularDataSourceSelectOption_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_FormularCondition_params
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_Paragraph_fragments
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_Table_rows
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_Table_columns
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_TableRow_cells
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_WebPage_formalParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_Frame_components
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0pwebPageView_ListOutputElement_dataSourceActualParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

#undef _NODECOMMON
#endif
